if(!this.OptionsMgr)
{
    this.OptionsMgr = new Object();
}

OptionsMgr = {
    isInit: true,
    //General settings
    autoStart: null,
    curr_autoStart: null,
    autoStart_change: false,
	displayNoty: null,
    curr_displayNoty: null,
    displayNoty_change: false,
	
    //Video settings
    videoReceive: null,
    videoAdvert: null,
	autoFocus: null,
    curr_videoReceive: null,
    curr_videoAdvert: null,
	curr_autoFocus: null,
    videoReceive_change: false,
    videoAdvert_change: false,
	autoFocus_change: false,
	
	isAutoFocusEnable: false,
    
    //Privacy settings
    allowPolicy: null,
	//allowChatPolicy: null,
    curr_allowPolicy: null,
	//curr_allowChatPolicy: null,
    allowPolicy_change:false,	
	//allowChatPolicy_change:false,

    //Call forward scene
    callForwardState: null,
    callForwardTimer: null,
    callForwardNumbers: null,
    curr_callForwardState: null,
    curr_callForwardTimer: null,
    curr_callForwardNumbers: null,
    callForwardState_change: false,
    callForwardTimer_change: false,
    callForwardNumbers_change: false,
    
    //Voice mail
    voiceMailForwardState: null,
    voiceMailReject: null,
    voiceMailBusy: null,
    curr_voiceMailForwardState: null,
    curr_voiceMailReject: null,
    curr_voiceMailBusy: null,
    voiceMailForwardState_change: false,
    voiceMailReject_change: false,
    voiceMailBusy_change: false,
    
    isVoiceMailEnabled: false,
    isSkypeOutEnabled: false,
    splitCharSpace: " ",
    splitCharComma: ",",
    
    flagChange : false,
    
    initCountryCode : null,
    callForwardCountryCode : null,
    callForwardLocalCode : null,
    curr_callForwardCountryCode : null,
    curr_callForwardLocalCode : null,
    callForwardCountryCode_change : null,
    callForwardLocalCode_change : null,
    
    waitingCommit : false,
    
    isCreditCheck : false,
	
	CloseTimer: false,
}

OptionsMgr.init = function()
{
    alert("OptionsMgr.init()");
    this.read();
    this.flagChange =false;
    this.waitingCommit = false;
    $.sfScene.get("Options").changeToDefaultHelpBar();
    this.isInit = false;
}

OptionsMgr.setInitFlag = function(initFlag)
{
    this.isInit = initFlag;
    this.initSubScene();
}

OptionsMgr.getInitFlag = function()
{
    return this.isInit;
}

OptionsMgr.read = function()
{
    alert("OptionsMgr.read()");

    //General settings
    this.autoStart = PluginAPIMgr.GetAutoStart();
    this.curr_autoStart =  this.autoStart;
    this.autoStart_change= false;
	
	this.displayNoty = PluginAPIMgr.GetDisplayNoty();
    this.curr_displayNoty =  this.displayNoty;
    this.displayNoty_change= false;

    //Video settings
    this.videoReceive = PluginAPIMgr.GetAutoVideoReceive();
    this.videoAdvert = PluginAPIMgr.GetVideoAdvert();
	this.autoFocus = PluginAPIMgr.GetAutoFocusValue();
    
    this.curr_videoReceive = this.videoReceive;
    this.curr_videoAdvert =  this.videoAdvert;
	this.curr_autoFocus =  this.autoFocus;
    
    this.videoReceive_change= false;
    this.videoAdvert_change= false;
	this.autoFocus_change= false;
	
	this.isAutoFocusEnable =ProcMgr.isAutoFocusEnable();

    //Privacy settings
    this.allowPolicy = PluginAPIMgr.GetCallAllowPolicy();
    this.curr_allowPolicy = this.allowPolicy ; 
    this.allowPolicy_change= false;
	
	/*this.allowChatPolicy = PluginAPIMgr.GetChatAllowPolicy();
    this.curr_allowChatPolicy = this.allowChatPolicy ; 
    this.allowChatPolicy_change= false;  */

    //Call forward 
    this.callForwardState = PluginAPIMgr.GetCallForward();
    this.callForwardTimer = PluginAPIMgr.GetCallForwardTimer(); 
    this.callForwardNumbers = PluginAPIMgr.GetCallForwardNumbers();
    
     this.curr_callForwardState = this.callForwardState;
     this.curr_callForwardTimer = this.callForwardTimer;
     this.curr_callForwardNumbers = this.callForwardNumbers;
     
     this.callForwardState_change= false;
     this.callForwardTimer_change= false;
     this.callForwardNumbers_change= false;

    OptionsMgr.initCallForwardNumber();
    
    //Voice mail
    this.voiceMailForwardState= PluginAPIMgr.GetVoicemailForward();
    this.voiceMailReject = PluginAPIMgr.GetVoicemailForReject();
    this.voiceMailBusy = PluginAPIMgr.GetVoicemailInBusy();
    
    this.curr_voiceMailForwardState= this.voiceMailForwardState;
    this.curr_voiceMailReject = this.voiceMailReject
    this.curr_voiceMailBusy = this.voiceMailBusy;
    
     this.voiceMailForwardState_change= false;
     this.voiceMailReject_change= false;
     this.voiceMailBusy_change= false;

    if(PluginAPIMgr.GetAccountCapability(ENUM_CONTACT_CAPABILITY.CAPABILITY_VOICEMAIL) !== "1")
        this.isVoiceMailEnabled = true;
    else
        this.isVoiceMailEnabled = false;

    if(PluginAPIMgr.GetAccountCapability(ENUM_CONTACT_CAPABILITY.CAPABILITY_SKYPEOUT) !== "1")
        this.isSkypeOutEnabled = true;
    else
        this.isSkypeOutEnabled = false;
  
    this.print();
}

OptionsMgr.print = function()
{
    alert("OptionsMgr.print()");
    alert("------------------------------------------------------");
    alert("------------------- Options values -------------------");
    alert("------------------------------------------------------");
    alert("| autoStart: " + this.autoStart);
	alert("| displayNoty: " + this.displayNoty);
    alert("| videoReceive: " + this.videoReceive); 
    alert("| videoAdvert: " + this.videoAdvert); 
	alert("| autoFocus: " + this.autoFocus); 
    alert("| allowPolicy: " + this.allowPolicy); 
	//alert("| allowChatPolicy: " + this.allowChatPolicy); 
    alert("| callForwardState: " + this.callForwardState); 
    alert("| callForwardTimer: " + this.callForwardTimer); 
    alert("| callForwardNumbers: " + this.callForwardNumbers); 
    alert("| voiceMailForwardState: " + this.voiceMailForwardState); 
    alert("| voiceMailReject: " + this.voiceMailReject); 
    alert("| voiceMailBusy: " + this.voiceMailBusy); 
    alert("| voiceMailForwardTimer: " + this.callForwardTimer); 
    alert("| isVoiceMailEnabled: " + this.isVoiceMailEnabled); 
    alert("| isSkypeOutEnabled: " + this.isSkypeOutEnabled); 
    alert("------------------------------------------------------");
}

OptionsMgr.initCallForwardNumber = function()
{
    alert("OptionsMgr.read()");
    
    this.initCountryCode = PluginAPIMgr.GetMyCountryCode();
    
    alert("SceneOptionsCallForwarding.deserialize()"); 
    this.resetRecords();
    
    alert("Packet :" + this.callForwardNumbers );
    if(!this.callForwardNumbers )
    {
        for( var i = 0; i < 3; i++)
        {
            this.callForwardCountryCode[i] =  this.initCountryCode ; 
            this.callForwardLocalCode[i] = "";
            this.curr_callForwardCountryCode[i] = this.callForwardCountryCode[i] ; 
            this.curr_callForwardLocalCode[i] = "";
        }
            return;
    }

	var set = this.callForwardNumbers.split(this.splitCharSpace);
	var period = 3;
    var offset = 2;
    alert("set.length: " + set.length);
	for(var i = 0; i < set.length; i++)
	{
        alert("Index: " + i);
        var item = set[i].split(this.splitCharComma);
        alert("item.length: " + item.length);
        
        alert("item: " + item);
        alert("item[offset]: " + item[offset]);
        if(!item || item[offset] === undefined)
        {
             continue;
        }
       
        this.callForwardCountryCode[i] = PluginAPIMgr.FindCountryCodeByNumber(item[offset]) ; 
        this.callForwardLocalCode[i] =PluginAPIMgr.GetLocalNumber(item[offset]);

         if(this.callForwardCountryCode[i].length  ==0)
        {
            this.callForwardCountryCode[i] =  this.initCountryCode;
             
        }
        
        this.curr_callForwardCountryCode[i] = this.callForwardCountryCode[i] ;
        this.curr_callForwardLocalCode[i] = this.callForwardLocalCode[i] ;
        
        alert("Country code: " + this.callForwardCountryCode[i] );
        alert("Local number: " + this.callForwardLocalCode[i]);
	}    
}

OptionsMgr.resetRecords = function()
{
    this.initCountryCode = PluginAPIMgr.GetMyCountryCode();
    
    if(this.callForwardCountryCode ==null)
    {
        this.callForwardCountryCode = new Array(3);
    }
    
     if(this.callForwardLocalCode ==null)
    {
        this.callForwardLocalCode = new Array(3);
    }
    
    if(this.curr_callForwardCountryCode ==null)
    {
        this.curr_callForwardCountryCode = new Array(3);
    }
    
    if(this.curr_callForwardLocalCode ==null)
    {
        this.curr_callForwardLocalCode = new Array(3);
    }
    
   if( this.callForwardCountryCode_change==null)
   {
        this.callForwardCountryCode_change = new Array(3);
   }
       
   if( this.callForwardLocalCode_change == null)
   {
     this.callForwardLocalCode_change = new Array(3);
   }
    
    alert("OptionsMgr.resetRecords");
	for( var i = 0; i < 3; i++)
	{
        this.callForwardCountryCode[i] = this.initCountryCode; 
        this.callForwardLocalCode[i] = "";
        this.curr_callForwardCountryCode[i] = this.callForwardCountryCode[i] ; 
        this.curr_callForwardLocalCode[i] = "";
        this.callForwardCountryCode_change[i]= false;
        this.callForwardLocalCode_change[i]= false;
	}
}

OptionsMgr.initSubScene = function()
{
    alert("OptionsMgr.initSubScene()");
     
     $.sfScene.get("OptionsGeneralSettings").setInitFlag(this.isInit);
     $.sfScene.get("OptionsVideoSettings").setInitFlag(this.isInit);
     $.sfScene.get( "OptionsPrivacySettings").setInitFlag(this.isInit);
     $.sfScene.get("OptionsCallForwarding").setInitFlag(this.isInit);
     $.sfScene.get( "OptionsVoiceMail").setInitFlag(this.isInit);

}

OptionsMgr.isChange= function()
{
    var backup_flag = this.flagChange;
    this.flagChange = false;
    
    if(this.autoStart  !=this.curr_autoStart)
    {
        this.autoStart_change = true;
        this.flagChange = true;
    }
    else
    {
        this.autoStart_change = false;
    }
	
	if(this.displayNoty  !=this.curr_displayNoty)
    {
        this.displayNoty_change = true;
        this.flagChange = true;
    }
    else
    {
        this.displayNoty_change = false;
    }
    
    if(this.curr_videoReceive != this.videoReceive)
    {
        this.videoReceive_change = true;
        this.flagChange = true;
    }
    else
    {
        this.videoReceive_change = false;
    }
   
   if(this.curr_videoAdvert !=  this.videoAdvert)
   {
        this.videoAdvert_change = true;
        this.flagChange = true;
    }
    else
    {
        this.videoAdvert_change = false;
    }
	
	if(this.curr_autoFocus !=  this.autoFocus)
   {
        this.autoFocus_change = true;
        this.flagChange = true;
    }
    else
    {
        this.autoFocus_change = false;
    }
    
   if(this.curr_allowPolicy != this.allowPolicy)
   {
        this.allowPolicy_change = true;
        this.flagChange = true;
    }
    else
    {
         this.allowPolicy_change = false;
    }
	
	/*if(this.curr_allowChatPolicy != this.allowChatPolicy)
   {
        this.allowChatPolicy_change = true;
        this.flagChange = true;
    }
    else
    {
         this.allowChatPolicy_change = false;
    }*/
    
    if( this.curr_callForwardState != this.callForwardState)
    {
        this.callForwardState_change = true;
        this.flagChange = true;
    }
    else
    {
        this.callForwardState_change = false;
    }
    
    if( this.curr_callForwardTimer != this.callForwardTimer)
    {
        this.callForwardTimer_change = true;
        this.flagChange = true;
    }
    else
    {
        this.callForwardTimer_change = false;
    }
    
    var a=0;
    for(a=0; a<3; a++)
    {
        if(this.curr_callForwardCountryCode[a] !=this.callForwardCountryCode[a])
        {
            this.callForwardCountryCode_change[a] = true;
        }
		else
		{
			this.callForwardCountryCode_change[a] = false;
		}
        
         if(this.curr_callForwardLocalCode[a] !=this.callForwardLocalCode[a])
        {
            this.callForwardLocalCode_change[a] = true;
        }
		else
		{
			this.callForwardLocalCode_change[a] = false;
		}
    }
    

        if(this.callForwardCountryCode_change[0] ==true  || this.callForwardCountryCode_change[1] ==true || this.callForwardCountryCode_change[2] ==true ||
        this.callForwardLocalCode_change[0] ==true  || this.callForwardLocalCode_change[1] ==true || this.callForwardLocalCode_change[2] ==true )
        {
             this.callForwardNumbers_change= true;
            this.flagChange = true;
        }
        else
        {
            this.callForwardNumbers_change= false;
        }
    
    if(this.isVoiceMailEnabled == true)
    {
        if(this.curr_voiceMailForwardState != this.voiceMailForwardState)
        {
            this.voiceMailForwardState_change = true;
            this.flagChange = true;
        }
        else
        {
            this.voiceMailForwardState_change = false;
        }
        
       if( this.curr_voiceMailReject != this.voiceMailReject )
       {
         this.voiceMailReject_change = true;
         this.flagChange = true;
       }
       else
       {
        this.voiceMailReject_change = false;
       }
       
       if(this.curr_voiceMailBusy != this.voiceMailBusy)
       {
         this.voiceMailBusy_change = true;
         this.flagChange = true;
       }
       else
       {
        this.voiceMailBusy_change = false;
       }
    }
    
   alert("OptionsMgr.isChange():  " + this.flagChange );
   
      if(backup_flag !=  this.flagChange )
   {
       if(this.flagChange == true)
       {
            this.changeToSaveHelpBar();
       }
       else
       { 
            this.changeToDefaultHelpBar();
       }
   }
   else
   {
        this.checkPlusBtnEnable();   
   }
   
  
   return  this.flagChange;  
}

OptionsMgr.changeToDefaultHelpBar = function()
{
     $.sfScene.get("Options").changeToDefaultHelpBar();
     $.sfScene.get("OptionsGeneralSettings").changeToDefaultHelpBar();
     $.sfScene.get("OptionsVideoSettings").changeToDefaultHelpBar();
     $.sfScene.get("OptionsPrivacySettings").changeToDefaultHelpBar();
     $.sfScene.get("OptionsBlockedUsers").changeToDefaultHelpBar();
     $.sfScene.get("OptionsCallForwarding").changeToDefaultHelpBar();
     $.sfScene.get("OptionsVoiceMail").changeToDefaultHelpBar();
}

OptionsMgr.changeToSaveHelpBar = function()
{
     $.sfScene.get("Options").changeToSaveHelpBar();
     $.sfScene.get("OptionsGeneralSettings").changeToSaveHelpBar();
     $.sfScene.get("OptionsVideoSettings").changeToSaveHelpBar();
     $.sfScene.get("OptionsPrivacySettings").changeToSaveHelpBar();
     $.sfScene.get("OptionsBlockedUsers").changeToSaveHelpBar();
     $.sfScene.get("OptionsCallForwarding").changeToSaveHelpBar();
     $.sfScene.get("OptionsVoiceMail").changeToSaveHelpBar();
}

OptionsMgr.checkPlusBtnEnable = function()
{
    $.sfScene.get("OptionsCallForwarding").checkPlusBtnEnable();
}

OptionsMgr.SaveOptions = function()
{
    alert("***** ProcMgr.SaveProfile()");
    if(this.flagChange == false)
    {
        return;
    }
    
    WndMgr.NextStepOptions();
    
     if(this.isCreditCheck == true  || OptionsMgr.haveSkypeCredit()  == true)
    {
        this.isCreditCheck = false ; //init
        if(OptionsMgr.isValidCallForwordingNumber() ==true)
        {
            OptionsMgr.SaveGeneralSettings();
            OptionsMgr.SaveVideoSettings();
            OptionsMgr.SaveVoiceMail();
            OptionsMgr.SavePrivacySettings();
            OptionsMgr.SaveCallForwarding();
            
            if(this.waitingCommit ==false)
            {
                WndMgr.NextStepOptions();
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_OK);
            }
         }
         else
         {
            WndMgr.NextStepOptions();
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_WRONG_NUMBER);
         }
    }
    else
    {
        WndMgr.BackStepOptions();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_SKYPEOUT_DISABLED);
    }        
}


OptionsMgr.SaveGeneralSettings= function( )
{
    if( this.autoStart_change== true)
    {
         if(this.curr_autoStart === SID_ON)
            PluginAPIMgr.SetAutoStart(true);
        else
            PluginAPIMgr.SetAutoStart(false);
    }
    
	if(this.displayNoty_change==true)
    {
         PluginAPIMgr.SetDisplayNotyValue(this.curr_displayNoty);
    }
		
    alert("***** ProcMgr.SaveGeneralSettings() -> this.autoStart_change" + this.autoStart_change);
	alert("***** ProcMgr.SaveGeneralSettings() -> this.displayNoty_change" + this.displayNoty_change);
}

OptionsMgr.SaveVideoSettings= function( )
{
        if(this.videoReceive_change== true)
        {
            PluginAPIMgr.SetAutoVideoReceive(this.curr_videoReceive);
        }
        
        if(this.videoAdvert_change==true)
        {
             PluginAPIMgr.SetVideoAdvert(this.curr_videoAdvert);
        }
		
		if(this.autoFocus_change==true)
        {
             PluginAPIMgr.SetAutoFocusValue(this.curr_autoFocus);
        }
    
    alert("***** ProcMgr.SaveVideoSettings() -> this.videoReceive_change" + this.videoReceive_change);
    alert("***** ProcMgr.SaveVideoSettings() -> this.videoAdvert_change" + this.videoAdvert_change);
	alert("***** ProcMgr.SaveVideoSettings() -> this.autoFocus_change" + this.autoFocus_change);
}

OptionsMgr.SavePrivacySettings= function( )
{
    if( this.allowPolicy_change== true)
    {
        PluginAPIMgr.SetCallAllowPolicy(this.curr_allowPolicy);
        this.waitingCommit = true;
    }
	
	/*if( this.allowChatPolicy_change== true)
    {
        PluginAPIMgr.SetChatAllowPolicy(this.curr_allowChatPolicy);
        this.waitingCommit = true;
    }*/
    
    alert("***** ProcMgr.SavePrivacySettings() -> this.allowPolicy_change" + this.allowPolicy_change);
	//alert("***** ProcMgr.SavePrivacySettings() -> this.allowChatPolicy_change" + this.allowChatPolicy_change);
}

OptionsMgr.SaveCallForwarding= function( )
{
    if(this.curr_callForwardState == SID_ON )
    {
         if(this.callForwardState_change== true)
         {
            PluginAPIMgr.SetCallForward(this.curr_callForwardState);   
         }
        
        if(this.callForwardTimer_change== true)
        {
            PluginAPIMgr.SetCallForwardTimer(this.curr_callForwardTimer);   
        }
        
        if(this.callForwardNumbers_change== true)
        {
            var curr_callForwardNumbers = OptionsMgr.GetCallForwardingNumbers(); 
            PluginAPIMgr.SetCallForwardNumbers(curr_callForwardNumbers); 
            this.waitingCommit =true;
        }
    }
    else
    {
           if(this.callForwardState_change== true)
         {
            PluginAPIMgr.SetCallForward(this.curr_callForwardState);
			
			if(this.curr_voiceMailForwardState != SID_ON)
			{
				PluginAPIMgr.SetCallForwardTimer(g_Data.DATA_DEFAULT_CALL_FORWARDING_TIME);
			}			   
         }
    
    }
    
    alert("***** ProcMgr.SaveCallForwarding() -> this.callForwardState_change" + this.callForwardState_change);
    alert("***** ProcMgr.SaveCallForwarding() -> this.callForwardTimer_change" + this.callForwardTimer_change);
    alert("***** ProcMgr.SaveCallForwarding() -> this.callForwardNumbers_change" + this.callForwardNumbers_change);
}

OptionsMgr.SaveVoiceMail= function( )
{
    if(this.isVoiceMailEnabled == true)
    {
        if(this.curr_voiceMailForwardState == SID_ON )
        {
            if( this.voiceMailForwardState_change== true )
            {
                PluginAPIMgr.SetVoicemailForward(this.curr_voiceMailForwardState);
            }
            
            if(this.voiceMailReject_change==true)
            {
                PluginAPIMgr.SetVoicemailForReject(this.curr_voiceMailReject);
            }
            
             if(this.voiceMailBusy_change==true)
            {
                PluginAPIMgr.SetVoicemailInBusy(this.curr_voiceMailBusy);
            }
            
            if(this.callForwardTimer_change== true)
            {
                PluginAPIMgr.SetCallForwardTimer(this.curr_callForwardTimer);   
            }
        }
        else
        {
             if( this.voiceMailForwardState_change== true )
            {
                PluginAPIMgr.SetVoicemailForward(this.curr_voiceMailForwardState);
				
				if(this.curr_callForwardState != SID_ON)
				{
					PluginAPIMgr.SetCallForwardTimer(g_Data.DATA_DEFAULT_CALL_FORWARDING_TIME);
				}
            }
        }
    }
    
    alert("***** ProcMgr.SaveVoiceMail() -> this.voiceMailForwardState_change" + this.voiceMailForwardState_change);
    alert("***** ProcMgr.SaveVoiceMail() -> this.voiceMailReject_change" + this.voiceMailReject_change);
    alert("***** ProcMgr.SaveVoiceMail() -> this.voiceMailBusy_change" + this.voiceMailBusy_change);
    alert("***** ProcMgr.SaveVoiceMail() -> this.callForwardTimer_change" + this.callForwardTimer_change);
}

OptionsMgr.haveSkypeCredit = function( )
{
    alert("***** ProcMgr.haveSkypeCredit()");
    
    this.isCreditCheck = true;
    
    if(this.callForwardState_change == true && this.curr_callForwardState == SID_ON )
    {
        if(this.isSkypeOutEnabled == true)
        {
            return true;
        }
        else
        {
            return false;
        }
        
    }
    else
    {
        return true;
    }
}

OptionsMgr.isValidCallForwordingNumber = function( )
{
    if(this.curr_callForwardState == SID_ON)
    {
        if( this.callForwardCountryCode_change[0] == true ||  this.callForwardCountryCode_change[1] == true  || this.callForwardCountryCode_change[2] == true ||
        this.callForwardLocalCode_change[0] == true || this.callForwardLocalCode_change[1] == true || this.callForwardLocalCode_change[2] == true )
        {
            var a=0;
            for(a=0; a<3; a++)
            {
                if(this.callForwardCountryCode_change[a] == true  ||  this.callForwardLocalCode_change[a] == true)
                {
					if(this.curr_callForwardLocalCode[a].length > 0)
					{
						var add_prefix_phone_number = this.addCountryPrefix(this.curr_callForwardCountryCode[a], this.curr_callForwardLocalCode[a]);
	                    alert("add_prefix_phone_number : " + add_prefix_phone_number);
	                    var normalized_phone_number = PluginAPIMgr.NormalizeIdentity(add_prefix_phone_number);
	                    
	                    if(normalized_phone_number.length <= 0)
	                    {
	                        return false;
	                    }
						else
						{
							 var isEmergencyCall = PluginAPIMgr.IsEmergencyCall(normalized_phone_number);
							 if(isEmergencyCall==1)
							 {
							 	return false;
							 }	
						}	
					}
                }
            }
        }
        else
        {
            return true;
        }
    }
    else
    {
        return true;
    }
    
    return true;
}

OptionsMgr.addCountryPrefix = function(input_country_code, input_phone_number){
    alert("OptionsMgr.addCountryPrefix() ");
    var Prefix = PluginAPIMgr.GetISOCountryPrefix(input_country_code);
    alert("OptionsMgr.addCountryPrefix() : " + Prefix);
    
    if(input_phone_number.indexOf("+") ==0)
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("00") ==0 )
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("011") ==0)
    {
        return input_phone_number;
    }
    else
    {
		if(Prefix != "0")
		{
			return  "+"+ Prefix + input_phone_number;
		}
		else
		{
			return  input_phone_number;
		}        
    }   
}

OptionsMgr.GetCallForwardingNumbers = function()
{
	var timeLimits = ["0", "60", "120", "180"];
    var recordIndex = 0;
    var NumberList = "";
    var divider = this.splitCharSpace;
    
	for(var i = 0; i < 3; i++)
	{
        var localNumber = this.curr_callForwardLocalCode[i];
        var countryCode = this.curr_callForwardCountryCode[i];
        var number = this.addCountryPrefix (countryCode, localNumber); 

        alert("Number: " + number);
        alert("Local number: " + localNumber);
        alert("Country code: " + countryCode);

        if(localNumber.length !== 0)
        {
            
            if(recordIndex === 0)
                divider = "";
            else
                divider = this.splitCharSpace;

            NumberList = NumberList + divider + timeLimits[recordIndex] + this.splitCharComma + timeLimits[recordIndex+1] + this.splitCharComma + number;
            recordIndex++;
        }
	}
    
    alert("OptionsMgr.GetCallForwardingNumbers()" +NumberList); 
    return NumberList;
}

OptionsMgr.getAutoStart = function()
{
    alert("OptionsMgr.getAutoStart()");
    return this.autoStart;
}

OptionsMgr.setAutoStart = function(value)
{
    alert("OptionsMgr.setAutoStart(): " + value);
     
    this.curr_autoStart = value; 
    OptionsMgr.isChange();
}

OptionsMgr.getDisplayNoty = function()
{
    alert("OptionsMgr.getDisplayNoty()");
    return this.displayNoty;
}

OptionsMgr.setDisplayNoty = function(value)
{
    alert("OptionsMgr.setDisplayNoty(): " + value);
     
    this.curr_displayNoty = value; 
    OptionsMgr.isChange();
}

OptionsMgr.getVideoReceive = function()
{
    alert("OptionsMgr.getVideoReceive()");
    return this.videoReceive;
}

OptionsMgr.setVideoReceive = function(value)
{
    alert("OptionsMgr.setVideoReceive(): " + value);
   
   this.curr_videoReceive = value;
   OptionsMgr.isChange();
}

OptionsMgr.getVideoAdvert = function()
{
    alert("OptionsMgr.getVideoAdvert()");
    return this.videoAdvert;
}

OptionsMgr.setVideoAdvert = function(value)
{
    alert("OptionsMgr.setVideoAdvert(): " + value);
   
   this.curr_videoAdvert = value;
   OptionsMgr.isChange();
}

OptionsMgr.getAutoFocus = function()
{
    alert("OptionsMgr.getAutoFocus()");
    return this.autoFocus;
}

OptionsMgr.setAutoFocus = function(value)
{
    alert("OptionsMgr.setAutoFocus(): " + value);
    this.curr_autoFocus = value; 
    OptionsMgr.isChange();
}

OptionsMgr.getCallAllowPolicy = function()
{
    alert("OptionsMgr.getCallAllowPolicy()");
    return this.allowPolicy; 
}

OptionsMgr.setCallAllowPolicy = function(value)
{
    alert("OptionsMgr.setCallAllowPolicy(): " + value);
   
   this.curr_allowPolicy = value;
   OptionsMgr.isChange();
}
/*
OptionsMgr.getChatAllowPolicy = function()
{
    alert("OptionsMgr.getChatlAllowPolicy()");
    return this.allowChatPolicy; 
}

OptionsMgr.setChatAllowPolicy = function(value)
{
    alert("OptionsMgr.setChatAllowPolicy(): " + value);
   this.curr_allowChatPolicy = value;
   OptionsMgr.isChange();
}
*/
OptionsMgr.getCallForwardState = function()
{
    alert("OptionsMgr.getCallForwardState()");
    return this.callForwardState;
}

OptionsMgr.setCallForwardState = function(value)
{
    alert("OptionsMgr.setCallForwardState(): " + value);
    
    this.curr_callForwardState = value;
    OptionsMgr.isChange();
}

OptionsMgr.getCallForwardTimer = function()
{
    alert("OptionsMgr.getCallForwardTimer()");
    return this.callForwardTimer;
}

OptionsMgr.setCallForwardTimer = function(value)
{
    alert("OptionsMgr.setCallForwardTimer(): " + value);
    
    this.curr_callForwardTimer = value;
    OptionsMgr.isChange();
}

OptionsMgr.setCallForwardCountryCode = function(index,value)
{
    alert("OptionsMgr.setCallForwardCountryCode(): " + value);
    this.curr_callForwardCountryCode[index]  = value;
    OptionsMgr.isChange();
}

OptionsMgr.setCallForwardLocalCode = function(index,value)
{
    alert("OptionsMgr.setCallForwardLocalCode(): " + value);
    this.curr_callForwardLocalCode[index]  = value;
    OptionsMgr.isChange();
}

OptionsMgr.getCallForwardNumbers = function()
{
    alert("OptionsMgr.getCallForwardNumbers()");
    return this.callForwardNumbers;
}

OptionsMgr.setCallForwardNumbers = function(value)
{
    alert("OptionsMgr.setCallForwardNumbers(): " + value);
    this.callForwardNumbers = value;
}

OptionsMgr.getVoiceMailForwardState = function()
{
    alert("OptionsMgr.getVoiceMailForwardState()");
    return this.voiceMailForwardState;
}

OptionsMgr.setVoiceMailForwardState = function(value)
{
    alert("OptionsMgr.setVoiceMailForwardState(): " + value);
   
   this.curr_voiceMailForwardState = value;
   OptionsMgr.isChange();
}

OptionsMgr.getVoiceMailReject = function()
{
    alert("OptionsMgr.getVoiceMailReject()");
    return this.voiceMailReject;
}

OptionsMgr.setVoiceMailReject = function(value)
{
    alert("OptionsMgr.setVoiceMailReject(): " + value);
   
   this.curr_voiceMailReject = value;
   OptionsMgr.isChange();
}

OptionsMgr.getVoiceMailBusy = function()
{
    alert("OptionsMgr.getVoiceMailBusy()");
    return this.voiceMailBusy;
}

OptionsMgr.setVoiceMailBusy = function(value)
{
    alert("OptionsMgr.setVoiceMailBusy(): " + value);
 
    this.curr_voiceMailBusy = value;
     OptionsMgr.isChange();
}

OptionsMgr.getVoiceMailForwardTimer = function()
{
    alert("OptionsMgr.getVoiceMailForwardTimer()");
    return this.getCallForwardTimer();
}

OptionsMgr.setVoiceMailForwardTimer = function(value)
{
    alert("OptionsMgr.setVoiceMailForwardTimer(): " + value);
    this.setCallForwardTimer(value);
}

OptionsMgr.getVoiceMailState = function()
{
    alert("OptionsMgr.getVoiceMailState: " + this.isVoiceMailEnabled);

    return this.isVoiceMailEnabled;
}

OptionsMgr.getSkypeOutState = function()
{
    alert("OptionsMgr.getSkypeOutState: " + this.isSkypeOutEnabled);

    return this.isSkypeOutEnabled;
}

OptionsMgr.startTimer = function()
{
    alert("OptionsMgr.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { OptionsMgr.popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

OptionsMgr.resetTimer = function()
{
    alert("OptionsMgr.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

OptionsMgr.stopTimer = function()
{
    alert("OptionsMgr.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

OptionsMgr.popupTimerCallback = function()
{
	alert("OptionsMgr.popupTimerCallback() ");
	if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;

 	StateMgr.Stop_Options_State(true); 
}




