if(!this.StateMgr) {
	this.StateMgr = new Object();
}

 var MAIN_STATE={
        INIT : 0,
        MAIN : 1,
        VOICE_CALL : 2,
        VIDEO_CALL : 3,
        CONFERENCE_CALL:4,
        SKYPE_OUT_CALL : 5,
        CHAT : 6,
		VIDEO_SNAPSHOT : 7,
		
		WELCOME : 8,
		SIGNIN : 9,
		CREATE_ACCOUNT : 10,
		
		CAMERA_CHECK_CONNECTED : 11,
		CAMERA_CHECK_DISCONNECTED : 12,
		
		CREATE_ACCOUNT_SUCCESS :13,
		FACE_RECOG_SIGNIN : 14,
		FACE_RECOG_REGISTRATION : 15,
		GUIDE_PAGE : 16,
		
		MAX_MAIN_STATE : 17,
}

 var SUB_STATE={
        ADD_CONTACT : 0,
        ONLINE_STATUS : 1,
        EDIT_PROFILE : 2,
        CHANGE_PICTURE	: 3,
        CHANGE_PASSWORD : 4,
        OPTIONS : 5,
        CALLING : 6,
        CALL_ENDING : 7,
        VOICE_MAIL: 8,
        VOLUME_MIC : 9,
        VOLUME_SPEAKER : 10,
        CHAT_MSG_SNED: 11,
        LIVE_CONTACT_SWITCH : 12,
        SIGNOUT : 13,
		LIST_TOOLS : 14,
		VIEW_PROFILE : 15,
		RENAME : 16,
        REMOVE_CONTACT : 17,
		REMOVE : 18,
		BLOCK :	19,
		CALL_SWITCH : 20,
		VIDEO_ALLOW : 21,
		
		FORGOT_PWD: 22,
		EXIT: 23,
		ADD_PHONE_NUMBER : 24,
		
		ACCOUNT_MANAGER : 25,
		
		MAX_SUB_STATE : 26
}

var SUB_LIST = {

	COUNTRY_FLAG			: 0,
	CONTACT_PHONE_NUMBER	: 1,
	MAX_SUB_LIST 			: 2, 	
}

StateMgr = {
    MainStateList : new Array(MAIN_STATE.MAX_MAIN_STATE),    
    SubStateList : new Array(SUB_STATE.MAX_SUB_STATE),   
    SubListArray : new Array(SUB_LIST.MAX_SUB_LIST),
	
    currentState : "Deactivate",
    preState : "Deactivate",
    
    currentSubState : "",
    preSubState : "",
    
    currentSubList : null,
    
    skypeLoadCheckTimer : null,
	
    FuncParamA : null,
	FuncParamB : null,
	FuncParamC : null,
	FuncParamD : null,
	
	delaySubLoadingState : null,
	flagDelaySubLoading : false,

}

StateMgr.GetCurrentState = function()
{
    return this.currentState;
}

StateMgr.GetCurrentSubState = function()
{
    return this.currentSubState;
}

StateMgr.GetPreSubState = function()
{
    return this.preSubState;
}

StateMgr.initState = function(){
 alert("***** StateMgr.initState ()");

    this.initMainState();
    this.initSubState();
	this.initSubList();

}

StateMgr.StartLoadingState = function(){ 
 	if(WndMgr.isShowLoading == true)
 	{
 		return;	
 	}
 	
 	alert("***** StateMgr.StartLoadingState ()");
	 $.sfScene.get("Loading").initLoadingType(LoadingTypeIndex.WAIT);
	 $.sfScene.focus('Loading');
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////  Main State  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


StateMgr.initMainState = function(){
    var a=0;
    for(a=0; a<this.MainStateList.length; a++)
    {
        this.MainStateList[a] = new Object();
        this.MainStateList[a].flagLoad = false;
        this.MainStateList[a].flagLoading = false;
    }
    
    this.MainStateList[MAIN_STATE.INIT].id = "Init";
    this.MainStateList[MAIN_STATE.MAIN].id = "Main";
    this.MainStateList[MAIN_STATE.VOICE_CALL].id = "VoiceCall";
    this.MainStateList[MAIN_STATE.VIDEO_CALL].id = "VideoCall";
    this.MainStateList[MAIN_STATE.CONFERENCE_CALL].id = "ConferenceCall";
    this.MainStateList[MAIN_STATE.SKYPE_OUT_CALL].id = "SkypeOutCall";
    this.MainStateList[MAIN_STATE.CHAT].id = "Chat";
    this.MainStateList[MAIN_STATE.VIDEO_SNAPSHOT].id = "VideoSnapshot";	
	this.MainStateList[MAIN_STATE.WELCOME].id ="Welcome";
	this.MainStateList[MAIN_STATE.SIGNIN].id = "Signin";	
	this.MainStateList[MAIN_STATE.CREATE_ACCOUNT].id = "CreateAccount";	
	this.MainStateList[MAIN_STATE.CAMERA_CHECK_CONNECTED].id = "CameraCheckConnected";
	this.MainStateList[MAIN_STATE.CAMERA_CHECK_DISCONNECTED].id = "CameraCheckDisconnected";
	this.MainStateList[MAIN_STATE.CREATE_ACCOUNT_SUCCESS].id = "CreateAccountSuccess";	
	this.MainStateList[MAIN_STATE.FACE_RECOG_SIGNIN].id = "FaceRecogSignin";
	this.MainStateList[MAIN_STATE.FACE_RECOG_REGISTRATION].id = "FaceRecogRegistration";	
	this.MainStateList[MAIN_STATE.GUIDE_PAGE].id = "GuidePage";	
	this.MainStateList[MAIN_STATE.GUIDE_PAGE].flagLoad = true;	
	    
    this.MainStateList[MAIN_STATE.INIT].flagLoad = true;
}

StateMgr.setMainStateLoading = function(index){
    
	this.initMainStateLoading();    
    this.MainStateList[index].flagLoading = true;
}

StateMgr.initMainStateLoading = function(){
    
    var a=0;
    for(a=0; a<this.MainStateList.length; a++)
    {
        this.MainStateList[a].flagLoading = false;
    }
}

StateMgr.showMainState = function(index , callbackShowFn){
    
     if(this.MainStateList[index].flagLoading == true)
    {
        return;
    }
	
	StateMgr.StartLoadingState();
	
    if(this.MainStateList[index].flagLoad ==false)
    {
        StateMgr.setMainStateLoading(index); 
        $.sfScene.loadMode(this.MainStateList[index].id, function() {
            alert('!!!@@@ other mode loaded @@@');
            StateMgr.MainStateList[index].flagLoad = true;
            if(StateMgr.MainStateList[index].flagLoading == true)
            {
                StateMgr.MainStateList[index].flagLoading = false;
                callbackShowFn();
				
				if(StateMgr.flagDelaySubLoading == true)
				{
					StateMgr.flagDelaySubLoading = false; //init
					StateMgr.delaySubLoadingState();
					StateMgr.setDelaySubLoadingState(null); //init
				}
            }
        });
    }
    else{
		StateMgr.initMainStateLoading();
        callbackShowFn();
    }
}

StateMgr.isMainStateLoaing = function()
{
	var a=0;
    for(a=0; a<this.MainStateList.length; a++)
    {
		if(this.MainStateList[a].flagLoading == true)
		{
			return true;
		} 
    }
	
	return false;
}

StateMgr.setDelaySubLoadingState = function(callbackSubStartFn)
{
	this.delaySubLoadingState =callbackSubStartFn;
}

StateMgr.Start_Init_State = function(){
	
	StateMgr.initState(); 
    this.currentState = this.MainStateList[MAIN_STATE.INIT].id;
    alert("***** Start_Init_State = new [" +  this.currentState + "]");
    
    ResMgr.initResource();
    WndMgr.init();
    
    WndMgr.ShowInit();
      
    PluginAPIMgr.initPluginAPI();
    EventMgr.initEvent();
        	
	ProcMgr.setDefaultRemoteType();

	setTimeout("CloseTimerCF()", 0);
	CloseTimerCF = function(){
		ProcMgr.getTVModel();
		//ProcMgr.getTargetLocation();
		ProcMgr.getIMERemoconAreaId();
		
		WndMgr.ImagePreLoad();
	
		PluginAPIMgr.SyncCameraState();
		PluginAPIMgr.GetPanelResolution();
		
		if(WndMgr.Is1366x768Panel()){
			PluginAPIMgr.SetMainVideoRect(87, 24, 820, 615);
			PluginAPIMgr.SetDefaultPreviewRect(1023, 451, 228, 171);
			
		}
		else{
			//124, 34, 1144, 858
			PluginAPIMgr.SetDefaultRecvRect(121, 31, 1152, 864);
			PluginAPIMgr.SetDefaultPreviewRect(1438, 634, 320, 240);
		}		
							
		if(PluginAPIMgr.GetSkypeState() == 1)
	    {
	        ProcMgr.StartWidget();
	    }			
	}
}

StateMgr.Start_Main_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Main_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.MAIN, function(){ StateMgr.Show_Main_State();}) ;
}

StateMgr.Show_Main_State = function(){
    this.currentState = this.MainStateList[MAIN_STATE.MAIN].id;
    alert("***** Start_Main_State = [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Main_State ()");
    this.StopPreState();
    
    WndMgr.ShowMain();
}


StateMgr.Start_Voice_Call_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Voice_Call_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.VOICE_CALL, function(){ StateMgr.Show_Voice_Call_State();}) ;
}

StateMgr.Show_Voice_Call_State = function(){
	if(this.currentSubState == "CallEnding")
	{
		return;
	}
	
    this.currentState = this.MainStateList[MAIN_STATE.VOICE_CALL].id;
    alert("***** Start_Voice_Call_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Voice_Call_State ()");
    this.StopPreState();
    
    WndMgr.ShowVoiceCall();
}

StateMgr.Start_Video_Call_State = function(){

    if( this.MainStateList[MAIN_STATE.VIDEO_CALL].flagLoading == true)
    {
        return;
    }
    
    this.preState =  this.currentState;
    alert("***** Start_Video_Call_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.VIDEO_CALL, function(){ StateMgr.Show_Video_Call_State();}) ;
}

StateMgr.Show_Video_Call_State = function(){
	if(this.currentSubState == "CallEnding")
	{
		return;
	}
	
    this.currentState = this.MainStateList[MAIN_STATE.VIDEO_CALL].id;
    alert("***** Start_Video_Call_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Video_Call_State ()");
    this.StopPreState();
    
    WndMgr.ShowVideoCall();
}

StateMgr.Start_Conference_Call_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Conference_Call_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.CONFERENCE_CALL, function(){ StateMgr.Show_Conferenc_Call_State();}) ;
}

StateMgr.Show_Conferenc_Call_State = function(){
	if(this.currentSubState == "CallEnding")
	{
		return;
	}
	
    this.currentState =this.MainStateList[MAIN_STATE.CONFERENCE_CALL].id;
    alert("***** Start_Conference_Call_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Conferenc_Call_State ()");
    this.StopPreState();
    
    WndMgr.ShowConferenceCall();
}

StateMgr.Start_Skype_Out_Call_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Skype_Out_Call_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.SKYPE_OUT_CALL, function(){ StateMgr.Show_Skype_Out_Call_State();}) ;
}

StateMgr.Show_Skype_Out_Call_State = function(){
	if(this.currentSubState == "CallEnding")
	{
		return;
	}
	
    this.currentState = this.MainStateList[MAIN_STATE.SKYPE_OUT_CALL].id;
    alert("***** Start_Skype_Out_Call_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Skype_Out_Call_State ()");
    this.StopPreState();
    
    WndMgr.ShowSkypeOutCall();
}

StateMgr.Start_Chat_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Chat_State = old [" +  this.preState + "]");

    StateMgr.showMainState(MAIN_STATE.CHAT, function(){ StateMgr.Show_Chat_State();}) ;
}

StateMgr.Show_Chat_State = function(){
    this.currentState =  this.MainStateList[MAIN_STATE.CHAT].id;
    alert("***** Start_Chat_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Chat_State ()");
   // WndMgr.StartLoading(LoadingTypeIndex.WAIT);
    
    this.StopPreState();
    
    WndMgr.InitChat();
    WndMgr.ShowChat();
}

StateMgr.Start_Vidoe_Snapshot_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Vidoe_Snapshot_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.VIDEO_SNAPSHOT, function(){ StateMgr.Show_Vidoe_Snapshot_State();}) ;
}

StateMgr.Show_Vidoe_Snapshot_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.VIDEO_SNAPSHOT].id;	
    alert("***** Start_Vidoe_Snapshot_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Vidoe_Snapshot_State ()");
	    
    this.StopPreState();
    
    WndMgr.ShowVideoSnapshot();
}

StateMgr.Start_Welcome_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Welcome_State = old [" +  this.preState + "]");

     StateMgr.showMainState(MAIN_STATE.WELCOME, function(){ StateMgr.Show_Welcome_State();}) ;
}

StateMgr.Show_Welcome_State = function(){
    this.currentState = this.MainStateList[MAIN_STATE.WELCOME].id;
    alert("***** Start_Welcome_State = [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Welcome_State ()");
    this.StopPreState();
	
	if(this.MainStateList[MAIN_STATE.MAIN].flagLoad ==true)
    {
        WndMgr.DestroyMain();
    }

    WndMgr.ShowWelcome();   
}

StateMgr.Start_Signin_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Signin_State = old [" +  this.preState + "]");

     StateMgr.showMainState(MAIN_STATE.SIGNIN, function(){ StateMgr.Show_Signin_State();}) ;
}

StateMgr.Show_Signin_State = function(){
    this.currentState = this.MainStateList[MAIN_STATE.SIGNIN].id;
    alert("***** Start_Signin_State = [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Signin_State ()");
	if(this.preState == this.currentState)
    {
        WndMgr.ReturnSignin();
        return;
    }
	
    this.StopPreState();
    
    WndMgr.InitSignin();
    WndMgr.ShowSignin();   
}

StateMgr.Start_Create_Account_State = function(){
    this.preState =  this.currentState;
    alert("***** Start_Create_Account_State = old [" +  this.preState + "]");

     StateMgr.showMainState(MAIN_STATE.CREATE_ACCOUNT, function(){ StateMgr.Show_Create_Account_State();}) ;
}

StateMgr.Show_Create_Account_State = function(){
    this.currentState = this.MainStateList[MAIN_STATE.CREATE_ACCOUNT].id;
    alert("***** Start_Create_Account_State = [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Create_Account_State ()");
    this.StopPreState();
    
    WndMgr.InitCreateAccount();
    WndMgr.ShowCreateAccount();   
}

StateMgr.Start_Camera_Check_Connected_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Camera_Check_Connected_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.CAMERA_CHECK_CONNECTED, function(){ StateMgr.Show_Camera_Check_Connected_State();}) ;
}

StateMgr.Show_Camera_Check_Connected_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.CAMERA_CHECK_CONNECTED].id;	
    alert("***** Start_Camera_Check_Connected_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Camera_Check_Connected_State ()");
	    
    this.StopPreState();
    
    WndMgr.ShowCameraCheckConnected();
}

StateMgr.Start_Camera_Check_Disconnected_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Camera_Check_Disconnected_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.CAMERA_CHECK_DISCONNECTED, function(){ StateMgr.Show_Camera_Check_Disconnected_State();}) ;
}

StateMgr.Show_Camera_Check_Disconnected_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.CAMERA_CHECK_DISCONNECTED].id;	
    alert("***** Start_Camera_Check_Disconnected_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Camera_Check_Disconnected_State ()");
	    
    this.StopPreState();
    
    WndMgr.ShowCameraCheckDisconnected();
}

StateMgr.Start_Create_Account_Success_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Create_Account_Success_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.CREATE_ACCOUNT_SUCCESS, function(){ StateMgr.Show_Create_Account_Success_State();}) ;
}

StateMgr.Show_Create_Account_Success_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.CREATE_ACCOUNT_SUCCESS].id;	
    alert("***** Start_Create_Account_Success_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Create_Account_Success_State ()");
	    
    this.StopPreState();
    
    WndMgr.ShowCreateAccountSuccess();
}

StateMgr.Start_Face_Recog_Signin_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Face_Recog_Signin_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.FACE_RECOG_SIGNIN, function(){ StateMgr.Show_Face_Recog_Signin_State();}) ;
}

StateMgr.Show_Face_Recog_Signin_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.FACE_RECOG_SIGNIN].id;	
    alert("***** Start_Face_Recog_Signin_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Face_Recog_Signin_State ()");
	    
    this.StopPreState();
    
    WndMgr.InitFaceRecogSignin();
    WndMgr.ShowFaceRecogSignin();
}

StateMgr.Start_Face_Recog_Registration_State = function(){
	
    this.preState =  this.currentState;
    alert("***** Start_Face_Recog_Registration_State = old [" +  this.preState + "]");
    
    StateMgr.showMainState(MAIN_STATE.FACE_RECOG_REGISTRATION, function(){ StateMgr.Show_Face_Recog_Registration_State();}) ;
}

StateMgr.Show_Face_Recog_Registration_State = function(){

    this.currentState =  this.MainStateList[MAIN_STATE.FACE_RECOG_REGISTRATION].id;	
    alert("***** Start_Face_Recog_Registration_State = new [" +  this.currentState + "]");
	
    alert("***** StateMgr.Show_Face_Recog_Registration_State ()");
	    
    this.StopPreState();
    
    WndMgr.ShowFaceRecogRegistration();
}
StateMgr.Start_Guide_Page_State = function(type){

    this.preState =  this.currentState;
    this.FuncParamA = type;

    alert("***** Start_Guide_Page_State = old [" +  this.preState + "]");
    
	StateMgr.showMainState(MAIN_STATE.GUIDE_PAGE, function(){ StateMgr.Show_Guide_Page_State();}, function(){ StateMgr.Start_Guide_Page_State();}) ;
    
}

StateMgr.Show_Guide_Page_State = function(){
    this.currentState = this.MainStateList[MAIN_STATE.GUIDE_PAGE].id;
    alert("***** Start_Guide_Page_State = new [" +  this.currentState + "]");
    
    alert("***** StateMgr.Show_Guide_Page_State ()");

    this.StopPreState();
    
    WndMgr.ShowGuidePage(this.FuncParamA);
 
}






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////  Sub State  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

StateMgr.initSubState = function(){

    var b=0;
    for(b=0; b<this.SubStateList.length; b++)
    {
        this.SubStateList[b] = new Object();
        this.SubStateList[b].flagLoad = false;
        this.SubStateList[b].flagLoading = false;
    }
    
    this.SubStateList[SUB_STATE.ADD_CONTACT].id = "AddContact";
    this.SubStateList[SUB_STATE.ONLINE_STATUS].id = "OnlineStatus";
    this.SubStateList[SUB_STATE.EDIT_PROFILE].id = "EditProfile";
    this.SubStateList[SUB_STATE.CHANGE_PICTURE].id = "ChangePicture";
    this.SubStateList[SUB_STATE.CHANGE_PASSWORD].id = "ChangePassword";
    this.SubStateList[SUB_STATE.OPTIONS].id = "Options";
    this.SubStateList[SUB_STATE.CALLING].id = "Calling";
    this.SubStateList[SUB_STATE.CALL_ENDING].id = "CallEnding";
    this.SubStateList[SUB_STATE.VOICE_MAIL].id = "VoiceMail";
    this.SubStateList[SUB_STATE.VOLUME_MIC].id = "VolumeMic";
    this.SubStateList[SUB_STATE.VOLUME_SPEAKER].id = "VolumeSpeaker";
    this.SubStateList[SUB_STATE.CHAT_MSG_SNED].id = "ChatMsgSend";
    this.SubStateList[SUB_STATE.LIVE_CONTACT_SWITCH].id = "LiveContactSwitch";
    this.SubStateList[SUB_STATE.SIGNOUT].id = "Signout"; 
	this.SubStateList[SUB_STATE.LIST_TOOLS].id = "ListMainToolList";
	this.SubStateList[SUB_STATE.VIEW_PROFILE].id = "ViewProfile"; 	
    this.SubStateList[SUB_STATE.RENAME].id = "Rename"; 	
    this.SubStateList[SUB_STATE.REMOVE_CONTACT].id = "RemoveContact";
	this.SubStateList[SUB_STATE.REMOVE].id = "Remove";
    this.SubStateList[SUB_STATE.BLOCK].id = "Block"; 	
	this.SubStateList[SUB_STATE.CALL_SWITCH].id = "CallSwitch";
	this.SubStateList[SUB_STATE.VIDEO_ALLOW].id = "VideoAllow";	
	this.SubStateList[SUB_STATE.FORGOT_PWD].id = "ForgotPassword";
	this.SubStateList[SUB_STATE.EXIT].id = "Exit"; 
	this.SubStateList[SUB_STATE.ADD_PHONE_NUMBER].id = "AddAssignedPhoneNumber";  
	this.SubStateList[SUB_STATE.ACCOUNT_MANAGER].id = "AccountManager"; 	   
		 	
    this.SubStateList[SUB_STATE.CALL_ENDING].flagLoad = true;    
}

StateMgr.IsLoadSubState = function(SubStateIndex){

	return this.SubStateList[SubStateIndex].flagLoad;
	
}

StateMgr.setSubStateLoading = function(index)
{
    this.initSubStateLoading();
    this.SubStateList[index].flagLoading = true;
}

StateMgr.initSubStateLoading= function(){
	var b=0;
    for(b=0; b<this.SubStateList.length; b++)
    {
        this.SubStateList[b].flagLoading = false;
    }
}

StateMgr.showSubState = function(index , callbackShowFn, callbackStartFn){
	
	if(this.SubStateList[index].flagLoading == true)
    {
        return;
    }
	
	if(StateMgr.flagDelaySubLoading == true) // cancel delay loading
	{
		StateMgr.flagDelaySubLoading = false;
		StateMgr.setDelaySubLoadingState(null); 
	}

	StateMgr.StartLoadingState();
	
    if(this.SubStateList[index].flagLoad ==false)
    {
		if(StateMgr.isMainStateLoaing()== true)
		{
			StateMgr.flagDelaySubLoading = true;
			StateMgr.setDelaySubLoadingState(callbackStartFn);
			return;
		}
		
        StateMgr.setSubStateLoading(index); 
        $.sfScene.loadMode(this.SubStateList[index].id, function() {
            alert('!!!@@@ other mode loaded @@@');
            StateMgr.SubStateList[index].flagLoad = true;
            if(StateMgr.SubStateList[index].flagLoading == true)
            {
                StateMgr.SubStateList[index].flagLoading = false;
                callbackShowFn();
            }
        });
    }
    else{
		StateMgr.initSubStateLoading();
        callbackShowFn();
    }
}

StateMgr.Start_Add_Contact_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Add_Contact_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.ADD_CONTACT, function(){ StateMgr.Show_Add_Contact_State();}, function(){ StateMgr.Start_Add_Contact_State();}) ;
}

StateMgr.Show_Add_Contact_State = function(){
    this.currentSubState =this.SubStateList[SUB_STATE.ADD_CONTACT].id;
    alert("***** Start_Add_Contact_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Add_Contact_State ()");
    StateMgr.StopPreSubState();
	
    WndMgr.InitAddContact();
    WndMgr.ShowAddContact();
}

StateMgr.Stop_Add_Contact_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Add_Contact_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Add_Contact_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideAddContact();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}


StateMgr.Start_Remove_Contact_State = function(Identity,Display){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Remove_Contact_State = old [" +  this.preSubState + "]");

	this.FuncParamA = Identity;
	this.FuncParamB = Display;

    StateMgr.showSubState(SUB_STATE.REMOVE_CONTACT, function(){ StateMgr.Show_Remove_Contact_State();}, function(){ StateMgr.Start_Remove_Contact_State();}) ;
}

StateMgr.Show_Remove_Contact_State = function(){

    this.currentSubState = this.SubStateList[SUB_STATE.REMOVE_CONTACT].id;	

    alert("***** Start_Remove_Contact_State = new [" +  this.currentSubState + "]");
    

    StateMgr.StopPreSubState();

    WndMgr.ShowRemoveContact(this.FuncParamA,this.FuncParamB);

	this.FuncParamA = null;
	this.FuncParamB = null;

}

StateMgr.Stop_Remove_Contact_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Remove_Contact_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
	
    alert("***** Stop_Remove_Contact_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideRemoveContact();
	
    if(flagReturn==true)
    {
        this.ReturnState();
    }

}


StateMgr.Start_Online_Status_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Online_Status_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.ONLINE_STATUS, function(){ StateMgr.Show_Online_Status_State();}, function(){ StateMgr.Start_Online_Status_State();});
}

StateMgr.Show_Online_Status_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.ONLINE_STATUS].id ;
    alert("***** Start_Online_Status_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Online_Status_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowOnlineStatus();
}

StateMgr.Stop_Online_Status_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Online_Status_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Online_Status_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideOnlineStatus();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Edit_Profile_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Edit_Profile_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.EDIT_PROFILE, function(){ StateMgr.Show_Edit_Profile_State();}, function(){ StateMgr.Start_Edit_Profile_State();}) ;

}

StateMgr.Show_Edit_Profile_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.EDIT_PROFILE].id;
    alert("***** Start_Edit_Profile_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Edit_Profile_State ()");
    StateMgr.StopPreSubState();
    
    WndMgr.InitEditProfile();
    WndMgr.ShowEditProfile();
}

StateMgr.Stop_Edit_Profile_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Edit_Profile_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Edit_Profile_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideEditProfile();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Change_Picture_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Change_Picture_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.CHANGE_PICTURE, function(){ StateMgr.Show_Change_Picture_State();}, function(){ StateMgr.Start_Change_Picture_State();}) ;
}

StateMgr.Show_Change_Picture_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.CHANGE_PICTURE].id;
    alert("***** Start_Change_Picture_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Change_Picture_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowChangePicture();
}

StateMgr.Stop_Change_Picture_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Change_Picture_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Change_Picture_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideChangePicture(true);
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Change_Password_State = function(){
    this.preSubState = this.currentSubState;   
    alert("***** Start_Change_Password_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.CHANGE_PASSWORD, function(){ StateMgr.Show_Change_Password_State();}, function(){ StateMgr.Start_Change_Password_State();}) ;
}

StateMgr.Show_Change_Password_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.CHANGE_PASSWORD].id;
    alert("***** Start_Change_Password_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Change_Password_State ()");

    StateMgr.StopPreSubState();
    
    WndMgr.InitChangePassword();
    WndMgr.ShowChangePassword();
}

StateMgr.Stop_Change_Password_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Change_Password_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Change_Password_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideChangePassword();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Options_State = function()
{
    this.preSubState = this.currentSubState;  
    alert("***** Start_Options_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.OPTIONS, function(){ StateMgr.Show_Options_State();}, function(){ StateMgr.Start_Options_State();}) ;
}

StateMgr.Show_Options_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.OPTIONS].id;
    alert("***** Start_Options_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Options_State ()");

    StateMgr.StopPreSubState();
    
    WndMgr.InitOption();
    WndMgr.ShowOptions();
}

StateMgr.Stop_Options_State = function(flagReturn)
{
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Options_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Options_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideOptions();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Calling_State = function(){
    this.preSubState = this.currentSubState;   
    alert("***** Start_Calling_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.CALLING, function(){ StateMgr.Show_Calling_State();}, function(){ StateMgr.Start_Calling_State();}) ;

}

StateMgr.Show_Calling_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.CALLING].id;
    alert("***** Start_Calling_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Calling_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowCalling();
}

StateMgr.Stop_Calling_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Calling_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Calling_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideCalling();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Voice_Mail_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Voice_Mail_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.VOICE_MAIL, function(){ StateMgr.Show_Voice_Mail_State();}, function(){ StateMgr.Start_Voice_Mail_State();}) ;

}

StateMgr.Show_Voice_Mail_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.VOICE_MAIL].id;
    alert("***** Start_Voice_Mail_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Voice_Mail_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowVoiceMail();
}

StateMgr.Stop_Voice_Mail_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Voice_Mail_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Voice_Mail_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideVoiceMail();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Call_Ending_State = function(flagCallEndByMe){
    if(this.currentSubState == "Calling" || StateMgr.SubStateList[SUB_STATE.CALLING].flagLoading == true)
    {
        WndMgr.updateCallingButton(true);
        return;
    }

    this.preSubState = this.currentSubState;
	
	if( this.currentState =="Chat" && this.preSubState =="ChatMsgSend" )
	{
		ProcMgr.isTypingChatMsg = true;
	}
	else
	{
		ProcMgr.isTypingChatMsg = false;
	}
   
    alert("***** Start_Call_Ending_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.CALL_ENDING, function(){ StateMgr.Show_Call_Ending_State();}, function(){ StateMgr.Start_Call_Ending_State();}) ;
}

StateMgr.Show_Call_Ending_State = function(flagCallEndByMe){
    this.currentSubState =this.SubStateList[SUB_STATE.CALL_ENDING].id;
    alert("***** Start_Call_Ending_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Call_Ending_State ()");
    if(this.preSubState ==  this.currentSubState)
    {
        WndMgr.UpdateCallEndingStatus();
     }
     else
     {
        StateMgr.StopPreSubState();
        WndMgr.ShowCallEnding(flagCallEndByMe);
     }

}

StateMgr.Stop_Call_Ending_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Call_Ending_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Call_Ending_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideCallEnding();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}


StateMgr.Start_Volume_Mic_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Volume_Mic_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.VOLUME_MIC, function(){ StateMgr.Show_Volume_Mic_State();}, function(){ StateMgr.Start_Volume_Mic_State();}) ;
}

StateMgr.Show_Volume_Mic_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.VOLUME_MIC].id;
    alert("***** Start_Volume_Mic_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Voice_Mail_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowVolumeMic();
}

StateMgr.Stop_Volume_Mic_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Volume_Mic_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Volume_Mic_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideVolumeMic();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Volume_Speaker_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Volume_Speaker_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.VOLUME_SPEAKER, function(){ StateMgr.Show_Volume_Speaker_State();}, function(){ StateMgr.Start_Volume_Speaker_State();}) ;
}

StateMgr.Show_Volume_Speaker_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.VOLUME_SPEAKER].id ;
    alert("***** Start_Volume_Speaker_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Volume_Speaker_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowVolumeSpeaker();
}


StateMgr.Stop_Volume_Speaker_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Volume_Speaker_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Volume_Speaker_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideVolumeSpeaker();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Chat_Msg_Send_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Chat_Msg_Send_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.CHAT_MSG_SNED, function(){ StateMgr.Show_Chat_Msg_Send_State();}, function(){ StateMgr.Start_Chat_Msg_Send_State();}) ;
}

StateMgr.Show_Chat_Msg_Send_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.CHAT_MSG_SNED].id ;
    alert("***** Start_Chat_Msg_Send_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Chat_Msg_Send_State ()");

    StateMgr.StopPreSubState();
    WndMgr.ShowChatMsgSend();
}


StateMgr.Stop_Chat_Msg_Send_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Chat_Msg_Send_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Chat_Msg_Send_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideChatMsgSend();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}


StateMgr.Start_Live_Contact_List_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Live_Contact_List_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.LIVE_CONTACT_SWITCH, function(){ StateMgr.Show_Live_Contact_List_State();}, function(){ StateMgr.Start_Live_Contact_List_State();}) ;
}

StateMgr.Show_Live_Contact_List_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.LIVE_CONTACT_SWITCH].id ;	
    alert("***** Start_Live_Contact_List_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Live_Contact_List_State ()");

	StateMgr.StopPreSubState();
	
    WndMgr.ShowLiveContactList();
}

StateMgr.Stop_Live_Contact_List_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Live_Contact_List_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
	
    alert("***** Stop_Live_Contact_List_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideLiveContactList();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Signout_State = function(){
    this.preSubState = this.currentSubState;
    
    alert("***** Start_Signout_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.SIGNOUT, function(){ StateMgr.Show_Signout_State();}, function(){ StateMgr.Start_Signout_State();}) ;
}

StateMgr.Show_Signout_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.SIGNOUT].id;
    alert("***** Start_Signout_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Signout_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowSignout();
}

StateMgr.Stop_Signout_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Signout_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Signout_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideSignout();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}


StateMgr.Start_Contact_List_Tools_State = function(){
    
	this.preSubState = this.currentSubState;
    
	alert("***** Start_Contact_List_Tools_State = old [" +  this.preSubState + "]");
	
	StateMgr.showSubState(SUB_STATE.CONTACT_LIST_TOOLS, function(){ StateMgr.Show_Contact_List_Tools_State();}, function(){ StateMgr.Start_Contact_List_Tools_State();}) ;

}

StateMgr.Show_Contact_List_Tools_State = function(){
	
    this.currentSubState = this.SubStateList[SUB_STATE.CONTACT_LIST_TOOLS].id;
	
    alert("***** Start_Contact_List_Tools_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowContactListTools();
}

StateMgr.Stop_Contact_List_Tools_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_Contact_List_Tools_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_Contact_List_Tools_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideContactListTools();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}

StateMgr.Start_History_List_Tools_State = function(){
    
	this.preSubState = this.currentSubState;
    
	alert("***** Start_History_List_Tools_State = old [" +  this.preSubState + "]");
	
	StateMgr.showSubState(SUB_STATE.HISTORY_LIST_TOOLS, function(){ StateMgr.Show_History_List_Tools_State();}, function(){ StateMgr.Start_History_List_Tools_State();}) ;

}

StateMgr.Show_History_List_Tools_State = function(){
	
    this.currentSubState = this.SubStateList[SUB_STATE.HISTORY_LIST_TOOLS].id;
	
    alert("***** Start_History_List_Tools_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowHistoryListTools();
}

StateMgr.Stop_History_List_Tools_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_History_List_Tools_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_History_List_Tools_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideHistorytListTools();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}

StateMgr.Start_List_Tools_State = function(ToolType){
    
	this.preSubState = this.currentSubState;

	this.FuncParamA = ToolType;	    
    
	alert("***** Start_List_Tools_State = old [" +  this.preSubState + "]");
	
	StateMgr.showSubState(SUB_STATE.LIST_TOOLS, function(){ StateMgr.Show_List_Tools_State();} , function(){ StateMgr.Start_List_Tools_State();}) ;

}

StateMgr.Show_List_Tools_State = function(){
			
    this.currentSubState = this.SubStateList[SUB_STATE.LIST_TOOLS].id;
	
    alert("***** Start_List_Tools_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowListTools(this.FuncParamA);

	this.FuncParamA = null;    
    
}

StateMgr.Stop_List_Tools_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_List_Tools_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_List_Tools_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideListTools();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}

StateMgr.Start_View_Profile_State = function(IdentityName){
    
	this.preSubState = this.currentSubState;
    
	alert("***** Start_View_Profile_State = old [" +  this.preSubState + "]");
	
	this.FuncParamA = IdentityName;
	
	StateMgr.showSubState(SUB_STATE.VIEW_PROFILE, function(){ StateMgr.Show_View_Profile_State();}, function(){ StateMgr.Start_View_Profile_State();}) ;

}

StateMgr.Show_View_Profile_State = function(){
	
    this.currentSubState = this.SubStateList[SUB_STATE.VIEW_PROFILE].id;
	
    alert("***** Start_View_Profile_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowViewProfile(this.FuncParamA);
	
	this.FuncParamA = null;
}

StateMgr.Stop_View_Profile_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_View_Profile_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_View_Profile_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideViewProfile();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}


StateMgr.Start_Rename_State = function(IdentityName){
    
	this.preSubState	= this.currentSubState;
	    
	alert("***** Start_Rename_State = old [" +  this.preSubState + "]");

	this.FuncParamA = IdentityName;
		
	StateMgr.showSubState(SUB_STATE.RENAME, function(){ StateMgr.Show_Rename_State();}, function(){ StateMgr.Start_Rename_State();}) ;

}

StateMgr.Show_Rename_State = function(){
	
    this.currentSubState = this.SubStateList[SUB_STATE.RENAME].id;
	
    alert("***** Start_Rename_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowRename(this.FuncParamA);
	
	this.FuncParam = null;
}

StateMgr.Stop_Rename_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_Rename_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_Rename_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideRename();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}

StateMgr.Start_Block_State = function(Type,Identity,Display){
    
	this.preSubState	= this.currentSubState;
	
	this.FuncParamA		= Type;
    this.FuncParamB		= Identity;
	this.FuncParamC		= Display;
	
	alert("***** Start_Block_State = old [" +  this.preSubState + "]");
		
	StateMgr.showSubState(SUB_STATE.BLOCK, function(){ StateMgr.Show_Block_State();}, function(){ StateMgr.Start_Block_State(StateMgr.FuncParamA, StateMgr.FuncParamB,StateMgr.FuncParamC,StateMgr.FuncParamD);}) ;

}

StateMgr.Show_Block_State = function(){
	
    this.currentSubState = this.SubStateList[SUB_STATE.BLOCK].id;
	
    alert("***** Start_Block_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
    WndMgr.ShowBlock(this.FuncParamA, this.FuncParamB, this.FuncParamC);
	
	this.FuncParamA = null;
	this.FuncParamB = null;
	this.FuncParamC = null;
}

StateMgr.Stop_Block_State = function(flagReturn){
	
	this.preSubState = this.currentSubState;
	
	alert("***** Stop_Block_State = old [" +  this.preSubState + "]");
	
	this.currentSubState = "";
	alert("***** Stop_Block_State = new [" +  this.currentSubState + "]");
	
	WndMgr.HideBlock();
	
	if(flagReturn==true)
	{
		this.ReturnState();
	}
}

StateMgr.Start_Remove_State = function(Type,Identity,Display,Index){
    
	this.preSubState = this.currentSubState;
 
 	this.FuncParamA		= Type;
    this.FuncParamB		= Identity;
	this.FuncParamC		= Display;
	this.FuncParamD		= Index;
    
    alert("***** Start_Remove_State = old [" +  this.preSubState + "]");

    StateMgr.showSubState(SUB_STATE.REMOVE, function(){ StateMgr.Show_Remove_State();}, function(){ StateMgr.Start_Remove_State(StateMgr.FuncParamA, StateMgr.FuncParamB,StateMgr.FuncParamC,StateMgr.FuncParamD);}) ;
}


StateMgr.Show_Remove_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.REMOVE].id;	
    alert("***** Start_Remove_State = new [" +  this.currentSubState + "]");
    
    StateMgr.StopPreSubState();
	
    WndMgr.ShowRemove(this.FuncParamA, this.FuncParamB, this.FuncParamC, this.FuncParamD);

	this.FuncParamA = null;
	this.FuncParamB = null;
	this.FuncParamC = null;
	this.FuncParamD = null;	
	
}

StateMgr.Stop_Remove_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Remove_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
	
    alert("***** Stop_Remove_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideRemove();

    if(flagReturn==true)
    {
        this.ReturnState();
    }

}

StateMgr.Start_Call_Switch_State = function(){
    this.preSubState = this.currentSubState;
    alert("***** Start_Call_Switch_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.CALL_SWITCH, function(){ StateMgr.Show_Call_Switch_State();}, function(){ StateMgr.Start_Call_Switch_State();}) ;
}

StateMgr.Show_Call_Switch_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.CALL_SWITCH].id;
    alert("***** Start_Call_Switch_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Call_Switch_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowCallSwitch();
}



StateMgr.Stop_Call_Switch_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Call_Switch_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Call_Switch_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideCallSwitch();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Video_Allow_State = function(){
    this.preSubState = this.currentSubState;
    alert("***** Start_Video_Allow_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.VIDEO_ALLOW, function(){ StateMgr.Show_Video_Allow_State();}, function(){ StateMgr.Start_Video_Allow_State();}) ;
}

StateMgr.Show_Video_Allow_State = function(){
	if(this.currentSubState == "CallEnding")
	{
		return;
	}
	
    this.currentSubState = this.SubStateList[SUB_STATE.VIDEO_ALLOW].id;
    alert("***** Start_Video_Allow_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Video_Allow_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowVideoAllow();
}


StateMgr.Stop_Video_Allow_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Video_Allow_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Video_Allow_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideVideoAllow();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Forgot_Pwd_State = function(){
    this.preSubState = this.currentSubState;
    alert("***** Start_Forgot_Pwd_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.FORGOT_PWD, function(){ StateMgr.Show_Forgot_Pwd_State();}, function(){ StateMgr.Start_Forgot_Pwd_State();}) ;
}

StateMgr.Show_Forgot_Pwd_State = function(){

    this.currentSubState = this.SubStateList[SUB_STATE.FORGOT_PWD].id;
    alert("***** Start_Forgot_Pwd_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Forgot_Pwd_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowForgotPwd();
}


StateMgr.Stop_Forgot_Pwd_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Forgot_Pwd_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Forgot_Pwd_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideForgotPwd();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}

StateMgr.Start_Exit_State = function(fromReturnKey){
    this.preSubState = this.currentSubState;
    alert("***** Start_Exit_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.EXIT, function(){ StateMgr.Show_Exit_State(fromReturnKey);}, function(){ StateMgr.Start_Exit_State();}) ;
}

StateMgr.Show_Exit_State = function(fromReturnKey){
    this.currentSubState = this.SubStateList[SUB_STATE.EXIT].id;
    alert("***** Start_Exit_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Exit_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowExit(fromReturnKey);
}

StateMgr.Stop_Exit_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Exit_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Exit_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideExit();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}



/* 	<parameter1: type>
 *   0 : add type
 *   1 : assign number 1 change or delete
 *   2 : assign number 2 change or delete
 *   3 : assign number 3 change or delete
 *  <parameter2: phone number>
 * 
 */
StateMgr.Start_Add_Phone_Number_State = function()
{
    this.preSubState = this.currentSubState;
    alert("***** Start_Add_Phone_Number_State = old [" +  this.preSubState + "]");

 	// this.FuncParamA		= Type;
    // this.FuncParamB		= PhoneNumber;
    // this.FuncParamC		= SkypeName;
        
	StateMgr.showSubState(SUB_STATE.ADD_PHONE_NUMBER, function(){ StateMgr.Show_Add_Phone_Number_State();}, function(){ StateMgr.Start_Add_Phone_Number_State();}) ;
}

StateMgr.Show_Add_Phone_Number_State = function()
{
	
    this.currentSubState = this.SubStateList[SUB_STATE.ADD_PHONE_NUMBER].id;
    alert("***** Start_Add_Phone_Number_State = new [" +  this.currentSubState + "]");
    
    alert("***** StateMgr.Show_Add_Phone_Number_State ()");
    StateMgr.StopPreSubState();
    WndMgr.ShowAddPhoneNumber();
    
 	// this.FuncParamA		= null;
    // this.FuncParamB		= null;
	// this.FuncParamC		= null;
}


StateMgr.Stop_Add_Phone_Number_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Add_Phone_Number_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Add_Phone_Number_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideAddPhoneNumber();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}



StateMgr.Start_Account_Manager_State = function(){
    this.preSubState = this.currentSubState;
    alert("***** Start_Account_Manager_State = old [" +  this.preSubState + "]");

     StateMgr.showSubState(SUB_STATE.ACCOUNT_MANAGER, function(){ StateMgr.Show_Account_Manager_State();}, function(){ StateMgr.Start_Account_Manager_State();}) ;
}

StateMgr.Show_Account_Manager_State = function(){
    this.currentSubState = this.SubStateList[SUB_STATE.ACCOUNT_MANAGER].id;
    alert("***** Start_Account_Manager_State = new [" +  this.currentSubState + "]");
    
    alert("***** Show_Account_Manager_State ()");
    StateMgr.StopPreSubState();
    
    WndMgr.InitAccountManager();
    WndMgr.ShowAccountManager();
}

StateMgr.Stop_Account_Manager_State = function(flagReturn){
    this.preSubState = this.currentSubState;
    
    alert("***** Stop_Account_Manager_State = old [" +  this.preSubState + "]");

    this.currentSubState = "";
    alert("***** Stop_Account_Manager_State = new [" +  this.currentSubState + "]");
    
    WndMgr.HideAccountManager();
    
    if(flagReturn==true)
    {
        this.ReturnState();
    }
}






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////// Return  State  ////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

StateMgr.ReturnToMainState = function()
{   
    WndMgr.HideTextEditor();
	WndMgr.HideOneBottonPopup();
	WndMgr.HideKeypad(); 
    
    if(this.currentSubState.length != 0)
    {
        this.StopSubState();
    }
    this.stopSubList();
    
    StateMgr.ReturnState(); 
}

StateMgr.ReturnState = function()
{
	alert("***** ReturnState");
	
	switch(this.currentState)
	{     
		case "Main": 
			WndMgr.ReturnMain();
			break;

		case "VoiceCall":     
			WndMgr.ReturnVoiceCall();
			break;
		
		case "VideoCall":     
			WndMgr.ReturnVideoCall();
			break;
		
		case "ConferenceCall":     
			WndMgr.ReturnConferenceCall();
			break;
		
		case "SkypeOutCall":     
			WndMgr.ReturnSkypeOutCall();
			break;
		
		case "Chat":     
			WndMgr.ReturnChat();
			break;
		
		case "VideoSnapshot":     
			WndMgr.ReturnVideoSnapshot();
			break;
			
		case "Welcome": 
			WndMgr.ReturnWelcome(); 
			break;	
			
		case "Signin": 	
			WndMgr.ReturnSignin() 
			break;
			
		case "CreateAccount":     
			WndMgr.ReturnCreateAccount();
			break;	
			
		case "CameraCheckConnected":     
			WndMgr.ReturnCameraCheckConnected();
			break;	
		
		case "CameraCheckDisconnected":     
			WndMgr.ReturnCameraCheckDisconnected();
			break;		
			
		case "CreateAccountSuccess":
			WndMgr.ReturnCreateAccountSuccess();
			break;	
			
		case "FaceRecogSignin":
			WndMgr.ReturnFaceRecogSignin();
			break;
			
		case "FaceRecogRegistration":
			WndMgr.ReturnFaceRecogRegistration();
			break;	
	
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////// Stop Pre State   //////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
StateMgr.StopPreState = function() {

	alert("***** StopPreState");
	  	
    WndMgr.HideTextEditor();
	WndMgr.HideOneBottonPopup();
	WndMgr.HideKeypad();

    if(this.currentSubState.lenght != 0)
    {
        this.StopSubState();
    }
    
    switch(this.preState)
    {
       case "Init":     
            this.Stop_Init_State(); 
            break;
              
        case "Main":     
            this.Stop_Main_State(); 
            break;
            
        case "VoiceCall":     
            this.Stop_Voice_Call_State(); 
            break;
            
        case "VideoCall":     
            this.Stop_Video_Call_State(); 
            break;
            
        case "ConferenceCall":     
            this.Stop_Conference_Call_State(); 
            break;
            
        case "SkypeOutCall":     
            this.Stop_Skype_Out_Call_State(); 
            break;
            
         case "Chat":     
            this.Stop_Chat_State(); 
            break;

        case "VideoSnapshot":     
            this.Stop_Video_Snapshot_State(); 
			
			break;
		
		case "Welcome": 
			this.Stop_Welcome_State(); 
			break;
			
		case "Signin": 
            if(this.currentState == "Main" || this.currentState == "CameraCheckConnected" || this.currentState == "CameraCheckDisconnected")
            {
                WndMgr.DestroySignin();  //init 
                if(this.MainStateList[MAIN_STATE.WELCOME].flagLoad == true)
                {
                	WndMgr.DestroyWelcome();  //init 
                }
                
            }
			else if(this.currentState == "Welcome")
			{
				WndMgr.DestroySignin();  //init 
			}
			
            this.Stop_Signin_State(); 
            break;       
			
		case "CreateAccount":  
		    if(this.currentState == "Main" || this.currentState == "CameraCheckConnected" || this.currentState == "CameraCheckDisconnected")
            {
                WndMgr.DestroyCreateAccount();  //init 
                if(this.MainStateList[MAIN_STATE.WELCOME].flagLoad == true)
                {
                	WndMgr.DestroyWelcome();  //init 
                }
            }
			else if(this.currentState == "Welcome")
			{
				WndMgr.DestroyCreateAccount();  //init  
			}
			   
            this.Stop_Create_Account_State(); 
            break;	
			
		case "CameraCheckConnected":
			this.Stop_Camera_Check_Connected_State(); 
			break;	
			
		case "CameraCheckDisconnected":
			this.Stop_Camera_Check_Disconnected_State(); 
			break;
			
		case "CreateAccountSuccess":
			this.Stop_Create_Account_Success_State(); 
			break;	
			
		case "FaceRecogSignin":
			this.Stop_Face_Recog_Signin_State(); 
			break;
			
		case "FaceRecogRegistration":
			this.Stop_Face_Recog_Registration_State(); 
			break;			
		case "GuidePage":
			this.Stop_Guide_Page_State(); 
			break;			
			
    }
}

StateMgr.Stop_Init_State = function(){
    alert("***** Stop_Init_State =  [" +  this.preState + "]");
    
    WndMgr.HideInit();
}

StateMgr.Stop_Main_State = function(){
    alert("***** Stop_Main_State =  [" +  this.preState + "]");
    
    WndMgr.HideMain();
}

StateMgr.Stop_Voice_Call_State = function()
{
    alert("***** Stop_Voice_Call_State =  [" +  this.preState + "]");
    
    WndMgr.HideVoiceCall();
}

StateMgr.Stop_Video_Call_State = function()
{
    alert("***** Stop_Video_Call_State =  [" +  this.preState + "]");
    
    WndMgr.HideVideoCall();
}

StateMgr.Stop_Conference_Call_State = function()
{
    alert("***** Stop_Conference_Call_State =  [" +  this.preState + "]");
    
    WndMgr.HideConferenceCall();
}

StateMgr.Stop_Skype_Out_Call_State = function()
{
    alert("***** Stop_Skype_Out_Call_State =  [" +  this.preState + "]");
    
    WndMgr.HideSkypeOutCall();
}

StateMgr.Stop_Chat_State = function()
{
    alert("***** Stop_Chat_State =  [" +  this.preState + "]");
    
    WndMgr.HideChat();
}

StateMgr.Stop_Video_Snapshot_State = function()
{
    alert("***** Stop_Video_Snapshot_State =  [" +  this.preState + "]");
    
    WndMgr.HideVideoSnapshot();
}

StateMgr.Stop_Welcome_State = function()
{
    alert("***** Stop_Welcome_State =  [" +  this.preState + "]");
    
    WndMgr.HideWelcome();
}

StateMgr.Stop_Signin_State = function(){
    alert("***** Stop_Signin_State =  [" +  this.preState + "]");
    
    WndMgr.HideSignin();
}

StateMgr.Stop_Create_Account_State = function()
{
    alert("***** Stop_Create_Account_State =  [" +  this.preState + "]");
    
    WndMgr.HideCreateAccount();
}

StateMgr.Stop_Camera_Check_Connected_State = function()
{
    alert("***** Stop_Camera_Check_Connected_State =  [" +  this.preState + "]");
    
    WndMgr.HideCameraCheckConnected();
}

StateMgr.Stop_Camera_Check_Disconnected_State = function()
{
    alert("***** Stop_Camera_Check_Disconnected_State =  [" +  this.preState + "]");
    
    WndMgr.HideCameraCheckDisconnected();
}

StateMgr.Stop_Create_Account_Success_State = function()
{
    alert("***** Stop_Create_Account_Success_State =  [" +  this.preState + "]");
    
    WndMgr.HideCreateAccountSuccess();
}

StateMgr.Stop_Face_Recog_Signin_State = function()
{
    alert("***** Stop_Face_Recog_Signin_State =  [" +  this.preState + "]");
    
    WndMgr.HideFaceRecogSignin();
}

StateMgr.Stop_Face_Recog_Registration_State = function()
{
    alert("***** Stop_Face_Recog_Registration_State =  [" +  this.preState + "]");
    
    WndMgr.HideFaceRecogRegistration();
}
StateMgr.Stop_Guide_Page_State = function(){

    alert("***** Stop_Guide_Page_State = old [" +  this.preState + "]");
    
    WndMgr.HideGuidePage();
    
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////Stop Sub State///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


StateMgr.StopSubState = function() {
	
    switch(this.currentSubState)
    {
		case "AddContact":
			this.Stop_Add_Contact_State(); 
			break;   
		
		case "RemoveContact":
			this.Stop_Remove_Contact_State(); 
			break;   
		
		case "OnlineStatus":
			this.Stop_Online_Status_State(); 
			break;
		
		case "EditProfile":
			this.Stop_Edit_Profile_State(); 
			break;    
		
		case "ChangePicture":
			this.Stop_Change_Picture_State(); 
			break;
		
		case "ChangePassword":
			this.Stop_Change_Password_State(); 
			break;  
		
		case"Options":
			this.Stop_Options_State();
			break;
		
		case "Calling":
			this.Stop_Calling_State(); 
			break;
		
		case "VoiceMail":
			this.Stop_Voice_Mail_State(); 
			break;    
		
		case "CallEnding":
			this.Stop_Call_Ending_State(); 
			break;     
		
		case "VolumeMic":
			this.Stop_Volume_Mic_State(); 
			break;
		
		case "VolumeSpeaker":
			this.Stop_Volume_Speaker_State(); 
			break;
		
		case "ChatMsgSend":
			this.Stop_Chat_Msg_Send_State(); 
			break;
		
		case "LiveContactSwitch":
			this.Stop_Live_Contact_List_State(); 
			break;	
		
		case "Signout":     
			this.Stop_Signout_State(); 
			break;

		case "ListMainToolList":     
			this.Stop_List_Tools_State(); 
			break;
						
		case "ViewProfile":     
			this.Stop_View_Profile_State(); 
			break;	
			
		case "Rename":     
			this.Stop_Rename_State(); 
			break;
			
		case "Block":     
			this.Stop_Block_State(); 
			break;		
			
		case "Remove":     
			this.Stop_Remove_State(); 
			break;
									
		case "CallSwitch":     
			this.Stop_Call_Switch_State(); 
			break;
			
		case "VideoAllow":     
			this.Stop_Video_Allow_State(); 
			break;
			
		case "ForgotPassword":   	
			this.Stop_Forgot_Pwd_State();
			break;	
			
		case "Exit":     
			this.Stop_Exit_State(); 
			break;	

		case "AddAssignedPhoneNumber":     
			this.Stop_Add_Phone_Number_State(); 
			break;	
			
		case "AccountManager":     
			this.Stop_Account_Manager_State(); 
			break;	
		
    }
}

//////Stop Pre Sub State///////////////////////////////////////////////////////////////////////////////////////////////////

StateMgr.StopPreSubState = function() {
    
	alert("StateMgr.StopPreSubState");
    
    WndMgr.HideTextEditor();
	WndMgr.HideOneBottonPopup();
	WndMgr.HideKeypad();
    
    if(this.preSubState.length ==0)
    {
            return;
    }
    
    var nextSubState = this.currentSubState;
    
    switch(this.preSubState)
    {
		case "AddContact":
			this.Stop_Add_Contact_State(); 
			break;    
		
		case "RemoveContact":
			this.Stop_Remove_Contact_State(); 
			break;   			
		
		case "OnlineStatus":
			this.Stop_Online_Status_State(); 
			break; 
		
		case "EditProfile":
			this.Stop_Edit_Profile_State(); 
			break;    
		
		case "ChangePicture":
			this.Stop_Change_Picture_State(); 
			break; 
		
		case "ChangePassword":
			this.Stop_Change_Password_State(); 
			break;  
		
		case"Options":
			this.Stop_Options_State();
			break;
		
		case "Calling":
			this.Stop_Calling_State(); 
			break;   
		
		case "VoiceMail":
			this.Stop_Voice_Mail_State(); 
			break;  
		
		case "CallEnding":
			this.Stop_Call_Ending_State(); 
			break;     
		
		case "VolumeMic":
			this.Stop_Volume_Mic_State(); 
			break;
		
		case "VolumeSpeaker":
			this.Stop_Volume_Speaker_State(); 
			break;
		
		case "ChatMsgSend":
			this.Stop_Chat_Msg_Send_State(); 
			break;
		
		case "LiveContactSwitch":
			this.Stop_Live_Contact_List_State(); 
			break;	
		
		case "Signout":     
			this.Stop_Signout_State(); 
			break;
		
		case "ListMainToolList":     
			this.Stop_List_Tools_State(); 
			break;
			
		case "ViewProfile":     
			this.Stop_View_Profile_State(); 
			break;
		
		case "CallSwitch":     
			this.Stop_Call_Switch_State(); 
			break;				
				
		case "Rename":     
			this.Stop_Rename_State(); 
			break;
			
		case "Block":     
			this.Stop_Block_State(); 
			break;								

		case "Remove":     
			this.Stop_Remove_State(); 
			break;
			
		case "VideoAllow":     
			this.Stop_Video_Allow_State(); 
			break;
			
		case "ForgotPassword":   	
			this.Stop_Forgot_Pwd_State();
			break;	
			
		case "Exit":     
			this.Stop_Exit_State(); 
			break;

		case "AddAssignedPhoneNumber":     
			this.Stop_Add_Phone_Number_State(); 
			break;	
			
		case "AccountManager":     
			this.Stop_Account_Manager_State(); 
			break;	
			
    }
    
    this.currentSubState = nextSubState;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////  Sub List  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

StateMgr.initSubList = function(){

    var d=0;
    for(d=0; d < SUB_LIST.MAX_SUB_LIST; d++)
    {
        this.SubListArray[d] = new Object();
        this.SubListArray[d].flagLoad = false;
    }
    
    this.SubListArray[SUB_LIST.COUNTRY_FLAG].id = "SignupCountryList";
    this.SubListArray[SUB_LIST.CONTACT_PHONE_NUMBER].id = "ListMainContactPhoneNumberList";
   
}


StateMgr.showSubList = function(index , callbackShowFn){
	
    if(this.SubListArray[index].flagLoad == false)
    {		        
        $.sfScene.loadMode(		
			this.SubListArray[index].id , 		
		    function() {
            	StateMgr.SubListArray[index].flagLoad = true;
				callbackShowFn();
        	}
		);
    }
    else{
        callbackShowFn();
    }

}

StateMgr.stopSubList = function(){

	if(this.currentSubList == 'SignupCountryList')
	{
		$.sfScene.get("SignupCountryList").ProcessKeyReturn();
	}
	else if(this.currentSubList == 'ListMainContactPhoneNumberList')
	{
		$.sfScene.get("ListMainContactPhoneNumberList").ProcessKeyReturn();
	}

	this.currentSubList = null;
}

StateMgr.Show_CountryFlagName = function(FuncParamA,FuncParamB,FuncParamC,FuncParamD){

	this.currentSubList = 'SignupCountryList';
	
     StateMgr.showSubList(
	 	SUB_LIST.COUNTRY_FLAG,
	 	function(){
			$.sfScene.get("SignupCountryList").Init(FuncParamA,FuncParamB,FuncParamC,FuncParamD );	
			$.sfScene.show('SignupCountryList');
			$.sfScene.focus('SignupCountryList');								
		}
	);
	 
}

StateMgr.Show_ContactPhoneNumberList = function(FuncParamA,FuncParamB,FuncParamC){

	this.currentSubList = 'ListMainContactPhoneNumberList';

     StateMgr.showSubList(
	 	SUB_LIST.CONTACT_PHONE_NUMBER,
	 	function(){
			$.sfScene.get("ListMainContactPhoneNumberList").SetInfo(FuncParamA,FuncParamB,FuncParamC);	
			$.sfScene.show('ListMainContactPhoneNumberList');
			$.sfScene.focus('ListMainContactPhoneNumberList');
		}
	);
	 
}
