
var MaxNumOfBlockItem = 5;
var BlockListPropNum = 2;

function BlockList() {
										
    ScrollList.call(this);
}

BlockList.prototype = new ScrollList(); 

BlockList.prototype.Create = function() {

    alert("BlockList.Create");
		
	//Set List 
	this.CreateBG("blockList");  
	this.SetBGImage(g_Image.IMAGE_BLOCK_LIST_L_BG);  
    this.ElimentName = "blockList";	
	this.SetNumOfVisibleItem(MaxNumOfBlockItem);
	this.SetItemClass(BlockItem);	
	this.CreateScrBar("blockListScrollBar");
	this.SetScrBarImage(g_Image.IMAGE_BLOCK_SCROLLBAR_BG,
		g_Image.IMAGE_BLOCK_SCROLLBAR_TOP,
		g_Image.IMAGE_BLOCK_SCROLLBAR_CENTER,
		g_Image.IMAGE_BLOCK_SCROLLBAR_BOTTOM);	
				
	this.ResetData();

	this.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.SetClickEventAvailable(WndMgr.MouseClickEnable);	
		
	this.ShowItem();
	this.SetScrBarPosition(210,0,5);
	
}

BlockList.prototype.GetCurSkypeName = function(){

	return this.ItemArray[this.CurrentItemIndex].GetUnblockName();
	
}


//Set Total~,Max~ Info..... not cur~ Info
BlockList.prototype.ResetData = function(){
	
	if(this.MaxNumOfData > 0){
		this.DeleteDataAll();
	}
	
	var strBlockList = PluginAPIMgr.GetBlockList();
	alert("strBlockList = " + strBlockList );	
							
	if(strBlockList)
	{				
		var STX = String.fromCharCode(2);
		var ETX = String.fromCharCode(3);
		var splitter = ETX + STX;
	
		var Result = strBlockList.split(splitter);	
		
		var totalNumOfBlock = parseInt(Result.length / BlockListPropNum);
		alert("totalNumOfBlock = " + totalNumOfBlock );	
					
		var TokenNum = 0;

		var SkypeName;
		var DisplayName;
				
		var tempData = new Array(totalNumOfBlock);					
							
		//Set Data 									
		for (var i=0; i < totalNumOfBlock ; i++) {
					
			TokenNum = i*BlockListPropNum;						
			
			SkypeName = Result[TokenNum];	
			DisplayName = Result[TokenNum+1];
							
/*
			alert("SkypeName[" + i +"] = " + SkypeName );	
			alert("DisplayName[" + i +"] = " + DisplayName );		
*/						
			if(SkypeName == DisplayName){
				DisplayName = null;
			}		
			tempData[i] = [SkypeName,DisplayName];
				
			this.AddData(tempData[i]);	
						
		}
				
		//Set Page Info
		this.TotalPage = parseInt(this.MaxNumOfData / this.MaxNumOfItem);
		if((this.MaxNumOfData % this.MaxNumOfItem) > 0)
		{
			this.TotalPage++;
		}	
				
	}
//	else {
//		
//		this.TotalPage = 0;
//		this.CurPage = 0;
//	}

	//this.PrintListInfo();
	
}

BlockList.prototype.IsExistBlockedUser = function(blockString){
		
	for (var i=0; i<this.MaxNumOfData; i++) {
		
		if(this.DataArray[i][0] == blockString){
			return true;
		}
	}
	return false;

}

BlockList.prototype.onClickEventFunc1 = function()
{
	var OriginalScene = $.sfScene.get("OptionsBlockedUsers");	
	OriginalScene.ProcessClick(0);	
}

BlockList.prototype.onClickEventFunc2 = function()
{
	var OriginalScene = $.sfScene.get("OptionsBlockedUsers");	
	OriginalScene.ProcessClick(1);	
}

BlockList.prototype.onClickEventFunc3 = function()
{
	var OriginalScene = $.sfScene.get("OptionsBlockedUsers");	
	OriginalScene.ProcessClick(2);	
}

BlockList.prototype.onClickEventFunc4 = function()
{
	var OriginalScene = $.sfScene.get("OptionsBlockedUsers");	
	OriginalScene.ProcessClick(3);	
}

BlockList.prototype.onClickEventFunc5 = function()
{
	var OriginalScene = $.sfScene.get("OptionsBlockedUsers");	
	OriginalScene.ProcessClick(4);	
}
