
var HISTORY_BUTTON_HIGHLIGHT = { 
	NO_ONE				:	0,
	VIDEO_BUTTON		:	1,
	VOICE_BUTTON		:	2,
	PLAY_BUTTON			:	3,	
	POPUP_AND_SUB_LIST	:	4,
	MAX					:	5
}

var HISTORY_BUTTON_MODE = { 

	NOTHING_TYPE			:	0,
	
	//enable 2 button
	NORMAL_TYPE				:	1,
	//enable 1 button
	ONLY_VOICE_CALL_TYPE	:	2,

	VOICEMAIL_TYPE			:	3,
	
}

function HistoryFuncButtons () {

	this.Frame			    = null,
	
	this.VideoButton	    = null,
	this.VoiceButton	    = null,
	this.PlayStopButton		= null,	
	
	this.DurationLabel		= null,
	
	this.CurHistoryIndex 	= -1;
	this.CurHistoryIdentiry	= null;	
	this.CurPosition		= -1;
	
	this.LastHighlight			= HISTORY_BUTTON_HIGHLIGHT.NO_ONE;	
	this.LastHighlightButton	= null;	

	this.PrevButtonMode     = HISTORY_BUTTON_MODE.NOTHING_TYPE;
	this.ButtonMode			= HISTORY_BUTTON_MODE.NOTHING_TYPE;	
	
	//for voice mail
	this.IS_PLAY_BTN = true; 
	this.DurationTime = null;	
	this.VMStatus = ENUM_VOICE_MAIL_STATUS.PLAYED;
	this.flag_Waiting_VM_event = false;
	

	//flag
	this.flag_Focus		= false;
	this.CurSubScene	= null;
	
}

HistoryFuncButtons.prototype.Create = function() {

	alert("HistoryFuncButtons.Create()");
	
    this.Frame = new CompBase();
    this.Frame.CreateBG("historyButtons");
    //this.Frame.SetBGImage("");	
    

	//create video button
    this.VideoButton = new ButtonBase();
	this.VideoButton.Create("historyVideoButton",BUTTON_BASE_TYPE.BG_FG_TEXT);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_NORMAL_BG);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_HIGHLIGHT_BG);	
	this.VideoButton.SetBgImage(BUTTON_BASE_STATE.SELECT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_SELECT_BG);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.DIM,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_DIM_BG);
    this.VideoButton.SetText(IDWS_MOIP_VIDEO_CALL);
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");	
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.DIM,"cFuncButton_Text_Dim");		
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON);
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON);
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.DIM,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON_DIM);
    this.VideoButton.SetID(HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON);
    this.VideoButton.SetOnClickCallbackFunc(this.ClickVideoButton);
    this.VideoButton.SetOnRightClickCallbackFunc(this.ClickVideoButton);
    
    this.VoiceButton = new ButtonBase();
    this.VoiceButton.Create("historyVoiceButton",BUTTON_BASE_TYPE.BG_FG_TEXT);
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_NORMAL_BG);
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_HIGHLIGHT_BG);	
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_SELECT_BG);
    this.VoiceButton.SetText(IDWS_MOIP_VOICE_CALL);
	this.VoiceButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.VoiceButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");
	this.VoiceButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VOICE_ICON);
    this.VoiceButton.SetFgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VOICE_ICON);
	this.VoiceButton.SetID(HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON);
	this.VoiceButton.SetOnClickCallbackFunc(this.ClickVoiceButton);
	this.VoiceButton.SetOnRightClickCallbackFunc(this.ClickVoiceButton);
	
	this.PlayStopButton = new ButtonBase();
    this.PlayStopButton.Create("historyPlayButton",BUTTON_BASE_TYPE.BG_FG_TEXT);
    this.PlayStopButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_NORMAL_BG);
    this.PlayStopButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_SELECT_BG);
	this.PlayStopButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_HIGHLIGHT_BG);
	this.PlayStopButton.SetText(SID_PLAY);
	this.PlayStopButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.PlayStopButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");
	this.PlayStopButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_PLAY_ICON);
	this.PlayStopButton.SetID(HISTORY_BUTTON_HIGHLIGHT.PLAY_BUTTON);
    this.PlayStopButton.SetOnClickCallbackFunc(this.ClickPlayStopButton);
    this.PlayStopButton.SetOnRightClickCallbackFunc(this.ClickPlayStopButton);


	this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;


    this.DurationLabel = new CompBase(); 
	this.DurationLabel.CreateBG("historyDuration");
	this.DurationLabel.SetBGImage("");	
	this.DurationLabel.AddTextLayer("historyDurationText");
	
	//this.flag_Camera_State = PluginAPIMgr.GetCameraState();
						
}

HistoryFuncButtons.prototype.Show = function() {
	
	//alert("HistoryFuncButtons.Show()");
    this.Frame.Show();
} 

HistoryFuncButtons.prototype.Hide = function() {

    this.Frame.Hide();   
    
}

HistoryFuncButtons.prototype.SetCurPosition = function(nItemIndex) {

	alert("HistoryFuncButtons.SetCurPosition(" + nItemIndex + ")");
	
	if(nItemIndex < 0 || nItemIndex > MaxNumOfMainItem){
		
		alert("Error nItemIndex is not valid!!!");
		this.CurPosition = 0;
	}
	else {
		this.CurPosition = nItemIndex;
	}
    
	this.MovePosition();

}

HistoryFuncButtons.prototype.SetCurProperty = function(nCurHistoryIndex) {
	
	alert("HistoryFuncButtons.SetCurProperty(" + nCurHistoryIndex + ")");
	
	this.CurHistoryIndex = nCurHistoryIndex;
	
	var CurButtonType;
	var Type;	
	var IS_PSTN;
	var IS_CONFERENCE;
	var Availability;
	var Identity;
	var Camera_State;
	var IsInCall;
	
	//process exception..
	if(nCurHistoryIndex < 0){
		alert("CurHistoryIndex < 0  error!!!");
		Availability = null;
		this.CurHistoryIdentity = null;
	}
	else{

		Type = PluginAPIMgr.GetHistoryPropWithIndex(nCurHistoryIndex,ENUM_HISTORY_PROPERTY.P_TYPE);
		IS_PSTN = PluginAPIMgr.GetHistoryPropWithIndex(nCurHistoryIndex,ENUM_HISTORY_PROPERTY.P_IS_PSTN);
		IS_CONFERENCE = PluginAPIMgr.GetHistoryPropWithIndex(nCurHistoryIndex,ENUM_HISTORY_PROPERTY.P_IS_CONFERENCE);
		this.CurHistoryIdentity = PluginAPIMgr.GetHistoryNameWithIndex(nCurHistoryIndex);
		Camera_State = PluginAPIMgr.GetCameraState();
		IsInCall = ProcMgr.GetIsInCall();	

		alert("Type = " + Type);
		alert("IS_PSTN = " + IS_PSTN);
		alert("Identity = " + this.CurHistoryIdentity);
		alert("Camera_State = " + Camera_State);
		alert("IS_CONFERENCE = " + IS_CONFERENCE);		
		
	}
		

	if(Type == "1"){
		
		alert("VOICEMAIL_TYPE");
		CurButtonType = HISTORY_BUTTON_MODE.VOICEMAIL_TYPE;	
		
		var totalDurationTime = PluginAPIMgr.GetHistoryPropWithIndex(nCurHistoryIndex,ENUM_HISTORY_PROPERTY.P_DURATION);
		this.DurationTime = g_Data.TransDuration(totalDurationTime);		
		this.DurationLabel.SetTextLayer(1,this.DurationTime);
	}
	else{
		
		var video_available;

		if(!(Camera_State == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || Camera_State == ENUM_CAM_STATE.CAM_STATE_CONNECTING))
		{		
			video_available = true
		}
		else{
			
			video_available = false;
		}
		
		if(IS_PSTN == "1" || this.CurHistoryIdentity == 'echo123' || video_available == false){
			
			alert("ONLY_VOICE_CALL_TYPE");
			CurButtonType = HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE;
			
		}
		else{

			alert("NORMAL_TYPE")
			CurButtonType = HISTORY_BUTTON_MODE.NORMAL_TYPE;
			
		}	
				
	}

				
    this.PrevButtonMode = this.ButtonMode;
	this.ButtonMode = CurButtonType;
	
	this.InitButtons();

}

HistoryFuncButtons.prototype.MovePosition = function() {

	var tempY = (this.CurPosition * NORMAL_ITEM_H);	
	var TopP = tempY + 'px';
	
	$("#"+ this.Frame.GetBGLayer().Obj).css('top', TopP );
	
}

HistoryFuncButtons.prototype.InitButtons = function(CurButtonType) {
    
	alert("HistoryFuncButtons.InitButtons");
	
	if(this.PrevButtonMode == this.ButtonMode) {
		alert("Not Changed");
		return;
	}
	
	this.ReSetHighlight();	
	
	if(this.ButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE){

		if(this.PrevButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
			
			this.VideoButton.blur();
		}		
		else if(this.PrevButtonMode == HISTORY_BUTTON_MODE.VOICEMAIL_TYPE){
			
			this.DurationLabel.Hide();			
			this.PlayStopButton.Hide();			
						
			this.VideoButton.Show();
			this.VoiceButton.Show()

		}
		//Nothing 
		else {
			this.VideoButton.Show();
			this.VoiceButton.Show()
		}

	}
	else if(this.ButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
		
		if(this.PrevButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE){
			
			this.VideoButton.dim();
		}			
		else if(this.PrevButtonMode == HISTORY_BUTTON_MODE.VOICEMAIL_TYPE){
			
			this.DurationLabel.Hide();							
			this.PlayStopButton.Hide();			
						
			this.VideoButton.Show();
			this.VoiceButton.Show()

			this.VideoButton.dim();

		}
		//nothing
		else {
			this.VideoButton.Show();
			this.VoiceButton.Show()

			this.VideoButton.dim();
		}		

	}
	else if(this.ButtonMode == HISTORY_BUTTON_MODE.VOICEMAIL_TYPE){
		
		alert("this.ButtonMode == HISTORY_BUTTON_MODE.VOICEMAIL_TYPE");
		if(this.PrevButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE)
		{
			this.VideoButton.Hide();
			this.VoiceButton.Hide()
			
			this.DurationLabel.Show();
			this.PlayStopButton.Show();				
		}
		else if(this.PrevButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
			alert("this.PrevButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE");
			this.VideoButton.Hide();
			this.VoiceButton.Hide()

			this.VideoButton.blur();
			
			this.DurationLabel.Show();						
			this.PlayStopButton.Show();						
		}			
		//nothing
		else {
			this.DurationLabel.Show();
			this.PlayStopButton.Show();					
		}
	}	
			
}

HistoryFuncButtons.prototype.Highlight = function(){

	alert("HistoryFuncButtons.Highlight");
	
	if(this.CurHistoryIndex < 0){
		alert("Error!! (CurHistoryIndex < 0 )");
		return;
	}


	if(this.flag_Focus){
		//initialize highlight
		if(this.ButtonMode != this.PrevButtonMode){		
			
			this.InitializeHighlight();	
		}		
	}	
    else if(this.LastHighlightButton && this.LastHighlightButton.GetState() == BUTTON_BASE_STATE.SELECT)
    {
		alert("unSelect!!!");
        this.LastHighlightButton.highlight();
        this.LastHighlight = this.LastHighlightButton.GetID();
    }
	else if(this.LastHighlightButton){
		this.LastHighlightButton.highlight();
		this.LastHighlight = this.LastHighlightButton.GetID();
	}		
    else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.NO_ONE){
		
          this.InitializeHighlight();     
    }
	
	this.flag_Focus = true;
	this.CurSubScene = null;
}

HistoryFuncButtons.prototype.Blur = function(){	
	alert("HistoryFuncButtons.Blur");	
	
	//check case at return scene
	if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST){
		
		if(this.LastHighlightButton){
			
			this.LastHighlightButton.select();
		}
		
	}
	//return main ....
	else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.NO_ONE){
		
		//highlight button change to blur
		if(this.LastHighlightButton){			
		    this.LastHighlightButton.blur();
			this.LastHighlightButton = null;			
		}
	}
	else if(this.LastHighlightButton){			
	    this.LastHighlightButton.blur();			
	}	

	this.flag_Focus = false;
	
}

HistoryFuncButtons.prototype.InitializeHighlight = function(){

	//09.01
	//prev highlight blur....
	if(this.LastHighlightButton && this.LastHighlightButton.GetState() == BUTTON_BASE_STATE.HIGHLIGHT){
		this.LastHighlightButton.blur();
	}		
			
	alert("InitializeHighlight");
	
    if(this.ButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE)
    {		
        this.VideoButton.highlight();
        this.LastHighlightButton = this.VideoButton;
        this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON;             
        
    }
    else if(this.ButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE)
    {
        this.VoiceButton.highlight();
        this.LastHighlightButton = this.VoiceButton;
        this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON;            
    }
    else if(this.ButtonMode == HISTORY_BUTTON_MODE.VOICEMAIL_TYPE)
    {			
        this.PlayStopButton.highlight();
        this.LastHighlightButton = this.PlayStopButton;
        this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.PLAY_BUTTON;
    } 	

}


HistoryFuncButtons.prototype.KeyProcess = function (keyCode) {
	
	alert("HistoryFuncButtons.KeyProcess");
	switch (keyCode) {

		case $.sfKey.LEFT:
			alert("KEY_LEFT");
			this.processLeftKey();
			break;	
			
		case $.sfKey.RIGHT:
			alert("KEY_RIGHT");
			this.processRightKey();
			break;
			
		case $.sfKey.ENTER:
			alert("KEY_ENTER");
			this.processEnterKey();
			break;
		
		case $.sfKey.TOOLS:
			alert("KEY_TOOLS");
			this.processToolKey();
			break;
			
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.processReturnKey();
			$.sfKey.block(event);
			break;	
			
		case $.sfKey.EXIT:
			alert("KEY_EXIT");			
			StateMgr.Start_Exit_State(false);
			$.sfKey.block(event);
			break;	
			
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
            
         default:
            ProcMgr.processBlockKey(keyCode);
            break;  

	}
	
}

HistoryFuncButtons.prototype.processLeftKey = function() {
    
	if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON) {

	    this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;		        
		WndMgr.ReturnSubToMain();
			
	}
	else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON) {
	
		if(this.ButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE)
		{
			this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON;
			
			this.VideoButton.highlight();
			this.LastHighlightButton = this.VideoButton;
			
			this.VoiceButton.blur();		
		}
		else if(this.ButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
			
		    this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;		        
			WndMgr.ReturnSubToMain();			
		}
		
				
	}
	else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.PLAY_BUTTON) {

	    this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;		        
		WndMgr.ReturnSubToMain();
				
	}	
}

HistoryFuncButtons.prototype.processRightKey = function() {
    
	if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON) {
		
		this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON;
		
		this.VideoButton.blur();		
		this.VoiceButton.highlight();
		
		this.LastHighlightButton = this.VoiceButton;
				
	}
}


HistoryFuncButtons.prototype.processReturnKey = function() {
    
	alert("HistoryFuncButtons.processReturnKey");

    this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;		        
	WndMgr.ReturnSubToMain();
		
}

HistoryFuncButtons.prototype.processToolKey = function() {

	var IsInCall = ProcMgr.GetIsInCall();
	
	if (IsInCall) {
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL_IN_HISTORY_LIST);
	}
	else {

		this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;
				
		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.HISTORY_LIST);
		
		//this.CurSubScene = 'ListMainHistoryToolList';

	}
    


}

HistoryFuncButtons.prototype.processEnterKey = function() {
    
	alert("HistoryName = " + this.CurHistoryIdentity);
	
	if(this.CurHistoryIdentity == null){
		
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_HISTORY_LIST);
		return;
	}	

	if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON) {
		
		this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;	

		var ReturnScene = $.sfScene.get('ListMainHistory');
		ReturnScene.Deactivation();
		
		ProcMgr.CreateCall( this.CurHistoryIdentity ,1);
							
	}
	else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON) {

		var ReturnScene = $.sfScene.get('ListMainHistory');
		ReturnScene.Deactivation();

		if(this.ButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
			
			this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.NO_ONE;	
			
			ProcMgr.CreateCall( this.CurHistoryIdentity ,0);
						
		}		
		else{

			this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;
										
			StateMgr.Show_ContactPhoneNumberList('ListMainHistory',this.CurPosition,this.CurHistoryIdentity);

			this.CurSubScene = 'ListMainContactPhoneNumberList';		
	
		}

	}
	else if(this.LastHighlight == HISTORY_BUTTON_HIGHLIGHT.PLAY_BUTTON) {
		
		//TEMPCODE
		var IsInCall = ProcMgr.GetIsInCall();
		
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_HISTORY_LIST);
		}
		else{
			
			if(this.IS_PLAY_BTN){
				this.PushPlayBtn();
			}
			else{
				this.PushStopBtn();
			}
		}		
				
	}	
	
}


HistoryFuncButtons.prototype.SetPlayBtn = function(){

	alert("HistoryFuncButtons.SetPlayBtn");
	this.PlayStopButton.SetText(SID_PLAY);
	this.PlayStopButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_PLAY_ICON);		
	this.IS_PLAY_BTN = true;
	
}

HistoryFuncButtons.prototype.SetStopBtn = function(){

	alert("HistoryFuncButtons.SetStopBtn");
	this.PlayStopButton.SetText(SID_STOP);
	this.PlayStopButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_STOP_ICON);		
	this.IS_PLAY_BTN = false;
}

HistoryFuncButtons.prototype.PushPlayBtn = function(){
	
	alert("HistoryFuncButtons.PushPlayBtn");
	
	
	//if(PluginAPIMgr.PlayHistoryVoicemail(this.CurHistoryIndex)== '1')
	if(ProcMgr.PlayHistoryVoicemail(this.CurHistoryIndex)== '1')
	{

		var scene = $.sfScene.get("ListMainHistory");
		scene.StartVMPlay();	
		this.SetStopBtn();
		
		this.DurationLabel.SetTextLayer(1,SID_CHECKING_NETWORK_STATUS);		
			
	}
	else
	{
		
		this.VMStatus = ENUM_VOICE_MAIL_STATUS.FAILED;	
		this.DurationLabel.SetTextLayer(1,IDWS_MOIP_VOICEMAIL_FAILED);	
	}
	
}

HistoryFuncButtons.prototype.PushStopBtn = function(){
	
	alert("HistoryFuncButtons.PushStopBtn");
	
	if(this.flag_Waiting_VM_event == false){
		
		this.flag_Waiting_VM_event = true;
		this.DurationLabel.SetTextLayer(1,TV_SID_WAITING_DOT);	
		
		alert("StopHistoryVoicemail");
		ProcMgr.StopHistoryVoicemail(this.CurHistoryIndex);	
	}
	
	
}

HistoryFuncButtons.prototype.FinishVMPlay = function(bSucess){
	
	alert("HistoryFuncButtons.FinishVMPlay");
		
	this.SetPlayBtn();
	
	if(bSucess){
		this.VMStatus = ENUM_VOICE_MAIL_STATUS.PLAYED;	
		this.DurationLabel.SetTextLayer(1,this.DurationTime);
	}
	else{
		this.VMStatus = ENUM_VOICE_MAIL_STATUS.FAILED;	
		this.DurationLabel.SetTextLayer(1,IDWS_MOIP_VOICEMAIL_FAILED);
	}
	
	//resume key
	var scene = $.sfScene.get("ListMainHistory");
	scene.StopVMPlay();
	
	this.flag_Waiting_VM_event = false;	
	
}

HistoryFuncButtons.prototype.ProcessVM = function(EventType){
	alert("HistoryFuncButtons.ProcessVM(" + EventType + ")");

	switch(EventType) {
		case ENUM_VOICE_MAIL_STATUS.BUFFERING:		
			this.DurationLabel.SetTextLayer(1,IDWS_MOIP_SKYPE_BUFFERING);
			this.VMStatus = ENUM_VOICE_MAIL_STATUS.BUFFERING;
			break;
			
		case ENUM_VOICE_MAIL_STATUS.PLAYING:
			if(this.VMStatus == ENUM_VOICE_MAIL_STATUS.BUFFERING){
				this.VMStatus = ENUM_VOICE_MAIL_STATUS.PLAYING;			
			}
			break;
			
		case ENUM_VOICE_MAIL_STATUS.PLAYED:
			this.FinishVMPlay(true);	
			break;		
			
		case ENUM_VOICE_MAIL_STATUS.UNPLAYED:
			this.FinishVMPlay(false);
			break;
			
		case ENUM_VOICE_MAIL_STATUS.FAILED:
			this.FinishVMPlay(true);
			break;
			
		case ENUM_VOICE_MAIL_STATUS.DELETING:
			break;		
			
		case ENUM_VOICE_MAIL_STATUS.BLANK:
			break;				
	}
}


HistoryFuncButtons.prototype.ProgressPlayBack = function(strTime){
	
	this.DurationLabel.SetTextLayer(1,strTime);	 
}

HistoryFuncButtons.prototype.HideSubScene = function(){
	
	if(this.CurSubScene){
		$.sfScene.hide(this.CurSubScene); 
	}   
}

HistoryFuncButtons.prototype.ReSetHighlight = function(){

	//unselect
    if(this.LastHighlightButton)
    {
        this.LastHighlightButton.blur();
    }
	
	//reset lighlight
	this.LastHighlight			= HISTORY_BUTTON_HIGHLIGHT.NO_ONE;
	this.LastHighlightButton	= null;
	
}

HistoryFuncButtons.prototype.MoveToVideoCallBtn = function(){
	
	alert("HistoryFuncButtons.MoveToVideoCallBtn");
		
	if(this.ButtonMode == HISTORY_BUTTON_MODE.NORMAL_TYPE)
	{
		this.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VIDEO_BUTTON;
		this.VoiceButton.blur();
		this.LastHighlightButton = this.VideoButton;		
	}
	else
	{
		alert("ButtonMode has no video button");
	}

}

HistoryFuncButtons.prototype.MoveToChatBtn = function(){
	
	alert("HistoryFuncButtons.MoveToChatBtn");	
	
}

HistoryFuncButtons.prototype.ClickVideoButton = function(){
	alert("HistoryFuncButtons.ClickVideoButton");	

	var ReturnScene = $.sfScene.get('ListMainHistory');
	ReturnScene.Deactivation();
	
	var This_ = ReturnScene.list.FuncPopup;
	
    if(This_.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		This_.flag_Focus = true;
		This_.CurSubScene = null;			
	}
	
	if(This_.LastHighlightButton)
	{
		This_.LastHighlightButton.blur();
	}
	
	This_.LastHighlightButton = This_.VideoButton;
	This_.VideoButton.highlight();	
	This_.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.NO_ONE;

	ProcMgr.CreateCall( This_.CurHistoryIdentity ,1);
	
}


HistoryFuncButtons.prototype.ClickVoiceButton = function(){
	alert("HistoryFuncButtons.ClickVoiceButton");	

	var ReturnScene = $.sfScene.get('ListMainHistory');
	ReturnScene.Deactivation();
	
	var This_ = ReturnScene.list.FuncPopup;

    if(This_.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		This_.flag_Focus = true;
		This_.CurSubScene = null;			
	}

	if(This_.LastHighlightButton)
	{
		This_.LastHighlightButton.blur();
	}
	
	This_.LastHighlightButton = This_.VoiceButton;
	This_.VoiceButton.highlight();
	This_.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.VOICE_BUTTON;

	if (This_.ButtonMode == HISTORY_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) {
		
		ProcMgr.CreateCall( This_.CurHistoryIdentity ,0);
	}
	else{
							
		This_.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;
		
		alert("CurPosition = " + This_.CurPosition);			
		StateMgr.Show_ContactPhoneNumberList('ListMainHistory',This_.CurPosition,This_.CurHistoryIdentity);										

		This_.CurSubScene = 'ListMainContactPhoneNumberList';
		
	}
}

HistoryFuncButtons.prototype.ClickChatButton = function(){
	alert("HistoryFuncButtons.ClickChatButton");	
}

HistoryFuncButtons.prototype.ClickPlayStopButton = function(){
	alert("HistoryFuncButtons.ClickPlayStopButton");	

	var ReturnScene = $.sfScene.get('ListMainHistory');

	var This_ = ReturnScene.list.FuncPopup;

    if(This_.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		This_.flag_Focus = true;
		This_.CurSubScene = null;			
	}

	if(This_.LastHighlightButton)
	{
		This_.LastHighlightButton.blur();
	}
		
	This_.LastHighlightButton = This_.PlayStopButton;
	This_.PlayStopButton.highlight();
	This_.LastHighlight = HISTORY_BUTTON_HIGHLIGHT.PLAY_BUTTON;
		

	var IsInCall = ProcMgr.GetIsInCall();
	
	if(IsInCall){
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_HISTORY_LIST);
	}
	else{

		if(This_.IS_PLAY_BTN){
			This_.PushPlayBtn();
		}
		else{
			This_.PushStopBtn();
		}
	}
}


