
function SceneAddAssignedPhoneLabelSeletor(options) {

	this.options = options;	
	
	this.list	= null;
	
	this.CurIndex	= -1;

	//this.AssignedLabelType = null;
	
	this.Callback = null;
}

SceneAddAssignedPhoneLabelSeletor.prototype.initialize = function () {
	alert("SceneAddAssignedPhoneLabelSeletor.initialize()");	
	this.create();
}

SceneAddAssignedPhoneLabelSeletor.prototype.handleShow = function () {
	alert("SceneAddAssignedPhoneLabelSeletor.handleShow()");

	this.list.Show();
}

SceneAddAssignedPhoneLabelSeletor.prototype.handleHide = function () {
	alert("SceneAddAssignedPhoneLabelSeletor.handleHide()");
	
	this.list.Hide();

}

SceneAddAssignedPhoneLabelSeletor.prototype.handleFocus = function () {
	alert("SceneAddAssignedPhoneLabelSeletor.handleFocus()");

	if(this.list.GetCurrentDataIndex() != this.CurIndex){
		this.list.SetHighlightForDataIndex(this.CurIndex);	
	}
	else {		
		this.list.highlight();
	}
	
}

SceneAddAssignedPhoneLabelSeletor.prototype.handleBlur = function () {
	alert("SceneAddAssignedPhoneLabelSeletor.handleBlur()");
	
	this.list.blur();
}

SceneAddAssignedPhoneLabelSeletor.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneAddAssignedPhoneLabelSeletor.handleKeyDown(" + keyCode + ")");
PluginAPIMgr.PlayAudio(keyCode);
	switch(keyCode){
    
		case $.sfKey.ENTER:
			alert("KEY_ENTER");
			this.ResetCallerSceneTimer();
			var Index = this.list.GetCurrentDataIndex();
			this.ProcessCallback(Index);			
			//this.ProcessKeyEnter();
			break;			
                   
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			this.ResetCallerSceneTimer();
			this.ProcessKeyReturn();
			$.sfKey.block(event);			
			break;
			
		case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;	
			
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default :
			if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
			{
				this.ResetCallerSceneTimer();	
			}
			
			this.list.KeyProcess(keyCode);	
			break;	
		                   
    }
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAddAssignedPhoneLabelSeletor.prototype.create = function(){
    alert("SceneAddAssignedPhoneLabelSeletor.create() ");


	this.list = new List();
	this.list.CreateBG("LabelList");
	this.list.SetBGImage(g_Image.IMAGE_LIST_MAIN_ADD_PHONE_NUMBER_LABEL_LIST_BG);	
	this.list.SetNumOfVisibleItem(4);
    this.list.SetStartDataIndex(0);	
	this.list.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.list.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.SELECTOR_ITEM_HIGHLIGHT);
	this.list.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cLabelListItem_Text_normal_style");
	this.list.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cLabelListItem_Text_Highlight_style");
	this.list.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);

	var tempData = [ IDWS_MOIP_MOBILE , null ];				
	this.list.AddData(tempData);

	tempData = [ IDWS_MOIP_OFFICE , null ];				
	this.list.AddData(tempData);

	tempData = [ SID_HOME_KR_HOMEPHONE , null ];				
	this.list.AddData(tempData);

	tempData = [ SID_COUNTRY_OTHER , null ];				
	this.list.AddData(tempData);	

	//Set Click Event
	this.list.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.list.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.list.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.list.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.list.SetClickEventAvailable(WndMgr.MouseClickEnable);
				
	this.list.ShowItem();	
}

SceneAddAssignedPhoneLabelSeletor.prototype.Init = function(LableType,CallbackFunc)
{
	alert("SceneAddAssignedPhoneLabelSeletor.Init()");
	
	this.CurIndex = LableType;
	this.Callback = CallbackFunc;
}


SceneAddAssignedPhoneLabelSeletor.prototype.ProcessKeyReturn = function(){
	alert("SceneAddAssignedPhoneLabelSeletor.ProcessKeyReturn() ");
	
	$.sfScene.focus('AddAssignedPhoneNumber');
	$.sfScene.hide('AddAssignedPhoneLabelSeletor');
}

/*
SceneAddAssignedPhoneLabelSeletor.prototype.ProcessKeyEnter = function(){
	alert("SceneAddAssignedPhoneLabelSeletor.ProcessKeyEnter() ");

	var Index = this.list.GetCurrentDataIndex();
	this.ProcessCallback(Index);	

}
*/

SceneAddAssignedPhoneLabelSeletor.prototype.ResetCallerSceneTimer = function()
{
	alert("SceneAddAssignedPhoneLabelSeletor.ResetCallerSceneTimer() ");	
	$.sfScene.get("AddAssignedPhoneNumber").resetTimer();
}

SceneAddAssignedPhoneLabelSeletor.prototype.ProcessCallback = function(ItemIndex){

	alert("SceneAddAssignedPhoneLabelSeletor.ProcessCallback() -- " + ItemIndex);	
	
	if(this.Callback)
	{
		this.Callback(ItemIndex);
	}
	
	this.ProcessKeyReturn();

}

SceneAddAssignedPhoneLabelSeletor.prototype.onClickEventFunc1 = function(){
	
	var This_ = $.sfScene.get("AddAssignedPhoneLabelSeletor");	
	This_.ProcessCallback(0);
}

SceneAddAssignedPhoneLabelSeletor.prototype.onClickEventFunc2 = function(){

	var This_ = $.sfScene.get("AddAssignedPhoneLabelSeletor");	
	This_.ProcessCallback(1);
}

SceneAddAssignedPhoneLabelSeletor.prototype.onClickEventFunc3 = function(){
	
	var This_ = $.sfScene.get("AddAssignedPhoneLabelSeletor");	
	This_.ProcessCallback(2);
}

SceneAddAssignedPhoneLabelSeletor.prototype.onClickEventFunc4 = function(){
	
	var This_ = $.sfScene.get("AddAssignedPhoneLabelSeletor");	
	This_.ProcessCallback(3);
}

