function SceneAddContactPhoneNumber(options) {
	this.options = options;
    
    this.AddContactPhoneNumberView=null;
	this.AddContactPhoneNumberDim=null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;
    
    this.NameLabel = null;
    this.TextInputBox = null;
    
    this.PhoneNumberLabel = null;
    this.CountryCodeBtn=null;
    this.ArrowLabel = null;
    this.PhoneNumberInputBox=null;
    
    this.flagPWD = false;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    
    this.flagInit = false;
	this.CountryPrefix = "";
    this.CountryCode ="";
    
    this.flagResetData = true;
    
	this.ShownFlagList = false;
		
    this.DefaultHelpBar =null;
    this.InputHelpBar =null;
    this.NumberInputHelpBar =null;
    this.NumberInputDefaultHelpBar = null;
	
	this.CloseTimer = false;
	this.isAddEnable = false;

	this.isCountryHelpBarInsertClickEvent = false;	
	
	this.CountryListHelpBar = null;
    
}

SceneAddContactPhoneNumber.prototype.initialize = function () {
	alert("SceneAddContactPhoneNumber.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneAddContactPhoneNumber.prototype.handleShow = function () {
	alert("SceneAddContactPhoneNumber.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.AddContactPhoneNumberDim.show();
	
    if(this.flagResetData==true)
    {
        this.resetData();
    }
    
	var ThisScene = $.sfScene.get("AddContactPhoneNumber");
	$.sfScene.get("CountryFlagList").Init(FLAG_LIST_TYPE.ADD_CONTACT_PHONENUMBER,'AddContactPhoneNumber',ThisScene.SetCountryFlag,ThisScene.HideCountryHelpbar);	

	this.startTimer();
}

SceneAddContactPhoneNumber.prototype.handleHide = function () {
	alert("SceneAddContactPhoneNumber.handleHide()");
	// this function will be called when the scene manager hide this scene  
	
	this.AddContactPhoneNumberDim.hide();
	
	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
	if(	this.ShownFlagList == true){
		
		this.CountryListHelpBar.hiddenObj();
		$.sfScene.hide('CountryFlagList');
	}
}

SceneAddContactPhoneNumber.prototype.handleFocus = function () {
	alert("SceneAddContactPhoneNumber.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	if(this.CloseTimer==false)
	{
		this.startTimer();
	}
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.TextInputBox);
    }
    else
    {
        this.highlight(currentHighlight);
    }
	
	this.ShownFlagList = false;
}

SceneAddContactPhoneNumber.prototype.handleBlur = function () {
	alert("SceneAddContactPhoneNumber.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var  obj = this.AddContactPhoneNumberView.getCurrentHighlight();
	if(obj != null)
	{
		obj.blur();	
	}    
}

SceneAddContactPhoneNumber.prototype.handleKeyDown = function (keyCode) {
	alert("SceneAddContactPhoneNumber.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			 this.resetTimer();
             this.processLeftRightKey();
			break;
		case $.sfKey.UP:
		case $.sfKey.DOWN:
			this.resetTimer();
            this.processUpDownKey();
			break;

		case $.sfKey.ENTER:
			 this.resetTimer();
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case $.sfKey.EXIT:
         	this.processExitKey();
            $.sfKey.block(event);
			break;
            
          case 147:  //infolink
          case 261:  //contents
          case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAddContactPhoneNumber.prototype.create = function(){
    alert("SceneAddContactPhoneNumber.create()");
    this.AddContactPhoneNumberView = new View("AddContactPhoneNumber");
    this.AddContactPhoneNumberView.SetBgImage(g_Image.IMAGE_ADD_CONTACT_PHONENUMBER_BG);
	
	this.AddContactPhoneNumberDim = new DimBg("AddContactPhoneNumberDim", "AddContactPhoneNumber");
    
    this.TitleBar = new Label(null,"add_contact_phone_number_title");
    this.TitleBar.SetTextStyle("add_contact_phone_number_title_style");
    this.TitleBar.SetText(IDWS_MOIP_SKYPE_ADD_A_PHONE_NUMBER);
   
    this.MsgLabel = new Label(null,"add_contact_phone_number_msg");
    this.MsgLabel.SetTextStyle("add_contact_phone_number_msg_style");
    this.MsgLabel.SetText(IDWS_MOIP_ENTER_ORDINARY_PHONE_NUMBER);
    
    this.NameLabel = new Label(null,"add_contact_phone_number_name_text");
    this.NameLabel.SetTextStyle("add_contact_phone_number_name_text_style");
    this.NameLabel.SetText(SID_NAME);
    
    var this_ = $.sfScene.get("AddContactPhoneNumber");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.TextInputBox= new Button();
    this.TextInputBox.SetImageObjId("add_contact_phone_number_name_input_box");
    this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_INPUT_BOX_NORMAL);
    this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_INPUT_BOX_NORMALFOCUS);
    this.TextInputBox.SetTextObjId("add_contact_phone_number_name_input_box_text");
    this.TextInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"add_contact_phone_number_btn_style");
    this.TextInputBox.SetMaxStringLength(50);//(100);
    this.TextInputBox.SetIsPlainText(true);
        
	var CurLangID = ResMgr.GetCurLanguage();    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.TextInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "add_contact_phone_number_btn_help_large_style");
	}
	else
	{
		this.TextInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "add_contact_phone_number_btn_help_style");
	}    
    this.TextInputBox.SetTextEditorInfo(IDWS_MOIP_SKYPE_ADD_A_PHONE_NUMBER, ADD_CONTACT_KEYPAD_HELP_ENTER_NAME_TO_SAVE);
    this.TextInputBox.SetOnClickCallbackFunc(clickCF);
    
    this.PhoneNumberLabel = new Label(null,"add_contact_phone_number_text");
    this.PhoneNumberLabel.SetTextStyle("add_contact_phone_number_text_style");
    this.PhoneNumberLabel.SetText(IDWS_MOIP_PHONE_NUMBER);
    
    this.CountryCodeBtn = new Button();
    this.CountryCodeBtn.SetImageObjId("add_contact_phone_number_country_code_btn");
    this.CountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMAL);
    this.CountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMALFOCUS);	
    this.CountryCodeBtn.AppendFgImage("add_contact_phone_number_country_code_btn_icon","13px","11px","37px","27px");
    this.CountryCodeBtn.SetOnClickCallbackFunc(clickCF);
    
    this.ArrowLabel= new Label("add_contact_phone_number_arrow_down", null);
    this.ArrowLabel.SetBgImage(g_Image.IMAGE_ADD_CONTACT_ALLOW_ICON);

	var scene = $.sfScene.get("AddContactPhoneNumber");
    this.PhoneNumberInputBox= new NumberInputBox();
    this.PhoneNumberInputBox.SetButtonObjId("add_contact_phone_number_input_box");
    this.PhoneNumberInputBox.SetButtonTextObjId("add_contact_phone_number_input_text");
    this.PhoneNumberInputBox.SetInputBoxObjId("add_contact_phone_number_input_text_editor");
    this.PhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMAL);
    this.PhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMALFOCUS);   
    this.PhoneNumberInputBox.setPrevEventOnLeftFunc(function(){scene.moveToCountryCodeBtn(); scene.resetTimer();});
    this.PhoneNumberInputBox.setPrevEventOnRightFunc(function(){scene.moveToCountryCodeBtn(); scene.resetTimer();});
    this.PhoneNumberInputBox.setPrevEventOnDownFunc(function(){scene.moveToNameInputBox(); scene.resetTimer();});
    this.PhoneNumberInputBox.setPrevEventOnUpFunc(function(){scene.moveToNameInputBox(); scene.resetTimer();});
    this.PhoneNumberInputBox.setPrevEventOnReturnFunc(function(){scene.processReturnKey()});
    this.PhoneNumberInputBox.setPrevEventOnExitFunc(function(){scene.processExitKey()});
    this.PhoneNumberInputBox.setEnterFunc(function(){scene.processEnterKey()});
	this.PhoneNumberInputBox.setAnyKeyFunc(function(keyCode){scene.checkAddEnable(); scene.resetTimer();});
    this.PhoneNumberInputBox.SetOnClickCallbackFunc(clickCF);
    this.PhoneNumberInputBox.SetReverseDisable(true);
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_PHONE_NUMBER,"AddContactPhoneNumber");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.InputHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT_TEXT,"AddContactPhoneNumber");
    this.InputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startTextInput();});
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.NumberInputHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT,"AddContactPhoneNumber");
    this.NumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
	this.NumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processEnterKey();});
    this.NumberInputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
	this.NumberInputDefaultHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT_DEFAULT,"AddContactPhoneNumber");
	this.NumberInputDefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
	this.NumberInputDefaultHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
	
    this.CountryCodeBtn.registHelpBar( this.DefaultHelpBar);
    this.PhoneNumberInputBox.registHelpBar( this.NumberInputHelpBar);
    this.TextInputBox.registHelpBar( this.InputHelpBar);
}

SceneAddContactPhoneNumber.prototype.setResetFlag= function(reset_flag){
     this.flagResetData = reset_flag;
}

SceneAddContactPhoneNumber.prototype.resetData = function()
{
    this.highlight(null);
      
    this.CountryCode = PluginAPIMgr.GetMyCountryCode();
    this.CountryPrefix = PluginAPIMgr.GetISOCountryPrefix(this.CountryCode);
    this.CountryCodeBtn.SetFgImage(PluginAPIMgr.GetMyCountryFlag());
    
    this.TextInputBox.SetText("");
    this.PhoneNumberInputBox.setInitString("");

	this.checkAddEnable();
    this.flagResetData= false;
}

SceneAddContactPhoneNumber.prototype.highlight=function(obj)
{
    this.AddContactPhoneNumberView.setCurrenHighlight(obj);
}

SceneAddContactPhoneNumber.prototype.startTextInput = function(){
    alert("SceneAddContactPhoneNumber.startTextInput() ");
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.TextInputBox:
        
        	if(this.CloseTimer==true)
			{
				this.stopTimer();
			} 
			
            WndMgr.StartTextEditor(this.TextInputBox, "AddContactPhoneNumber", this.AddContactPhoneNumberDim);
            break;            
    }    
}

SceneAddContactPhoneNumber.prototype.processLeftRightKey = function(){
    alert("SceneAddContactPhoneNumber.processLeftRightKey() ");
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CountryCodeBtn:
            this.highlight(this.PhoneNumberInputBox);
            break;
    }
}

SceneAddContactPhoneNumber.prototype.processUpDownKey = function(){
    alert("SceneAddContactPhoneNumber.processUpDownKey() ");
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.TextInputBox:        
            this.highlight(this.CountryCodeBtn);
            break;
            
        case this.CountryCodeBtn:
            this.highlight(this.TextInputBox);
            break;
    }
}

SceneAddContactPhoneNumber.prototype.processEnterKey = function()
{

    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
     switch(currentHighlight)
    {
        case this.TextInputBox:  
			this.startTextInput();
            break;
            
         case this.CountryCodeBtn:
            this.showFlagList();	
          break;
          
        case this.PhoneNumberInputBox:  
            var input_phone_number = this.PhoneNumberInputBox.GetText(); 
            if(input_phone_number.length >0)
            {
                var add_prefix_phone_number = this.addCountryPrefix(input_phone_number);
                alert("add_prefix_phone_number : " + add_prefix_phone_number);
                var normalized_phone_number = PluginAPIMgr.NormalizeIdentity(add_prefix_phone_number);
				
				this.highlight(null);
				$.sf.returnFocus();
				
				if(normalized_phone_number.length > 0)
				{
				   var is_emergency_call = PluginAPIMgr.IsEmergencyCall(normalized_phone_number);
				   if(is_emergency_call == 1)
				   {
				   		ProcMgr.AddSkypeOutContact( "", this.TextInputBox.GetText());
				   }
				   else
				   {
				   		ProcMgr.AddSkypeOutContact( normalized_phone_number, this.TextInputBox.GetText());
				   }
				}
				else
				{
					ProcMgr.AddSkypeOutContact( normalized_phone_number, this.TextInputBox.GetText());
				}
            }         
          break;
    }
}

SceneAddContactPhoneNumber.prototype.addCountryPrefix = function(input_phone_number){
    alert("SceneAddContactPhoneNumber.addCountryPrefix() --> this.CountryPrefix : "+ this.CountryPrefix);

    if(input_phone_number.indexOf("+") ==0)
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("00") ==0 )
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("011") ==0)
    {
        return input_phone_number;
    }
    else
    {
		if(this.CountryPrefix != "0")
		{
			return  "+"+this.CountryPrefix + input_phone_number;
		}
		else
		{
			return  input_phone_number;
		}        
    }   
}

SceneAddContactPhoneNumber.prototype.checkAddEnable = function()
{
    var input_text = this.PhoneNumberInputBox.GetText();
    
    if(input_text.length ==0)
    {
        this.isAddEnable = false;
    }
    else
    {

        this.isAddEnable = true;
    }
    
    if(this.isAddEnable == true)
    {
        this.PhoneNumberInputBox.changeHelpBar( this.NumberInputHelpBar);
    }   
    else
    {
		this.PhoneNumberInputBox.changeHelpBar( this.NumberInputDefaultHelpBar);
    }
    
    alert("SceneChatMsgSend.checkAddEnable()  :  " +this.isAddEnable);
}

SceneAddContactPhoneNumber.prototype.processReturnKey = function(){
    alert("SceneAddContactPhoneNumber.processReturnKey() ");
	this.highlight(null);
    WndMgr.BackStepAddContact();
	$.sfKey.block(event);
}

SceneAddContactPhoneNumber.prototype.processExitKey = function(){
    alert("SceneAddContactPhoneNumber.processExitKey() ");
	this.highlight(null);
    StateMgr.Stop_Add_Contact_State(true);
	$.sfKey.block(event);
}

SceneAddContactPhoneNumber.prototype.moveToCountryCodeBtn = function()
{
    alert("SceneAddContactPhoneNumber.moveToCountryCodeBtn() ");
    
    this.highlight(this.CountryCodeBtn);
   	$.sfScene.focus('AddContactPhoneNumber');
    //$.sf.returnFocus();
}

SceneAddContactPhoneNumber.prototype.moveToNameInputBox = function()
{
    alert("SceneAddContactPhoneNumber.moveToNameInputBox() ");
  
    this.highlight(this.TextInputBox);
}

SceneAddContactPhoneNumber.prototype.showFlagList = function()
{
	alert("SceneAddContactPhoneNumber.showFlagList() ");	

	var ThisScene = $.sfScene.get("AddContactPhoneNumber");
	var Index = g_Data.GetCountryIndexWithCode(ThisScene.CountryCode);

	$.sfScene.get("CountryFlagList").SetCurIndex(Index);	
	$.sfScene.show('CountryFlagList');
	$.sfScene.focus('CountryFlagList');
	
	ThisScene.ShownFlagList = true;
	
	if(ThisScene.isCountryHelpBarInsertClickEvent == false)
	{
		ThisScene.CountryListHelpBar = new HelpBar(HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_COUNTRY_LIST,"CountryFlagList");
		ThisScene.CountryListHelpBar.SetOnClickCallbackFunc(1, function(){ThisScene.closeCountryList();});
		
		ThisScene.isCountryHelpBarInsertClickEvent = true;
	}
	
	ThisScene.CountryListHelpBar.visibleObj();
}

SceneAddContactPhoneNumber.prototype.SetCountryFlag = function()
{
    alert("SceneAddContactPhoneNumber.SetCountryFlag() ");
	
	var Scene = $.sfScene.get("CountryFlagList");	
	var FlagImage = Scene.GetCountryFlag();

	var This_ = $.sfScene.get("AddContactPhoneNumber");	
	This_.CountryCodeBtn.SetFgImage(FlagImage );
	This_.CountryPrefix = Scene.GetPrefix();
	This_.CountryCode = Scene.GetCountryCode();

	This_.CountryListHelpBar.hiddenObj();	

}

SceneAddContactPhoneNumber.prototype.HideCountryHelpbar = function()
{
    alert("SceneAddContactPhoneNumber.HideCountryHelpbar() ");
    
	This_ = $.sfScene.get("AddContactPhoneNumber");	
	This_.CountryListHelpBar.hiddenObj();	
}



SceneAddContactPhoneNumber.prototype.startTimer = function()
{
    alert("SceneAddContactPhoneNumber.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('AddContactPhoneNumber').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactPhoneNumber.prototype.resetTimer = function()
{
    alert("SceneAddContactPhoneNumber.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneAddContactPhoneNumber.prototype.stopTimer = function()
{
    alert("SceneAddContactPhoneNumber.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactPhoneNumber.prototype.popupTimerCallback = function()
{
   alert("SceneAddContactPhoneNumber.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	this.highlight(null);
    WndMgr.BackStepAddContact();
}

SceneAddContactPhoneNumber.prototype.processClickEvent = function(obj){
	alert("SceneAddContactPhoneNumber.processClickEvent() ");
	
	this.resetTimer();
	
	var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();

	if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
	if(obj == this.PhoneNumberInputBox)
	{
		return;
	}
    
    this.processEnterKey();	
}

SceneAddContactPhoneNumber.prototype.startKeypad = function(){
    alert("SceneAddContactPhoneNumber.startKeypad() ");
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.PhoneNumberInputBox:
		
		if(this.CloseTimer==true)
		{
			this.stopTimer();
		}
        
        var this_ = $.sfScene.get("AddContactPhoneNumber");
        var stopCF = function(){this_.startTimer();};
        
        WndMgr.StartKeypad(currentHighlight, "AddContactPhoneNumber", stopCF);
        break;            
    }    
}


SceneAddContactPhoneNumber.prototype.inputDelete = function(){
    alert("SceneAddContactPhoneNumber.inputDelete() ");
    
    var currentHighlight =  this.AddContactPhoneNumberView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.PhoneNumberInputBox:
		
		if(this.CloseTimer==true)
		{
			this.resetTimer();
		}	
				        
        currentHighlight.processPreChKey();
        break;            
    }    
}

SceneAddContactPhoneNumber.prototype.closeCountryList = function()
{
	this.CountryListHelpBar.hiddenObj();
	
	$.sfScene.focus('AddContactPhoneNumber');
	$.sfScene.hide('CountryFlagList'); 
   
   
}

