function SceneAddContactSkypeName(options) {
	this.options = options;
    
    this.AddContactSkypeNameView=null;
	this.AddContactSkypeNameDim =null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;
	this.MsgLengthLabel = null;
    
    this.TextInputBox = null;
    
    this.flagPWD = false;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    
    this.flagInit =false;
    
    this.flagResetData= true;
	
	this.isFindEnable= false;
	this.CloseTimer = false;
}

SceneAddContactSkypeName.prototype.initialize = function () {
	alert("SceneAddContactSkypeName.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneAddContactSkypeName.prototype.handleShow = function () {
	alert("SceneAddContactSkypeName.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.AddContactSkypeNameDim.show();
	
	this.TextInputBox.initKeySet();
	
    if(this.flagResetData== true)
    {
        this.resetData();
    }
    
   this.startTimer();
}

SceneAddContactSkypeName.prototype.handleHide = function () {
	alert("SceneAddContactSkypeName.handleHide()");
	// this function will be called when the scene manager hide this scene  
    var obj = this.AddContactSkypeNameView.getCurrentHighlight();
	if(obj != null)
	{
		obj.imeHide();
	}

	this.AddContactSkypeNameDim.hide();	
	
	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneAddContactSkypeName.prototype.handleFocus = function () {
	alert("SceneAddContactSkypeName.handleFocus()");
	// this function will be called when the scene manager focus this scene
    this.highlight(this.TextInputBox);
}

SceneAddContactSkypeName.prototype.handleBlur = function () {
	alert("SceneAddContactSkypeName.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneAddContactSkypeName.prototype.handleKeyDown = function (keyCode) {
	alert("SceneAddContactSkypeName.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneAddContactSkypeName.prototype.create = function(){
    alert("SceneAddContactSkypeName.create()");
    this.AddContactSkypeNameView = new View("AddContactSkypeName");
    this.AddContactSkypeNameView.SetBgImage( WndMgr.Bg_TextEditor.src );
	
	this.AddContactSkypeNameDim = new DimBg("AddContactSkypeNameDim", "AddContactSkypeName");
    
    this.TitleBar = new Label(null,"add_contact_skype_name_title");
    this.TitleBar.SetTextStyle("add_contact_skype_name_title_style");
    this.TitleBar.SetText(IDWS_MOIP_SKYPE_ADD_A_SKYPE_CONTACT);
   
    this.MsgLabel = new Label(null,"add_contact_skype_name_msg");
    this.MsgLabel.SetTextStyle("add_contact_skype_name_msg_style");
    this.MsgLabel.SetText(IDWS_MOIP_ADD_CONTACT_KEYPAD_HELP_ENTER_USER_INFORMATION);
	
	this.MsgLengthLabel = new Label(null,"add_contact_msg_length");
    this.MsgLengthLabel.SetTextStyle("add_contact_msg_length_style");
    this.MsgLengthLabel.SetText("");
    
    this.TextInputBox= new InputBox();
	this.TextInputBox.SetButtonObjId("add_contact_skype_name_input_box");
    this.TextInputBox.SetButtonTextObjId("add_contact_skype_name_input_box_text");
	this.TextInputBox.SetInputBoxObjId("add_contact_skype_name_input_box_editor");
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_INPUT_BOX_NORMAL);
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_INPUT_BOX_NORMALFOCUS);	
	this.TextInputBox.setKeypadPos(675,100);
    this.TextInputBox.setWordBoxPos(236,50);
    
}


SceneAddContactSkypeName.prototype.setResetFlag= function(reset_flag){
     this.flagResetData = reset_flag;
}

SceneAddContactSkypeName.prototype.resetData = function()
{  
	this.isFindEnable= false;
    this.TextInputBox.SetText("");
	this.MsgLengthLabel.SetText("");

    this.flagResetData= false;	
}

SceneAddContactSkypeName.prototype.highlight=function(obj)
{
    this.AddContactSkypeNameView.setCurrenHighlight(obj);
  
    var scene = $.sfScene.get("AddContactSkypeName");
    if(obj == this.TextInputBox)
    {
        if(this.flagInit ==false)
        {
            this.TextInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
            this.flagInit =true;
       }
       else
       {
            this.TextInputBox.initInputBox( this.flagPWD, this.TextInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
       
        var ime = new IMEShell(obj.IMEObjInfo.id, scene.imeReady, 'en' /*, 'en' ,  "2_35_259"*/);
    }
	else
	{
		if(obj == null)
		{
			this.TextInputBox.imeHide();	
		}
	}	 
}

SceneAddContactSkypeName.prototype.processReturnKey = function(){
    alert("SceneAddContactSkypeName.processReturnKey() ");
	this.highlight(null);
	WndMgr.BackStepAddContact();
	$.sfKey.block(event);
}

SceneAddContactSkypeName.prototype.processExitKey = function(){
    alert("SceneAddContactSkypeName.processExitKey() ");
    this.highlight(null);
    StateMgr.Stop_Add_Contact_State(true);
    $.sfKey.block(event);
}

SceneAddContactSkypeName.prototype.initInputBox = function(flagPWD, initText, maxLen, callerObj)
{
    alert("SceneAddContactSkypeName.initInputBox()");
    this.flagPWD = flagPWD;
    this.initText = initText;
    this.maxStringLenght = maxLen;
    this.callerObj = callerObj;
}

SceneAddContactSkypeName.prototype.imeReady = function(imeObject){
	alert("SceneAddContactSkypeName.imeReady() ");
	
	var scene = $.sfScene.get("AddContactSkypeName");
	var obj = scene.AddContactSkypeNameView.getCurrentHighlight();
	
	obj.imeShow(imeObject);
	
	obj.setKeyFunc(88,  function(keyCode){ scene.processReturnKey(); $.sfKey.block(event); return false;}); // return key
	obj.setKeyFunc(45,  function(keyCode){ scene.processExitKey(); $.sfKey.block(event); return false;}); // exit key
	obj.setKeyFunc(108, function(keyCode){ scene.DeleteAllText();  return false;}); // red key
	obj.setKeyFunc(222, function(keyCode){$.sfKey.block(event);  return false;}); // source
	
	obj.setKeyFunc(147, function(keyCode){$.sfKey.block(event);  return false;}); // infolink
	obj.setKeyFunc(261, function(keyCode){$.sfKey.block(event);  return false;}); // contents
	obj.setKeyFunc(115, function(keyCode){$.sfKey.block(event);  return false;}); // wiselink
	
	obj.setEnterFunc( function(keyCode){scene.SearchNewContact() ; return false;});
	
	obj.setOnCompleteFunc(function(keyCode){scene.updateMsgLength(); scene.checkFindEnable(); scene.resetTimer();  return false;});
	obj.setAnyKeyFunc(function(keyCode){scene.resetTimer();  return false;});
	
	obj.setKeySetFunc("qwerty");
	
	obj.setReady();
	
	scene.updateMsgLength();
	scene.checkFindEnable();
}

SceneAddContactSkypeName.prototype.updateMsgLength = function()
{
	alert("SceneAddContactSkypeName.updateMsgLength() ");
    var obj = this.AddContactSkypeNameView.getCurrentHighlight();
    var input_string = obj.getString();
	
	obj.SetText(input_string);
	this.MsgLengthLabel.SetText(String(input_string.length) +"/" +String(this.maxStringLenght));  	
}

SceneAddContactSkypeName.prototype.SearchNewContact = function()
{
    alert("SceneAddContactSkypeName.SearchNewContact() ");
	var search_text = this.TextInputBox.GetText();
	
	if(this.isFindEnable == true)
	{
		this.highlight(null);
		ProcMgr.SearchNewContact(search_text);
	}  
}

SceneAddContactSkypeName.prototype.GetInputText = function()
{
    var obj = this.AddContactSkypeNameView.getCurrentHighlight();
    return obj.getString();
}

SceneAddContactSkypeName.prototype.DeleteAllText = function()
{
	this.resetTimer();
    var obj = this.AddContactSkypeNameView.getCurrentHighlight();
    obj. setString("");
	
	this.updateMsgLength();
	this.checkFindEnable();
}

SceneAddContactSkypeName.prototype.checkFindEnable = function()
{
    var input_text = this.TextInputBox.GetText();
    
    if(input_text.length ==0)
    {
        this.isFindEnable = false;
    }
    else
    {
        var a=0;
        for(a=0; a<input_text.length; a++)
        {
            this.isFindEnable = false;
             var ch = input_text.substring(a,  a+1);
             if(ch !=" ")
             {
                 this.isFindEnable = true;
                 break;
}
        }
    }
        
    alert("SceneAddContactSkypeName.checkFindEnable()  :  " +this.isFindEnable);
}

SceneAddContactSkypeName.prototype.startTimer = function()
{
    alert("SceneAddContactSkypeName.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('AddContactSkypeName').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactSkypeName.prototype.resetTimer = function()
{
    alert("SceneAddContactSkypeName.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneAddContactSkypeName.prototype.stopTimer = function()
{
    alert("SceneAddContactSkypeName.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneAddContactSkypeName.prototype.popupTimerCallback = function()
{
   alert("SceneAddContactSkypeName.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	this.highlight(null);
	WndMgr.BackStepAddContact();
}




