function SceneChangePassword(options) {
	this.options = options;
    
    this.ChangePasswordView=null;
	this.ChangePasswordDim=null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;
    
    this.CurrentPWDLabel = null;
    this.CurrentPWDInputBox = null;
    
    this.NewPWDLabel = null;
    this.NewPWDInputBox = null;
    
    this.RepeatPWDLabel = null;
    this.RepeatPWDInputBox = null;
    
    this.ApplyBtn = null;
    
    this.flagPWD = true;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    
    this.flagCurrentPWDInit = false;
    this.flagNewPWDInit = false;
    this.flagRepeatPWDInit = false;
    
    this.reserveHighlight = null;
    
    this.InitFlag = true;
    
    this.DefaultHelpBar =null;
    this.InputHelpBar =null;
	
	this.CloseTimer = false;
}

SceneChangePassword.prototype.initialize = function () {
	alert("SceneChangePassword.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneChangePassword.prototype.handleShow = function () {
	alert("SceneChangePassword.handleShow()");
	// this function will be called when the scene manager show this scene 
    
    this.ChangePasswordDim.show();
     if(this.InitFlag == true)
    {
        this.initChangePassword();
    }
	
	this.startTimer();
}

SceneChangePassword.prototype.handleHide = function () {
	alert("SceneChangePassword.handleHide()");
	// this function will be called when the scene manager hide this scene  

    this.ChangePasswordDim.hide();

	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneChangePassword.prototype.handleFocus = function () {
	alert("SceneChangePassword.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	if(this.CloseTimer==false)
	{
		this.startTimer();
	}
    
    var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();
    if(currentHighlight ==null && this.reserveHighlight ==null)
    {
        this.highlight(this.CurrentPWDInputBox);
    }
    else
    {
        if(this.reserveHighlight !=null)
        {
             this.highlight(this.reserveHighlight );
             this.reserveHighlight =null;
        }
        else
        {
            this.highlight(currentHighlight);
        }
    }
}

SceneChangePassword.prototype.handleBlur = function () {
	alert("SceneChangePassword.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var  obj = this.ChangePasswordView.getCurrentHighlight();
    obj.blur();
}

SceneChangePassword.prototype.handleKeyDown = function (keyCode) {
	alert("SceneChangePassword.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:
			this.resetTimer();
        	this.processUpKey();
        	break;
		case $.sfKey.DOWN:
			this.resetTimer();
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

          case 147:  //infolink
          case 261:  //contents
          case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneChangePassword.prototype.create = function(){
    alert("SceneChangePassword.create()");
    this.ChangePasswordView = new View("ChangePassword");
    this.ChangePasswordView.SetBgImage(g_Image.IMAGE_CHANGE_PASSWORD_BG);
	
	this.ChangePasswordDim = new DimBg("ChangePasswordDim", "ChangePassword");  
    
    this.TitleBar = new Label(null,"change_password_title");
    this.TitleBar.SetTextStyle("change_password_title_style");
    this.TitleBar.SetText(IDWS_MOIP_CHANGE_PASS);
   
    this.CurrentPWDLabel = new Label(null,"change_password_current_password_text");
    this.CurrentPWDLabel.SetTextStyle("change_password_text_style");
    this.CurrentPWDLabel.SetText(IDWS_MOIP_ENTER_CURRENT_PASS);
    
    this.NewPWDLabel = new Label(null,"change_password_new_password_text");
    this.NewPWDLabel.SetTextStyle("change_password_text_style");
    this.NewPWDLabel.SetText(IDWS_MOIP_ENTER_NEW_PASS);
    
    this.RepeatPWDLabel = new Label(null,"change_password_repeat_password_text");
    this.RepeatPWDLabel.SetTextStyle("change_password_text_style");
    this.RepeatPWDLabel.SetText(IDWS_MOIP_ENTER_RE_NEW_PASS);

	var CurLangID = ResMgr.GetCurLanguage();

 	if(CurLangID == ENUM_TV_LANGUAGE.TAM)
 	{	
		$("#change_password_current_password_text").css('top', "73px" );
		$("#change_password_current_password_input_box").css('top', "89px" );		
		
		$("#change_password_new_password_text").css('top', "140px" );	
		$("#change_password_new_password_input_box").css('top', "156px" );		//-12
		
		$("#change_password_repeat_password_text").css('top', "207px" );
		$("#change_password_repeat_password_input_box").css('top', "242px" ); //+5
	}
	
	var this_ = $.sfScene.get("ChangePassword");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.CurrentPWDInputBox= new Button();
    this.CurrentPWDInputBox.SetImageObjId("change_password_current_password_input_box");
    this.CurrentPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMAL);
    this.CurrentPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMALFOCUS);
    this.CurrentPWDInputBox.SetTextObjId("change_password_current_password_input_box_text", true);
    this.CurrentPWDInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"change_password_input_btn_style");		
    this.CurrentPWDInputBox.SetMaxStringLength(20);
    this.CurrentPWDInputBox.SetMinStringLength(6);
    this.CurrentPWDInputBox.SetIsPlainText(true);      
    this.CurrentPWDInputBox.SetOnTextChangeFunc(function(){this_.checkApplyBtnEnable(); });
        
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.CurrentPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_large_style");
	}
	else
	{
		this.CurrentPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_style");
	}    
    this.CurrentPWDInputBox.SetTextEditorInfo(IDWS_MOIP_CHANGE_PASS, IDWS_MOIP_ENTER_CURRENT_PASS);
    this.CurrentPWDInputBox.SetOnClickCallbackFunc(clickCF);
    
    this.NewPWDInputBox= new Button();
    this.NewPWDInputBox.SetImageObjId("change_password_new_password_input_box");
    this.NewPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMAL);
    this.NewPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMALFOCUS);
    this.NewPWDInputBox.SetTextObjId("change_password_new_password_input_box_text", true);
    this.NewPWDInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"change_password_input_btn_style");
    this.NewPWDInputBox.SetMaxStringLength(20);
    this.NewPWDInputBox.SetMinStringLength(6);
    this.NewPWDInputBox.SetIsPlainText(true);        
    this.NewPWDInputBox.SetOnTextChangeFunc(function(){this_.checkApplyBtnEnable(); });    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.NewPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_large_style");
	}
	else
	{
		this.NewPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_style");
	}        
    this.NewPWDInputBox.SetTextEditorInfo(IDWS_MOIP_CHANGE_PASS, IDWS_MOIP_ENTER_NEW_PASS);
    this.NewPWDInputBox.SetOnClickCallbackFunc(clickCF);
    
    this.RepeatPWDInputBox= new Button();
    this.RepeatPWDInputBox.SetImageObjId("change_password_repeat_password_input_box");
    this.RepeatPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMAL);
    this.RepeatPWDInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CHANGE_PASSWORD_INPUTBOX_NORMALFOCUS);
    this.RepeatPWDInputBox.SetTextObjId("change_password_repeat_password_input_box_text", true);
    this.RepeatPWDInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"change_password_input_btn_style");
    this.RepeatPWDInputBox.SetMaxStringLength(20);
    this.RepeatPWDInputBox.SetMinStringLength(6);
    this.RepeatPWDInputBox.SetIsPlainText(true);      
    this.RepeatPWDInputBox.SetOnTextChangeFunc(function(){this_.checkApplyBtnEnable(); });    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.RepeatPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_large_style");
	}
	else
	{
		this.RepeatPWDInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "change_password_input_btn_help_style");
	}       
    this.RepeatPWDInputBox.SetTextEditorInfo(IDWS_MOIP_CHANGE_PASS, IDWS_MOIP_ENTER_RE_NEW_PASS);    
    this.RepeatPWDInputBox.SetOnClickCallbackFunc(clickCF);
    
    this.MsgLabel = new Label(null,"change_password_msg");
    this.MsgLabel.SetTextStyle("change_password_msg_style");
    this.MsgLabel.SetText(SID_PRESS_APPLY_TO_RESET_PASSWORD_MSG);
    
    this.ApplyBtn = new Button();
    this.ApplyBtn.SetImageObjId("change_password_apply_btn");
    this.ApplyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CHANGE_PASSWORD_BTN_NORMAL);
    this.ApplyBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CHANGE_PASSWORD_BTN_NORMALFOCUS);
	this.ApplyBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CHANGE_PASSWORD_BTN_DIM);	
    this.ApplyBtn.SetTextObjId("change_password_apply_btn_text");
    this.ApplyBtn.SetText(IDWS_MOIP_APPLY);
 	this.ApplyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	//this.ApplyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"common_btn_text_f19_highlight_style");
	this.ApplyBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f19_dim_style"); 
    this.ApplyBtn.SetOnClickCallbackFunc(clickCF);
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.CHANGE_PWD,"ChangePassword");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.InputHelpBar = new HelpBar(HelpBarIndex.CHANGE_PWD_INPUT,"ChangePassword");
    this.InputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startTextInput();});
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});

    this.ApplyBtn.registHelpBar( this.DefaultHelpBar);
    this.CurrentPWDInputBox.registHelpBar( this.InputHelpBar);
    this.NewPWDInputBox.registHelpBar( this.InputHelpBar);
    this.RepeatPWDInputBox.registHelpBar( this.InputHelpBar);
    
}

SceneChangePassword.prototype.setInitFlag= function(init_flag){
     this.InitFlag = init_flag;
}

SceneChangePassword.prototype.initChangePassword= function()
{
    alert("SceneChangePassword.initChangePassword() ");
    
    this.CurrentPWDInputBox.SetText("");
    this.NewPWDInputBox.SetText("");
    this.RepeatPWDInputBox.SetText("");
    
    this.highlight(null);
    this.reserveHighlight = null;

    this.InitFlag = false;
    
    this.checkApplyBtnEnable();
}

SceneChangePassword.prototype.highlight=function(obj)
{
    this.ChangePasswordView.setCurrenHighlight(obj);
 
}

SceneChangePassword.prototype.startTextInput = function(){
    alert("SceneChangePassword.startTextInput() ");
    
    var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CurrentPWDInputBox:
        case this.NewPWDInputBox:
        case this.RepeatPWDInputBox:
        
			if(this.CloseTimer==true)
			{
				this.stopTimer();
			}
		    WndMgr.StartTextEditor(currentHighlight, "ChangePassword",this.ChangePasswordDim);
            break;            
    }    
}

/*
SceneChangePassword.prototype.startIME= function(obj)
{    
    var scene = $.sfScene.get("ChangePassword");
    
    if(obj == this.CurrentPWDInputBox)
    {
        if(this.flagCurrentPWDInit ==false)
        {
            this.CurrentPWDInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
            this.flagCurrentPWDInit =true
       }
       else
       {
            this.CurrentPWDInputBox.initInputBox( this.flagPWD, this.CurrentPWDInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en' ));
    }
     
     if(obj == this.NewPWDInputBox)
    {
        if(this.flagNewPWDInit ==false)
        {
            this.NewPWDInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
            this.flagNewPWDInit =true
       }
       else
       {
            this.NewPWDInputBox.initInputBox( this.flagPWD, this.NewPWDInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
    
      if(obj == this.RepeatPWDInputBox)
    {
        if(this.flagRepeatPWDInit ==false)
        {
            this.RepeatPWDInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
            this.flagRepeatPWDInit =true
       }
       else
       {
            this.RepeatPWDInputBox.initInputBox( this.flagPWD, this.RepeatPWDInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en' ));
    }
}
*/

SceneChangePassword.prototype.processUpKey = function(){
    alert("SceneChangePassword.processUpKey() ");
    
    var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.CurrentPWDInputBox:
            if( this.ApplyBtn.GetFlagDim() == true)
            {
                this.highlight(this.RepeatPWDInputBox);
            }
            else
            {
                 this.highlight(this.ApplyBtn);
            }
            break;
            
        case this.NewPWDInputBox:
            this.highlight(this.CurrentPWDInputBox);
            break;
            
        case this.RepeatPWDInputBox:
            this.highlight(this.NewPWDInputBox);
            break;
            
        case this.ApplyBtn:
            this.highlight(this.RepeatPWDInputBox);
            break;
    }
}

SceneChangePassword.prototype.processDownKey = function(){
    alert("SceneChangePassword.processDownKey() ");
    
    var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CurrentPWDInputBox:
           this.highlight(this.NewPWDInputBox);
            break;
            
        case this.NewPWDInputBox:
            this.highlight(this.RepeatPWDInputBox);
            break;
            
        case this.RepeatPWDInputBox:
        
            if( this.ApplyBtn.GetFlagDim() == true)
            {
                this.highlight(this.CurrentPWDInputBox);
            }
            else
            {
                this.highlight(this.ApplyBtn);
            }
            break;
            
        case this.ApplyBtn:
            this.highlight(this.CurrentPWDInputBox);
            break;
    }
}

SceneChangePassword.prototype.processEnterKey = function(){
    alert("SceneChangePassword.processEnterKey() ");
    
    var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();
    
    switch(currentHighlight)
    {     
        case this.CurrentPWDInputBox:
        case this.NewPWDInputBox:
        case this.RepeatPWDInputBox:
        
			this.startTextInput();
            break;
            
        case this.ApplyBtn:
        
	         var old_pwd = this.CurrentPWDInputBox.GetText();
	         var new_pwd = this.NewPWDInputBox.GetText();
	         var re_pwd = this.RepeatPWDInputBox.GetText();
	         
	         if(old_pwd.length >0 && new_pwd.length >0 && re_pwd.length> 0)
	         {
	            ProcMgr.ChangePassword(old_pwd, new_pwd, re_pwd );
	         }              
        
        break;
    }
}

SceneChangePassword.prototype.moveToApplyBtn = function()
{
    alert("SceneAddContactPhoneNumber.moveToApplyBtn() ");
  
    this.highlight(this.ApplyBtn);
   	$.sfScene.focus('ChangePassword');
    $.sf.returnFocus();
}


SceneChangePassword.prototype.checkApplyBtnEnable = function()
{
    if(this.InitFlag ==true)
    {
        return;
    }
    
    alert("SceneChangePassword.checkApplyBtnEnable() ");
    
     var old_pwd = this.CurrentPWDInputBox.GetText();
     var new_pwd = this.NewPWDInputBox.GetText();
     var re_pwd = this.RepeatPWDInputBox.GetText();
     
     if((old_pwd.length >0) && (new_pwd.length >0) && (re_pwd.length> 0))
     {
        this.ApplyBtn.SetFlagDim(false);
     }
     else
     {
        this.ApplyBtn.SetFlagDim(true);
     }
}


SceneChangePassword.prototype.processReturnKey = function(){
    alert("SceneChangePassword.processReturnKey() ");
    StateMgr.Stop_Change_Password_State(true);
}

/*
SceneChangePassword.prototype.initInputBox = function(flagPWD, initText, maxLen, callerObj)
{
    alert("SceneChangePassword.initInputBox()");
    this.flagPWD = flagPWD;
    this.initText = initText;
    this.maxStringLenght = maxLen;
    this.callerObj = callerObj;
    // this.TextInputBox.initInputBox(flagPWD, initText, maxLen, callerObj);
}

SceneChangePassword.prototype.imeReady = function(){
    alert("SceneChangePassword.imeReady() ");

	var obj = this.ChangePasswordView.getCurrentHighlight();
    
    obj.setKeyFunc($.sfKey.DOWN, function(keyCode){$.sfScene.get('ChangePassword').processDownKey();  return false;});
	obj.setKeyFunc($.sfKey.UP,  function(keyCode){$.sfScene.get('ChangePassword').processUpKey();  return false;});

    obj.setKeyFunc(88,  function(keyCode){$.sf.returnFocus();  StateMgr.Stop_Change_Password_State(true);$.sfKey.block(event); return false;}); // return key
    obj.setKeyFunc(108,  function(keyCode){$.sfScene.get('ChangePassword').DeleteAllText();  $.sfScene.get('ChangePassword').checkApplyBtnEnable(); return false;}); // red key
    
    obj.setAnyKeyFunc(function(keyCode){$.sfScene.get('ChangePassword').checkApplyBtnEnable();   return false;});
    obj.setEnterFunc( function(keyCode){$.sfScene.get('ChangePassword').processDownKey(); return false;});
    
	obj.setReady();
}

SceneChangePassword.prototype.GetInputText = function()
{
    var obj = this.ChangePasswordView.getCurrentHighlight();
    return obj.getString();
}

SceneChangePassword.prototype.DeleteAllText = function()
{
    var obj = this.ChangePasswordView.getCurrentHighlight();
    obj. setString("");
}
*/

SceneChangePassword.prototype.InputOldPWDAgain = function()
{
    alert("SceneSignup.InputOldPWDAgain() ");
   
    this.reserveHighlight  =this.CurrentPWDInputBox;
    this.CurrentPWDInputBox.SetText("");
}

SceneChangePassword.prototype.InputNewPWDAgain = function()
{
    alert("SceneSignup.InputNewPWDAgain() ");
   
    this.reserveHighlight  =this.NewPWDInputBox;
    this.NewPWDInputBox.SetText("");
    this.RepeatPWDInputBox.SetText("");
}

SceneChangePassword.prototype.startTimer = function()
{
    alert("SceneChangePassword.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('ChangePassword').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneChangePassword.prototype.resetTimer = function()
{
    alert("SceneChangePassword.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneChangePassword.prototype.stopTimer = function()
{
    alert("SceneChangePassword.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneChangePassword.prototype.popupTimerCallback = function()
{
	alert("SceneChangePassword.popupTimerCallback() ");
	if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	StateMgr.Stop_Change_Password_State(true);
}

SceneChangePassword.prototype.processClickEvent = function(obj){
	alert("SceneChangePassword.processClickEvent() ");
	
	var currentHighlight =  this.ChangePasswordView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}




