function SceneCheckPassword(options) {
	this.options = options;
    
    this.MainView=null;
	this.MainViewDim =null;
    
    this.TitleBar = null;    
    this.MsgLabel = null;
	this.MsgLengthLabel = null;
    
    this.TextInputBox = null;
    
    this.flagPWD = true;
    this.initText ="";
    this.maxStringLenght = 20;
    this.callerObj = null;
    
    this.flagPwdShow = false;

	this.isCheckEnable= false;
	this.CloseTimer = false;
}

SceneCheckPassword.prototype.initialize = function () {
	alert("SceneCheckPassword.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneCheckPassword.prototype.handleShow = function () {
	alert("SceneCheckPassword.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
	
	this.TextInputBox.initKeySet();
	
    this.resetData();
    
   this.startTimer();
}

SceneCheckPassword.prototype.handleHide = function () {
	alert("SceneCheckPassword.handleHide()");
	// this function will be called when the scene manager hide this scene  
    var obj = this.MainView.getCurrentHighlight();
	if(obj != null)
	{
		obj.imeHide();
	}
	
	this.flagPwdShow = false; //init

	this.MainViewDim.hide();	
	
	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneCheckPassword.prototype.handleFocus = function () {
	alert("SceneCheckPassword.handleFocus()");
	// this function will be called when the scene manager focus this scene
    this.highlight(this.TextInputBox);
}

SceneCheckPassword.prototype.handleBlur = function () {
	alert("SceneCheckPassword.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneCheckPassword.prototype.handleKeyDown = function (keyCode) {
	alert("SceneCheckPassword.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCheckPassword.prototype.create = function(){
    alert("SceneCheckPassword.create()");
    this.MainView = new View("CheckPassword");
    this.MainView.SetBgImage( WndMgr.Bg_TextEditor.src );
	
	this.MainViewDim = new DimBg("CheckPasswordDim", "CheckPassword");
    
    this.TitleBar = new Label(null,"check_password_title");
    this.TitleBar.SetTextStyle("check_password_title_style");
    this.TitleBar.SetText(SID_PASSWORD);
   
    this.MsgLabel = new Label(null,"check_password_msg");
    this.MsgLabel.SetTextStyle("check_password_msg_style");
    this.MsgLabel.SetText(SIGN_IN_KEYPAD_HELP_ENTER_PASSWORD);
	
	this.MsgLengthLabel = new Label(null,"check_password_msg_length");
    this.MsgLengthLabel.SetTextStyle("check_password_msg_length_style");
    this.MsgLengthLabel.SetText("");
    
    this.TextInputBox= new InputBox();
	this.TextInputBox.SetButtonObjId("check_password_input_box");
    this.TextInputBox.SetButtonTextObjId("check_password_input_box_text");
	this.TextInputBox.SetInputBoxObjId("check_password_input_box_editor");
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_INPUT_BOX_NORMAL);
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_INPUT_BOX_NORMALFOCUS);	
	this.TextInputBox.setKeypadPos(675,100);
    this.TextInputBox.setWordBoxPos(236,50);
    
}

SceneCheckPassword.prototype.resetData = function()
{  
	this.isCheckEnable= false;
    this.TextInputBox.SetText("");
	this.MsgLengthLabel.SetText("");

    this.flagPwdShow = false; 	
}

SceneCheckPassword.prototype.update = function()
{  
 alert("SceneTextEditor.update() ");
  var obj = this.MainView.getCurrentHighlight();
    
   var scene = $.sfScene.get("CheckPassword");
   
   var ime = new IMEShell(obj.IMEObjInfo.id, scene.imeReady, 'en' /*, 'en' ,  "2_35_259"*/);

}

SceneCheckPassword.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);
  
    var scene = $.sfScene.get("CheckPassword");
    if(obj == this.TextInputBox)
    {
        this.TextInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
       
        var ime = new IMEShell(obj.IMEObjInfo.id, scene.imeReady, 'en' /*, 'en' ,  "2_35_259"*/);
    }
	else
	{
		if(obj == null)
		{
			this.TextInputBox.imeHide();	
		}
	}	 
}

SceneCheckPassword.prototype.processReturnKey = function(){
    alert("SceneCheckPassword.processReturnKey() ");
	this.highlight(null);
	ProcMgr.CancelCheckPwd();
	$.sfKey.block(event);
}

SceneCheckPassword.prototype.processExitKey = function(){
    alert("SceneCheckPassword.processExitKey() ");
    this.highlight(null);
    ProcMgr.CancelCheckPwd();
    $.sfKey.block(event);
}

SceneCheckPassword.prototype.imeReady = function(imeObject){
	alert("SceneCheckPassword.imeReady() ");
	
	var scene = $.sfScene.get("CheckPassword");
	var obj = scene.MainView.getCurrentHighlight();
	
	obj.imeShow(imeObject);
	
	obj.setKeyFunc(88,  function(keyCode){ scene.processReturnKey(); $.sfKey.block(event); return false;}); // return key
	obj.setKeyFunc(45,  function(keyCode){ scene.processExitKey(); $.sfKey.block(event); return false;}); // exit key
	obj.setKeyFunc(108, function(keyCode){scene.DeleteAllText();  return false;}); // red key
	obj.setKeyFunc(222, function(keyCode){$.sfKey.block(event);  return false;}); // source
	
	obj.setKeyFunc(147, function(keyCode){$.sfKey.block(event);  return false;}); // infolink
	obj.setKeyFunc(261, function(keyCode){$.sfKey.block(event);  return false;}); // contents
	obj.setKeyFunc(115, function(keyCode){$.sfKey.block(event);  return false;}); // wiselink
	
	obj.setEnterFunc( function(keyCode){scene.CheckInputPwd() ; return false;});
	
	obj.setOnCompleteFunc(function(keyCode){scene.updateMsgLength(); scene.checkEnterEnable(); scene.resetTimer();  return false;});
	obj.setAnyKeyFunc(function(keyCode){scene.resetTimer();  return false;});
	
	obj.setKeySetFunc("qwerty");
	
	scene.updateHelpBar(); //when input mode is pwd, display show or hide pwd string on help bar
	
	obj.setReady();
	
	scene.updateMsgLength();
	scene.checkEnterEnable();
}

SceneCheckPassword.prototype.updateMsgLength = function()
{
	alert("SceneCheckPassword.updateMsgLength() ");
    var obj = this.MainView.getCurrentHighlight();
    var input_string = obj.getString();
	
	obj.SetText(input_string);
	this.MsgLengthLabel.SetText(String(input_string.length) +"/" +String(this.maxStringLenght));  	
}

SceneCheckPassword.prototype.CheckInputPwd = function()
{
    alert("SceneCheckPassword.CheckInputPwd() ");
	var input_text = this.TextInputBox.GetText();
	
	if(this.isCheckEnable == true)
	{
		this.highlight(null);
		ProcMgr.CheckInputPwd(input_text);
	}  
}

SceneCheckPassword.prototype.GetInputText = function()
{
    var obj = this.MainView.getCurrentHighlight();
    return obj.getString();
}

SceneCheckPassword.prototype.DeleteAllText = function()
{
	this.resetTimer();
	
	if(this.flagPWD == true)
    {
        this.TogglePWDShowMode();
    }
    else
    {
	    var obj = this.MainView.getCurrentHighlight();
	    obj.setString("");
		
		this.updateMsgLength();
		this.checkEnterEnable();
    }
}

SceneCheckPassword.prototype.TogglePWDShowMode = function()
{
    alert("SceneCheckPassword.TogglePWDShowMode() ");
    
	var obj = this.MainView.getCurrentHighlight();
	var curr_string = obj.GetText();
    obj.setEngOnly(true);
    
    this.TextInputBox.updateInputBox( this.flagPwdShow, curr_string, this.maxStringLenght,  this.callerObj );
    if( $.sfScene.get('CheckPassword').flagPwdShow == false)
    {
        obj.setBlockSpace(true);
    }
    
    if(this.flagPwdShow == false)
    {
        this.flagPwdShow = true;
        
    }
    else
    {
        this.flagPwdShow = false;
        
    }  
    
    this.update();
}

SceneCheckPassword.prototype.updateHelpBar = function()
{
	var scene = $.sfScene.get("CheckPassword");
	var obj = scene.MainView.getCurrentHighlight();
	
	if(scene.flagPWD == true) 
	{
 		if(scene.flagPwdShow == true)
		{
			alert("SceneCheckPassword.updateHelpBar() : mode 1 (hide)");
			obj.setShowHideString(SID_HIDE_PASSWORD);
		}
		else
		{
			alert("SceneCheckPassword.updateHelpBar() : mode 2 (show)");
			obj.setShowHideString(SID_SHOW_PASSWORD);
		}
	} 
	else
	{
		alert("SceneCheckPassword.updateHelpBar() : mode 3 (null)");
		obj.setShowHideString(null);
	}
}

SceneCheckPassword.prototype.checkEnterEnable = function()
{
    var input_text = this.TextInputBox.GetText();
    
    if(input_text.length ==0)
    {
        this.isCheckEnable = false;
    }
    else
    {
        this.isCheckEnable = true;
    }
           
    alert("SceneCheckPassword.checkEnterEnable()  :  " +this.isCheckEnable);
}

SceneCheckPassword.prototype.startTimer = function()
{
    alert("SceneCheckPassword.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('CheckPassword').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneCheckPassword.prototype.resetTimer = function()
{
    alert("SceneCheckPassword.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneCheckPassword.prototype.stopTimer = function()
{
    alert("SceneCheckPassword.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneCheckPassword.prototype.popupTimerCallback = function()
{
   alert("SceneCheckPassword.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
	this.highlight(null);
	ProcMgr.CancelCheckPwd();
}




