
function SceneCreateAccountStep4(options) {
	this.options = options;
	
	this.MainView=null;
	
	this.ProgressBarBgLabel = null;
	this.ProgressBarPrevious1Label = null;
	this.ProgressBarPrevious2Label = null;
	this.ProgressBarPrevious3Label = null;
	this.ProgressBarCurrentLabel = null;
	
	this.AgreemenBg = null;
	this.TitleLabel = null;
	
	this.AcceptPage = null;
	this.ReadPage = null;
	
	this.MsgTopLabel = null;
	this.Msg1Label = null;
	this.Msg2Label = null;
	//this.EulaBtn = null;
	this.TosBtn = null;
	this.PsBtn = null;
	
	this.PreviousBtn = null;
	this.AcceptBtn= null;
	
	this.ReadTitleLabel = null;
	this.ReadContentsLabel = null;
	
	this.DefaultHelpBar =null;
	
	this.isReadMode = false;
	this.ReadContents = null;
	this.ContentsAnchor = null;
	
	this.ScrollBg=null;
	this.ScrollTop=null;
	this.ScrollCenter=null;
	this.ScrollUnder=null;
	
	this.TopArrow = null;
	this.BottomArrow = null;
	
	this.KeyDown = false;
}

SceneCreateAccountStep4.prototype.initialize = function () {
	alert("SceneCreateAccountStep4.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
}

SceneCreateAccountStep4.prototype.handleShow = function () {
	alert("SceneCreateAccountStep4.handleShow()");
	// this function will be called when the scene manager show this scene 
}

SceneCreateAccountStep4.prototype.handleHide = function () {
	alert("SceneCreateAccountStep4.handleHide()");
	// this function will be called when the scene manager hide this scene  
	
}

SceneCreateAccountStep4.prototype.handleFocus = function () {
	alert("SceneCreateAccountStep4.handleFocus()");
	// this function will be called when the scene manager focus this scene

    this.highlight(this.AcceptBtn);
}

SceneCreateAccountStep4.prototype.handleBlur = function () {
	alert("SceneCreateAccountStep4.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    var currentHighlight =  this.MainView.getCurrentHighlight();
    currentHighlight.blur();

}

SceneCreateAccountStep4.prototype.handleKeyDown = function (keyCode) {
	alert("SceneCreateAccountStep4.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {

		case $.sfKey.LEFT:
        case $.sfKey.RIGHT:
            this.processLeftRightKey();
			break;
		case $.sfKey.UP:
			this.processUpKey();
			break;
		case $.sfKey.DOWN:
			this.processDownKey();
			break;
		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
        
       case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
       case 147:  //infolink
       case 261:  //contents
       case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
		
		default:
            ProcMgr.processBlockKey(keyCode);
            break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCreateAccountStep4.prototype.create = function(){
    alert("SceneCreateAccountStep4.create()");
    this.MainView = new View("CreateAccountStep4");
    this.MainView.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_BG);
    
   	this.ProgressBarBgLabel= new Label("create_account_step4_progress_bar_bg", null);
    this.ProgressBarBgLabel.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_PROGRESS_BAR_BG);
	
	this.ProgressBarPrevious1Label= new Label("create_account_step4_progress_bar_previous1", null);
    this.ProgressBarPrevious1Label.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_PROGRESS_BAR_PREVIOUS_BG);
	
	this.ProgressBarPrevious2Label= new Label("create_account_step4_progress_bar_previous2", null);
    this.ProgressBarPrevious2Label.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_PROGRESS_BAR_PREVIOUS_BG);
	
	this.ProgressBarPrevious3Label= new Label("create_account_step4_progress_bar_previous3", null);
    this.ProgressBarPrevious3Label.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_PROGRESS_BAR_PREVIOUS_BG);
    
	this.ProgressBarCurrentLabel= new Label("create_account_step4_progress_bar_current", null);
    this.ProgressBarCurrentLabel.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_PROGRESS_BAR_CURRENT_BG);
	
	this.AcceptPage = new View("create_account_step4_agreement_accept_page");
	
	this.ReadPage = new View("create_account_step4_agreement_read_page");
	this.ReadPage.hiddenObj();

    this.TitleLabel = new Label(null,"create_account_step4_title");
    this.TitleLabel.SetTextStyle("create_account_title_style");
    this.TitleLabel.SetText(TV_SID_CREATE_A_NEW_SKYPE_ACCOUNT);  
	
	this.AgreemenBg= new Label("create_account_step4_agreement_bg", null);
    this.AgreemenBg.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BG); 

    this.MsgTopLabel = new Label(null,"create_account_step4_agreement_message_top");
    this.MsgTopLabel.SetTextStyle("create_account_step4_agreement_message_top_style");
    this.MsgTopLabel.SetText(IDWS_MOIP_LICENSE_AGREEMENT);   
	
	this.Msg1Label = new Label(null,"create_account_step4_agreement_message1");
    this.Msg1Label.SetTextStyle("create_account_step4_agreement_message_style");
    this.Msg1Label.SetText(TV_NO_EMERGENCY_CALLS+"</br>"+TV_SKYPE_NOT_ORDINARY_AND_EMERGENCY_MSG); 
    
	this.Msg2Label = new Label(null,"create_account_step4_agreement_message2");
    this.Msg2Label.SetTextStyle("create_account_step4_agreement_message_style");
    this.Msg2Label.SetText(TV_SID_READ_AND_ACCEPT_TERM_MSG); 
	
	/*this.EulaBtn= new Button();
    this.EulaBtn.SetImageObjId("create_account_step4_agreement_eula_btn");
    this.EulaBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMAL);
    this.EulaBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMALFOCUS);
    this.EulaBtn.SetTextObjId("create_account_step4_agreement_eula_btn_text");
    this.EulaBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f18_normal_style");
    this.EulaBtn.SetText(TV_SID_SKYPE_END_USER_LICENSE_AGREEMENT);*/
	
	var this_ = $.sfScene.get("CreateAccountStep4");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
	this.TosBtn= new Button();
    this.TosBtn.SetImageObjId("create_account_step4_agreement_tos_btn");
    this.TosBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMAL);
    this.TosBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMALFOCUS);
    this.TosBtn.SetTextObjId("create_account_step4_agreement_tos_btn_text");
    this.TosBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f18_normal_style");
    this.TosBtn.SetText(TV_SID_VIEW_TERMS_KR_CAPITAL);
    this.TosBtn.SetOnClickCallbackFunc(clickCF);
	
	this.PsBtn= new Button();
    this.PsBtn.SetImageObjId("create_account_step4_agreement_ps_btn");
    this.PsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMAL);
    this.PsBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_BTN_NORMALFOCUS);
    this.PsBtn.SetTextObjId("create_account_step4_agreement_ps_btn_text");
    this.PsBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f18_normal_style");
	this.PsBtn.SetText(TV_VIEW_PRIVACY_STATEMENT);
	this.PsBtn.SetOnClickCallbackFunc(clickCF);
    
    this.PreviousBtn= new Button();
    this.PreviousBtn.SetImageObjId("create_account_step4_previous_btn");
    this.PreviousBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CREATE_ACCOUNT_PREVIOUS_BTN_NORMAL);
    this.PreviousBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CREATE_ACCOUNT_PREVIOUS_BTN_NORMALFOCUS);
    this.PreviousBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CREATE_ACCOUNT_PREVIOUS_BTN_NORMAL);
    this.PreviousBtn.SetTextObjId("create_account_step4_previous_btn_text");
    this.PreviousBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"create_account_btn_normal_style");
	this.PreviousBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"create_account_btn_select_style");
    this.PreviousBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"create_account_btn_dim_style");
    this.PreviousBtn.SetText(SID_BACK_KR_PREV);
    this.PreviousBtn.SetOnClickCallbackFunc(clickCF);
	
	this.AcceptBtn= new Button();
    this.AcceptBtn.SetImageObjId("create_account_step4_accept_btn");
    this.AcceptBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CREATE_ACCOUNT_NEXT_BTN_NORMAL);
    this.AcceptBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CREATE_ACCOUNT_NEXT_BTN_NORMALFOCUS);
    this.AcceptBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CREATE_ACCOUNT_NEXT_BTN_NORMAL);
    this.AcceptBtn.SetTextObjId("create_account_step4_accept_btn_text");
    this.AcceptBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"create_account_btn_normal_style");
	this.AcceptBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"create_account_btn_select_style");
    this.AcceptBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"create_account_btn_dim_style");
    this.AcceptBtn.SetText(TV_ACCEPT_M_AGREE);
    this.AcceptBtn.SetOnClickCallbackFunc(clickCF);
	
	this.ReadTitleLabel = new Label(null,"create_account_step4_agreement_read_title");
    this.ReadTitleLabel.SetTextStyle("create_account_step4_agreement_message_top_style");
	
	this.ReadContentsLabel = new Label(null,"create_account_step4_agreement_read_contents");
	
	this.ScrollBg= new Label("create_account_step4_agreement_scroll_bg", null);
    this.ScrollBg.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_SCROLL_BG);
    
    this.ScrollTop= new Label("create_account_step4_agreement_scroll_top", null);
    this.ScrollTop.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_SCROLL_TOP);
    
    this.ScrollUnder= new Label("create_account_step4_agreement_scroll_middle", null);
    this.ScrollUnder.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_SCROLL_MIDDLE);
    
    this.ScrollCenter= new Label("create_account_step4_agreement_scroll_bottom", null);
    this.ScrollCenter.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_SCROLL_BOTTOM);
    
    this.TopArrow= new Label("create_account_step4_agreement_top_arrow", null);
    this.TopArrow.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_TOP_NOR);
    this.TopArrow.SetOnClickCallbackFunc(clickCF);
    this.TopArrow.SetOnMouseOutOverImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_TOP_NOR, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_TOP_OVER);

    this.BottomArrow= new Label("create_account_step4_agreement_bottom_arrow", null);
    this.BottomArrow.SetBgImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_BOTTOM_NOR);
    this.BottomArrow.SetOnClickCallbackFunc(clickCF);
    this.BottomArrow.SetOnMouseOutOverImage(g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_BOTTOM_NOR, g_Image.IMAGE_CREATE_ACCOUNT_AGREEMENT_ALLOW_BOTTOM_OVER);	    
    
    this.hiddenScrollBar();
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.CREATE_ACCOUNT_STEP4,"CreateAccountStep4");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.MainView.registHelpBar(this.DefaultHelpBar);
	    
}

SceneCreateAccountStep4.prototype.goToAcceptPage = function(){
	alert("SceneCreateAccountStep4.goToAcceptPage() ");
	this.isReadMode = false;
	
	//To fix DMS01140789
	this.ReadTitleLabel.SetText(" ");
	
	this.hiddenScrollBar();
	$("div#signup_agreement_read_contents p:first").html("");
	this.AcceptPage.visibleObj();
	this.ReadPage.hiddenObj();
}

SceneCreateAccountStep4.prototype.goToReadPage = function(index){
	alert("SceneCreateAccountStep4.goToReadPage() ");
	
	this.isReadMode = true;
	var _THIS_=$.sfScene.get('CreateAccountStep4');
	
	this.ContentsAnchor = document.getElementById("LicenseAgreementAnchor");	
    this.ContentsAnchor.onkeyup = function(){
            _THIS_.keyup();
    };
	this.ContentsAnchor.onkeydown = function(){
            _THIS_.keydown();
    };
    
    this.ContentsAnchor.onblur = function(){
            _THIS_.anchorblur();
    };
    
    this.ContentsDiv = document.getElementById("create_account_step4_agreement_read_contents");
   	this.ContentsDiv.onmousewheel = function(){
            _THIS_.mousewheel();
    };
	
	$("div#create_account_step4_agreement_read_contents p:first").html(""); //init
	
	this.AcceptPage.hiddenObj();
	this.ReadPage.visibleObj();
	
	this.ContentsAnchor.focus();
	
	setTimeout("CloseTimerCF()", 0);
	CloseTimerCF = function(){ 
		var contents ="";
		var lan_code = ResMgr.GetCurLicenseLanguageCode();
		
		var THIS_=$.sfScene.get('CreateAccountStep4');
		
		if(index==1)
		{
			 THIS_.ReadTitleLabel.SetText(TV_SID_SKYPE_END_USER_LICENSE_AGREEMENT);
			 if(lan_code.length >0)
			 {
			 	var contents= $.sf.readFile("resource/eula_"+lan_code+".html");
			 }
			 else
			 {
			 	var contents= $.sf.readFile("resource/eula.html");		 	
			 }
			 
		}
		else if(index==2)
		{
			THIS_.ReadTitleLabel.SetText(TV_SID_SKYPE_TERMS_OF_SERVICE);
			if (lan_code.length > 0) 
			{
				var contents= $.sf.readFile("resource/terms_"+lan_code+".html");	
			}
			else
			{
				var contents= $.sf.readFile("resource/terms.html");	
			}
			
		}
		else if(index==3)
		{
			THIS_.ReadTitleLabel.SetText(TV_SID_SKYPE_PRIVACY_STATEMENT);
			
			if (lan_code.length > 0)
			{
				var contents = $.sf.readFile("resource/privacy_"+lan_code+".html");
			}
			else
			{
				var contents = $.sf.readFile("resource/privacy.html");
			}
		}
		
		$("div#create_account_step4_agreement_read_contents p:first").html(contents);
		
		THIS_.ReadContents = document.getElementById("create_account_step4_agreement_read_contents");
		THIS_.ReadContents.scrollTop = 0;

		THIS_.updateScrollBar();
	}
}

SceneCreateAccountStep4.prototype.anchorblur = function(){
	alert("SceneCreateAccountStep4.anchorblur() ");
	
	if(this.isReadMode == true)
	{
		this.ContentsAnchor = document.getElementById("LicenseAgreementAnchor");
		this.ContentsAnchor.focus();	
	}
}

SceneCreateAccountStep4.prototype.scrollUp = function(){
	alert("SceneCreateAccountStep4.scrollUp() ");
	var scrollTop = this.ReadContents.scrollTop;
	var scrollHeight = this.ReadContents.scrollHeight;
	var offsetHeight = this.ReadContents.offsetHeight;
	
	if(scrollTop<=0)
	{
		alert("scrollTop==0");
		return;
	}
	else
	{
		if(scrollTop>=40)
		{
			this.ReadContents.scrollTop-=40;
		}
		else
		{
			this.ReadContents.scrollTop-=scrollTop;
		}
	}
	
	this.updateScrollBar();
}

SceneCreateAccountStep4.prototype.scrollDown = function(){
	alert("SceneCreateAccountStep4.scrollDown() ");
	
	var scrollTop = this.ReadContents.scrollTop;
	var scrollHeight = this.ReadContents.scrollHeight;
	var offsetHeight = this.ReadContents.offsetHeight;
	
	if(scrollHeight<=scrollTop+offsetHeight)
	{
		alert("scrollHeight>=scrollTop+offsetHeight");
		return;
	}
	else
	{
		under_offset=scrollHeight-scrollTop+offsetHeight;
		if(under_offset>=40)
		{
			this.ReadContents.scrollTop+=40;
		}
		else
		{
			this.ReadContents.scrollTop+=under_offset;
		}
	}
	
	this.updateScrollBar();	
}

SceneCreateAccountStep4.prototype.updateScrollBar = function(){
	alert("SceneCreateAccountStep4.updateScrollBar() ");
	
	var scrollTop = this.ReadContents.scrollTop;
	var scrollHeight = this.ReadContents.scrollHeight;
	var offsetHeight = this.ReadContents.offsetHeight;
	
	alert("scrollTop " + scrollTop);
	alert("scrollHeight " + scrollHeight);
	alert("offsetHeight " + offsetHeight);
	
	if (scrollHeight <= offsetHeight) 
	{
		this.hiddenScrollBar();
	}
	else 
	{
		var total_item = scrollHeight;
		var displayed_item = offsetHeight;
		var max_scroll_length = 261;
		var init_scroll_start_position = 171;
		var curr_scroll_start_position = init_scroll_start_position;
		var curr_scroll_length=0;  
		
		var upper_hidden_item = scrollTop;
			var under_hidden_item = scrollHeight-(scrollTop+offsetHeight);
		
		var scroll_length = Math.floor((max_scroll_length *displayed_item)/total_item);
		var upper_hidden_length = Math.floor((max_scroll_length *upper_hidden_item)/total_item);
		var under_hidden_length = Math.floor((max_scroll_length *under_hidden_item)/total_item);
     
		if(scroll_length < 2)
		{
			upper_hidden_length =  Math.floor(( 2 *upper_hidden_length)/scroll_length);
			upper_hidden_length =  Math.floor(( 2 *under_hidden_length)/scroll_length);
			scroll_length =2; 
		}
     
     
     	var extra_length =max_scroll_length - (scroll_length+upper_hidden_length+under_hidden_length);
      
		if(upper_hidden_length >0)
		{
			curr_scroll_start_position =  init_scroll_start_position + upper_hidden_length+ extra_length;
		}
		else
		{
			curr_scroll_start_position =  init_scroll_start_position + upper_hidden_length;
		}
      
		curr_scroll_length  =  scroll_length;
		
		var center_top = String(curr_scroll_start_position);
		var center_height = String(curr_scroll_length);
		
		var scroll_top = String(curr_scroll_start_position-5);
		var scroll_under = String(curr_scroll_start_position+curr_scroll_length);
		
		$("#create_account_step4_agreement_scroll_middle").css("top",  center_top+"px");
		$("#create_account_step4_agreement_scroll_middle").height(center_height+"px");
		
		$("#create_account_step4_agreement_scroll_top").css("top",  scroll_top+"px");
		$("#create_account_step4_agreement_scroll_bottom").css("top",  scroll_under+"px");
		
		alert("SceneSignupAgreement.updateScrollBar() top: "+ scroll_top+" length : "+center_height+" bottom : " + scroll_under);
		this.visibleScrollBar();
		
		this.toggleAllow();
	}	
}

SceneCreateAccountStep4.prototype.toggleAllow = function()
{
	alert("SceneCreateAccountStep4.toggleAllow() ");
	var scrollTop = this.ReadContents.scrollTop;
	var scrollHeight = this.ReadContents.scrollHeight;
	var offsetHeight = this.ReadContents.offsetHeight;

	if(scrollTop<=0)
	{
		this.TopArrow.hiddenObj();		
	}
	else
	{
		this.TopArrow.visibleObj();
	}
	
	if(scrollHeight<=scrollTop+offsetHeight)
	{
		this.BottomArrow.hiddenObj();
	}
	else
	{
		this.BottomArrow.visibleObj();
	}	
}

SceneCreateAccountStep4.prototype.hiddenScrollBar = function()
{
    this.ScrollTop.hiddenObj();
    this.ScrollUnder.hiddenObj();
    this.ScrollCenter.hiddenObj();
    
    this.TopArrow.hiddenObj();
    this.BottomArrow.hiddenObj();
}

SceneCreateAccountStep4.prototype.visibleScrollBar = function()
{
    this.ScrollTop.visibleObj();
    this.ScrollUnder.visibleObj();
    this.ScrollCenter.visibleObj();
}

SceneCreateAccountStep4.prototype.keydown = function(){
	var keycode = event.keyCode;
	alert("SceneCreateAccountStep4.keydown() -> key code :" + keycode);
	
	switch (keycode) {
	case $.sfKey.DOWN:
		if(this.KeyDown==false)
		{
			this.KeyDown=true;
		}
		else{
			this.updateScrollBar();
		}
		
        break;
    case $.sfKey.UP:
		if(this.KeyDown==false)
		{
			this.KeyDown=true;
		}
		else{
			this.updateScrollBar();
		}
		
        break;
		
	case $.sfKey.RETURN:
    	this.processReturnKey();
		$.sf.returnFocus();
        $.sfKey.block(event);
        break;
	}
}

SceneCreateAccountStep4.prototype.keyup = function(){
	var keycode = event.keyCode;
	alert("SceneCreateAccountStep4.keyup() -> key code :" + keycode);
	
	switch (keycode) {
	case $.sfKey.DOWN:
		this.KeyDown=false;
		this.updateScrollBar();
        break;
    case $.sfKey.UP:
		this.KeyDown=false;
		this.updateScrollBar();
        break;
	}
}

SceneCreateAccountStep4.prototype.mousewheel = function(){
	alert("SceneCreateAccountStep4.mousewheel()");
	
	this.updateScrollBar();	
}

SceneCreateAccountStep4.prototype.highlight=function(obj)
{
	alert("SceneCreateAccountStep4.highlight()");
	
    this.MainView.setCurrenHighlight(obj);
}


SceneCreateAccountStep4.prototype.processLeftRightKey = function(){
    alert("SceneCreateAccountStep4.processLeftRightKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.PreviousBtn:
               this.highlight(this.AcceptBtn);
            break;
            
        case this.AcceptBtn:
            this.highlight(this.PreviousBtn);
        break;
    }
    
}

SceneCreateAccountStep4.prototype.processUpKey = function(){
    alert("SceneCreateAccountStep4.processUpKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    
    switch(currentHighlight)
    {
		/*case this.EulaBtn:
               this.highlight(this.AcceptBtn);
            break;*/
            
        case this.TosBtn:
            this.highlight(this.AcceptBtn);
        break;
		
		case this.PsBtn:
            this.highlight(this.TosBtn);
        break;
		
        case this.PreviousBtn:
               this.highlight(this.PsBtn);
            break;
            
        case this.AcceptBtn:
            this.highlight(this.PsBtn);
        break;		
    }    
}

SceneCreateAccountStep4.prototype.processDownKey = function(){
    alert("SceneCreateAccountStep4.processDownKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    
    switch(currentHighlight)
    {
		/*case this.EulaBtn:
               this.highlight(this.TosBtn);
            break;*/
            
        case this.TosBtn:
            this.highlight(this.PsBtn);
        break;
		
		case this.PsBtn:
            this.highlight(this.AcceptBtn);
        break;
		
        case this.PreviousBtn:
               this.highlight(this.TosBtn);
            break;
            
        case this.AcceptBtn:
            this.highlight(this.TosBtn);
        break;		
    }    
}


SceneCreateAccountStep4.prototype.processEnterKey = function(){
    alert("SceneCreateAccountStep4.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

     switch(currentHighlight)
    {
		/*case this.EulaBtn:
            this.goToReadPage(1);
            break;*/
            
        case this.TosBtn:
            this.goToReadPage(2);
        break;
		
		case this.PsBtn:
            this.goToReadPage(3);
        break;
		
        case this.PreviousBtn:
            this.processReturnKey();
        break;
        
        case this.AcceptBtn:
           ProcMgr.CreateAccount();
        break;					
    }
}

SceneCreateAccountStep4.prototype.processReturnKey = function(){
    alert("SceneCreateAccountStep4.processReturnKey() ");
    if(this.isReadMode == true)
	{
		this.goToAcceptPage();
	}
	else
	{
		WndMgr.BackStepCreateAccount();
	}   
}

SceneCreateAccountStep4.prototype.processExitKey = function(){
    alert("SceneCreateAccountStep4.processExitKey() ");
   
   ProcMgr.ExitWithSignIn();
}


///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////


SceneCreateAccountStep4.prototype.processClickEvent = function(obj){
	alert("SceneCreateAccountStep4.processClickEvent() ");
	
	if(obj == this.TopArrow)
	{
		this.scrollUp();
		return;
	}
	else if(obj == this.BottomArrow)
	{
		this.scrollDown();
		return;
	}
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

