function SceneFaceRecogNotRegisteredPopup(options) {
	this.options = options;
    
    this.MainView=null;
	this.MainViewDim=null;
    
    this.PopupMsg = null;
    
    this.ConnectionBtn = null;
    //this.CreateBtn = null;
    this.CancelBtn = null;
   
    this.CloseTimer = false;

}

SceneFaceRecogNotRegisteredPopup.prototype.initialize = function () {
	alert("SceneFaceRecogNotRegisteredPopup.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneFaceRecogNotRegisteredPopup.prototype.handleShow = function () {
	alert("SceneFaceRecogNotRegisteredPopup.handleShow()");
	// this function will be called when the scene manager show this scene 
	this.MainViewDim.show();
	
    this.highlight(this.ConnectionBtn);

    this.startTimer();
    
}

SceneFaceRecogNotRegisteredPopup.prototype.handleHide = function () {
	alert("SceneFaceRecogNotRegisteredPopup.handleHide()");
	// this function will be called when the scene manager hide this scene  

	this.MainViewDim.hide();
	
	if(this.CloseTimer== true)
	{
		this.stopTimer();
	}
}

SceneFaceRecogNotRegisteredPopup.prototype.handleFocus = function () {
	alert("SceneFaceRecogNotRegisteredPopup.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneFaceRecogNotRegisteredPopup.prototype.handleBlur = function () {
	alert("SceneFaceRecogNotRegisteredPopup.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneFaceRecogNotRegisteredPopup.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogNotRegisteredPopup.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
			this.resetTimer();
        	this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
			this.resetTimer();
        	this.processRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogNotRegisteredPopup.prototype.create = function(){
    alert("SceneFaceRecogNotRegisteredPopup.create()");
    
    this.MainView = new View("FaceRecogNotRegisteredPopup");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_NOT_REGISTERED_POPUP_BG); 
	 
	this.MainViewDim = new DimBg("FaceRecogNotRegisteredPopupDim", "FaceRecogNotRegisteredPopup");   
    
    this.PopupMsg = new Label(null,"face_recog_not_registered_popup_msg");
    this.PopupMsg.SetTextStyle("face_recog_not_registered_popup_msg_style");
    this.PopupMsg.SetText(TV_FACE_DOESNT_HAVE_ACCOUNT_MSG+"</br>"+TV_SKYPE_REGISTER_FACE_ACCOUNT_MSG+"</br>"+TV_DONT_HAVE_SKYPE_ACCOUNT_THEN_CREATE_MSG);
    
    var this_ = $.sfScene.get("FaceRecogNotRegisteredPopup");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.ConnectionBtn = new Button();
    this.ConnectionBtn.SetImageObjId("face_recog_not_registered_popup_connection_btn");
    this.ConnectionBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_L_BTN_NORMAL);
    this.ConnectionBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_L_BTN_NORMALFOCUS);	
    this.ConnectionBtn.SetTextObjId("face_recog_not_registered_popup_connection_btn_text");
    this.ConnectionBtn.SetText(TV_LINK_ACCOUNT);
    this.ConnectionBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_not_registered_popup_btn_text_style");
	this.ConnectionBtn.SetOnClickCallbackFunc(clickCF);
	
    /*this.CreateBtn = new Button();
    this.CreateBtn.SetImageObjId("face_recog_not_registered_popup_create_btn");
    this.CreateBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_L_BTN_NORMAL);
    this.CreateBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_L_BTN_NORMALFOCUS);	
    this.CreateBtn.SetTextObjId("face_recog_not_registered_popup_create_btn_text");
    this.CreateBtn.SetText(SID_CREATE_ACCOUNT);
    this.CreateBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_not_registered_popup_btn_text_style");
	this.CreateBtn.SetOnClickCallbackFunc(clickCF);*/
	
    this.CancelBtn = new Button();
    this.CancelBtn.SetImageObjId("face_recog_not_registered_popup_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_POPUP_BTN_NORMALFOCUS);	
    this.CancelBtn.SetTextObjId("face_recog_not_registered_popup_cancel_btn_text");
    this.CancelBtn.SetText(SID_CANCEL);
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_not_registered_popup_btn_text_style");
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);
    
}


SceneFaceRecogNotRegisteredPopup.prototype.highlight=function(obj)
{
    this.MainView.setCurrenHighlight(obj);

}

SceneFaceRecogNotRegisteredPopup.prototype.startTimer = function()
{
    alert("SceneFaceRecogNotRegisteredPopup.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('FaceRecogNotRegisteredPopup').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneFaceRecogNotRegisteredPopup.prototype.resetTimer = function()
{
    alert("SceneFaceRecogNotRegisteredPopup.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneFaceRecogNotRegisteredPopup.prototype.stopTimer = function()
{
    alert("SceneFaceRecogNotRegisteredPopup.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneFaceRecogNotRegisteredPopup.prototype.popupTimerCallback = function()
{
    alert("SceneFaceRecogNotRegisteredPopup.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
   WndMgr.BackStepFaceRecogSignin(); 
}

SceneFaceRecogNotRegisteredPopup.prototype.processLeftKey = function(){
    alert("SceneFaceRecogNotRegisteredPopup.processLeftKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
            
            
        case this.CancelBtn:
           this.highlight(this.ConnectionBtn);
            break;
    }
}

SceneFaceRecogNotRegisteredPopup.prototype.processRightKey = function(){
    alert("SceneFaceRecogNotRegisteredPopup.processRightKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.ConnectionBtn:
           this.highlight(this.CancelBtn);
            break;
            
            
    }
}

SceneFaceRecogNotRegisteredPopup.prototype.processEnterKey = function(){
    alert("SceneFaceRecogNotRegisteredPopup.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.ConnectionBtn:
			WndMgr.NextStepFaceRecogSignin(); 
            break;
            
            
        case this.CancelBtn:
		   WndMgr.BackStepFaceRecogSignin(); 
            break;
    }
}

SceneFaceRecogNotRegisteredPopup.prototype.processReturnKey = function(){
    alert("SceneFaceRecogNotRegisteredPopup.processReturnKey() ");
	
    WndMgr.BackStepFaceRecogSignin();  
}

SceneFaceRecogNotRegisteredPopup.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogNotRegisteredPopup.processClickEvent() ");
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

