
function SceneFaceRecogResult(options) {
	this.options = options;
    
    this.MainView=null;
    
    this.TitleLabel = null;
    
    this.SubView = new Array(4);
    
    this.MsgLabel = new Array(4);     	
    
    this.ResultBtn0 = null;
	this.ResultBtn1 = null;	
	this.ResultBtn2 = new Array(2);
	this.ResultBtn3 = new Array(3);
	
	this.ResultText1 = null;
	this.ResultText2 = new Array(2);
	this.ResultText3 = new Array(3);
	
    this.PwdModeBtn = null;
    this.RetryBtn = null;
    this.CancelBtn = null;
    
    this.ScrollBg=null;
    this.ScrollLeft=null;
    this.ScrollMiddle=null;
    this.ScrollRight=null;
    
    this.LeftArrow = null;
	this.RightArrow = null; 
    
    this.defaultHighLight = new Array(4); 

    this.DefaultHelpBar =null;

	//flag	
	this.flagWaiting = false;

	this.TempViweIndex =0;
	this.ViewIndex =0;
	
	this.RecogResult = null;
	this.DataIndex = 0;
}

SceneFaceRecogResult.prototype.initialize = function () {
	alert("SceneFaceRecogResult.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
    
}

SceneFaceRecogResult.prototype.handleShow = function () {
	alert("SceneFaceRecogResult.handleShow()");
	// this function will be called when the scene manager show this scene 

	this.initFaceRecogResult();
}

SceneFaceRecogResult.prototype.handleHide = function () {
	alert("SceneFaceRecogResult.handleHide()");
	// this function will be called when the scene manager hide this scene      
	
	this.highlight(null);
}

SceneFaceRecogResult.prototype.handleFocus = function () {
	alert("SceneFaceRecogResult.handleFocus()");
	// this function will be called when the scene manager focus this scene

    var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.PwdModeBtn);
    }
    else
    {
         this.highlight(currentHighlight);
    }
}

SceneFaceRecogResult.prototype.handleBlur = function () {
	alert("SceneFaceRecogResult.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
	if(currentHighlight !=null)
    {
    	currentHighlight.blur();
	}

}
 
SceneFaceRecogResult.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFaceRecogResult.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	if(this.flagWaiting==true)
	{
		return;	
	}
	
	switch (keyCode) {
		case $.sfKey.LEFT:
			this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
			this.processRightKey();
			break;
		case $.sfKey.UP:          
		case $.sfKey.DOWN:
			this.processUpDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
        
		case $.sfKey.TOOLS:
            
			break; 
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
			
		default:
            ProcMgr.processBlockKey(keyCode);
            break;

	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneFaceRecogResult.prototype.create = function(){
    alert("SceneFaceRecogResult.create()");
    this.MainView = new View("FaceRecogResult");
    this.MainView.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_BG);
    
    this.TitleLabel = new Label(null,"face_recog_result_title");
    this.TitleLabel.SetTextStyle("face_recog_result_title_style");
    this.TitleLabel.SetText(IDWS_MOIP_WELCOM_TO_SKYPE );  
    
    this.SubView[0] = new View("face_recog_result_0_view");
    this.SubView[1] = new View("face_recog_result_1_view");
    this.SubView[2] = new View("face_recog_result_2_view");
    this.SubView[3] = new View("face_recog_result_3_view");
    	
    this.MsgLabel[0] = new Label(null,"face_recog_result_0_msg");
    this.MsgLabel[0].SetTextStyle("face_recog_result_msg_style");
    this.MsgLabel[0].SetText(TV_THERE_ARE_NO_RECOGNIZED_FACES); 
    
    this.MsgLabel[1] = new Label(null,"face_recog_result_1_msg");
    this.MsgLabel[1].SetTextStyle("face_recog_result_msg_style");
    this.MsgLabel[1].SetText(TV_SELECT_YOUR_ACCOUNT);
    
    this.MsgLabel[2] = new Label(null,"face_recog_result_2_msg");
    this.MsgLabel[2].SetTextStyle("face_recog_result_msg_style");
    this.MsgLabel[2].SetText(TV_SELECT_YOUR_ACCOUNT); 
    
    this.MsgLabel[3] = new Label(null,"face_recog_result_3_msg");
    this.MsgLabel[3].SetTextStyle("face_recog_result_msg_style");
    this.MsgLabel[3].SetText(TV_SELECT_YOUR_ACCOUNT);  
	
	var this_ = $.sfScene.get("FaceRecogResult");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.ResultBtn0= new Button();
    this.ResultBtn0.SetImageObjId("face_recog_result_0_btn");
    this.ResultBtn0.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn0.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
    this.ResultBtn0.AppendFgImage("face_recog_result_0_btn_icon","15px","15px","107px","108px");
    this.ResultBtn0.SetFgImage(g_Image.IMAGE_FACE_RECOG_RESULT_QAUESTION_IMAGE);
	
    this.ResultBtn1= new Button();
    this.ResultBtn1.SetImageObjId("face_recog_result_1_btn");
    this.ResultBtn1.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn1.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
    this.ResultBtn1.AppendFgImage("face_recog_result_1_btn_icon","15px","15px","107px","108px");
    this.ResultBtn1.SetOnClickCallbackFunc(clickCF);
	
    this.ResultBtn2[0]= new Button();
    this.ResultBtn2[0].SetImageObjId("face_recog_result_2_1_btn");
    this.ResultBtn2[0].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn2[0].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
	this.ResultBtn2[0].AppendFgImage("face_recog_result_2_1_btn_icon","15px","15px","107px","108px");
	this.ResultBtn2[0].SetOnClickCallbackFunc(clickCF);
	
    this.ResultBtn2[1]= new Button();
    this.ResultBtn2[1].SetImageObjId("face_recog_result_2_2_btn");
    this.ResultBtn2[1].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn2[1].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
	this.ResultBtn2[1].AppendFgImage("face_recog_result_2_2_btn_icon","15px","15px","107px","108px");
	this.ResultBtn2[1].SetOnClickCallbackFunc(clickCF);
	
    this.ResultBtn3[0]= new Button();
    this.ResultBtn3[0].SetImageObjId("face_recog_result_3_1_btn");
    this.ResultBtn3[0].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn3[0].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
	this.ResultBtn3[0].AppendFgImage("face_recog_result_3_1_btn_icon","15px","15px","107px","108px");
	this.ResultBtn3[0].SetOnClickCallbackFunc(clickCF);
	
    this.ResultBtn3[1]= new Button();
    this.ResultBtn3[1].SetImageObjId("face_recog_result_3_2_btn");
    this.ResultBtn3[1].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn3[1].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
	this.ResultBtn3[1].AppendFgImage("face_recog_result_3_2_btn_icon","15px","15px","107px","108px");
	this.ResultBtn3[1].SetOnClickCallbackFunc(clickCF);
	
    this.ResultBtn3[2]= new Button();
    this.ResultBtn3[2].SetImageObjId("face_recog_result_3_3_btn");
    this.ResultBtn3[2].SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMAL);
    this.ResultBtn3[2].SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_IMAGE_BTN_NORMALFOCUS);
	this.ResultBtn3[2].AppendFgImage("face_recog_result_3_3_btn_icon","15px","15px","107px","108px");
	this.ResultBtn3[2].SetOnClickCallbackFunc(clickCF);
	
    this.ResultText1 = new Label(null,"face_recog_result_1_text");
    this.ResultText1.SetTextStyle("face_recog_result_text_style");
    this.ResultText1.SetText("text1");
    
    this.ResultText2[0] = new Label(null,"face_recog_result_2_1_text");
    this.ResultText2[0].SetTextStyle("face_recog_result_text_style");
    this.ResultText2[0].SetReverseDisable(true);
    this.ResultText2[0].SetIsPlainText(true);
    this.ResultText2[0].SetText("text2_1");
    
    
    this.ResultText2[1] = new Label(null,"face_recog_result_2_2_text");
    this.ResultText2[1].SetTextStyle("face_recog_result_text_style");
    this.ResultText2[1].SetReverseDisable(true);
    this.ResultText2[1].SetIsPlainText(true);
    this.ResultText2[1].SetText("text2_2");
    
    this.ResultText3[0] = new Label(null,"face_recog_result_3_1_text");
    this.ResultText3[0].SetTextStyle("face_recog_result_text_style");
    this.ResultText3[0].SetReverseDisable(true);
    this.ResultText3[0].SetIsPlainText(true);
    this.ResultText3[0].SetText("text3_1");
    
    this.ResultText3[1] = new Label(null,"face_recog_result_3_2_text");
    this.ResultText3[1].SetTextStyle("face_recog_result_text_style");
    this.ResultText3[1].SetReverseDisable(true);
    this.ResultText3[1].SetIsPlainText(true);
    this.ResultText3[1].SetText("text3_2");
    
    this.ResultText3[2] = new Label(null,"face_recog_result_3_3_text");
    this.ResultText3[2].SetTextStyle("face_recog_result_text_style");
    this.ResultText3[2].SetReverseDisable(true);
    this.ResultText3[2].SetIsPlainText(true);
    this.ResultText3[2].SetText("text3_3");	

    this.PwdModeBtn= new Button();
    this.PwdModeBtn.SetImageObjId("face_recog_result_pwd_mode_btn");
    this.PwdModeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMAL);
    this.PwdModeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMALFOCUS);
	this.PwdModeBtn.SetTextObjId("face_recog_result_pwd_mode_btn_text");
    this.PwdModeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_result_btn_normal_style");
	this.PwdModeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_result_btn_select_style");
	this.PwdModeBtn.SetText(TV_PASSWORD_MODE);
	this.PwdModeBtn.SetOnClickCallbackFunc(clickCF);
	
    this.RetryBtn= new Button();
    this.RetryBtn.SetImageObjId("face_recog_result_retry_btn");
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMAL);
    this.RetryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMALFOCUS);
	this.RetryBtn.SetTextObjId("face_recog_result_retry_btn_text");
    this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_result_btn_normal_style");
	this.RetryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_result_btn_select_style");
	this.RetryBtn.SetText(SID_RETRY_KR_RETRY);
	this.RetryBtn.SetOnClickCallbackFunc(clickCF);
	
    this.CancelBtn= new Button();
    this.CancelBtn.SetImageObjId("face_recog_result_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_FACE_RECOG_RESULT_BTN_NORMALFOCUS);
	this.CancelBtn.SetTextObjId("face_recog_result_cancel_btn_text");
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"face_recog_result_btn_normal_style");
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"face_recog_result_btn_select_style");
	this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);
	
	this.defaultHighLight[0]=this.RetryBtn;
	this.defaultHighLight[1]=this.ResultBtn1;
	this.defaultHighLight[2]=this.ResultBtn2[0];
	this.defaultHighLight[3]=this.ResultBtn3[0];
	
    this.ScrollBg= new Label("face_recog_result_scroll_bg", null);
    this.ScrollBg.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_SCROLLBAR_BG);
    
    this.ScrollLeft= new Label("face_recog_result_scroll_left", null);
    this.ScrollLeft.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_SCROLLBAR_LEFT);
    
    this.ScrollRight= new Label("face_recog_result_scroll_right", null);
    this.ScrollRight.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_SCROLLBAR_RIGHT);
    
    this.ScrollMiddle= new Label("face_recog_result_scroll_middle", null);
    this.ScrollMiddle.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_SCROLLBAR_MIDDLE);
	
    this.LeftArrow= new Label("face_recog_result_left_arrow", null);
    this.LeftArrow.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_LEFT_ARROW_NOR);
    this.LeftArrow.SetOnClickCallbackFunc(clickCF);
    this.LeftArrow.SetOnMouseOutOverImage(g_Image.IMAGE_FACE_RECOG_RESULT_LEFT_ARROW_NOR, g_Image.IMAGE_FACE_RECOG_RESULT_LEFT_ARROW_SEL);

    this.RightArrow= new Label("face_recog_result_right_arrow", null);
    this.RightArrow.SetBgImage(g_Image.IMAGE_FACE_RECOG_RESULT_RIGHT_ARROW_NOR);
    this.RightArrow.SetOnClickCallbackFunc(clickCF);
    this.RightArrow.SetOnMouseOutOverImage(g_Image.IMAGE_FACE_RECOG_RESULT_RIGHT_ARROW_NOR, g_Image.IMAGE_FACE_RECOG_RESULT_RIGHT_ARROW_SEL);


    this.DefaultHelpBar = new HelpBar(HelpBarIndex.FACE_RECOG_RESULT,"FaceRecogResult");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
	this.MainView.registHelpBar(this.DefaultHelpBar);
}


SceneFaceRecogResult.prototype.initFaceRecogResult = function(){
   
   this.RecogResult = null;
   this.RecogResult = g_Data.GetFaceRecogResult();
   
   alert("SceneFaceRecogResult.initFaceRecogResult() -> length of RecogResult : "+this.RecogResult.length );
   
   if(this.RecogResult.length >=3)
   {
   		this.ViewIndex = 3;
   }
   else
   {
   	 this.ViewIndex = this.RecogResult.length;
   	 this.hiddenArrow();
   	 this.hiddenScrollBar();
   }
   
    alert("SceneFaceRecogResult.initFaceRecogResult() -> index of view : "+this.ViewIndex);
   
   if(this.ViewIndex>0)
   {
   	 this.initData();
   }

    for(var a=0; a<this.SubView.length; a++)
    {    	
    	if(a==this.ViewIndex)
    	{
    		this.SubView[a].visibleObj();
    	}
    	else
    	{
    		this.SubView[a].hiddenObj();
    	}
    }
    
    this.highlight(this.defaultHighLight[this.ViewIndex]);
      
}

SceneFaceRecogResult.prototype.initData = function(){
    alert("SceneFaceRecogResult.initData() ");
    
    this.DataIndex =0;
   
    if(this.ViewIndex==1)
    {		
    	this.ResultBtn1.SetFgImage("");//init
    	this.ResultBtn1.SetFgImage(this.RecogResult[0].face+g_Data.GetImgSuffixPath());
    	
    	if(this.RecogResult[0].registered== true)
    	{
    		this.ResultText1.SetText(this.RecogResult[0].id);
    	}
    	else
    	{	
    		this.ResultText1.SetText(TV_NOT_REGISTERED);   		
    	}
    }
    else if(this.ViewIndex==2)
    {
    	 for(var a=0; a<this.ViewIndex; a++)
    	{
	    	this.ResultBtn2[a].SetFgImage("");//init
	    	this.ResultBtn2[a].SetFgImage(this.RecogResult[a].face+g_Data.GetImgSuffixPath());
	    	
	    	if(this.RecogResult[a].registered== true)
	    	{
	    		this.ResultText2[a].SetText(this.RecogResult[a].id);
	    	}
	    	else
	    	{
	    		this.ResultText2[a].SetText(TV_NOT_REGISTERED);   		
	    	}
    	}
    }
    else
    {    	
		this.updateView3Data();
		
		if(this.RecogResult.length==3)
		{
			this.hiddenScrollBar();
		}
		else
		{
			this.visibleScrollBar();
		}		
    }  
}

SceneFaceRecogResult.prototype.updateView3Data = function(){
	
	for(var a=0; a<this.ViewIndex; a++)
	{
    	this.ResultBtn3[a].SetFgImage("");//init
    	this.ResultBtn3[a].SetFgImage(this.RecogResult[a+this.DataIndex].face+g_Data.GetImgSuffixPath());
    	
    	if(this.RecogResult[a+this.DataIndex].registered== true)
    	{
    		this.ResultText3[a].SetText(this.RecogResult[a+this.DataIndex].id);
    	}
    	else
    	{
    		this.ResultText3[a].SetText(TV_NOT_REGISTERED);   		
    	}
	}
	
	this.updateScrollBar();
	this.toggleArrow();
}

SceneFaceRecogResult.prototype.hiddenScrollBar = function()
{ 
	this.ScrollBg.hiddenObj();
	this.ScrollLeft.hiddenObj();
	this.ScrollMiddle.hiddenObj();
	this.ScrollRight.hiddenObj();
}

SceneFaceRecogResult.prototype.visibleScrollBar = function()
{ 
	this.ScrollBg.visibleObj();
	this.ScrollLeft.visibleObj();
	this.ScrollMiddle.visibleObj();
	this.ScrollRight.visibleObj();
}

SceneFaceRecogResult.prototype.updateScrollBar = function(){  	 
    var total_item = this.RecogResult.length;//2;
    
    if(total_item==3)
    {
    	return
    }
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    var max_scroll_length = 634;//331;
    var init_scroll_start_position = 163;//87;
    var curr_scroll_start_position = init_scroll_start_position;
    var curr_scroll_length=0;   

    var scroll_rate= Math.floor(max_scroll_length / total_item);

    var left_item = this.DataIndex;
    var extra_length =max_scroll_length - (scroll_rate*total_item)
    
    curr_scroll_start_position =  init_scroll_start_position +(scroll_rate*left_item);
    curr_scroll_length = (scroll_rate*3) + extra_length;
   
    var middle_left = String(curr_scroll_start_position);
    var middle_width = String(curr_scroll_length);
    
    var scroll_left = String(curr_scroll_start_position-5);
    var scroll_right = String(curr_scroll_start_position+curr_scroll_length);

    $("#face_recog_result_scroll_middle").css("left",  middle_left+"px");
    $("#face_recog_result_scroll_middle").width(middle_width+"px");
    
    $("#face_recog_result_scroll_left").css("left",  scroll_left+"px");
    $("#face_recog_result_scroll_right").css("left",  scroll_right+"px");
    
    
   alert("SceneEditProfile.updateScrollBar() left: "+ scroll_left+" length : "+middle_width+" right : " + scroll_right);

}

SceneFaceRecogResult.prototype.hiddenArrow = function()
{
	alert("SceneFaceRecogResult.hiddenArrow() ");

	this.LeftArrow.hiddenObj();
	this.RightArrow.hiddenObj();
}

SceneFaceRecogResult.prototype.toggleArrow = function()
{
	alert("SceneFaceRecogResult.toggleArrow() ");
	
	if(this.RecogResult.length==3)
    {
    	this.LeftArrow.hiddenObj();
		this.RightArrow.hiddenObj();
    }
    else
    {
    	if(this.DataIndex ==0)
    	{
    		this.LeftArrow.hiddenObj();
    	}
    	else
    	{
    		this.LeftArrow.visibleObj();
    	}
    	
    	if(this.DataIndex+2 ==this.RecogResult.length-1)
    	{
    		this.RightArrow.hiddenObj();
    	}
    	else
    	{
    		this.RightArrow.visibleObj();
    	}
    }
}


SceneFaceRecogResult.prototype.moveDataToLeft= function(){
    alert("SceneFaceRecogResult.moveDataToLeft() ");

    if(this.RecogResult.length==3)
    {
    	return false;
    }
    
	if(this.DataIndex >0)
	{
		this.DataIndex--;
		this.updateView3Data();    		
	}
    
    return true;
}

SceneFaceRecogResult.prototype.moveDataToRight = function(){
    alert("SceneFaceRecogResult.moveDataToRight() ");
    
    if(this.RecogResult.length==3)
    {
    	return false;
    }

	if(this.DataIndex+2 <this.RecogResult.length-1)
	{
		this.DataIndex++;
		this.updateView3Data();    		
	}

    return true;
}

SceneFaceRecogResult.prototype.getSelectedDataIndex= function(){ 
    var currentHighlight =  this.MainView.getCurrentHighlight();
    var btnIndex =0;
    
    if(this.ViewIndex==1)
    {
    	btnIndex=0;
    }
    else if(this.ViewIndex==2)
    {
    	for(btnIndex=0; btnIndex<this.ResultBtn2.length; btnIndex++)
	    {
	    	if(currentHighlight==this.ResultBtn2[btnIndex])
	    	{
	    		break;
	    	}
	    }
    }
    else
    {
    	for(btnIndex=0; btnIndex<this.ResultBtn3.length; btnIndex++)
	    {
	    	if(currentHighlight==this.ResultBtn3[btnIndex])
	    	{
	    		break;
	    	}
	    }
    }
    
    var selectedDataIndex =this.DataIndex+btnIndex;
    
    alert("SceneFaceRecogResult.getSelectedData() selectedDataIndex");
	return selectedDataIndex;
}

SceneFaceRecogResult.prototype.highlight=function(obj)
{
	alert("SceneFaceRecogResult.highlight()");
	
    this.MainView.setCurrenHighlight(obj);	
}

SceneFaceRecogResult.prototype.processLeftKey = function(){
    alert("SceneFaceRecogResult.processLeftKey() ");
        
    var currentHighlight =  this.MainView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.PwdModeBtn:
        	this.highlight(this.CancelBtn);
            break;
            
        case this.RetryBtn:
			this.highlight(this.PwdModeBtn);
            break;
            
        case this.CancelBtn:
			this.highlight(this.RetryBtn);
            break;
            
        case this.ResultBtn2[0]:   
			this.highlight(this.ResultBtn2[1]);
            break;
            
        case this.ResultBtn2[1]:      
			this.highlight(this.ResultBtn2[0]);
            break;
        
        case this.ResultBtn3[0]: 
        	if(this.moveDataToLeft()==false)
		    {
		    	this.highlight(this.ResultBtn3[2]);
		    }        			
            break;
        
        case this.ResultBtn3[1]:      
			this.highlight(this.ResultBtn3[0]);
            break;
            
        case this.ResultBtn3[2]:      
			this.highlight(this.ResultBtn3[1]);
            break;
        	
    }
}

SceneFaceRecogResult.prototype.processRightKey = function(){
    alert("SceneFaceRecogResult.processRightKey() ");
        
    var currentHighlight =  this.MainView.getCurrentHighlight();
	
    switch(currentHighlight)
    {
        case this.PwdModeBtn:
        	this.highlight(this.RetryBtn);
            break;
            
        case this.RetryBtn:
			this.highlight(this.CancelBtn);
            break;
            
        case this.CancelBtn:
			this.highlight(this.PwdModeBtn);
            break;
            
        case this.ResultBtn2[0]:      
			this.highlight(this.ResultBtn2[1]);
            break;
            
        case this.ResultBtn2[1]:      
			this.highlight(this.ResultBtn2[0]);
            break;
        
        case this.ResultBtn3[0]:      
			this.highlight(this.ResultBtn3[1]);
            break;
        
        case this.ResultBtn3[1]:      
			this.highlight(this.ResultBtn3[2]);
            break;
            
        case this.ResultBtn3[2]:
            if(this.moveDataToRight()==false)
		    {
		    	this.highlight(this.ResultBtn3[0]);
		    }      			
            break;
    }
}

SceneFaceRecogResult.prototype.processUpDownKey = function(){
    alert("SceneFaceRecogResult.processUpDownKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();
   	
    switch(currentHighlight)
    {
        case this.PwdModeBtn:
        case this.RetryBtn:
        case this.CancelBtn:
        	
        	if(this.ViewIndex !=0 && this.ViewIndex <4)
        	{
        		this.highlight(this.defaultHighLight[this.ViewIndex]);
        	}
            break;
        
        case this.ResultBtn1:     
        case this.ResultBtn2[0]:      
        case this.ResultBtn2[1]:      
        case this.ResultBtn3[0]:      
        case this.ResultBtn3[1]:      
        case this.ResultBtn3[2]:  
           
         	this.highlight(this.defaultHighLight[0]);
       		break;        	
    }
}


SceneFaceRecogResult.prototype.processEnterKey = function(){
    alert("SceneFaceRecogResult.processEnterKey() ");
    
    var currentHighlight =  this.MainView.getCurrentHighlight();

    switch(currentHighlight)
    {       
        case this.PwdModeBtn:
			StateMgr.Start_Signin_State(); 			
            break;
            
        case this.RetryBtn:
			ProcMgr.RetryFaceRecogSignin();
            break;
            
        case this.CancelBtn:
			StateMgr.Start_Welcome_State();
            break;
            
        case this.ResultBtn1:     
        case this.ResultBtn2[0]:      
        case this.ResultBtn2[1]:      
        case this.ResultBtn3[0]:      
        case this.ResultBtn3[1]:      
        case this.ResultBtn3[2]:  
           
         	var selectedIndex = this.getSelectedDataIndex();
         	ProcMgr.ProcessSelectedRecogResult(selectedIndex);
       		break; 
    }
}


SceneFaceRecogResult.prototype.processReturnKey = function(){
    alert("SceneFaceRecogResult.processReturnKey() ");
	
   StateMgr.Start_Welcome_State();
}

SceneFaceRecogResult.prototype.processExitKey = function(){
    alert("SceneFaceRecogResult.processExitKey() ");
	  
   ProcMgr.ExitWithSignIn();
}


SceneFaceRecogResult.prototype.processClickEvent = function(obj){
	alert("SceneFaceRecogResult.processClickEvent() ");
	
	if(obj == this.LeftArrow)
	{
		this.moveDataToLeft();
		return;
	}
	
	if(obj == this.LeftArrow)
	{
		this.moveDataToRight();
		return;
	}
	
	var currentHighlight =  this.MainView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

