function SceneListMain(options) {
	this.options = options;
    
    this.ListMainView=null;
    this.AvataFrameLabel=null;
    this.AvataImageLabel=null;
    this.OnlineStatusLabel=null;
    this.SkypeNameLabel=null;
    this.MoodMessageLabel=null;

	this.SkypeCreditValueBg=null;
    this.SkypeCreditValueLabel=null;
    this.SkypeCreditZeroValueLabel=new Array(3);
    
    this.ListMainContactBtn=null;
    ///this.ListMainChatBtn=null;
    this.ListMainHistoryBtn=null;
    this.ListMainCallBtn=null;
    this.ListMainLiveCallBtn=null;
    this.ListMainSettingBtn=null;
    //this.NewChatMessageBtn=null;
    
    this.ContactHelpBar =null;
    this.DefaultHelpBar =null;
    
    this.iCurrentSubScene = 0;
    
    //this.BtnList = new Array(5);
    this.BtnList = new Array(4);
    
    this.destroyFlag = true;
    this.liveCallFlag = false;
    
    this.flagFocus = false;
}

SceneListMain.prototype.initialize = function () {
	alert("SceneListMain.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   
    this.create();
}

SceneListMain.prototype.handleShow = function () {
	alert("SceneListMain.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.initListMain();
}

SceneListMain.prototype.handleHide = function () {
	alert("SceneListMain.handleHide()");
	// this function will be called when the scene manager hide this scene  
    
    //$.sfScene.hide(this.SubSceneId[this.iCurrentSubScene]);
    WndMgr.HideMainSub(this.iCurrentSubScene);
}

SceneListMain.prototype.handleFocus = function () {
	alert("SceneListMain.handleFocus()");
	// this function will be called when the scene manager focus this scene

     var a=0;
     for(a=0; a<this.BtnList.length; a++)
     {
         this.BtnList[a].flagSelect = false;
     }
     
    this.highlight(this.BtnList[this.iCurrentSubScene].obj, this.iCurrentSubScene);
    
    this.flagFocus = true;
}

SceneListMain.prototype.handleBlur = function () {
	alert("SceneListMain.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    if(this.BtnList[this.iCurrentSubScene].flagSelect == false)
    {
        this.BtnList[this.iCurrentSubScene].obj.blur();
    }
    
    this.flagFocus = false;
}

SceneListMain.prototype.handleKeyDown = function (keyCode) {
	alert("SceneListMain.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
			break;
		case $.sfKey.RIGHT:
			this.processRightKey();
			break;
		case $.sfKey.UP:
            this.processUpKey();
			break;
		case $.sfKey.DOWN:
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
       case $.sfKey.RED:
            this.processRedKey();
			break;
        
        case $.sfKey.YELLOW:
            this.processYellowKey();
			break;

        case $.sfKey.BLUE:
            this.processBlue();
			break;
			            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
        
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
            
       default:
            ProcMgr.processBlockKey(keyCode);
            break;  
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMain.prototype.create = function(){
    alert("SceneListMain.create()");
    this.ListMainView = new View("ListMain");
    this.ListMainView.SetBgImage(g_Image.IMAGE_LIST_MAIN_BG);
    
    this.AvataFrameLabel= new Label("list_main_avata_frame", null);
    this.AvataFrameLabel.SetBgImage(g_Image.IMAGE_LIST_MAIN_ONLY_MY_THUMBNAIL);
    this.AvataFrameLabel.AppendFgImage("list_main_avata_image","7px","7px","60px","60px");

    this.OnlineStatusLabel= new Label("list_main_online_status", null);

    this.SkypeNameLabel = new Label(null,"list_main_skype_name");
    this.SkypeNameLabel.SetTextStyle("list_main_skype_name_style");
    this.SkypeNameLabel.SetReverseDisable(true);
    this.SkypeNameLabel.SetIsPlainText(true);

    this.MoodMessageLabel = new Label(null,"list_main_mood_message");
    this.MoodMessageLabel.SetTextStyle("list_main_mood_message_style");
    this.MoodMessageLabel.SetReverseDisable(true);
    this.MoodMessageLabel.SetIsPlainText(true);
    
    this.SkypeCreditValueBg= new Label("list_main_skype_credit_value_bg", null);
    this.SkypeCreditValueBg.SetBgImage(g_Image.IMAGE_LIST_MAIN_CREDIT_BTN);
 
    this.SkypeCreditValueLabel= new Label(null, "list_main_skype_credit_value");
    this.SkypeCreditValueLabel.SetTextStyle("list_main_skype_credit_value_style");
    this.SkypeCreditValueLabel.SetReverseDisable(true);
    
    this.SkypeCreditZeroValueLabel[0]= new Label(null, "list_main_skype_credit_zero_value_1");
    this.SkypeCreditZeroValueLabel[0].SetTextStyle("list_main_skype_credit_zero_value_style_1");
    this.SkypeCreditZeroValueLabel[0].SetText(TV_SID_SKYPE_CREDIT);
    
    this.SkypeCreditZeroValueLabel[1]= new Label(null, "list_main_skype_credit_zero_value_2");
    this.SkypeCreditZeroValueLabel[1].SetTextStyle("list_main_skype_credit_zero_value_style_2");
    this.SkypeCreditZeroValueLabel[1].SetText(":");
    
    this.SkypeCreditZeroValueLabel[2]= new Label(null, "list_main_skype_credit_zero_value_3");
    this.SkypeCreditZeroValueLabel[2].SetTextStyle("list_main_skype_credit_zero_value_style_3");
    this.SkypeCreditZeroValueLabel[2].SetText("0");

	var this_ = $.sfScene.get('ListMain');
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    this.ListMainContactBtn = new Button();
    this.ListMainContactBtn.SetImageObjId("list_main_contact_btn");
    this.ListMainContactBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.ListMainContactBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
	this.ListMainContactBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainContactBtn.SetTextObjId("list_main_contact_btn_text");
    this.ListMainContactBtn.SetText(IDWS_MOIP_CONTACTS_KR_CONTACK);
    this.ListMainContactBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainContactBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");     	
			
    // delete chat
    /*this.ListMainChatBtn = new Button();
    this.ListMainChatBtn.SetImageObjId("list_main_chat_btn");
    this.ListMainChatBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.ListMainChatBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
    this.ListMainChatBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainChatBtn.SetTextObjId("list_main_chat_btn_text");
    this.ListMainChatBtn.SetText(TV_SID_CHAT);
    this.ListMainChatBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainChatBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");*/


    this.ListMainHistoryBtn = new Button();
    this.ListMainHistoryBtn.SetImageObjId("list_main_history_btn");
    this.ListMainHistoryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG,null);
    this.ListMainHistoryBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
	this.ListMainHistoryBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainHistoryBtn.SetTextObjId("list_main_history_btn_text");
    this.ListMainHistoryBtn.SetText(SID_HISTORY_KR_CALL);
    this.ListMainHistoryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainHistoryBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");



    this.ListMainCallBtn = new Button();
    this.ListMainCallBtn.SetImageObjId("list_main_call_btn");
    this.ListMainCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.ListMainCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
    this.ListMainCallBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainCallBtn.SetTextObjId("list_main_call_btn_text");
	this.ListMainCallBtn.SetIsTextInTable(true);
    this.ListMainCallBtn.SetText(IDWS_MOIP_CALL_PHONES); //(SID_CALL_KR_CALL);
    this.ListMainCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");
    this.ListMainCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_SELECTED_STYLE,"list_main_category_btn_style_focus");



    this.ListMainLiveCallBtn = new Button();
    this.ListMainLiveCallBtn.SetImageObjId("list_main_live_call_btn");
    this.ListMainLiveCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.ListMainLiveCallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
    this.ListMainLiveCallBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainLiveCallBtn.SetTextObjId("list_main_live_call_btn_text");
	this.ListMainLiveCallBtn.SetIsTextInTable(true);    
    this.ListMainLiveCallBtn.SetText(TV_SID_LIVE_CALL);
    this.ListMainLiveCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainLiveCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");
    this.ListMainLiveCallBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_SELECTED_STYLE,"list_main_category_btn_style_focus");



    this.ListMainSettingBtn = new Button();
    this.ListMainSettingBtn.SetImageObjId("list_main_setting_btn");
    this.ListMainSettingBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.ListMainSettingBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_NORMALFOCUS);
	this.ListMainSettingBtn.SetBgImage(BtnImgIndex.BTN_SELECTED_IMG, g_Image.IMAGE_LIST_MAIN_CATEGORY_BTN_SELECTED);
    this.ListMainSettingBtn.SetTextObjId("list_main_setting_btn_text");
    this.ListMainSettingBtn.SetText(SID_SETTINGS);
    this.ListMainSettingBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_category_btn_style_nor");
    this.ListMainSettingBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"list_main_category_btn_style_focus");

	this.AdjustBtnText();
    
    this.ListMainContactBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_CONTACT_BTN_ICON);		
	this.ListMainContactBtn.SetOnClickCallbackFunc(clickCF);
    
    /*this.ListMainChatBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_CHAT_BTN_ICON);	
    this.ListMainChatBtn.SetOnClickCallbackFunc(clickCF);*/	

    this.ListMainHistoryBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_HISTORY_BTN_ICON);    
    this.ListMainHistoryBtn.SetOnClickCallbackFunc(clickCF);	
    
    this.ListMainCallBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_CALL_BTN_ICON);       
    this.ListMainCallBtn.SetOnClickCallbackFunc(clickCF);	
    
    this.ListMainLiveCallBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_LIVE_CALL_BTN_ICON);        
    this.ListMainLiveCallBtn.SetOnClickCallbackFunc(clickCF);   

    this.ListMainSettingBtn.SetFgImage(g_Image.IMAGE_LIST_MAIN_CATEGORY_SETTINGS_BTN_ICON);    
    this.ListMainSettingBtn.SetOnClickCallbackFunc(clickCF);
    

   /* this.NewChatMessageBtn = new Button();
    this.NewChatMessageBtn.SetImageObjId("list_main_new_chat_msg_btn");
    this.NewChatMessageBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_MSG_BALLON);
    this.NewChatMessageBtn.SetTextObjId("list_main_new_chat_msg_btn_text");
    this.NewChatMessageBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"list_main_new_chat_msg_btn_style");*/
	
    this.ContactHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CONTACT,"SceneListMain");
    this.ContactHelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.ContactHelpBar.SetOnClickCallbackFunc(2, function(){this_.processYellowKey();});
    this.ContactHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_DEFAULT,"SceneListMain");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.DefaultHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});

    this.ListMainContactBtn.registHelpBar( this.ContactHelpBar);
    //this.ListMainChatBtn.registHelpBar( this.DefaultHelpBar);
    this.ListMainHistoryBtn.registHelpBar( this.DefaultHelpBar);
    this.ListMainCallBtn.registHelpBar( this.DefaultHelpBar);
    this.ListMainSettingBtn.registHelpBar( this.DefaultHelpBar);
    this.ListMainLiveCallBtn.registHelpBar( this.DefaultHelpBar);
    
	var a=0;
	for(a=0; a<this.BtnList.length; a++)
	{
	    this.BtnList[a]=new Object();
	}
	

}

SceneListMain.prototype.setDestroyFlag= function(destroy_flag){
     this.destroyFlag = destroy_flag;
}

SceneListMain.prototype.setLiveCallFlag= function(live_call_flag){
     this.liveCallFlag = live_call_flag;
}

SceneListMain.prototype.initListMain=function()
{
    alert("SceneListMain.initListMain()");
    
    this.update();
    
    if(this.destroyFlag==true)
    {
        this.iCurrentSubScene = 0;
        var a=0;
        for(a=0; a<this.BtnList.length; a++)
        {
            this.BtnList[a].flagSelect = false;
        }

        this.BtnList[0].obj =  this.ListMainContactBtn;
        //this.BtnList[1].obj =  this.ListMainChatBtn;
        this.BtnList[1].obj =  this.ListMainHistoryBtn;
        this.BtnList[2].obj =  this.ListMainCallBtn;
        this.BtnList[3].obj =  this.ListMainSettingBtn;
        
        this.ListMainCallBtn.visibleObj();
        this.ListMainLiveCallBtn.hiddenObj();

        this.destroyFlag = false;
    }
    
    if( this.liveCallFlag==true)
    {
        this.ListMainCallBtn.hiddenObj();
        this.BtnList[2].obj =  this.ListMainLiveCallBtn;
        this.ListMainLiveCallBtn.visibleObj();
    }
    else
    {
        this.ListMainLiveCallBtn.hiddenObj();
        this.BtnList[2].obj =  this.ListMainCallBtn;
        this.ListMainCallBtn.visibleObj();
    }
    
    if(this.BtnList[2].flagSelect ==true)
    {
         this.BtnList[2].obj.select();
    }
	
	//this.UpdateNewChatNum();	
	
}

/*SceneListMain.prototype.UpdateNewChatNum=function(){
	
	var NumOfMsg = PluginAPIMgr.GetTotalNumOfUnReadChats();
	
	alert("UpdateNewChatNum >>  NumOfMsg=" + NumOfMsg);
		
	if(NumOfMsg > 0){
		
		if(NumOfMsg > 999){
			NumOfMsg = 999;
		}			
		this.NewChatMessageBtn.SetText(NumOfMsg);
		this.NewChatMessageBtn.visibleObj();
		
	}
	else{	
		this.NewChatMessageBtn.hiddenObj();
	}
		
}*/

SceneListMain.prototype.toggleCameraOffBtnEnable=function()
{
    alert("SceneListMain.toggleCameraOffBtnEnable() ");
    
    var camera_state = PluginAPIMgr.GetCameraState();
    
    if(camera_state == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || camera_state == ENUM_CAM_STATE.CAM_STATE_CONNECTING)
    {
        alert("SceneListMain.toggleCameraOffBtnEnable() Dim : true ->  camera_state : "+ camera_state );
    }
    else
    {
        alert("SceneListMain.toggleCameraOffBtnEnable() Dim :  false ");
        if(PluginAPIMgr.IsInCall()==1)
		{
			PluginAPIMgr.StartRecord();
		}
    }    
}

SceneListMain.prototype.update=function()
{
    alert("SceneListMain.update()");
    this.updateAvata();
    this.updateOnlineStatus();
    this.updateSkypeName();
    this.updateMoodMessage();
    this.updateCredit();
}

SceneListMain.prototype.updateAvata = function()
{	
    this.AvataFrameLabel.SetFgImage(PluginAPIMgr.GetMyAvataImageForMain());	
}

SceneListMain.prototype.updateOnlineStatus= function()
{
    this.OnlineStatusLabel.SetBgImage(PluginAPIMgr.GetMyOnlineStateImage());
}

SceneListMain.prototype.updateSkypeName = function()
{
     this.SkypeNameLabel.SetText(PluginAPIMgr.GetMyDisplayName());
}

SceneListMain.prototype.updateMoodMessage= function()
{
    this.MoodMessageLabel.SetText(PluginAPIMgr.GetMyMoodMsg());
}

SceneListMain.prototype.updateCredit = function(){
	
	if(PluginAPIMgr.GetMyBalance() > 0 )
	{
		this.SkypeCreditValueLabel.SetText(PluginAPIMgr.GetMyCredit());
		this.SkypeCreditValueLabel.visibleObj();
		this.SkypeCreditZeroValueLabel[0].hiddenObj();
		this.SkypeCreditZeroValueLabel[1].hiddenObj();
		this.SkypeCreditZeroValueLabel[2].hiddenObj();
	}
	else 
	{
		//this.SkypeCreditValueLabel.SetText(TV_SID_SKYPE_CREDIT+" : "+"0");
		this.SkypeCreditValueLabel.hiddenObj();
		this.SkypeCreditZeroValueLabel[0].visibleObj();
		this.SkypeCreditZeroValueLabel[1].visibleObj();
		this.SkypeCreditZeroValueLabel[2].visibleObj();
	}	
}


SceneListMain.prototype.highlight=function(obj, index)
{
	alert("SceneListMain.highlight()");
	
    this.ListMainView.setCurrenHighlight(obj);

    if(index != this.iCurrentSubScene)
    {
       WndMgr.HideMainSub(this.iCurrentSubScene);
        this.iCurrentSubScene = index;
    }
 
    WndMgr.ShowMainSub(this.iCurrentSubScene);
}

SceneListMain.prototype.select=function(obj)
{
	alert("SceneListMain.select()");
	if( WndMgr.CheckMoveSubToMain(this.iCurrentSubScene) == false ){
		return;
	}
		
	this.ListMainView.setCurrentSelect(obj);     
	this.BtnList[this.iCurrentSubScene].flagSelect = true;
	
	WndMgr.SelectMainSub(this.iCurrentSubScene);
   
}

SceneListMain.prototype.selectOnCurrHighlight=function()
{
	alert("SceneListMain.selectOnCurrHighlight()");
	var currentHighlight =  this.ListMainView.getCurrentHighlight();
	if(currentHighlight!=null)
	{
		this.select(currentHighlight);
	}	
}

SceneListMain.prototype.processDownKey = function(){
    alert("SceneListMain.processDownKey() ");
    var currentHighlight =  this.ListMainView.getCurrentHighlight();
    
    var a =0;
    for(a=0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a+1;
            if(b==this.BtnList.length) { b=0;}
            this.highlight(this.BtnList[b].obj, b);
        }
     }
}

SceneListMain.prototype.processUpKey = function(){
    alert("SceneListMain.processUpKey() ");
    
    var currentHighlight =  this.ListMainView.getCurrentHighlight();
    
    var a =0;
    for(a=0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == currentHighlight )
        {
            var b = a-1;
            if(b<0) { b = this.BtnList.length-1;}
            this.highlight(this.BtnList[b].obj, b);
        }
     }
}

SceneListMain.prototype.processRightKey = function(){
    
	alert("SceneListMain.processRightKey() ");
   
   this.processEnterKey();
}



SceneListMain.prototype.processEnterKey = function(){
    alert("SceneListMain.processEnterKey() ");
	
    var currentHighlight =  this.ListMainView.getCurrentHighlight();
    
    this.select(currentHighlight);
       
}

SceneListMain.prototype.processYellowKey = function(){
    alert("SceneListMain.processYellowKey() ");
    
    var currentHighlight =  this.ListMainView.getCurrentHighlight();
    
   if(currentHighlight == this.ListMainContactBtn)
   {
		var IsInCall = ProcMgr.GetIsInCall();
		
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL);
		}
		else
		{
			StateMgr.Start_Add_Contact_State();
		}       
   }      
}

SceneListMain.prototype.processRedKey = function(){
    alert("SceneListMain.processRedKey() ");
    
    StateMgr.Start_Signout_State();     
}

SceneListMain.prototype.processReturnKey = function(){
    alert("SceneConferenceCall.processReturnKey() ");
   
  StateMgr.Start_Exit_State(true);
}

SceneListMain.prototype.processExitKey = function(){
    alert("SceneConferenceCall.processExitKey() ");
   
   StateMgr.Start_Exit_State(false);
}

SceneListMain.prototype.processBlue = function(){
    alert("SceneListMain.processBlue() ");
    
	if(PluginAPIMgr.GetMySkyeName() == 'young477'){

		$.sfScene.show('TestPopupForText');
	    $.sfScene.focus('TestPopupForText');       				
	}
}

SceneListMain.prototype.gotoContact = function()
{
	alert("SceneListMain.gotoContact()");
    
    alert("CurrentSubScene = " + this.iCurrentSubScene);

	//Show sub Main win
    if(this.iCurrentSubScene != 0)
    {
    	this.ListMainView.setCurrenHighlight(this.BtnList[0].obj);
    	 
		WndMgr.HideMainSub(this.iCurrentSubScene);
		
		this.iCurrentSubScene = 0;
		WndMgr.ShowMainSub(0);		
    }
 
 	//Select focus..
    if(this.BtnList[0].flagSelect == false)
    {
    	this.BtnList[0].flagSelect = true;    	
    	this.ListMainView.setCurrentSelect(this.BtnList[0].obj);
    	WndMgr.SelectMainSub(0);
    }	
}

///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMain.prototype.processClickEvent = function(obj){
	alert("SceneListMain.processClickEvent() ");
	
	var index =0;

    for(var a=0; a<this.BtnList.length; a++)
    {
        if(this.BtnList[a].obj == obj)
        {
        	index=a;
        	break;
        }
    }
    
    if(index==this.iCurrentSubScene)
    {
    	if(this.BtnList[this.iCurrentSubScene].flagSelect==true)
    	{
    		$.sfScene.get(WndMgr.GetMainSubSceneID()).processReturnKey();
    	}
    	else
    	{
    		this.processEnterKey();
    	}
    }
    else
    {
    	if(this.BtnList[this.iCurrentSubScene].flagSelect==true)
    	{
    		$.sfScene.get(WndMgr.GetMainSubSceneID()).processReturnKey();
    	}
    	
    	this.highlight(obj, index);
    }
}
SceneListMain.prototype.AdjustBtnText = function(){
	
	var CurLangID = ResMgr.GetCurLanguage();
 	if(CurLangID == ENUM_TV_LANGUAGE.XHO)
 	{
 		$("#list_main_contact_btn_text").css('left', "67px" );
 		//$("#list_main_chat_btn_text").css('left', "67px" ); 		
 		$("#list_main_history_btn_text").css('left', "67px" );
 		$("#list_main_call_btn_text").css('left', "67px" );  		 	
 		$("#list_main_live_call_btn_text").css('left', "67px" ); 		
 		$("#list_main_setting_btn_text").css('left', "67px" );  		
	
 		this.ListMainContactBtn.AppendFgImage("list_main_contact_btn_icon","11px","1px","58px","58px");
	    //this.ListMainChatBtn.AppendFgImage("list_main_chat_btn_icon","11px","1px","58px","58px");
	    this.ListMainHistoryBtn.AppendFgImage("list_main_history_btn_icon","11px","1px","58px","58px");
	    this.ListMainCallBtn.AppendFgImage("list_main_call_btn_icon","11px","1px","58px","58px");
	    this.ListMainLiveCallBtn.AppendFgImage("list_main_live_call_btn_icon","11px","1px","58px","58px");
	    this.ListMainSettingBtn.AppendFgImage("list_main_setting_btn_icon","11px","1px","58px","58px");

   	}
   	else
   	{
 		 this.ListMainContactBtn.AppendFgImage("list_main_contact_btn_icon","21px","1px","58px","58px");   		
	    //this.ListMainChatBtn.AppendFgImage("list_main_chat_btn_icon","21px","1px","58px","58px");
	    this.ListMainHistoryBtn.AppendFgImage("list_main_history_btn_icon","21px","1px","58px","58px");
	    this.ListMainCallBtn.AppendFgImage("list_main_call_btn_icon","21px","1px","58px","58px");
	    this.ListMainLiveCallBtn.AppendFgImage("list_main_live_call_btn_icon","21px","1px","58px","58px");
	    this.ListMainSettingBtn.AppendFgImage("list_main_setting_btn_icon","21px","1px","58px","58px");
 		
   	}
	
}	


