function SceneListMainCall(options) {
	this.options = options;
    
    this.ListMainCallView=null;
    
    this.CountryCodeBtn=null;
   	this.CountryPrefixLabel=null;
    this.CountryNameLabel=null;
    this.CountryCode ="";
    this.CountryPrefix ="";
    
    this.PhoneNumberInputBox=null;
    
    this.CallBtn=null;
 
    this.Number1Btn=null;
    this.Number2Btn=null;
    this.Number3Btn=null;
    this.Number4Btn=null;
    this.Number5Btn=null;
    this.Number6Btn=null;
    this.Number7Btn=null;
    this.Number8Btn=null;
    this.Number9Btn=null;
    this.Number0Btn=null;
    this.StarBtn=null;
    this.SharpBtn=null;
    
    this.NumBtnList = new Array(12);
    this.SelectTimer = null;
	
	this.ShownPhoneNumberList = false;
	this.ShownFlagList = false;
    
    this.DefaultHelpBar =null;
    this.InputHelpBar =null;
    this.InputPlusHelpBar =null;
    this.ListHelpBar = null;
    this.CountryListHelpBar = null;
    
    this.destroyFlag =true;
    
    this.flagCallBtnEnable = true;
    this.flagPlusBtnEnable = true;
	
	this.isEmergencyCall = false;
	
	this.FlagFocus=false;
	
	this.isCountryHelpBarInsertClickEvent = false;
	
}

SceneListMainCall.prototype.initialize = function () {
	alert("SceneListMainCall.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneListMainCall.prototype.handleShow = function () {
	alert("SceneListMainCall.handleShow()");
	// this function will be called when the scene manager show this scene 

    this.initListMainCall();
    
	var ThisScene = $.sfScene.get("ListMainCall");
	$.sfScene.get("CountryFlagList").Init(FLAG_LIST_TYPE.LIST_MAIN_CALL,'ListMainCall',ThisScene.SetCountryFlag,ThisScene.ShowCountryBtn );	

}

SceneListMainCall.prototype.handleHide = function () {
	alert("SceneListMainCall.handleHide()");
	// this function will be called when the scene manager hide this scene  
		
	if (this.ShownPhoneNumberList == true) {

		$.sfScene.hide('ListMainCallPhoneNumberList');
		this.ListHelpBar.hiddenObj();
		this.ShownPhoneNumberList = false;
	}
	
	if(this.ShownFlagList == true){

		$.sfScene.hide('CountryFlagList');
		this.CountryListHelpBar.hiddenObj();
		this.ShownFlagList = false;				
	}
	
	
}

SceneListMainCall.prototype.handleFocus = function () {
	alert("SceneListMainCall.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	this.FlagFocus=true;
    
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.PhoneNumberInputBox);
    }
    else
    {
        this.highlight(currentHighlight);
    }
	
	//TEMPCODE:
	this.ShownFlagList = false;
}

SceneListMainCall.prototype.handleBlur = function () {
	alert("SceneListMainCall.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    this.FlagFocus=false;
    
     var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
	 if(currentHighlight != null)     
	 {
	 	currentHighlight.blur();
	 }
}

SceneListMainCall.prototype.handleKeyDown = function (keyCode) {
	alert("SceneListMainCall.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
			
	switch (keyCode) {
		case $.sfKey.LEFT:
        this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
            this.processRightKey();
			break;
		case $.sfKey.UP:
            //this.processUpKey();
			break;
		case $.sfKey.DOWN:
            //this.processDownKey();
			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.RED:
            this.processRedKey();
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
            
        default:
            ProcMgr.processBlockKey(keyCode);
            break;  
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainCall.prototype.create = function(){
    alert("SceneListMainCall.create()");
    this.ListMainCallView = new View("ListMainCall");
    
    var this_ = $.sfScene.get('ListMainCall');
    var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.CountryCodeBtn = new Button();
    this.CountryCodeBtn.SetImageObjId("list_main_call_country_code_btn");
    this.CountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LIST_MAIN_CALL_COUNTRY_CODE_BTN_NORMAL);
    this.CountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CALL_COUNTRY_CODE_BTN_NORMALFOCUS);	
    this.CountryCodeBtn.AppendFgImage("list_main_call_country_code_btn_icon","20px","10px","37px","27px");
	this.CountryCodeBtn.SetOnClickCallbackFunc(clickCF);
	
	this.CountryPrefixLabel = new Label(null,"list_main_call_country_prefix");
    this.CountryPrefixLabel.SetTextStyle("list_main_call_country_prefix_style");
    this.CountryPrefixLabel.SetReverseDisable(true);
	
    this.CountryNameLabel = new Label(null,"list_main_call_country_name");
    this.CountryNameLabel.SetTextStyle("list_main_call_country_name_style");

    this.PhoneNumberInputBox= new NumberInputBox();
    this.PhoneNumberInputBox.SetButtonObjId("list_main_call_phone_number_input_box");
    this.PhoneNumberInputBox.SetButtonTextObjId("list_main_call_phone_number_input_text");
    this.PhoneNumberInputBox.SetInputBoxObjId("list_main_call_phone_number_input_text_editor");
    this.PhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LIST_MAIN_CALL_INPUTBOX_NORMAL);
    this.PhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CALL_INPUTBOX_NORMALFOCUS);
    var scene = $.sfScene.get("ListMainCall");
    this.PhoneNumberInputBox.setPrevEventOnLeftFunc(function(){scene.moveToCountryCodeBtn()});
    this.PhoneNumberInputBox.setPrevEventOnRightFunc(function(){if(scene.flagCallBtnEnable == true){scene.moveToCallBtn() }  else{scene.moveToCountryCodeBtn()}});
    this.PhoneNumberInputBox.setPrevEventOnDownFunc(function(){scene.moveToPhoneNumberList()});
    this.PhoneNumberInputBox.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); });
	this.PhoneNumberInputBox.setPrevEventOnExitFunc(function(){$.sfKey.block(event);  $.sf.returnFocus(); scene.processExitKey();  });
    this.PhoneNumberInputBox.setAnyKeyFunc(function(keyCode){scene.callbackPhoneNumberInput(keyCode)});
    this.PhoneNumberInputBox.setEnterFunc(function(){scene.processEnterKey()});
	this.PhoneNumberInputBox.setPrevEventOnInfolinkFunc(function(){ProcMgr.processInfolinkKey();});
	this.PhoneNumberInputBox.setPrevEventOnBlockFunc(function(keyCode){ProcMgr.processBlockKey(keyCode);});
	this.PhoneNumberInputBox.setPrevEventOnRedFunc(function(){scene.processRedKey();  $.sf.returnFocus();});
	this.PhoneNumberInputBox.setPrevEventOnBlueFunc(function(keyCode) {ProcMgr.processBlockKey(keyCode); $.sf.returnFocus();});
	this.PhoneNumberInputBox.SetOnClickCallbackFunc(clickCF);
	this.PhoneNumberInputBox.SetReverseDisable(true);
	
    this.CallBtn = new Button();
    this.CallBtn.SetImageObjId("list_main_call_start_call_btn");
    this.CallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG,  g_Image.IMAGE_LIST_MAIN_CALL_START_CALL_BTN_NORMAL);
    this.CallBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_CALL_START_CALL_BTN_NORMALFOCUS);
	this.CallBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_LIST_MAIN_CALL_START_CALL_BTN_DIM);	
    this.CallBtn.SetOnClickCallbackFunc(clickCF);


///// number key pad //////////////////////////////////////////////////////////////////////////////////////////////////////


    this.Number1Btn = new Label("list_main_call_number_1_btn", "list_main_call_number_1_btn_text");
    this.Number1Btn.SetText("1");

    this.Number2Btn = new Label("list_main_call_number_2_btn", "list_main_call_number_2_btn_text");
    this.Number2Btn.SetText("2");

    this.Number3Btn = new Label("list_main_call_number_3_btn", "list_main_call_number_3_btn_text");
    this.Number3Btn.SetText("3");

    this.Number4Btn = new Label("list_main_call_number_4_btn", "list_main_call_number_4_btn_text");
    this.Number4Btn.SetText("4");

    this.Number5Btn = new Label("list_main_call_number_5_btn", "list_main_call_number_5_btn_text");
    this.Number5Btn.SetText("5");

    this.Number6Btn = new Label("list_main_call_number_6_btn", "list_main_call_number_6_btn_text");
    this.Number6Btn.SetText("6");

    this.Number7Btn = new Label("list_main_call_number_7_btn", "list_main_call_number_7_btn_text");
    this.Number7Btn.SetText("7");

    this.Number8Btn = new Label("list_main_call_number_8_btn", "list_main_call_number_8_btn_text");
    this.Number8Btn.SetText("8");

    this.Number9Btn = new Label("list_main_call_number_9_btn", "list_main_call_number_9_btn_text");
    this.Number9Btn.SetText("9");

    this.StarBtn = new Label("list_main_call_star_btn", "list_main_call_star_btn_text");
    this.StarBtn.SetText("+");

    this.Number0Btn = new Label("list_main_call_number_0_btn", "list_main_call_number_0_btn_text");
    this.Number0Btn.SetText("0");

    this.SharpBtn = new Label("list_main_call_sharp_btn", "list_main_call_sharp_btn_text");
    this.SharpBtn.SetText("Del");
    
    var a=0;
     for(a=0; a<this.NumBtnList.length; a++)
     {
         this.NumBtnList[a]=new Object();
     }
     
     this.NumBtnList[0].obj =  this.Number1Btn;
     this.NumBtnList[1].obj =  this.Number2Btn;
     this.NumBtnList[2].obj =  this.Number3Btn;
     this.NumBtnList[3].obj =  this.Number4Btn;
     this.NumBtnList[4].obj =  this.Number5Btn;
     this.NumBtnList[5].obj =  this.Number6Btn;
     this.NumBtnList[6].obj =  this.Number7Btn;
     this.NumBtnList[7].obj =  this.Number8Btn;
     this.NumBtnList[8].obj =  this.Number9Btn;
     this.NumBtnList[9].obj =  this.StarBtn;
     this.NumBtnList[10].obj = this.Number0Btn;
     this.NumBtnList[11].obj = this.SharpBtn;
    
     for(a=0; a<this.NumBtnList.length; a++)
     {
         this.NumBtnList[a].obj.SetBgImage( g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_NORMAL);
         this.NumBtnList[a].obj.SetTextStyle("list_main_call_number_btn_text_style");
		 this.NumBtnList[a].obj.isSelected = false;
     }	 
     
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_PAGE,"SceneListMain");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.DefaultHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.InputHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_INPUT,"SceneListMain");
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.InputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processRedKey();});
    this.InputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.InputPlusHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_INPUT_PLUS,"SceneListMain");
    this.InputPlusHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputPlus();});
    this.InputPlusHelpBar.SetOnClickCallbackFunc(3, function(){this_.inputDelete();});
    this.InputPlusHelpBar.SetOnClickCallbackFunc(4, function(){this_.processRedKey();});
    this.InputPlusHelpBar.SetOnClickCallbackFunc(5, function(){this_.processReturnKey();});
    
	this.ListHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_PHONENUMBER_LIST,"SceneListMain");
    this.ListHelpBar.SetOnClickCallbackFunc(1, function(){this_.closePhoneNumberList();});
    
	//this.CountryListHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_COUNTRY_LIST,"SceneCountryFlagList");
    //this.CountryListHelpBar.SetOnClickCallbackFunc(1, function(){this_.closeCountryList();});
    
    this.CountryCodeBtn.registHelpBar( this.DefaultHelpBar);
    this.PhoneNumberInputBox.registHelpBar( this.InputHelpBar);
    this.CallBtn.registHelpBar( this.DefaultHelpBar);

 
 // for processing mouse click event    
	this.NumBtnList[0].key =  $.sfKey.N1;
	this.NumBtnList[1].key =  $.sfKey.N2;
	this.NumBtnList[2].key =  $.sfKey.N3;
	this.NumBtnList[3].key =  $.sfKey.N4;
	this.NumBtnList[4].key =  $.sfKey.N5;
	this.NumBtnList[5].key =  $.sfKey.N6;
	this.NumBtnList[6].key =  $.sfKey.N7;
	this.NumBtnList[7].key =  $.sfKey.N8;
	this.NumBtnList[8].key =  $.sfKey.N9;
	if(ProcMgr.isTTXMIX == false)
	{
		this.NumBtnList[9].key =  35;  //plus100
	}
	else
	{
		this.NumBtnList[9].key =  650; // TTXMIX
	}	
	this.NumBtnList[10].key = $.sfKey.N0;
	this.NumBtnList[11].key = 259; //$.sfKey.PRECH:
	
	var keypadClickCF = function(obj){this_.processKeyPadClickEvent(obj);};
	
    for(a=0; a<this.NumBtnList.length; a++)
    {
        this.NumBtnList[a].obj.SetOnClickCallbackFunc(keypadClickCF);
    }	
        
}

SceneListMainCall.prototype.initListMainCall=function()
{
    alert("SceneListMainCall.initListMainCall()"); 

         this.CountryCodeBtn.SetFgImage(PluginAPIMgr.GetMyCountryFlag());
         this.CountryNameLabel.SetText(PluginAPIMgr.GetMyCountryName());
         this.CountryCode =PluginAPIMgr.GetMyCountryCode() ;
         this.CountryPrefix =PluginAPIMgr.GetMyCountryPrefix();
		 if(this.CountryPrefix.length > 0 && this.CountryPrefix !="0" )
		 {
		 	this.CountryPrefixLabel.SetText("+"+this.CountryPrefix);
		 }
		 else
		 {
		 	this.CountryPrefixLabel.SetText("");
		 }	 
         
        this.PhoneNumberInputBox.setInitString("");
        this.ShownPhoneNumberList = false;
        this.highlight(null);
        
        this.setCallBtnEnable(false);
		this.isEmergencyCall =false;

}

SceneListMainCall.prototype.setDestroyFlag= function(destroy_flag){
     this.destroyFlag = destroy_flag;
}

SceneListMainCall.prototype.highlight=function(obj)
{
	var preHighlight =  this.ListMainCallView.getCurrentHighlight();
	
    this.ListMainCallView.setCurrenHighlight(obj);
    
    if(obj != null && preHighlight!=null)
    {
    	if(preHighlight.objType == "NUMBERINPUTBOX" && obj.objType != "NUMBERINPUTBOX")
    	{
    		this.leaveInputBox();
    	}        
    }
	
	if(obj == this.PhoneNumberInputBox)
	{
		if (this.ShownPhoneNumberList == false) {
			var curString = this.PhoneNumberInputBox.getString();
			$.sfScene.get('ListMainCallPhoneNumberList').SetSearchNumber(curString);
			$.sfScene.show('ListMainCallPhoneNumberList');
			this.ShownPhoneNumberList = true;
		}	
        
        this.checkPlusBtnEnable();
	}
	else {
		if (this.ShownPhoneNumberList == true) {

			var Scene = $.sfScene.get('ListMainCallPhoneNumberList');
			if(Scene) {
				var curString = this.PhoneNumberInputBox.getString();
				Scene.ResetListforSearch(curString);					
			}
			
			$.sfScene.hide('ListMainCallPhoneNumberList');
			this.ShownPhoneNumberList = false;
		}		
	}
	
}

SceneListMainCall.prototype.leaveInputBox = function()
{
    alert("SceneListMainCall.leaveInputBox() ");
    $.sfScene.focus('ListMainCall');
	$.sf.returnFocus();
}

SceneListMainCall.prototype.processLeftKey = function(){
    alert("SceneListMainCall.processLeftKey() ");
    
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CountryCodeBtn:
             WndMgr.ReturnSubToMain();
            this.highlight(null);
            break;
            
        case this.PhoneNumberInputBox:
            this.moveToCountryCodeBtn();
            break;
            
        case this.CallBtn:
            this.highlight(this.PhoneNumberInputBox);
            break;	
    }
}

SceneListMainCall.prototype.processRightKey = function(){
    alert("SceneListMainCall.processRightKey() ");
    
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CountryCodeBtn:
            this.highlight(this.PhoneNumberInputBox);
            break;
            
        case this.PhoneNumberInputBox:
            if(this.flagCallBtnEnable ==true)
            {
                this.moveToCallBtn();
             }
             else
             {
                this.moveToCountryCodeBtn();
             }
            break;           
        case this.CallBtn:
            this.highlight(this.CountryCodeBtn);
            break;

    }
}

SceneListMainCall.prototype.processEnterKey = function(){
    alert("SceneListMainCall.processEnterKey() ");
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CountryCodeBtn:
		this.showFlagList();
            break;
            
        case this.PhoneNumberInputBox:
             if(this.flagCallBtnEnable ==true)
            {
                this.moveToCallBtn();
             }
             
            break;
            
        case this.CallBtn:
        
        var input_phone_number = this.PhoneNumberInputBox.GetText(); 
        if(input_phone_number.length >0)
        {
			if(this.isEmergencyCall == true)
			{
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.EMERGENCY_CALL);
				return;
			}
			
            var add_prefix_phone_number = this.addCountryPrefix(input_phone_number);
             alert("add_prefix_phone_number : " + add_prefix_phone_number);
            var normalized_phone_number = PluginAPIMgr.NormalizeIdentity(add_prefix_phone_number);
            if(normalized_phone_number.length >0)
            {
                ProcMgr.CreateCall( normalized_phone_number, 0);
            }
         }
         break;

    }
}


SceneListMainCall.prototype.processReturnKey = function(){
    alert("SceneListMainCall.processReturnKey() ");
	this.highlight(null);
    WndMgr.ReturnSubToMain();    
}

SceneListMainCall.prototype.processRedKey = function(){
    alert("SceneListMainCall.processRedKey() ");

	var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
	if(currentHighlight == this.PhoneNumberInputBox)
	{
		this.highlight(null);
	}
	
    StateMgr.Start_Signout_State();
       
}

SceneListMainCall.prototype.processExitKey = function(){
    alert("SceneListMainCall.processExitKey() ");

	var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
	if(currentHighlight == this.PhoneNumberInputBox)
	{
		this.highlight(null);
	}
	
  	StateMgr.Start_Exit_State(false);
}


SceneListMainCall.prototype.selectTimerCallback= function()
{
     alert("SceneListMainCall.selectTimerCallback() ");
     
     for(a=0; a<this.NumBtnList.length; a++)
     {     
		if(this.NumBtnList[a].isSelected== true)
		{
			this.NumBtnList[a].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_NORMAL);
			this.NumBtnList[a].obj.SetTextStyle("list_main_call_number_btn_text_style");
			this.NumBtnList[a].isSelected=false;
		}
     } 
}

SceneListMainCall.prototype.callbackPhoneNumberInput = function(keyCode)
{
    alert("SceneListMainCall.callbackPhoneNumberInput() ");

     for(a=0; a<this.NumBtnList.length; a++)
     {     
	 	if(this.NumBtnList[a].isSelected== true)
		{
		 	this.NumBtnList[a].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_NORMAL);
            this.NumBtnList[a].obj.SetTextStyle("list_main_call_number_btn_text_style");
			this.NumBtnList[a].isSelected=false;
		}
     } 
     
    switch(keyCode)
    {
        case $.sfKey.N1:
        alert(" KEY_1");
        this.NumBtnList[0].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[0].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[0].isSelected = true;
    break;
    
    case $.sfKey.N2:
        alert(" KEY_2");
        this.NumBtnList[1].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[1].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[1].isSelected = true;
    break;   
    
    case $.sfKey.N3:
        alert(" KEY_3");
        this.NumBtnList[2].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[2].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[2].isSelected = true;
    break;
    
    case $.sfKey.N4:
        alert(" KEY_4");
        this.NumBtnList[3].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[3].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[3].isSelected = true;
    break;
    
    case $.sfKey.N5:
        alert(" KEY_5");
        this.NumBtnList[4].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[4].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[4].isSelected = true;
    break;
    
    case $.sfKey.N6:
        alert(" KEY_6");
        this.NumBtnList[5].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[5].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[5].isSelected = true;
    break;
    
    case $.sfKey.N7:
        alert(" KEY_7");
        this.NumBtnList[6].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[6].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[6].isSelected = true;
    break;
    
    case $.sfKey.N8:
        alert(" KEY_8");
        this.NumBtnList[7].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[7].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[7].isSelected = true;
    break;

    case $.sfKey.N9:
        alert(" KEY_9");
        this.NumBtnList[8].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[8].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[8].isSelected = true;
    break;
    
   case 35:  // plus100
        alert(" KEY_plus100");
        this.NumBtnList[9].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[9].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[9].isSelected = true;
    break;
    
    case $.sfKey.N0:
        alert(" KEY_0");
        this.NumBtnList[10].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[10].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[10].isSelected = true;
    break;
    
    case 259: //$.sfKey.PRECH:
        alert(" KEY_PRECH");
        this.NumBtnList[11].obj.SetBgImage(g_Image.IMAGE_LIST_MAIN_CALL_NUMBER_KEY_PAD_SELECTED);
        this.NumBtnList[11].obj.SetTextStyle("list_main_call_number_btn_text_select_style");
		this.NumBtnList[11].isSelected = true;
    break;
    }
    
    this.SelectTimer=setTimeout("timerCF()", 300);
    timerCF = function() { $.sfScene.get("ListMainCall").selectTimerCallback();}
    
    var searchString = this.PhoneNumberInputBox.getString();
	alert("searchString = " + searchString);
	
	var Scene = $.sfScene.get('ListMainCallPhoneNumberList');
	if(Scene) {
	
		Scene.ResetListforSearch(searchString);	
	
	}
    
    this.checkCallBtnEnable();  
    this.checkPlusBtnEnable();
    
}

SceneListMainCall.prototype.checkCallBtnEnable = function()
{
    alert("SceneListMainCall.checkCallBtnEnable() ");
    var input_phone_number = this.PhoneNumberInputBox.GetText(); 
    if(input_phone_number.length >0)
    {	
        var add_prefix_phone_number = this.addCountryPrefix(input_phone_number);
        var normalized_phone_number = PluginAPIMgr.NormalizeIdentity(add_prefix_phone_number);

        if(normalized_phone_number.length >0)
        {
			var is_emergency_call = PluginAPIMgr.IsEmergencyCall(normalized_phone_number);
			if (is_emergency_call == 1) 
			{
				this.isEmergencyCall = true;
			}
			else
			{
				this.isEmergencyCall = false;
			}
			
			if(this.isEmergencyCall == false && this.isZeroString(normalized_phone_number) == true)
			{
				this.setCallBtnEnable(false);
			}
			else
			{
				this.setCallBtnEnable(true);
			}           
        }
        else
        {
            this.setCallBtnEnable(false);
        }
     }
     else
     {
            this.setCallBtnEnable(false);
     }      
}

SceneListMainCall.prototype.isZeroString = function(phone_number)
{
	var a=0; 
	var zero_length =0;
	for(a=1; a< phone_number.length ; a++)
	{
		if(phone_number.substring(a, a+1)=="0")
		{
			zero_length++;
		}
		else
		{
			break;
		}
	}
	
	if(zero_length == phone_number.length-1)
	{
		alert("SceneListMainCall.isZeroString() : true " );
		return true;
	}
	else
	{
		alert("SceneListMainCall.isZeroString() : false " );
		return false;
	}
}

SceneListMainCall.prototype.setCallBtnEnable= function(flag_enable)
{
	alert("SceneListMainCall.setCallBtnEnable() : " + flag_enable);
	
    this.flagCallBtnEnable = flag_enable;
    
    if(this.flagCallBtnEnable == true)
    {
        this.CallBtn.SetFlagDim(false);
    }
    else
    {
         this.CallBtn.SetFlagDim(true);
    }
}

SceneListMainCall.prototype.checkPlusBtnEnable = function()
{
    alert("SceneListMainCall.checkPlusBtnEnable() ");
        
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    if(currentHighlight !=this.PhoneNumberInputBox)
    {
           return;
    }
    
    var input_phone_number = this.PhoneNumberInputBox.GetText();
    var pos_of_caret = this.PhoneNumberInputBox.GetPosOfCaret();
    
    if(input_phone_number.length ==0)
    {
        this.flagPlusBtnEnable = true;
    }
    else if(input_phone_number.indexOf("+") ==0 || input_phone_number.indexOf("00") ==0 || input_phone_number.indexOf("011") ==0)
    {
        this.flagPlusBtnEnable = false;
    }   
    else if( pos_of_caret ==0)
    {
        this.flagPlusBtnEnable = true;
    }
    else
    {
         this.flagPlusBtnEnable = false;
    }

    this.setPlusBtnEnable();
}

SceneListMainCall.prototype.setPlusBtnEnable = function()
{
    alert("SceneListMainCall.setPlusBtnEnable() ");
    
    if(this.flagPlusBtnEnable == true)
    {
        this.PhoneNumberInputBox.changeHelpBar( this.InputPlusHelpBar);
        this.PhoneNumberInputBox.setFlagPhoneNumber(true);
    }
    else
    {   
        this.PhoneNumberInputBox.changeHelpBar( this.InputHelpBar);
        this.PhoneNumberInputBox.setFlagPhoneNumber(false);
    }    
}


SceneListMainCall.prototype.addCountryPrefix = function(input_phone_number){
    alert("SceneListMainCall.addCountryPrefix() --> this.CountryPrefix : "+ this.CountryPrefix);
    
    if(input_phone_number.indexOf("+") ==0)
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("00") ==0 )
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("011") ==0)
    {
        return input_phone_number;
    }
    else
    {
		if(this.CountryPrefix !="0")
		{
			return  "+"+this.CountryPrefix + input_phone_number;
		}
		else
		{
			return  input_phone_number;
		}       
    }   
}


SceneListMainCall.prototype.moveToCountryCodeBtn = function()
{
    alert("SceneListMainCall.moveToCountryCodeBtn() ");
  
    this.highlight(this.CountryCodeBtn);
   	//$.sfScene.focus('ListMainCall');
    //$.sf.returnFocus();
}

SceneListMainCall.prototype.moveToCallBtn = function()
{
	alert("SceneListMainCall.moveToCallBtn() ");
	
    this.highlight(this.CallBtn);
	//$.sfScene.focus('ListMainCall');
	//$.sf.returnFocus();
}

SceneListMainCall.prototype.comebackCallScene= function()
{
	alert("SceneListMainCall.comebackCallScene() ");
	
    if(this.CallBtn.GetFlagDim()==false)
    {
        this.highlight(this.CallBtn);
    }
    
	$.sfScene.focus('ListMainCall');
}

SceneListMainCall.prototype.moveToPhoneNumberList = function()
{
    alert("SceneListMainCall.moveToPhoneNumberList() ");
    var list_scene = $.sfScene.get('ListMainCallPhoneNumberList');

    if(list_scene.GetNumberOfPhoneCall() > 0 )
    {
		$.sfScene.focus('ListMainCallPhoneNumberList');
	    $.sf.returnFocus();
	
		this.ListHelpBar.visibleObj();
    }

}

SceneListMainCall.prototype.showFlagList = function()
{
	alert("SceneListMainCall.showFlagList() ");

	var ThisScene = $.sfScene.get("ListMainCall");
	ThisScene.CountryPrefixLabel.hiddenObj();
	ThisScene.CountryNameLabel.hiddenObj();
		
	var Index = g_Data.GetCountryIndexWithCode(ThisScene.CountryCode);
	//alert("CountryCode = " + ThisScene.CountryCode);
	//alert("Index = " + Index);

	$.sfScene.get("CountryFlagList").SetCurIndex(Index);
	$.sfScene.show('CountryFlagList');
	
	setTimeout("CloseTimerCF()", 0);
	CloseTimerCF = function(){
		$.sfScene.focus('CountryFlagList');		
	}	
	
	ThisScene.ShownFlagList = true;
	
	if(ThisScene.isCountryHelpBarInsertClickEvent == false)
	{
		ThisScene.CountryListHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CALL_COUNTRY_LIST,"CountryFlagList");
		ThisScene.CountryListHelpBar.SetOnClickCallbackFunc(1, function(){ThisScene.closeCountryList();});
		
		ThisScene.isCountryHelpBarInsertClickEvent = true;
	}

	ThisScene.CountryListHelpBar.visibleObj();
}

SceneListMainCall.prototype.SetCountryFlag = function()
{
    alert("SceneListMainCall.SetCountryFlag() ");
	
	var Scene = $.sfScene.get("CountryFlagList");	
	var This_ = $.sfScene.get("ListMainCall");
	
	var FlagImage = Scene.GetCountryFlag();
	var CountryName = Scene.GetCountryName();
	var Prefix = Scene.GetPrefix();
	var CountryCode = Scene.GetCountryCode();

	This_.CountryCodeBtn.SetFgImage(FlagImage );
	This_.CountryNameLabel.SetText(CountryName);
	This_.CountryPrefix = Prefix;
	This_.CountryPrefixLabel.SetText("+"+Prefix);
	This_.CountryCode = CountryCode;
	
    alert("SceneListMainCall.SetCountryFlag() --> this.CountryPrefix : "+ this.CountryPrefix);
	
	This_.CountryPrefixLabel.visibleObj();
	This_.CountryNameLabel.visibleObj();
	This_.CountryListHelpBar.hiddenObj();
		
	This_.checkCallBtnEnable(); 

}
SceneListMainCall.prototype.ShowCountryBtn = function(){

	var This_ = $.sfScene.get("ListMainCall");	
	This_.CountryPrefixLabel.visibleObj();
	This_.CountryNameLabel.visibleObj();
	This_.CountryListHelpBar.hiddenObj();	
	
}


///////// Processing Click evnet  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainCall.prototype.processClickEvent = function(obj){
	alert("SceneListMainCall.processClickEvent() ");
	
	var currentHighlight =  this.ListMainCallView.getCurrentHighlight();

	if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if(this.FlagFocus==false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
	}
	
	if(obj == this.PhoneNumberInputBox)
	{
		return;
	}

    this.processEnterKey();	
}

SceneListMainCall.prototype.processKeyPadClickEvent = function(obj){
	alert("SceneListMainCall.processKeyPadClickEvent() ");
	
	var index=12;
   	for(a=0; a<this.NumBtnList.length; a++)
    {
        if(this.NumBtnList[a].obj==obj)
        {
        	index = a;
        	break;
        }
    }
    
    if(index<0 || index>=12)
    {
    	return;
    }
	
	var currentHighlight =  this.ListMainCallView.getCurrentHighlight();

	if(currentHighlight != this.PhoneNumberInputBox)
    {
    	this.highlight(this.PhoneNumberInputBox);
    }
    
    if(this.FlagFocus==false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
	}
	

	if(index==11)
	{
		this.PhoneNumberInputBox.processPreChKey();
	}
	else
	{
		this.PhoneNumberInputBox.processNumberKey(this.NumBtnList[index].key)
	}
}

SceneListMainCall.prototype.inputPlus = function(){
    alert("SceneListMainCall.inputPlus() ");
    
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.PhoneNumberInputBox:
		
		var keycode =35; //plus100
		if(ProcMgr.isTTXMIX == false)
		{
			keycode = 650 ; // TTXMIX
		}
        
        currentHighlight.processNumberKey(keycode);
        break;            
    }    
}

SceneListMainCall.prototype.inputDelete = function(){
    alert("SceneListMainCall.inputDelete() ");
    
    var currentHighlight =  this.ListMainCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.PhoneNumberInputBox:
		        
        currentHighlight.processPreChKey();
        break;            
    }    
}

SceneListMainCall.prototype.closeCountryList = function()
{
	this.ShowCountryBtn();

	$.sfScene.focus('ListMainCall');
	$.sfScene.hide('CountryFlagList'); 	
   
}

SceneListMainCall.prototype.closePhoneNumberList = function()
{
	this.ListHelpBar.hiddenObj();
	$.sfScene.focus('ListMainCall');

}
