var CONTACT_BUTTONS_START_NORMAL_X = 533;
var CONTACT_BUTTONS_START_POPUP_X = 165;
var CONTACT_BUTTONS_START_Y = 40;
var CONTACT_PHONE_NUMBER_LIST_START_Y = 176;
var CONTACT_PHONE_NUMBER_LIST_START2_Y = 195;
var CONTACT_PHONE_NUMBER_LIST_POPUP_START_Y = 140;
var CONTACT_PHONE_NUMBER_LIST_POPUP_START2_Y = 47;
var CONTACT_PHONE_NUMBER_LIST_HIGHT = 185;
var CONTACT_PHONE_NUMBER_LIST_BG_HALF_HEIGHT = 134;
var CONTACT_PHONE_NUMBER_LIST_BG_FULL_HEIGHT = 224;

function SceneListMainContactPhoneNumberList(options) {

	this.options			= options;
	
	this.PhoneNumberList	= null;
	
	//for list
	this.PhoneNumberArray	= new Array(7);
	this.MenuStringArray	= new Array(7);
	
	//to save data for popup
	this.MenuLabelArray		= new Array(7);		
	this.MenuIndexArray		= new Array(7);		//Assigned Index Array
			
	this.StartPosX			= 0;
	this.StartPosY			= 0;
	
	this.CallerScene		= null;

	this.TargetIdentity		= null;
	this.TotalPhoneNumber	= null;
	this.TotalItemNumber	= null;
	
	this.HomeNumber			= null;
	this.OfficeNumber		= null;
	this.MobileNumber		= null;
	
	this.AssignedNumber1	= null;	
	this.AssignedNumber2	= null;	
	this.AssignedNumber3	= null;
	
	this.AssignedLabel1		= null;	
	this.AssignedLabel2		= null;	
	this.AssignedLabel3		= null;

	this.IsAddMassage		= false;
	
	this.LastItemSmallized  = false;
	
	// this.AssignedIndex		= 0;
	this.NumOfAssignedLabel = 0;

	this.HelpBar			= null;
		
	this.changedFontIndex = 0;	
	//for reverse osd
	this.IsReverseOSD = false;
	
	this.CategoryLabelArray = new Array(7);
	this.ColonLabelArray = new Array(7);
	
}

SceneListMainContactPhoneNumberList.prototype.initialize = function () {
	alert("SceneListMainContactPhoneNumberList.initialize()");	
	//nothing!!s
	this.create();
}

SceneListMainContactPhoneNumberList.prototype.handleShow = function () {
	alert("SceneListMainContactPhoneNumberList.handleShow()");
	
	this.ResetListData();
	
	this.GetPhoneInfo();
	this.SetListData();
	this.SetPosition();

	this.PhoneNumberList.Show();

}

SceneListMainContactPhoneNumberList.prototype.handleHide = function () {
	alert("SceneListMainContactPhoneNumberList.handleHide()");
	this.PhoneNumberList.Hide();

	if(this.LastItemSmallized == true)
	{
		$("#phoneNumberListItem7").css("height","44px");
		this.LastItemSmallized = false;
	}
	
	this.AdjustTextFont(-1);
	
	if(this.IsReverseOSD == true && this.IsAddMassage == true)
	{
		var TextObj = "#phoneNumberListItem" + this.TotalItemNumber + "Text";
		$(TextObj).css('left', "61px" );
		$(TextObj).css('width', "128px" ); 
	}	
}

SceneListMainContactPhoneNumberList.prototype.handleFocus = function () {
	alert("SceneListMainContactPhoneNumberList.handleFocus()");

	this.PhoneNumberList.highlight();
	
	this.HelpBar.visibleObj();
}

SceneListMainContactPhoneNumberList.prototype.handleBlur = function () {
	alert("SceneListMainContactPhoneNumberList.handleBlur()");
	
	this.PhoneNumberList.blur();
	
	this.HelpBar.hiddenObj();
}

SceneListMainContactPhoneNumberList.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneListMainContactPhoneNumberList.handleKeyDown(" + keyCode + ")");
PluginAPIMgr.PlayAudio(keyCode);
	if(keyCode == $.sfKey.TOOLS)
	{
		this.processToolKey();	
		$.sfKey.block(event);
	}
	else
	{
		this.PhoneNumberList.KeyProcess(keyCode);
	}
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainContactPhoneNumberList.prototype.create = function()
{
    alert("SceneListMainContactPhoneNumberList.createList() ");
	
	this.PhoneNumberList = new MenuList();
	this.PhoneNumberList.CreateBG("phoneNumberList");
	this.PhoneNumberList.SetBGImage(g_Image.IMAGE_LIST_MAIN_PHONE_NEMBER_LIST_HALF_BG);
	this.PhoneNumberList.SetNumOfVisibleItem(7);	//Set Max Item
	//this.PhoneNumberList.SetStartDataIndex(0);	
	this.PhoneNumberList.SetItemClass(MenuListItem);	
	this.PhoneNumberList.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.PhoneNumberList.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_PHONE_NEMBER_LIST_ITEM_HIGHLIGHT_BG);
	this.PhoneNumberList.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cPhoneNumberList_Text_Normal");
	this.PhoneNumberList.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cPhoneNumberList_Text_Highlight");
	this.PhoneNumberList.SetItemDisableTextStyle("cPhoneNumberList_Text_Disable");	
	this.PhoneNumberList.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);

	var scene = $.sfScene.get("ListMainContactPhoneNumberList");	

	this.PhoneNumberList.SetEventOnLeftFunc(scene.ProcessKeyLeft);
	this.PhoneNumberList.SetEventOnRightFunc(scene.ProcessKeyRight);	
	this.PhoneNumberList.SetEventOnReturnFunc(scene.ProcessKeyReturn);
	this.PhoneNumberList.SetItemPressedEventCallback(scene.ProcessKeyEnter);	

	this.PhoneNumberList.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.PhoneNumberList.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.PhoneNumberList.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.PhoneNumberList.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.PhoneNumberList.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.PhoneNumberList.SetOnClickCallbackFunc(5,this.onClickEventFunc6);
	this.PhoneNumberList.SetOnClickCallbackFunc(5,this.onClickEventFunc7);	
	this.PhoneNumberList.SetClickEventAvailable(WndMgr.MouseClickEnable);
	
	this.HelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_VOICE_CALL_PHONE_NUMBER_LIST, "ListMainContactPhoneNumberList");

	this.HelpBar.SetOnClickCallbackFunc(1, 	function(){scene.processToolKey();		});    
	this.HelpBar.SetOnClickCallbackFunc(2, 	function(){scene.ProcessKeyReturn();	});   
	
	
	this.CheckReverseOSD();
	
	if(this.IsReverseOSD == true)
	{
    	//this.CallDurationTextLabel.SetTextStyle("live_call_duration_text_style");
    	//this.CallDurationTextLabel.SetText(IDWS_MOIP_SKYPE_CALL_DURATION);
    	alert("CategoryLabelArray & ColonLabelArray apply reverse osd !!!!");
    		
		this.CategoryLabelArray[0] = new Label(null,"phoneNumberListItem1Text3");
		this.CategoryLabelArray[1] = new Label(null,"phoneNumberListItem2Text3");
		this.CategoryLabelArray[2] = new Label(null,"phoneNumberListItem3Text3");
		this.CategoryLabelArray[3] = new Label(null,"phoneNumberListItem4Text3");
		this.CategoryLabelArray[4] = new Label(null,"phoneNumberListItem5Text3");
		this.CategoryLabelArray[5] = new Label(null,"phoneNumberListItem6Text3");
		this.CategoryLabelArray[6] = new Label(null,"phoneNumberListItem7Text3");
		
		this.ColonLabelArray[0] = new Label(null,"phoneNumberListItem1Text2");
		this.ColonLabelArray[1] = new Label(null,"phoneNumberListItem2Text2");
		this.ColonLabelArray[2] = new Label(null,"phoneNumberListItem3Text2");
		this.ColonLabelArray[3] = new Label(null,"phoneNumberListItem4Text2");
		this.ColonLabelArray[4] = new Label(null,"phoneNumberListItem5Text2");
		this.ColonLabelArray[5] = new Label(null,"phoneNumberListItem6Text2");
		this.ColonLabelArray[6] = new Label(null,"phoneNumberListItem7Text2");	

		for(i=0; i < 7; i++)
		{
			this.ColonLabelArray[i].SetText(":");
		}		
		this.PhoneNumberList.DisableReverse();
	}
}

SceneListMainContactPhoneNumberList.prototype.SetListData = function()
{
	alert("SceneListMainContactPhoneNumberList.SetListData()");

	//1. Set total item number 
	this.SetPhoneNumberArray();
	
	tempdata = new Array(this.TotalItemNumber);
	 		
	for(var i=0; i < this.TotalItemNumber; i++)
	{		
		tempdata[i] = [this.MenuStringArray[i],null];
	}
	
	var NumOfCreatedItem = this.PhoneNumberList.GetNumOfCreatedItem();


	if(this.TotalItemNumber > NumOfCreatedItem)
	{
		
		for(i=0; i < NumOfCreatedItem; i++)
		{
			this.PhoneNumberList.ChangeData(i,tempdata[i]);
		}
				
		for(i = NumOfCreatedItem; i < this.TotalItemNumber; i++)
		{
			this.PhoneNumberList.AddData(tempdata[i]);
		}
				
	}
	else
	{
		for(i=0; i < this.TotalItemNumber; i++)
		{			
			this.PhoneNumberList.ChangeData(i,tempdata[i]);
		}			
	}
	
	if(this.IsReverseOSD == true)
	{
		alert("TotalPhoneNumber = " + this.TotalPhoneNumber);
		for(i=0; i < this.TotalPhoneNumber; i++)
		{			
			this.CategoryLabelArray[i].visibleObj();
			this.ColonLabelArray[i].visibleObj();
			//hiddenObj
		}
		
		if(this.IsAddMassage == true)
		{
			var TextObj = "#phoneNumberListItem" + this.TotalItemNumber + "Text";
			alert("TextObj = " + TextObj);
			$(TextObj).css('left', "11px" );
			$(TextObj).css('width', "178px" ); 
		}
	}

	//Item show && hide!!!
	this.PhoneNumberList.SetNumOfMaxItem(this.TotalItemNumber);
	this.PhoneNumberList.ShowItem();
}


SceneListMainContactPhoneNumberList.prototype.SetPhoneNumberArray = function(IsReverse)
{

	alert("SceneListMainContactPhoneNumberList.SetPhoneNumberArray()");	
			
	var PNAIndex	= 0;
	var TmpNumCount	= 0;
	
	var bUseFirstIndex = false;
	var bUseSecondIndex = false;
	var bUseThirdIndex = false;
	
	//1.Contact Name
	ContactName = this.TargetIdentity;

	this.PhoneNumberArray[PNAIndex] = ContactName;
	
	if(this.IsReverseOSD == true)
	{
		this.CategoryLabelArray[0].SetText("Skype");
		this.MenuStringArray[PNAIndex++] = ContactName;
	}
	else
	{
		this.MenuStringArray[PNAIndex++] = "Skype: " + ContactName;
	}

	var TotalCount	= 1;
	
	//2. Mobile
	if(this.AssignedLabel1 == "mobile")
	{
		this.MenuLabelArray[PNAIndex] = 1;
		this.MenuIndexArray[PNAIndex] = 1;		
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber1;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_MOBILE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber1;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_MOBILE + ": " +  this.AssignedNumber1;
		}
					
		bUseFirstIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel2 == "mobile")
	{
		this.MenuLabelArray[PNAIndex] = 1;
		this.MenuIndexArray[PNAIndex] = 2;
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber2;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_MOBILE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber2;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_MOBILE + ": " + this.AssignedNumber2;
		}		
				
		bUseSecondIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel3 == "mobile")
	{
		this.MenuLabelArray[PNAIndex] = 1;
		this.MenuIndexArray[PNAIndex] = 3;
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber3;

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_MOBILE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber3;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_MOBILE + ": " + this.AssignedNumber3;
		}

		bUseThirdIndex = true;
		
		TmpNumCount++;
		TotalCount++;

	}
		
	if(this.MobileNumber.length > 0)
	{
		this.PhoneNumberArray[PNAIndex] = this.MobileNumber;		

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_MOBILE);
			this.MenuStringArray[PNAIndex++] = this.MobileNumber;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_MOBILE + ": " + this.MobileNumber;
		}
		
		TotalCount++;
	}

	//3. Office
	if(this.AssignedLabel1 == "office")
	{
		this.MenuLabelArray[PNAIndex] = 2;
		this.MenuIndexArray[PNAIndex] = 1;
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber1;

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_OFFICE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber1;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_OFFICE + ": " + this.AssignedNumber1;
		}
				
		bUseFirstIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel2 == "office")
	{
		this.MenuLabelArray[PNAIndex] = 2;
		this.MenuIndexArray[PNAIndex] = 2;
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber2;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_OFFICE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber2;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_OFFICE + ": " + this.AssignedNumber2;
		}
		
		bUseSecondIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel3 == "office")
	{
		this.MenuLabelArray[PNAIndex] = 2;
		this.MenuIndexArray[PNAIndex] = 3;
				
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber3;	

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_OFFICE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber3;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_OFFICE + ": " + this.AssignedNumber3;
		}
		
		bUseThirdIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	
	if(this.OfficeNumber.length > 0)
	{
		this.PhoneNumberArray[PNAIndex] = this.OfficeNumber;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(IDWS_MOIP_OFFICE);
			this.MenuStringArray[PNAIndex++] = this.OfficeNumber;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = IDWS_MOIP_OFFICE + ": " + this.OfficeNumber;
		}
		
		TotalCount++;
	}	

	
	//3. Home
	if(this.AssignedLabel1 == "home")
	{
		this.MenuLabelArray[PNAIndex] = 3;
		this.MenuIndexArray[PNAIndex] = 1;		
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber1;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_HOME_KR_HOMEPHONE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber1;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_HOME_KR_HOMEPHONE + ": " + this.AssignedNumber1;
		}
		
		bUseFirstIndex = true;
				
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel2 == "home")
	{
		this.MenuLabelArray[PNAIndex] = 3;
		this.MenuIndexArray[PNAIndex] = 2;
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber2;

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_HOME_KR_HOMEPHONE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber2;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_HOME_KR_HOMEPHONE + ": " + this.AssignedNumber2;
		}

		bUseSecondIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel3 == "home")
	{
		this.MenuLabelArray[PNAIndex] = 3;
		this.MenuIndexArray[PNAIndex] = 3;		
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber3;	
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_HOME_KR_HOMEPHONE);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber3;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_HOME_KR_HOMEPHONE + ": " + this.AssignedNumber3;
		}
		
		bUseThirdIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	
	if(this.HomeNumber.length > 0)
	{
		this.PhoneNumberArray[PNAIndex] = this.HomeNumber;	

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_HOME_KR_HOMEPHONE);
			this.MenuStringArray[PNAIndex++] = this.HomeNumber;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_HOME_KR_HOMEPHONE + ": " + this.HomeNumber;
		}
			
		TotalCount++;
	}

	//4. other
	if(this.AssignedLabel1 == "other")
	{
		this.MenuLabelArray[PNAIndex] = 4;
		this.MenuIndexArray[PNAIndex] = 1;		
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber1;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_COUNTRY_OTHER);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber1;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_COUNTRY_OTHER + ": " + this.AssignedNumber1;
		}
	
		bUseFirstIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel2 == "other")
	{
		this.MenuLabelArray[PNAIndex] = 4;
		this.MenuIndexArray[PNAIndex] = 2;
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber2;
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_COUNTRY_OTHER);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber2;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_COUNTRY_OTHER + ": " + this.AssignedNumber2;
		}
		
		bUseSecondIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	if(this.AssignedLabel3 == "other")
	{
		this.MenuLabelArray[PNAIndex] = 4;
		this.MenuIndexArray[PNAIndex] = 3;		
		
		this.PhoneNumberArray[PNAIndex] = this.AssignedNumber3;	
		
		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[TotalCount].SetText(SID_COUNTRY_OTHER);
			this.MenuStringArray[PNAIndex++] = this.AssignedNumber3;
		}
		else
		{
			this.MenuStringArray[PNAIndex++] = SID_COUNTRY_OTHER + ": " + this.AssignedNumber3;
		}

		bUseThirdIndex = true;
		
		TmpNumCount++;
		TotalCount++;
	}
	
	//Set NumOfAssignedLabel
	//Index of Added PhoneNumber

	if(bUseFirstIndex == false)
	{
		this.NumOfAssignedLabel = 1;
	}
	else if(bUseFirstIndex == true && bUseSecondIndex == false)
	{
		this.NumOfAssignedLabel = 2;
	}
	else if(bUseFirstIndex == true && bUseSecondIndex == true && bUseThirdIndex == false)
	{
		this.NumOfAssignedLabel = 3;
	}
	else 
	{
		this.NumOfAssignedLabel = 4;
	}
	
	alert("NumOfAssignedLabel = " + this.NumOfAssignedLabel);	

	this.TotalPhoneNumber = TotalCount;

	if(TmpNumCount < 3)
	{	
		this.AdjustTextFont(PNAIndex);
		this.MenuStringArray[PNAIndex++] = IDWS_MOIP_SKYPE_ADD_A_PHONE_NUMBER;
		TotalCount++;		
		this.IsAddMassage = true;
	}	
		
	this.TotalItemNumber = TotalCount;
	alert("TotalItemNumber = " + this.TotalItemNumber);

}

SceneListMainContactPhoneNumberList.prototype.ResetListData = function()
{	
	alert("SceneListMainContactPhoneNumberList.ResetListData");
	
	var tempdata = [null,null];
	
	for(var i=0; i < 7; i++)
	{			
		this.PhoneNumberList.ChangeData(i,tempdata);
		this.MenuLabelArray[i] = 0;
		this.MenuIndexArray[i] = 0;	
		this.PhoneNumberArray[i] = null;
		this.MenuStringArray[i] = null;

		if(this.IsReverseOSD == true)
		{
			this.CategoryLabelArray[i].SetText("");
			this.CategoryLabelArray[i].hiddenObj();
			this.ColonLabelArray[i].hiddenObj();
		}

	}
	this.NumOfAssignedLabel = 0;
	this.IsAddMassage = false;
	
}


SceneListMainContactPhoneNumberList.prototype.SetInfo = function(SceneName,ItemPosition,SkypeName){
	
	//alert("SceneListMainContact.SetInfo >>>  CallerScene : " + SceneName);
	
	this.TargetIdentity = SkypeName;
		
	this.CallerScene = SceneName;
	
	this.FuncPopPosition = ItemPosition;
	
}

SceneListMainContactPhoneNumberList.prototype.SetPosition = function(){
	
	alert("SceneListMainContact.SetPosition ");

	var TopP = 0;
	var LeftP = 0;
	var HeightP = 0;	
	var StartPositionY1 = 0;
	var StartPositionY2 = 0;
	
	//Select Option	
	if(this.CallerScene == "LiveContactSwitch"){		
		
		this.StartPosX = CONTACT_BUTTONS_START_POPUP_X;
		StartPositionY1 = CONTACT_PHONE_NUMBER_LIST_POPUP_START_Y;
		StartPositionY2 = CONTACT_PHONE_NUMBER_LIST_POPUP_START2_Y;

	}
	else{
		
		this.StartPosX = CONTACT_BUTTONS_START_NORMAL_X;
		StartPositionY1 = CONTACT_PHONE_NUMBER_LIST_START_Y;
		StartPositionY2 = CONTACT_PHONE_NUMBER_LIST_START2_Y;
	}

	if(this.FuncPopPosition < 0 ){
		
		alert("SceneListMainContact.SetInfo Error !!!!  this.FuncPopPosition < 0 ");
		this.FuncPopPosition = 0;
	}
	
	//Set X		
	LeftP = this.StartPosX + "px";		
	alert("left : " + LeftP);

	
	//Set Y
	if( this.FuncPopPosition > 2){
		
		this.StartPosY = StartPositionY2 + ((this.FuncPopPosition - 3) * NORMAL_ITEM_H);
		
		if(this.TotalItemNumber > 4)
		{
			this.StartPosY = this.StartPosY - (CONTACT_PHONE_NUMBER_LIST_BG_FULL_HEIGHT - CONTACT_PHONE_NUMBER_LIST_BG_HALF_HEIGHT);
		}		

	}
	else
	{		
		this.StartPosY = StartPositionY1 + (this.FuncPopPosition * NORMAL_ITEM_H);
			
	}	
	
	TopP = this.StartPosY + "px";	
	alert("top : " + TopP);

	//Set H
	if(this.TotalItemNumber > 4)
	{
		HeightP = CONTACT_PHONE_NUMBER_LIST_BG_FULL_HEIGHT + "px";
		this.PhoneNumberList.SetBGImage(g_Image.IMAGE_LIST_MAIN_PHONE_NEMBER_LIST_FULL_BG);	
	}
	else
	{	
		HeightP = CONTACT_PHONE_NUMBER_LIST_BG_HALF_HEIGHT + "px";
		this.PhoneNumberList.SetBGImage(g_Image.IMAGE_LIST_MAIN_PHONE_NEMBER_LIST_HALF_BG);
		
		if(this.FuncPopPosition == 5)
		{
			$("#phoneNumberListItem7").css("height","1px");
			this.LastItemSmallized = true;
		}
		
		
	}

	alert("height : " + HeightP);	
	
	
	$("#"+ this.PhoneNumberList.GetBGLayer().Obj).css('top', TopP );		
	$("#"+ this.PhoneNumberList.GetBGLayer().Obj).css('left', LeftP );	
	$("#"+ this.PhoneNumberList.GetBGLayer().Obj).css('height', HeightP );
	
}


SceneListMainContactPhoneNumberList.prototype.GetPhoneInfo = function(){
	
	alert("SceneListMainContact.GetPhoneInfo");
	
	// this.TargetIdentity = g_Data.DATA_PHONE_NUMBER_INFO.Name;

	var ContactName = this.TargetIdentity;

	this.HomeNumber			= PluginAPIMgr.GetHomePhoneNumberWithName(ContactName);
	this.OfficeNumber		= PluginAPIMgr.GetOfficePhoneNumberWithName(ContactName);	
	this.MobileNumber		= PluginAPIMgr.GetMobilePhoneNumberWithName(ContactName);
	
	this.AssignedLabel1		= PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,2);
	this.AssignedLabel2		= PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,4);
	this.AssignedLabel3		= PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,6);


	alert("homePhone = " + this.HomeNumber);
	alert("officePhone = " + this.OfficeNumber);
	alert("mobilePhone = " + this.MobileNumber);
	alert("AssignedPhone1Label = " + this.AssignedLabel1);
	alert("AssignedPhone2Label = " + this.AssignedLabel2);
	alert("AssignedPhone3Label = " + this.AssignedLabel3);	
			
	var count = 0;

	//&& this.AssignedLabel1.length > 0
	if(this.AssignedLabel1 != null && this.AssignedLabel1 != "none")
	{
		this.AssignedNumber1 = PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,1);
		alert("this.AssignedNumber1 = " + this.AssignedNumber1);
		count++;
	}
	else
	{
		this.AssignedNumber1 = null;
		this.AssignedLabel1 = "none";
	}

	if(this.AssignedLabel2 != null && this.AssignedLabel2 != "none")
	{
		this.AssignedNumber2 = PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,3);
		alert("this.AssignedNumber2 = " + this.AssignedNumber2);
		count++;
	}
	else
	{
		this.AssignedNumber2 = null;
		this.AssignedLabel2 = "none";
	}
	
	if(this.AssignedLabel3 != null && this.AssignedLabel3 != "none")
	{
		this.AssignedNumber3 = PluginAPIMgr.GetAssignedPhoneNumberWithName(ContactName,5);
		alert("this.AssignedNumber3 = " + this.AssignedNumber3);
		count++;
	}
	else
	{
		this.AssignedNumber3 = null;		
		this.AssignedLabel3 = "none";
	}
		 	
}

SceneListMainContactPhoneNumberList.prototype.ProcessKeyReturn = function(){

	alert("SceneListMainContactPhoneNumberList.ProcessKeyReturn() ");
	
	var this_ = $.sfScene.get("ListMainContactPhoneNumberList");	
	var returnScene = $.sfScene.get(this_.CallerScene);
	

	$.sfScene.focus(this_.CallerScene);

	returnScene.Activation();

	$.sfScene.hide('ListMainContactPhoneNumberList');
	
}

SceneListMainContactPhoneNumberList.prototype.ProcessKeyEnter = function(){

	alert("SceneListMainContactPhoneNumberList.ProcessKeyEnter() ");
	
	var this_ = $.sfScene.get("ListMainContactPhoneNumberList");
	var Index = this_.PhoneNumberList.GetCurrentItem();
		
	var phonenumber = this_.PhoneNumberArray[Index];
	alert("phonenumber[" + Index + "] ="  + phonenumber);			
			
	//TEMPCODE:
	//var returnScene = $.sfScene.get(this_.CallerScene);
	
	$.sfScene.focus(this_.CallerScene);
	//returnScene.Activation();

	$.sfScene.hide('ListMainContactPhoneNumberList');
			
	if(phonenumber){

		alert(" Create Call...");

		var IsInCall = ProcMgr.GetIsInCall();
		
		if(IsInCall){
			
			//$.sfScene.hide('ListMainContactPhoneNumberList');
			
			ProcMgr.CreateCall(phonenumber,0);
					
		}
		else{
			ProcMgr.CreateCall(phonenumber,0);
		}
	
	}
	else{

		alert(" Show Add Assigned Phone Number...");

		g_Data.SetAssignedPhoneNumberInfo(this_.TargetIdentity,this_.NumOfAssignedLabel,this_.MenuLabelArray[Index],phonenumber,false);
		StateMgr.Start_Add_Phone_Number_State();
			
	}	
}

SceneListMainContactPhoneNumberList.prototype.ProcessKeyLeft = function(){

	alert("SceneListMainContactPhoneNumberList.ProcessKeyLeft() ");
	
	
	var this_ = $.sfScene.get("ListMainContactPhoneNumberList");	
	var returnScene = $.sfScene.get(this_.CallerScene);
	
	returnScene.MoveToVideoCallBtn();	
	$.sfScene.focus(this_.CallerScene);
	
	returnScene.Activation();

	$.sfScene.hide('ListMainContactPhoneNumberList');
		
}

SceneListMainContactPhoneNumberList.prototype.ProcessKeyRight = function(){

	alert("SceneListMainContactPhoneNumberList.ProcessKeyRight() ");
	
	
	var this_ = $.sfScene.get("ListMainContactPhoneNumberList");	
	var returnScene = $.sfScene.get(this_.CallerScene);
	
	returnScene.MoveToChatBtn();	
	$.sfScene.focus(this_.CallerScene);
	
	returnScene.Activation();

	$.sfScene.hide('ListMainContactPhoneNumberList');
	
}

SceneListMainContactPhoneNumberList.prototype.processToolKey = function(){

	alert("SceneListMainContactPhoneNumberList.processToolKey() ");
	
	var Index = this.PhoneNumberList.GetCurrentItem();
	alert("Index = " + Index);
	alert("SkypName = " + this.TargetIdentity);
	alert("LabelType = " + this.MenuLabelArray[Index]);
	alert("PhoneNumber = " + this.PhoneNumberArray[Index]);	
		
	//Case 1 Add	
	if(this.MenuIndexArray[Index] == 0)
	{
		this.MenuIndexArray[Index] = this.NumOfAssignedLabel;
	}
	
	
	alert("LabelIndex = " + this.MenuIndexArray[Index]);	
		
	g_Data.SetAssignedPhoneNumberInfo(this.TargetIdentity,this.MenuIndexArray[Index],this.MenuLabelArray[Index],this.PhoneNumberArray[Index],true);	
	
	$.sfScene.hide('ListMainContactPhoneNumberList');
	StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.VOICE_CALL_BUTTON);
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc1 = function(){
	processPhoneNumber(0);
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc2 = function(){
	processPhoneNumber(1);	
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc3 = function(){
	processPhoneNumber(2);	
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc4 = function(){
	processPhoneNumber(3);
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc5 = function(){
	processPhoneNumber(4);
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc6 = function(){
	processPhoneNumber(5);
}

SceneListMainContactPhoneNumberList.prototype.onClickEventFunc7 = function(){
	processPhoneNumber(6);
}

function processPhoneNumber(Index)
{
	var this_ = $.sfScene.get("ListMainContactPhoneNumberList");
	var phonenumber = this_.PhoneNumberArray[Index];
	alert("phonenumber[" + Index + "] ="  + phonenumber);			
			
	$.sfScene.focus(this_.CallerScene);

	$.sfScene.hide('ListMainContactPhoneNumberList');
			
	if(phonenumber){

		alert(" Create Call...");

		ProcMgr.CreateCall(phonenumber,0);

	}
	else{

		alert(" Show Add Assigned Phone Number...");
		
		g_Data.SetAssignedPhoneNumberInfo(this_.TargetIdentity,this_.NumOfAssignedLabel,this_.MenuLabelArray[Index],phonenumber,false);
		StateMgr.Start_Add_Phone_Number_State();			
	}	
	
}


SceneListMainContactPhoneNumberList.prototype.AdjustTextFont = function(Index){


	var CurLangID = ResMgr.GetCurLanguage();
	var TextObj;
	
 	if(CurLangID == ENUM_TV_LANGUAGE.MKD || CurLangID == ENUM_TV_LANGUAGE.NOR || CurLangID == ENUM_TV_LANGUAGE.RUS || CurLangID == ENUM_TV_LANGUAGE.UKR)
 	{ 		
		if(Index == -1)
		{
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex + "Text";
	 		alert("Changed Text >>> " + TextObj);			
			$(TextObj).css('font-size', "15px" );			
			this.changedFontIndex  = 0;
		}
		else{
			this.changedFontIndex = Index + 1;
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex  + "Text";
	 		alert("Changed Text >>> " + TextObj);
			$(TextObj).css('font-size', "14px" );
		}	
   	}
   	//temp
 	else if(CurLangID == ENUM_TV_LANGUAGE.TAM)
 	{ 		
		if(Index == -1)
		{
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex + "Text";		
			$(TextObj).css('font-size', "15px" );			
			this.changedFontIndex  = 0;
		}
		else{
			this.changedFontIndex = Index + 1;
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex  + "Text";
			$(TextObj).css('font-size', "17px" );
		}	
   	}   	
   	//mulitple text
   	else if(CurLangID == ENUM_TV_LANGUAGE.POR || CurLangID == ENUM_TV_LANGUAGE.ROM || CurLangID == ENUM_TV_LANGUAGE.SPA || CurLangID == ENUM_TV_LANGUAGE.BUL ||
   		CurLangID == ENUM_TV_LANGUAGE.DEU || CurLangID == ENUM_TV_LANGUAGE.FRA)
   	{

		if(Index == -1)
		{
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex + "Text";
	 		alert("Changed Text >>> " + TextObj);			
			$(TextObj).removeClass('cPhoneNumberList_Text_Mulity');
			$(TextObj).addClass('cPhoneNumberList_Text');
			this.changedFontIndex  = 0;
		}
		else{
			this.changedFontIndex = Index + 1;
	 		TextObj =  "#phoneNumberListItem" +  this.changedFontIndex  + "Text";
	 		alert("Changed Text >>> " + TextObj);
			$(TextObj).removeClass('cPhoneNumberList_Text');
			$(TextObj).addClass('cPhoneNumberList_Text_Mulity');
		}
   		
   	}
}

SceneListMainContactPhoneNumberList.prototype.CheckReverseOSD = function(){
	
	var CurLangID = ResMgr.GetCurLanguage();
	
 	if(CurLangID == ENUM_TV_LANGUAGE.ARA || CurLangID == ENUM_TV_LANGUAGE.PER || CurLangID == ENUM_TV_LANGUAGE.URD || CurLangID == ENUM_TV_LANGUAGE.HEB)
 	{ 		
 		this.IsReverseOSD = true;
 	
		$('#phoneNumberListItem1Text').css('left', "61px" ); 
		$('#phoneNumberListItem2Text').css('left', "61px" ); 
		$('#phoneNumberListItem3Text').css('left', "61px" ); 
		$('#phoneNumberListItem4Text').css('left', "61px" ); 		
		$('#phoneNumberListItem5Text').css('left', "61px" ); 
		$('#phoneNumberListItem6Text').css('left', "61px" );
		$('#phoneNumberListItem7Text').css('left', "61px" ); 
		
		$('#phoneNumberListItem1Text').css('width', "128px" ); 
		$('#phoneNumberListItem2Text').css('width', "128px" ); 
		$('#phoneNumberListItem3Text').css('width', "128px" ); 
		$('#phoneNumberListItem4Text').css('width', "128px" ); 		
		$('#phoneNumberListItem5Text').css('width', "128px" ); 
		$('#phoneNumberListItem6Text').css('width', "128px" );
		$('#phoneNumberListItem7Text').css('width', "128px" ); 		
 	}
}
