var HISTORY_LIST_VM_STATUS = { 

	NOTHING			:	0,
	START_PALYBACK	:	1,
	
}


function SceneListMainHistory(options) {

	this.options = options;
	
    this.GIFLayer		= null;
	this.list			= null;
	this.ListHelpBar	= null;
	this.PlayVMHelpBar	= null;
	
	//flags	
	this.Status				= ENUM_SCENE_STATUS.INITIALIZED;
	this.SetFocus			= false;	
	this.IsShownObj			= false;
	this.VMStatus			= HISTORY_LIST_VM_STATUS.NOTHING;
	this.IsShownVolumWindow = false;
	
	this.Timer	= null;
	
	this.WheelOperation = false;	
}

SceneListMainHistory.prototype.initialize = function () {
	alert("SceneListMainHistory.initialize()");
	this.createLoading();
}

SceneListMainHistory.prototype.handleShow = function () {
	alert("SceneListMainHistory.handleShow()");

	this.ShowLoading();	

	this.Timer = setTimeout("ShowObj()", 300);	

	ShowObj = function(){
	
		This_ = $.sfScene.get("ListMainHistory");
		
		This_.ShowObj();
		This_.HideLoading();
		This_.FocusObj();
				
	}
	
}

SceneListMainHistory.prototype.handleHide = function () {
	alert("SceneListMainHistory.handleHide()");

    clearTimeout( this.Timer);
    this.Timer=null;	
		
	if(this.IsShownObj){
		
		this.list.Hide();	
		this.ResetVM();
		this.IsShownObj = false;
		this.Status = ENUM_SCENE_STATUS.DISAPPEARED;
	}
		
}

SceneListMainHistory.prototype.handleFocus = function () {
	
	if(this.IsShownObj){
		
		alert("SceneListMainHistory.handleFocus()");

		if(this.VMStatus == HISTORY_LIST_VM_STATUS.START_PALYBACK){
		
			this.PlayVMHelpBar.visibleObj();
		}
		else{
			
			this.ListHelpBar.visibleObj();	
		}
				
		this.list.highlight();
	}
		
	this.SetFocus = true;

}

SceneListMainHistory.prototype.handleBlur = function () {	
	alert("SceneListMainHistory.handleBlur()");
	
	this.list.blur();
	
	if(this.VMStatus == HISTORY_LIST_VM_STATUS.START_PALYBACK){
	
		this.PlayVMHelpBar.hiddenObj();
	}
	else{
		
		this.ListHelpBar.hiddenObj();	
	}
	
	
	this.SetFocus = false;
}

SceneListMainHistory.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneListMainHistory.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	//TEMPCODE:
	if(this.IsShownObj == false){
		return;
	}
	
	
	if(this.VMStatus == HISTORY_LIST_VM_STATUS.NOTHING){
		
		switch(keyCode) {
			
			case $.sfKey.RED:
                StateMgr.Start_Signout_State();
				break;
	
			default:
				this.list.KeyProcess(keyCode);					
		}			
	}
	else if(keyCode == $.sfKey.ENTER){
		
		this.list.KeyProcess(keyCode);	
	}
	else if(keyCode == $.sfKey.VOL_DOWN || keyCode == $.sfKey.PANEL_VOL_DOWN || keyCode == $.sfKey.VOL_UP || keyCode == $.sfKey.VOL_DOWN){
		
		this.processVolumeKey();	
	}
	else{		
		$.sfKey.block(event);		
	}
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainHistory.prototype.create = function(){
    alert("SceneListMainHistory.create() ");

	this.list = new HistoryList();	
    this.list.Create();
	
	this.ListHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_HISTORY_PAGE, "ListMain");
	this.PlayVMHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_HISTORY_VMPLAY, "ListMain");

	var this_ = $.sfScene.get('ListMainHistory');
    this.ListHelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.ListHelpBar.SetOnClickCallbackFunc(2, function(){this_.processToolKey();});
    this.ListHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});


    this.PlayVMHelpBar.SetOnClickCallbackFunc(1, function(){this_.processStopKey();});

	this.Status = ENUM_SCENE_STATUS.CREATED;

    this.TempDiv = document.getElementById("ListMainHistory");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(this_.WheelOperation == false)
   		{
   			alert("SceneListMainContact.onmousewheel");
	   		this_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { this_.timerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				this_.list.PageScroll(true);
			}
			else
			{
				//alert("Down Down");
				this_.list.PageScroll(false);
			}
	    }		
    };		

}

SceneListMainHistory.prototype.createLoading = function(){

	this.GIFLayer = new JPGImageLayer("History_loading_gif");
	this.GIFLayer.SetImage(WndMgr.Bg_LoadingGIF.src); 
 
}


SceneListMainHistory.prototype.Refresh = function(){

	if(this.IsShownObj){
		
		if(this.Status == ENUM_SCENE_STATUS.ACTIVATED && this.VMStatus == HISTORY_LIST_VM_STATUS.NOTHING){		
			this.list.Refresh();
		}		
	} 
}

SceneListMainHistory.prototype.setDestroyFlag= function(destroy_flag){

	 if(destroy_flag && this.Status > ENUM_SCENE_STATUS.INITIALIZED){
	 	this.Status = ENUM_SCENE_STATUS.DESTORYED;
	}
	
}

SceneListMainHistory.prototype.ProcessVM= function(EventType){
	
	if(this.VMStatus == HISTORY_LIST_VM_STATUS.START_PALYBACK){
		this.list.ProcessVM(EventType);		
	}
		
	switch(EventType) {
		
		case ENUM_VOICE_MAIL_STATUS.UNPLAYED:			
		case ENUM_VOICE_MAIL_STATUS.PLAYED:
		case ENUM_VOICE_MAIL_STATUS.UPLOADED:
		case ENUM_VOICE_MAIL_STATUS.FAILED:		
			this.CloseVolumeWnd();
			break;
	}
	
}

SceneListMainHistory.prototype.ResetVM = function(){
		
	if(this.VMStatus == HISTORY_LIST_VM_STATUS.START_PALYBACK){
		this.list.ProcessVM(ENUM_VOICE_MAIL_STATUS.PLAYED);		
	}
	
	this.CloseVolumeWnd();
}

SceneListMainHistory.prototype.CloseVolumeWnd = function(){
		
	if(this.IsShownVolumWindow){

		StateMgr.Stop_Volume_Speaker_State(true);
		this.IsShownVolumWindow = false;
	}
	
}


SceneListMainHistory.prototype.StartVMPlay = function(){
	
	this.VMStatus = HISTORY_LIST_VM_STATUS.START_PALYBACK;
	ProcMgr.registerCallKey();

	
	this.ListHelpBar.hiddenObj();
	this.PlayVMHelpBar.visibleObj();
	
	g_Data.SetIndexOfPlayingVoicemail(this.list.GetCurIndex());	

}

SceneListMainHistory.prototype.StopVMPlay = function(){

	this.VMStatus = HISTORY_LIST_VM_STATUS.NOTHING;
	ProcMgr.unregisterCallKey();
	
	this.PlayVMHelpBar.hiddenObj();
	this.ListHelpBar.visibleObj();
	
	g_Data.SetIndexOfPlayingVoicemail(-1);
}

SceneListMainHistory.prototype.VMProgressPlayback = function(strTime){
	
	if(this.VMStatus == HISTORY_LIST_VM_STATUS.START_PALYBACK){
		this.list.VMProgressPlayback(strTime);
	}

}

SceneListMainHistory.prototype.CheckValidList = function(){
	
	if( this.list.GetTotalDataNum() > 0){
		return true;
	}
	else {
		return false;
	}
}

SceneListMainHistory.prototype.GetState = function(){
	
	return this.Status;
}

SceneListMainHistory.prototype.SetState = function(ValueOfStatus){
	
	this.Status = ValueOfStatus;
}

SceneListMainHistory.prototype.Activation = function(){
	alert("SceneListMainHistory.Activation()");	
	
	if(this.Status > ENUM_SCENE_STATUS.CREATED){
		
		this.Status = ENUM_SCENE_STATUS.ACTIVATED;
		this.list.Refresh();			
	}
}

//TEMPCODE:
SceneListMainHistory.prototype.ActivationForIdentity = function(){
	alert("SceneListMainHistory.Activation()");	
	
	if(this.Status > ENUM_SCENE_STATUS.CREATED){
		
		this.Status = ENUM_SCENE_STATUS.ACTIVATED;
		this.list.RefreshForCurIdentity();			
	}
}


SceneListMainHistory.prototype.Deactivation = function(){
	alert("SceneListMainHistory.Deactivation()");	
	
	this.Status = ENUM_SCENE_STATUS.DEACTIVATED;
}

SceneListMainHistory.prototype.ShowLoading = function(){
	
	$("#"+ this.GIFLayer.Obj).css('display', 'block');
}

SceneListMainHistory.prototype.HideLoading = function(){
	
	$("#"+ this.GIFLayer.Obj).css('display', 'none');
}

SceneListMainHistory.prototype.ShowObj = function(){
	
	if(this.Status == ENUM_SCENE_STATUS.INITIALIZED){					
		this.create();
	}						

	if(this.Status == ENUM_SCENE_STATUS.CREATED || this.Status == ENUM_SCENE_STATUS.DESTORYED){		

		this.list.Initialize();	
		this.Status = ENUM_SCENE_STATUS.ACTIVATED;
	}
	else if(this.Status == ENUM_SCENE_STATUS.DISAPPEARED){
	
		this.ActivationForIdentity();	
	}
	else{
		
		this.Activation();
	}
	
	this.list.Show();
	
	this.IsShownObj = true;
	
}

SceneListMainHistory.prototype.FocusObj = function(){
	
	//check focus
	if(this.SetFocus){
		alert("SceneListMainChatHistory.FocusObj()");
		this.ListHelpBar.visibleObj();
		this.list.highlight();			
	}	
}

SceneListMainHistory.prototype.GetIsShownObj = function(){
	
	return this.IsShownObj;
}

SceneListMainHistory.prototype.processVolumeKey = function(){
	
	StateMgr.Start_Volume_Speaker_State();
	this.IsShownVolumWindow = true;
}


//for ListMainContactPhoneNumberList
SceneListMainHistory.prototype.MoveToVideoCallBtn = function(){
	
	this.list.MoveToVideoCallBtn();	
}

SceneListMainHistory.prototype.MoveToChatBtn = function(){
	
	this.list.MoveToChatBtn();	
}

//move to main ... 
SceneListMainHistory.prototype.processReturnKey = function(){
	
	this.list.MoveToMain();	
}

SceneListMainHistory.prototype.processRedKey = function(){
    alert("SceneListMainHistory.processRedKey() ");
    
    StateMgr.Start_Signout_State();   
}

SceneListMainHistory.prototype.processToolKey=function()
{
    alert("SceneListMainHistory.processToolKey() ");
	
	var IsInCall = ProcMgr.GetIsInCall();
	
	if (IsInCall) {
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL_IN_HISTORY_LIST);
	}
	else {
		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.HISTORY_LIST);
	}
}

SceneListMainHistory.prototype.processStopKey = function(){
	
	this.list.ProgressStopkey();	
}

SceneListMainHistory.prototype.timerCallback=function()
{
	this.WheelOperation = false;
}
