/**
 * @author Samsung
 */

function SceneOptionsBlockedUsers(options)
{
	
    this.options = options;

    this.OptionsBlockedUsersView = null;
	
    this.SkypeNameInputBox	= null;
	this.BlockUserBtn		= null;
	this.PreventLabel		= null;
	this.BlockedPeopleLabel	= null;
	this.list 				= null;
	this.DownArrow			= null;
	this.HelpBar			= null;
	
	this.maxStringLenght = 50;
	
	this.flagSkypeNameInit =false;

	//flag
	this.InitFlag	= true;	
	this.showState	= false;
	this.showIME	= false;
    
    this.DefaultHelpBar = null;
    this.SaveHelpBar = null;
    this.InputHelpBar = null;
    this.InputSaveHelpBar = null;
    
    this.flagCreate = false;


	this.WheelOperation = false;
}

SceneOptionsBlockedUsers.prototype.initialize = function ()
{
	alert("SceneOptionsBlockedUsers.initialize()");
	this.create();
}

SceneOptionsBlockedUsers.prototype.handleShow = function ()
{
	alert("SceneOptionsBlockedUsers.handleShow()");

	this.list.Show();
	this.showState = true;
    
     if(OptionsMgr.flagChange == true)
    {
        this.changeToSaveHelpBar();
    }
    else
    {
        this.changeToDefaultHelpBar();
    }
}

SceneOptionsBlockedUsers.prototype.handleHide = function ()
{
	alert("SceneOptionsBlockedUsers.handleHide()");
		
	this.highlight(null);
	this.list.ResetHighlight();	
	
	this.showState = false;
}

SceneOptionsBlockedUsers.prototype.handleFocus = function ()
{
	alert("SceneOptionsBlockedUsers.handleFocus()");
	
	if(OptionsMgr.CloseTimer == false)
	{
		OptionsMgr.startTimer();
	}

	var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
	
	if(currentHighlight == null){
    
    	this.highlight(this.SkypeNameInputBox);
	}
	else{
		if(currentHighlight == this.list && this.list.GetMaxNumOfData() == 0){
			this.highlight(this.SkypeNameInputBox);
		}
		else {
			this.highlight(currentHighlight);
		}
		
	}
    
}

SceneOptionsBlockedUsers.prototype.handleBlur = function ()
{
	alert("SceneOptionsBlockedUsers.handleBlur()");
     
	var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
	
	if(currentHighlight != null)
	{
		currentHighlight.blur();
	/*	
		if(this.showIME){						
			this.showIME = false;
			this.SkypeNameInputBox.imeHide();
		}
		*/
	}
}

SceneOptionsBlockedUsers.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsBlockedUsers.handleKeyDown(" + keyCode + ")");

    switch (keyCode) {
        case $.sfKey.LEFT:
            //alert("left");
			OptionsMgr.resetTimer();
            this.processLeftKey();
            break;

        case $.sfKey.RIGHT:
            //alert("right");
			OptionsMgr.resetTimer();
            this.processRightKey();
            break;

        case $.sfKey.UP:
			OptionsMgr.resetTimer();
            this.processUpKey();
            break;

        case $.sfKey.DOWN:
			OptionsMgr.resetTimer();
            this.processDownKey();
            break;			

        case $.sfKey.BLUE:
            this.processBlueKey();
            break;

        case $.sfKey.ENTER:
			OptionsMgr.resetTimer();
            this.processEnterKey();
            break;

        case $.sfKey.RETURN:
			OptionsMgr.resetTimer();
            this.processReturnKey();
            $.sfKey.block(event);
			break;
         case $.sfKey.EXIT:
         	this.processExitKey();
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;		
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsBlockedUsers.prototype.create = function()
{
    alert("SceneOptionsBlockedUsers.create()");

    this.OptionsBlockedUsersView = new View("OptionsBlockedUsers");
    
    var this_ = $.sfScene.get("OptionsBlockedUsers");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
    
    this.SkypeNameInputBox= new Button();
    this.SkypeNameInputBox.SetImageObjId("options_skype_name_input_box");
    this.SkypeNameInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_BLOCK_USER_INPUT_BOX_NORMAL);
    this.SkypeNameInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_BLOCK_USER_INPUT_BOX_NORMALFOCUS);
    this.SkypeNameInputBox.SetTextObjId("options_skype_name_input_box_text");
    this.SkypeNameInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"options_block_btn_style");
    this.SkypeNameInputBox.SetMaxStringLength(50);
    this.SkypeNameInputBox.SetIsPlainText(true);
    		
    //Skypname + PSTN number    
	var CurLangID = ResMgr.GetCurLanguage();
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.SkypeNameInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "options_block_btn_help_lagre_style");
	}
	else
	{
		this.SkypeNameInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "options_block_btn_help_style");
	}
	
    this.SkypeNameInputBox.SetTextEditorInfo(IDWS_MOIP_SKYPE_BLOCK, IDWS_MOIP_OPTIONS_BLOCKED_USERS_KEYPAD_HELP_ENTER_SKYPE_NAME_PHONE_NUMBER);
	this.SkypeNameInputBox.SetOnClickCallbackFunc(clickCF);
	
    this.BlockUserBtn= new Button();
    this.BlockUserBtn.SetImageObjId("options_block_user_btn");
    this.BlockUserBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_BLOCK_BTN_NORMAL);
    this.BlockUserBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_BLOCK_BTN_NORMALFOCUS);
    this.BlockUserBtn.SetTextObjId("options_block_user_btn_text");
    this.BlockUserBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
    this.BlockUserBtn.SetText(IDWS_MOIP_SKYPE_BLOCK);
	this.BlockUserBtn.SetOnClickCallbackFunc(clickCF);

    this.PreventLabel = new Label(null, "options_prevent_label");
    this.PreventLabel.SetTextStyle("options_prevent_label_style");
    this.PreventLabel.SetText(IDWS_MOIP_BLOCKED_LONG_TEXT);

 	if(CurLangID == ENUM_TV_LANGUAGE.MAY || CurLangID == ENUM_TV_LANGUAGE.IND || CurLangID == ENUM_TV_LANGUAGE.MKD || CurLangID == ENUM_TV_LANGUAGE.KAZ)
 	{
		$("#options_prevent_label").css('top', "70px" );	 		
   	}

    this.BlockedPeopleLabel = new Label(null, "options_blocked_people_label");
    this.BlockedPeopleLabel.SetTextStyle("options_blocked_people_label");
    this.BlockedPeopleLabel.SetText(IDWS_MOIP_BLOCKED_PEOPLE);
	
	this.list = new BlockList();
	this.list.Create();

	var list_ = this_.list;
	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("blockListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){list_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){this_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});		

	if(this.list.TotalPage > 1)
	{
		this.DownArrow.Show();
	}
	else
	{
		this.DownArrow.Hide();;
	}

    this.TempDiv = document.getElementById("blockList");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(this_.WheelOperation == false)
   		{
   			alert("blockList.onmousewheel");
	   		this_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { this_.wheelTimerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				list_.PreviousPage();
			}
			else
			{
				//alert("Down Down");
				list_.NextPage();
			}
	    }		
    };	

    
    this.DefaultHelpBar  = new HelpBar(HelpBarIndex.OPTIONS_BLOCKED_USERS,"Options");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.SaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_BLOCKED_USERS_SAVE,"Options");
    this.SaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.InputHelpBar = new HelpBar(HelpBarIndex.OPTIONS_BLOCKED_USERS_INPUT,"Options");
    this.InputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startTextInput();});
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
    this.InputSaveHelpBar = new HelpBar(HelpBarIndex.OPTIONS_BLOCKED_USERS_INPUT_SAVE,"Options");
   	this.InputSaveHelpBar.SetOnClickCallbackFunc(1, function(){this_.startTextInput();});
   	this.InputSaveHelpBar.SetOnClickCallbackFunc(2, function(){this_.processBlueKey();});
    this.InputSaveHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    
    this.SkypeNameInputBox.registHelpBar(this.InputHelpBar);
    this.BlockUserBtn.registHelpBar(this.DefaultHelpBar);
    this.list.registHelpBar(this.DefaultHelpBar);
    
    this.flagCreate = true;
	
}

SceneOptionsBlockedUsers.prototype.changeToDefaultHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.SkypeNameInputBox.changeHelpBar(this.InputHelpBar);
    this.BlockUserBtn.changeHelpBar(this.DefaultHelpBar);
    this.list.changeHelpBar(this.DefaultHelpBar);
}

SceneOptionsBlockedUsers.prototype.changeToSaveHelpBar= function()
{
     if(this.flagCreate == false)
    {
        return;
    }
    
    this.SkypeNameInputBox.changeHelpBar(this.InputSaveHelpBar);
    this.BlockUserBtn.changeHelpBar(this.SaveHelpBar);
    this.list.changeHelpBar(this.SaveHelpBar);
}

SceneOptionsBlockedUsers.prototype.highlight = function(obj)
{
	this.OptionsBlockedUsersView.setCurrenHighlight(obj);
	//this.startIME(obj);	
}

/*
SceneOptionsBlockedUsers.prototype.startIME= function(obj)
{    
	alert("SceneEditProfile.startIME()");
	
    if(obj == null){
		alert("obj is null");
        return;
    }
	
    var scene = $.sfScene.get("OptionsBlockedUsers");
    
	if(obj == this.SkypeNameInputBox)
	{
		if(this.flagSkypeNameInit == false)
		{
			this.SkypeNameInputBox.initInputBox( false , "" , this.maxStringLenght, null );
			this.flagSkypeNameInit = true;
		}
		else
		{
			this.SkypeNameInputBox.initInputBox( false, this.SkypeNameInputBox.GetText(), this.maxStringLenght, null );
		}

		if(this.showIME == false){
			this.showIME = true;
			obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en' ));	
		}
		
	}
	else {
		
		if(this.showIME){
									
			this.showIME = false;
			this.SkypeNameInputBox.imeHide();
		}
	}
    
}

SceneOptionsBlockedUsers.prototype.imeReady = function(){
    alert("SceneOptionsBlockedUsers.imeReady() ");


	var obj = this.OptionsBlockedUsersView.getCurrentHighlight();

    obj.setKeyFunc($.sfKey.LEFT, function(keyCode){$.sfScene.get('OptionsBlockedUsers').processLeftKey();  return false;});
	obj.setKeyFunc($.sfKey.RIGHT,  function(keyCode){$.sfScene.get('OptionsBlockedUsers').processRightKey();  return false;});
    obj.setKeyFunc($.sfKey.DOWN, function(keyCode){$.sfScene.get('OptionsBlockedUsers').processDownKey();  return false;});
	obj.setKeyFunc($.sfKey.UP,  function(keyCode){$.sfScene.get('OptionsBlockedUsers').processUpKey();  return false;});

    obj.setKeyFunc(88,  function(keyCode){$.sf.returnFocus();  $.sfScene.get('OptionsBlockedUsers').processReturnKey(); $.sfKey.block(event); return false;}); // return key
    obj.setKeyFunc(108,  function(keyCode){$.sfScene.get('OptionsBlockedUsers').DeleteAllText();  return false;}); // red key

	obj.setReady();

}*/


SceneOptionsBlockedUsers.prototype.processDownKey = function()
{
    alert("SceneOptionsBlockedUsers.processDownKey() ");

    var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();

	if(currentHighlight == this.SkypeNameInputBox || currentHighlight == this.BlockUserBtn){
		
		if(this.list.GetMaxNumOfData() > 0 ){
			
			this.highlight(this.list);
		}
		
	}
	else {

		this.list.Next();
	}
}

SceneOptionsBlockedUsers.prototype.processUpKey = function()
{
    alert("SceneOptionsBlockedUsers.processUpKey() ");
	
    var currentHighlight = this.OptionsBlockedUsersView.getCurrentHighlight();

    if(currentHighlight == this.list)
    {
		this.list.Previous();
    }
}

SceneOptionsBlockedUsers.prototype.processLeftKey = function()
{

    alert("ScenOptionsBlockedUsers.processLeftKey() ");

    var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.SkypeNameInputBox:
            WndMgr.ReturnOptionsSubToMain();
			
            break;

        case this.BlockUserBtn:		
			this.highlight(null);
            this.highlight(this.SkypeNameInputBox);
            break;
            
        case this.list:
        	this.highlight(null);
            WndMgr.ReturnOptionsSubToMain();
			
            break;
    }

}

SceneOptionsBlockedUsers.prototype.processRightKey = function()
{

    alert("ScenOptionsBlockedUsers.processLeftRightKey() ");

    var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();

    if(currentHighlight == this.SkypeNameInputBox)
    {
		this.highlight(this.BlockUserBtn);
    }
	
}


SceneOptionsBlockedUsers.prototype.processEnterKey = function()
{
    alert("SceneOptionsBlockedUsers.processEnterKey()");
    
    var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.BlockUserBtn:
			this.blockUser();
            break;
            
        case this.SkypeNameInputBox:
			this.startTextInput();
			break;
			
        case this.list:
			this.unblockUser();
            break;
    }
}

SceneOptionsBlockedUsers.prototype.startTextInput = function(){
    alert("SceneOptionsBlockedUsers.startTextInput() ");
    
    var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.SkypeNameInputBox:
			if(OptionsMgr.CloseTimer ==true)
			{
				OptionsMgr.stopTimer();
			}
            WndMgr.StartTextEditor(this.SkypeNameInputBox, "OptionsBlockedUsers" , $.sfScene.get("Options").OptionsDim);
            break;            
    }    
}

SceneOptionsBlockedUsers.prototype.processReturnKey = function()
{
    alert("SceneOptionsBlockedUsers.processReturnKey() ");

    var currentHighlight = this.OptionsBlockedUsersView.getCurrentHighlight();
    
    if(currentHighlight == this.list)
    {
    	this.highlight(this.SkypeNameInputBox);
    }	
	else {
		this.highlight(null);
	    WndMgr.ReturnOptionsSubToMain();	    	
	}	
}

SceneOptionsBlockedUsers.prototype.processExitKey = function()
{
    alert("SceneOptionsBlockedUsers.processExitKey()");
        
     if(OptionsMgr.flagChange == true)
    {
        WndMgr.StartOptionsSaveReturnStep();
     }
     else
     {
        StateMgr.Stop_Options_State(true); 
     }
}

/*
SceneOptionsBlockedUsers.prototype.DeleteAllText = function()
{
    var obj = this.OptionsBlockedUsersView.getCurrentHighlight();
    obj. setString("");
}*/


SceneOptionsBlockedUsers.prototype.blockUser = function() {
	alert("SceneOptionsBlockedUsers.blockUser ");	

	if(OptionsMgr.CloseTimer ==true)
	{
		OptionsMgr.stopTimer();
	}
			
			
	var Name = this.SkypeNameInputBox.GetText();
	var NameLength = Name.length;
	
	//validity check
	//1. skypeout call

	if(this.IsStringAllNumber(Name,NameLength)){
		
		if(NameLength < 6 ){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_INVALID_PHONE_NUMBER);
		}
		else{
			
			var finalNumber;
			
			if(Name[0] == '+'){
				
				finalNumber = PluginAPIMgr.NormalizeIdentity(Name); 
			}
			else{
				
				finalNumber = PluginAPIMgr.NormalizeIdentity('+' + Name);
			}
			
			if(finalNumber){
				
				ProcMgr.BlockContact(finalNumber,false,MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_BLOCK);
			}
			else{
				
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_INVALID_PHONE_NUMBER);
			}			
		}
	}
	else{

		//1.check valid identity
		if(PluginAPIMgr.NormalizeIdentity(Name) == null){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_INVALID_NAME);
		}
		//2.check length 
		else if(NameLength < 6 || NameLength > 32){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_INVALID_NAME);
		}
		//3.check my account
		else if(Name == PluginAPIMgr.GetMySkyeName()){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_MYSELF);
		}
		//4. blocked people check
		else if(this.list.IsExistBlockedUser(Name)){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_AREADY_LIST);
		}
		//5. Authrization check
		else if(parseInt(PluginAPIMgr.GetContactAvailabilityWithName(Name)) == ENUM_CONTACT_AVAILABILITY.UNKNOWN){
			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTIONS_BLOCK_AREADY_LIST);
		}
		else{				
			ProcMgr.BlockContact(Name,false,MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_BLOCK);
		}
		
	}	
}

SceneOptionsBlockedUsers.prototype.IsStringAllNumber = function(String,length) {
	//alert("SceneOptionsBlockedUsers.IsStringAllNumber");
		
	if(String == null || length == 0){
		return false;
	}
	
	if(String[0] == '+'){

		for (var i=1; i < length; i++) {
	
			if(String[i] < '0' || String[i] > '9'){
				return false;
			}
		}
		return true;				
	}
	else{

		for (var i=0; i < length; i++) {
	
			if(String[i] < '0' || String[i] > '9'){
				return false;
			}
		}
		
		return true;
	}
				
}

SceneOptionsBlockedUsers.prototype.unblockUser = function() {
	alert("SceneOptionsBlockedUsers.unblockUser");
	if(OptionsMgr.CloseTimer ==true)
	{
		OptionsMgr.stopTimer();
	}		
	
	var Name = this.list.GetCurSkypeName();
			
	PluginAPIMgr.UnblockContact(Name);
	ProcMgr.UnblockContact(Name,MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_UNBLOCK)
}

SceneOptionsBlockedUsers.prototype.update = function() {
	alert("SceneOptionsBlockedUsers.update ");	

	//Clear InpuBox
    if(this.SkypeNameInputBox){
        this.SkypeNameInputBox.SetText("");
    }
	
	
	if(this.list){
		var curPage = this.list.GetCurPage();
		this.list.ResetData();
		this.list.SetCurPage(curPage);
		this.list.RefreshPage();
		
		if(this.list.TotalPage > 1)
		{
			this.DownArrow.Show();
		}
		else
		{
			this.DownArrow.Hide();;
		}
	}
	
}
	
SceneOptionsBlockedUsers.prototype.GetShowState = function() {
	alert("SceneOptionsBlockedUsers.GetShowState ");	

	return this.showState;	
}


SceneOptionsBlockedUsers.prototype.processBlueKey = function()
{
    alert("SceneOptionsCallForwarding.processBlueKey() ");
    OptionsMgr.SaveOptions();
}

//check
SceneOptionsBlockedUsers.prototype.ProcessClick = function(ItemIndex)
{
	alert("SceneOptionsBlockedUsers.ProcessClick() -- " + ItemIndex);		


    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}
	
	var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
	
    if(currentHighlight != this.list)
    {
    	currentHighlight.blur();
    	this.OptionsBlockedUsersView.currentHighlight = this.list;
    }
    	
	this.list.MoveItem(ItemIndex);

	var Name = this.list.GetCurSkypeName();
			
	PluginAPIMgr.UnblockContact(Name);
	ProcMgr.UnblockContact(Name,MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_UNBLOCK)

}

SceneOptionsBlockedUsers.prototype.NextScroll = function()
{
	var This_ = $.sfScene.get("OptionsBlockedUsers");	
	This_.list.NextPage();

}

SceneOptionsBlockedUsers.prototype.processClickEvent = function(obj){
	alert("SceneOptionsBlockedUsers.processClickEvent() ");
	OptionsMgr.resetTimer();
	
	var currentHighlight =  this.OptionsBlockedUsersView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
    
    if($.sfScene.get('Options').flag_Focus==true)
	{   
		$.sfScene.get('Options').moveToSub();
	}

    this.processEnterKey();
}

SceneOptionsBlockedUsers.prototype.ChangeArrow = function(Type)
{
	alert("SceneOptionsBlockedUsers.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}

SceneOptionsBlockedUsers.prototype.wheelTimerCallback=function()
{
	this.WheelOperation = false;
}
