function SceneSkypeOutCall(options) {
	this.options = options;
    
    this.SkypeOutCallView =null;
    
    this.CallDurationTextLabel =null;
    this.CallDurationTimeLabel =null;

    this.YourNameLabel=null;
    this.MyNameLabel=null;
    
    this.YourPhoneNumberLabel=null;
    this.MyCreditLabel=null;

    this.YourThumbnailLabel=null;
    this.MyThumbnailLabel=null;

    this.CallEndBtn=null;
    this.ShowDialBtn=null;
    this.MicVolumeBtn=null;
    this.HoldBtn=null;
    
	 this.PhoneIconLabel = null;
	 this.HoldIconLabel = null;
	 this.HelpBar=null;

}

SceneSkypeOutCall.prototype.initialize = function () {
	alert("SceneSkypeOutCall.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneSkypeOutCall.prototype.handleShow = function () {
	alert("SceneSkypeOutCall.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.update();
   
}

SceneSkypeOutCall.prototype.handleHide = function () {
	alert("SceneSkypeOutCall.handleHide()");
	// this function will be called when the scene manager hide this scene  
    
         this.highlight(null);
}

SceneSkypeOutCall.prototype.handleFocus = function () {
	alert("SceneSkypeOutCall.handleFocus()");
	// this function will be called when the scene manager focus this scene
  
    var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
    if(currentHighlight ==null)
    {
        this.highlight(this.CallEndBtn);
    }
    else
    {
        this.highlight(currentHighlight);
    }
}

SceneSkypeOutCall.prototype.handleBlur = function () {
	alert("SceneSkypeOutCall.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    
    var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
     if(currentHighlight !=null)
    {
        currentHighlight.blur();
    }
}

SceneSkypeOutCall.prototype.handleKeyDown = function (keyCode) {
	alert("SceneSkypeOutCall.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
            this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
           this.processRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
            this.processEnterKey();
			break;
            
        case $.sfKey.VOL_DOWN:
        case $.sfKey.PANEL_VOL_DOWN:
		case $.sfKey.VOL_UP:
        case $.sfKey.PANEL_VOL_UP:
             this.processVolumeKey();
			break;            
         
        case $.sfKey.RED:
            
			break;
		
		case $.sfKey.BLUE:
			//this.processBlueKey();
			break;

		case $.sfKey.TOOLS:
			alert("KEY_TOOLS");
			//this.processToolKey();
            break;
				
		case $.sfKey.YELLOW:
		case $.sfKey.GREEN:

            break;
			
            
        case $.sfKey.N1:
        case $.sfKey.N2:
        case $.sfKey.N3:
        case $.sfKey.N4:
        case $.sfKey.N5:
        case $.sfKey.N6:
        case $.sfKey.N7:
        case $.sfKey.N8:
        case $.sfKey.N9:
        case 35:
		case 650: 
        case $.sfKey.N0:
        case 259:
            ProcMgr.SendDTMF(keyCode);
            break;
            
       case $.sfKey.RETURN:
           this.processReturnKey();
            $.sfKey.block(event);
            break;
            
         case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey();
			break;
            
        default:
            ProcMgr.processBlockKey(keyCode);
            break;  
        
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneSkypeOutCall.prototype.create = function(){
    alert("SceneSkypeOutCall.create() ");
    this.SkypeOutCallView = new View("SkypeOutCall");
    this.SkypeOutCallView.SetBgImage(g_Image.IMAGE_VOICE_CALL_BG);
    
    this.CallDurationTextLabel = new Label(null,"skype_out_call_duration_text");
    this.CallDurationTextLabel.SetTextStyle("skype_out_call_duration_text_style");
    this.CallDurationTextLabel.SetText(IDWS_MOIP_SKYPE_CALL_DURATION);

    this.CallDurationTimeLabel = new Label(null,"skype_out_call_duration_time");
    this.CallDurationTimeLabel.SetTextStyle("skype_out_call_duration_time_style");
    this.CallDurationTimeLabel.SetText("00:00:00");

    this.YourNameLabel = new Label(null,"skype_out_call_your_name");
    this.YourNameLabel.SetTextStyle("skype_out_call_member_name_style");
    this.YourNameLabel.SetReverseDisable(true);
    this.YourNameLabel.SetIsPlainText(true);

    this.MyNameLabel = new Label(null,"skype_out_call_my_name");
    this.MyNameLabel.SetTextStyle("skype_out_call_member_name_style");
   	this.MyNameLabel.SetReverseDisable(true);
   	this.MyNameLabel.SetIsPlainText(true);
   	
    this.YourPhoneNumberLabel = new Label(null,"skype_out_call_your_phone_number");
    this.YourPhoneNumberLabel.SetTextStyle("skype_out_call_member_name_style");
    this.YourPhoneNumberLabel.SetReverseDisable(true);

    this.MyCreditLabel = new Label(null,"skype_out_call_my_credit");
    this.MyCreditLabel.SetTextStyle("skype_out_call_member_name_style");
    this.MyCreditLabel.SetReverseDisable(true);

    this.YourThumbnailLabel= new Label("skype_out_call_your_thumbnail", null);
    this.YourThumbnailLabel.SetBgImage(g_Image.IMAGE_VOICE_CALL_THUMBNAIL);
    this.YourThumbnailLabel.AppendFgImage("skype_out_call_your_thumbnail_avata","3px","3px","143px","140px");
    this.YourThumbnailLabel.SetFgImage(g_Image.IMAGE_VOICE_CALL_DEFAULT_AVATA_PSTN);

    this.MyThumbnailLabel= new Label("skype_out_call_my_thumbnail", null);
    this.MyThumbnailLabel.SetBgImage(g_Image.IMAGE_VOICE_CALL_THUMBNAIL);
    this.MyThumbnailLabel.AppendFgImage("skype_out_call_my_thumbnail_avata","3px","3px","143px","140px");
    this.MyThumbnailLabel.SetFgImage(g_Image.IMAGE_LIST_MAIN_VIEW_DEFAULT_AVATA);
    
    var this_ = $.sfScene.get("SkypeOutCall");
	var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.CallEndBtn = new Button();
    this.CallEndBtn.SetImageObjId("skype_out_call_end_btn");
    this.CallEndBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_END_BTN_NORMAL);
    this.CallEndBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_END_BTN_NORMALFOCUS);	
    this.CallEndBtn.SetTextObjId("skype_out_call_end_btn_text");
    this.CallEndBtn.SetText(TV_SID_END_CALL);
    this.CallEndBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.CallEndBtn.SetOnClickCallbackFunc(clickCF);
	
    this.ShowDialBtn = new Button();
    this.ShowDialBtn.SetImageObjId("skype_out_call_show_dial_btn");
    this.ShowDialBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMAL);
    this.ShowDialBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMALFOCUS);	
    this.ShowDialBtn.SetTextObjId("skype_out_call_show_dial_btn_text");
    this.ShowDialBtn.SetText(TV_SID_SHOW_DIAL);
    this.ShowDialBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
  	this.ShowDialBtn.SetOnClickCallbackFunc(clickCF);
  	
	this.MicVolumeBtn = new Button();
    this.MicVolumeBtn.SetImageObjId("skype_out_call_mic_volume_btn");
    this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMAL);
    this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMALFOCUS);
	this.MicVolumeBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_VOICE_CALL_BTN_DIM);	
    this.MicVolumeBtn.SetTextObjId("skype_out_call_mic_volume_btn_text");
    this.MicVolumeBtn.SetText(TV_SID_MIC_VOL);
    this.MicVolumeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
    this.MicVolumeBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE, "common_btn_text_f17_dim_style");
	this.MicVolumeBtn.SetOnClickCallbackFunc(clickCF);
	
    this.HoldBtn = new Button();
    this.HoldBtn.SetImageObjId("skype_out_call_hold_btn");
    this.HoldBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMAL);
    this.HoldBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_VOICE_CALL_BTN_NORMALFOCUS);	
    this.HoldBtn.SetTextObjId("skype_out_call_hold_btn_text");
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.HoldBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	this.HoldBtn.SetOnClickCallbackFunc(clickCF);
	
	this.PhoneIconLabel= new Label("skype_out_call_icon", null);
    this.PhoneIconLabel.SetBgImage(g_Image.IMAGE_VOICE_CALL_ICON);
    
    this.HoldIconLabel= new Label("skype_out_call_hold_icon", null);
    this.HoldIconLabel.SetBgImage(g_Image.IMAGE_VIDEO_CALL_HOLD_ICON);
    
    this.HelpBar = new HelpBar(HelpBarIndex.SKYPE_OUT_CALL, "SkypeOutCall");   
    //this.HelpBar.SetOnClickCallbackFunc(2, function(){this_.processBlueKey();});    
    //this.HelpBar.SetOnClickCallbackFunc(2, function(){this_.processToolKey();});
    this.HelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    
	this.CallEndBtn.registHelpBar( this.HelpBar);
	this.ShowDialBtn.registHelpBar( this.HelpBar);
	this.MicVolumeBtn.registHelpBar( this.HelpBar);
	this.HoldBtn.registHelpBar( this.HelpBar);   
    
}

SceneSkypeOutCall.prototype.update = function()
{
    var call_member_display_name =  PluginAPIMgr.GetCallMemberDisplayName();
    var call_member_id = PluginAPIMgr.GetCallMemberID() ;
    if(call_member_display_name == call_member_id)
    {
        this.YourNameLabel.SetText("");
        
    }
    else
    {
        this.YourNameLabel.SetText(call_member_display_name);
    }
    
    this.YourPhoneNumberLabel.SetText(call_member_id);
    this.YourThumbnailLabel.SetFgImage(g_Image.IMAGE_VOICE_CALL_DEFAULT_AVATA_PSTN);
    
    this.MyNameLabel.SetText(PluginAPIMgr.GetMyDisplayName() );
    this.MyCreditLabel.SetText(PluginAPIMgr.GetMyCredit());
    this.MyThumbnailLabel.SetFgImage(PluginAPIMgr.GetMyAvataImageForCall());
    
    this.toggleMicVolumeBtnEnable();
    
      if(g_Data.GetCallLocalHold() == true)
     {
        this.LocalHold();
     }
     else if(g_Data.GetCallRemoteHold() == true)
     {
        this.RemoteHold();
     }
     else
     {
        this.Resume();
     }
     
     this.updateCallDuration(g_Data.GetCallDuration());
}

 SceneSkypeOutCall.prototype.updateCallDuration = function(time)
{
     this.CallDurationTimeLabel.SetText(time);
}

 SceneSkypeOutCall.prototype.updateCredit = function()
{
     this.MyCreditLabel.SetText(PluginAPIMgr.GetMyCredit());
}

SceneSkypeOutCall.prototype.toggleMicVolumeBtnEnable=function()
{
    alert("SceneSkypeOutCall.toggleMicVolumeBtnEnable() ");
    
    var camera_state = PluginAPIMgr.GetCameraState();
    
    if(camera_state == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || camera_state == ENUM_CAM_STATE.CAM_STATE_CONNECTING)
    {
        alert("SceneSkypeOutCall.toggleMicVolumeBtnEnable() Dim : true ->  camera_state : "+ camera_state );
         var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
        
        if(currentHighlight ==  this.MicVolumeBtn)
        {
              if(this.MicVolumeBtn.flag_highlight == true)
            {
                this.highlight(this.CallEndBtn);
            }
            else
            {
                this.highlight(null);
            }
        }
        this.MicVolumeBtn.SetFlagDim(true);
    }
    else
    {
        alert("SceneSkypeOutCall.toggleMicVolumeBtnEnable() Dim :  false ");
       	if(PluginAPIMgr.IsInCall()==1)
		{
			PluginAPIMgr.StartRecord();
		}
        this.MicVolumeBtn.SetFlagDim(false);
    }    
}

SceneSkypeOutCall.prototype.highlight=function(obj)
{
    this.SkypeOutCallView.setCurrenHighlight(obj);
}

SceneSkypeOutCall.prototype.processLeftKey=function()
{
    alert("SceneSkypeOutCall.processLeftKey() ");
    var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
            this.highlight(this.HoldBtn);
            break;
         case this.ShowDialBtn:
            this.highlight(this.CallEndBtn);
            break;
        case this.MicVolumeBtn:
            this.highlight(this.ShowDialBtn);
            break; 
         case this.HoldBtn:
          if(this.MicVolumeBtn.GetFlagDim() == true)
          {
             this.highlight(this.ShowDialBtn);
          }
          else
          {
            this.highlight(this.MicVolumeBtn);
          }
            break;           
            
    }
}

SceneSkypeOutCall.prototype.processRightKey=function()
{
    alert("SceneSkypeOutCall.processRightKey() ");
    var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
            this.highlight(this.ShowDialBtn);
            break;
         case this.ShowDialBtn:
           if(this.MicVolumeBtn.GetFlagDim() == true)
          {
             this.highlight(this.HoldBtn);
          }
          else
          {
            this.highlight(this.MicVolumeBtn);
          }
            break;
        case this.MicVolumeBtn:
            this.highlight(this.HoldBtn);
            break; 
         case this.HoldBtn:
            this.highlight(this.CallEndBtn);
            break;           
            
    }
}

SceneSkypeOutCall.prototype.processEnterKey=function()
{
    alert("SceneSkypeOutCall.processEnterKey() ");
    var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.CallEndBtn:
           ProcMgr.DisconnectCall();
            break;
         case this.ShowDialBtn:         
            WndMgr.ToggleSkypeOutCallMode();
            break;
        case this.MicVolumeBtn:
             StateMgr.Start_Volume_Mic_State();
            break; 
         case this.HoldBtn:
            ProcMgr.ToggleLocalHold(); 
            break;           
            
    }
}

SceneSkypeOutCall.prototype.processReturnKey = function(){
    alert("SceneSkypeOutCall.processReturnKey() ");
    
    /*if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_Main_State();
	}
	else
	{
		StateMgr.Start_Call_Switch_State(); 
	}*/  
	
	ProcMgr.DisconnectCall();     
}

SceneSkypeOutCall.prototype.processExitKey = function(){
    alert("SceneSkypeOutCall.processExitKey() ");
   
   StateMgr.Start_Exit_State(false);
}

SceneSkypeOutCall.prototype.processVolumeKey=function()
{
    alert("SceneSkypeOutCall.processVolumeKey() ");
    StateMgr.Start_Volume_Speaker_State();
}

SceneSkypeOutCall.prototype.processBlueKey = function(){
    alert("SceneVoiceCall.processBlueKey() ");
    
	if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_Live_Contact_List_State();
	}	
}

SceneSkypeOutCall.prototype.LocalHold=function()
{
    alert("SceneSkypeOutCall.LocalHold() ");   
    this.HoldIconLabel.visibleObj();
    this.HoldBtn.SetText(SID_RESUME);
    this.CallDurationTextLabel.SetText(IDWS_MOIP_CALL_ON_HOLD);    
}

SceneSkypeOutCall.prototype.RemoteHold=function()
{
    alert("SceneSkypeOutCall.RemoteHold() ");  
    this.HoldIconLabel.visibleObj();
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.CallDurationTextLabel.SetText(TV_SID_YOU_ARE_ON_HOLD); 
}

SceneSkypeOutCall.prototype.Resume=function()
{
    alert("SceneSkypeOutCall.Resume() ");  
    this.HoldIconLabel.hiddenObj();
    this.HoldBtn.SetText(IDWS_MOIP_SKYPE_HOLD);
    this.CallDurationTextLabel.SetText(IDWS_MOIP_SKYPE_CALL_DURATION); 
}

SceneSkypeOutCall.prototype.processClickEvent = function(obj){
	alert("SceneSkypeOutCall.processClickEvent() ");
	
	var currentHighlight =  this.SkypeOutCallView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	if(event.button==2)
	{
		alert("SceneSkypeOutCall.processClickEvent() -> right button ");
		//this.processToolKey();
	}
	else
	{
		alert("SceneSkypeOutCall.processClickEvent() -> left button ");
		this.processEnterKey();
	}
}

SceneSkypeOutCall.prototype.processToolKey=function()
{
    alert("SceneSkypeOutCall.processToolKey() ");

	if(ProcMgr.isGenoaS==false)
	{
		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.VOICE_CALL);  
	}
		  
}

