function SceneViewProfile(options) {
	this.options = options;

    this.ProfileView=null;
	this.ViewProfileDim=null;
    
    this.Title = null;
	
    this.ThumbnailLabel 	= null;
    this.NameLabel 			= null;
    this.MoodMsgLabel 		= null;
    this.SkypeNameLabel 	= null;
    this.BirthDayLabel 		= null;
    this.GenderLabel 		= null;
	this.LanguageLabel 		= null;
    this.LocationLabel 		= null;
	this.WebsiteLabel 		= null;
	this.PhoneNumberLabel 	= null;
	this.AboutMeLabel		= null;
	
    this.SkypeNameText 	= new Array(3);
    this.BirthDayText = new Array(3);
    this.GenderText = new Array(3);
	this.LanguageText = new Array(3);
    this.LocationText = new Array(3);
	this.WebsiteText = new Array(3);
	this.PhoneNumberText = new Array(3);
	this.AboutMeText = new Array(3);
	

    this.CloseBtn = null;
    
    this.ViewProfileHelpBar = null;

	this.ContactName	= null;

	//timer
    this.PopupTimer = false;
	
}

SceneViewProfile.prototype.initialize = function () {
	alert("SceneViewProfileProfile.initialize()");
	
	this.create();
}

SceneViewProfile.prototype.handleShow = function () {
	alert("SceneViewProfileProfile.handleShow()");
	this.ViewProfileDim.show();
	
	this.setData();
    this.highlight(this.CloseBtn);

    this.startTimer();
    
}

SceneViewProfile.prototype.handleHide = function () {
	alert("SceneViewProfileProfile.handleHide()");
    this.ViewProfileDim.hide();

    if (this.PopupTimer == true)
    {
        this.stopTimer();
    }

}

SceneViewProfile.prototype.handleFocus = function () {
	alert("SceneViewProfileProfile.handleFocus()");

}

SceneViewProfile.prototype.handleBlur = function () {
	alert("SceneViewProfileProfile.handleBlur()");	
}

SceneViewProfile.prototype.handleKeyDown = function (keyCode) {
	alert("SceneViewProfileProfile.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);	
            break;

		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneViewProfile.prototype.create = function(){
    alert("SceneViewProfileProfile.create()");
		
    this.ProfileView = new View("ViewProfile");
    this.ProfileView.SetBgImage(g_Image.IMAGE_LIST_MAIN_VIEW_PROFILE_BG);
	
	this.ViewProfileDim = new DimBg("ViewProfileDim", "ViewProfile"); 
    
    this.Title = new Label(null,"view_profile_title");
    this.Title.SetText(SID_PROFILE_KR_PROFILE);
  
    this.ThumbnailLabel= new Label("view_profile_thumbnail", null);
    this.ThumbnailLabel.SetBgImage(g_Image.IMAGE_LIST_MAIN_VIEW_PROFILE_THUMBNAIL);
    this.ThumbnailLabel.AppendFgImage("view_profile_thumbnail_avata","3px","2px","69px","69px");	
    
    this.NameLabel = new Label(null,"view_profile_full_name");
    this.NameLabel.SetReverseDisable(true);
    this.NameLabel.SetIsPlainText(true);
    
    this.MoodMsgLabel = new Label(null,"view_profile_mood_msg");
    this.MoodMsgLabel.SetReverseDisable(true);
    this.MoodMsgLabel.SetIsPlainText(true);
    /*this.SkypeNameLabel = new Label(null,"view_profile_skype_name");
    //this.SkypeNameLabel.SetReverseDisable(true);
	this.BirthDayLabel = new Label(null,"view_profile_birth_date");
	//this.BirthDayLabel.SetReverseDisable(true);
	this.GenderLabel = new Label(null,"view_profile_gender");
	//this.GenderLabel.SetReverseDisable(true);
    this.LanguageLabel = new Label(null,"view_profile_language");
    //this.LanguageLabel.SetReverseDisable(true);
    this.LocationLabel = new Label(null,"view_profile_location");
    //this.LocationLabel.SetReverseDisable(true);
	this.WebsiteLabel = new Label(null,"view_profile_website");
	//this.WebsiteLabel.SetReverseDisable(true);
    this.PhoneNumberLabel = new Label(null,"view_profile_contacts");
    //this.PhoneNumberLabel.SetReverseDisable(true);
    this.AboutMeLabel = new Label(null,"view_profile_about_me");
    //this.AboutMeLabel.SetReverseDisable(true);    */
	
	var a=1;
	for(a=1; a<=3; a++)
	{
		this.SkypeNameText[a-1]=new Label(null,"view_profile_skype_name"+"_"+a);
		this.SkypeNameText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);
		
		this.BirthDayText[a-1]=new Label(null,"view_profile_birth_date"+"_"+a);
		this.BirthDayText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);

		this.GenderText[a-1]=new Label(null,"view_profile_gender"+"_"+a);
		this.GenderText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);
		
		this.LanguageText[a-1]=new Label(null,"view_profile_language"+"_"+a);
		this.LanguageText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);
		
		this.LocationText[a-1]=new Label(null,"view_profile_location"+"_"+a);
		this.LocationText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);

		this.WebsiteText[a-1]=new Label(null,"view_profile_website"+"_"+a);
		this.WebsiteText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);
		
		this.PhoneNumberText[a-1]=new Label(null,"view_profile_contacts"+"_"+a);
		this.PhoneNumberText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);

		this.AboutMeText[a-1]=new Label(null,"view_profile_about_me"+"_"+a);
		this.AboutMeText[a-1].SetTextStyle("view_profile_text_style"+"_"+a);
		
		if(a==1)
		{
			this.SkypeNameText[0].SetText(IDWS_MOIP_SKYPE_NAME);
			this.BirthDayText[0].SetText(IDWS_MOIP_SETTING_BIRTH_DATE);
			this.GenderText[0].SetText(IDWS_MOIP_SETTING_GENDER);	
			this.LanguageText[0].SetText(SID_LANGUAGE);
			this.LocationText[0].SetText(SID_LOCATION_KR_LOCATE);
			this.WebsiteText[0].SetText(IDWS_MOIP_WEBSITE);	
			this.PhoneNumberText[0].SetText(IDWS_MOIP_CONTACTS);
			this.AboutMeText[0].SetText(IDWS_MOIP_ABOUT_ME);	  
		}
		
		if(a==2)
		{
			this.SkypeNameText[1].SetText(":");
			this.BirthDayText[1].SetText(":");
			this.GenderText[1].SetText(":");	
			this.LanguageText[1].SetText(":");
			this.LocationText[1].SetText(":");
			this.WebsiteText[1].SetText(":");	
			this.PhoneNumberText[1].SetText(":");
			this.AboutMeText[1].SetText(":");	  
		}
		
		if(a==3)
		{
			this.SkypeNameText[2].SetReverseDisable(true); 
			this.BirthDayText[2].SetReverseDisable(true); 
			this.GenderText[2].SetReverseDisable(true); 
			this.LanguageText[2].SetReverseDisable(true); 
			this.LocationText[2].SetReverseDisable(true); 
			this.WebsiteText[2].SetReverseDisable(true); 
			this.PhoneNumberText[2].SetReverseDisable(true); 
			this.AboutMeText[2].SetReverseDisable(true);
			
			this.SkypeNameText[2].SetIsPlainText(true); 
			this.BirthDayText[2].SetIsPlainText(true); 
			this.GenderText[2].SetIsPlainText(true); 
			this.LanguageText[2].SetIsPlainText(true); 
			this.LocationText[2].SetIsPlainText(true); 
			this.WebsiteText[2].SetIsPlainText(true); 
			this.PhoneNumberText[2].SetIsPlainText(true); 
			this.AboutMeText[2].SetIsPlainText(true);  	  
		}
	}
	
	var this_ = $.sfScene.get("ViewProfile");
    var clickCF =  function(obj){this_.processClickEvent(obj);};    	  
    
    this.CloseBtn = new Button();
    this.CloseBtn.SetImageObjId("view_profile_close_btn");
    this.CloseBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LIST_MAIN_VIEW_PROFILE_BTN_NORMALFOCUS);
    this.CloseBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LIST_MAIN_VIEW_PROFILE_BTN_NORMALFOCUS);	
    this.CloseBtn.SetTextObjId("view_profile_close_btn_text");
    this.CloseBtn.SetText(SID_CLOSE);
    this.CloseBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	this.CloseBtn.SetOnClickCallbackFunc(clickCF);
	
    this.ViewProfileHelpBar = new HelpBar(HelpBarIndex.VIEW_PROFILE, "ViewProfile");
    this.ViewProfileHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    
    this.ProfileView.registHelpBar( this.ViewProfileHelpBar);

}

SceneViewProfile.prototype.Init = function(Identity){
	this.ContactName = Identity;
}

SceneViewProfile.prototype.setData=function()
{
	var AvataImage = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_AVATAR_IMAGE);
	var Fullname = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_FULLNAME);
	var MoodMsg = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_MOOD_TEXT);
	var Birthday = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_BIRTHDAY);
	var gender = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_GENDER);
	var Language = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_LANGUAGES);
	var City = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_CITY);
	var Province = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_PROVINCE);
	var Country = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_COUNTRY);	
	var Website = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_HOMEPAGE);
	var NumOfContacts = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_NROF_AUTHED_BUDDIES);
	var AboutMe = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_ABOUT);
	
	if(!AvataImage){
		var PSTN = PluginAPIMgr.GetContactPropWithName(this.ContactName,ENUM_CONTACT_PROPERTY.P_PSTNNUMBER);

		if (PSTN){
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_PSTN_BIG;
		}
		else if (gender == "1"){
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_MALE_BIG;			
		}
		else if (gender == "2" ) {
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_FEMALE_BIG;
		}
		else if (this.ContactName == "echo123") {
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_TEST_CALL_BIG;
		}	
		else if (gender == "0"){
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_NO_GENDER_BIG;
		}			
		//this contact is mine !!
		else {
			AvataImage = g_Image.IMAGE_LIST_MAIN_HISTORY_LIST_ITEM_DEFAULT_AVATA_MYSELF_BIG;
		}		
	}	
	var BDate = "";
	if(Birthday && Birthday.length == 8)
	{
		var year = Birthday.slice(0,4);
		var month = Birthday.slice(4,6);
		var day	= Birthday.slice(6);
		
		BDate = year + "." + month + "." + day;
	}
	else{
		
		alert("Error Birthdat format!!!");
	}

	var Sex = "";
	if(gender == '1'){
		Sex = "Male";
	}
	else if(gender == '2'){
		Sex = "Female"
	}

	if(City){
		City = City +  "/";
	}

	if(Province){
		Province = Province +  "/";
	}

	if(Country){
		Country = g_Data.GetCountryNameWithPrePix(Country);
	}
		
	var Location = City + Province  + Country;
	
	
	var Contacts = "";
	
	if(NumOfContacts){
		Contacts = NumOfContacts;
	}

	this.Title.SetText(SID_PROFILE_KR_PROFILE);
	this.ThumbnailLabel.SetFgImage(AvataImage);
	this.NameLabel.SetText(Fullname);
	this.MoodMsgLabel.SetText(MoodMsg);
	/*this.SkypeNameLabel.SetText(IDWS_MOIP_SKYPE_NAME + " : " + this.ContactName);
	this.BirthDayLabel.SetText(IDWS_MOIP_SETTING_BIRTH_DATE + " : " + BDate);
	this.GenderLabel.SetText(IDWS_MOIP_SETTING_GENDER + " : " + Sex);	
	this.LanguageLabel.SetText(SID_LANGUAGE+ " : " + Language);
	this.LocationLabel.SetText(SID_LOCATION_KR_LOCATE+ " : " + Location);
	this.WebsiteLabel.SetText(IDWS_MOIP_WEBSITE + " : " + Website);	
	this.PhoneNumberLabel.SetText(IDWS_MOIP_CONTACTS+ " : " + Contacts);
	this.AboutMeLabel.SetText(IDWS_MOIP_ABOUT_ME+ " : " + AboutMe);	*/
	
	this.SkypeNameText[2].SetText(this.ContactName);
	this.BirthDayText[2].SetText(BDate);
	this.GenderText[2].SetText(Sex);	
	this.LanguageText[2].SetText(Language);
	this.LocationText[2].SetText(Location);
	this.WebsiteText[2].SetText(Website);	
	this.PhoneNumberText[2].SetText(Contacts);
	this.AboutMeText[2].SetText(AboutMe);     

}

SceneViewProfile.prototype.highlight=function(obj)
{
	this.CloseBtn.highlight();
}


SceneViewProfile.prototype.processEnterKey = function(){
    alert("SceneViewProfileProfile.processEnterKey() ");

	StateMgr.Stop_View_Profile_State(true);
}

SceneViewProfile.prototype.processReturnKey = function(){
    alert("SceneViewProfileProfile.processReturnKey() ");

	StateMgr.Stop_View_Profile_State(true);
}

SceneViewProfile.prototype.startTimer = function()
{
    alert("SceneViewProfile.startTimer() ");

	this.PopupTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('ViewProfile').popupTimerCallback();}, ENUM_TIMER_TYPE.ONE_BUTTON);
}

SceneViewProfile.prototype.stopTimer = function()
{
    alert("SceneViewProfile.stopTimer() ");

	this.PopupTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.ONE_BUTTON);
}

SceneViewProfile.prototype.popupTimerCallback = function()
{
    alert("SceneViewProfile.popupTimerCallback() ");
	if(this.PopupTimer == false)
	{
		return;
	}
	this.PopupTimer = false;
	
    StateMgr.Stop_View_Profile_State(true);
}

SceneViewProfile.prototype.processClickEvent = function(obj){
	alert("SceneViewProfile.processClickEvent() ");
	
	this.processEnterKey();
}
