if(!this.ProcMgr) {
	this.ProcMgr = new Object();
}

ProcMgr ={
	isWelcomeMode : true,
	
	flagQuit : false,
	
	loggedIn : false,
	cblSync : false,
	
	isLoginCencel : false,
	
	isConferenceCall: false,
	isCalling : false,
	isCallCencel : false,
	isVoiceMailSending : false,
	callHoldTimer : false,
	callResumeTimer : false,
	
	callEndWaitingTimer : false,
	isLogoutAfterCallEnd : false,
	isQuitAfterCallEnd : false,
	isCloseAfterCallEnd : false,
	isExitAfterCallEnd : false,

	isCallStartAfterCallEnd : false,
	isCallingFail : false,
	
	isIncomingCall : false,
	isReceivingVideo : false,
	isPauseVideo : false,
	
	isChatting: false,
	isTypingChatMsg : false,
	numOfChatMember :0,
	ChatMember :"",
	ChatParticipants : "",
	ChatMemberSkypeName :"",
	
	isVoiceMailPlaying : false,
	
	isKeyRegister: false,
	isCallKeyRegister: false,
	
	isTTXMIX: false,
	isGenoaS: false,
	ModelCode : null,
	
	isVideoAvailable:false,

	cameraZoomValue :0,
	
	MainListFuncType : null,
	start_main : false,
	
	isExitAfterSignout : false,
	
	//isGestureRecognition : false,
	
	isAutoFocus:false,
	
	isFaceRecog : false,
	isFaceDetect : false,
	isFaceTraining : false,
	
	FaceRecogTimer:false,
	FaceDetectTimer:false,
	
	CountOfRecogFail : 0,
	CountOfTrainingFail :0,
	CountOfRecogInfo : 0,
	
	isRegisteredFace : false,
	isReRegisterFace : false,
	FaceRegistrationCallerState : "",
	isFaceRegistrationAfterSignin : false,
	isSigninAfterPwdCheck : false,

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  TV Model / Target location / remote control ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.getTVModel =function()
{	
	var tv_model = PluginAPIMgr.GetTVModel();
	//var tv_model = "T-GASAKUC";
	//var tv_model = "T-GAPAKUC";
	//var tv_mode =  "T-MST10PDEUC"
	alert("***** ProcMgr.getTVModel() :  " + tv_model );
	
	var model_id = tv_model.substring(4,5);
	var X10Pchecker = tv_model.substring(2,8);
	
	if(model_id == "S")
	{
		this.isGenoaS = true;
		this.ModelCode = TV_MODEL_CODE.GENOA_S;
	}
	else if( X10Pchecker == "MST10P")
	{
		alert("this is X10P" );
		this.isGenoaS = false;
		this.ModelCode = TV_MODEL_CODE.X10P;
	}
	else
	{
		this.isGenoaS = false;
		this.ModelCode = TV_MODEL_CODE.NORMAL;		
	}
}
/*
ProcMgr.getTargetLocation =function()
{
    //return;
    var p = $.sf.plugin('TV');
    var curr_location = ENUM_TV_TARGET_LOCATION.UNKNOWN;

     if(p){
       curr_location=  p.GetTargetLocation();
       
       alert("***** ProcMgr.getTargetLocation()  -> " + curr_location);
       
       if(curr_location == ENUM_TV_TARGET_LOCATION.PANEURO)
       {
            this.isTTXMIX = true;
       }
       else
       {
            this.isTTXMIX = false;
       }
       
       alert("***** ProcMgr.getTargetLocation() :  isTTXMIX-> " +  this.isTTXMIX );
    }
}*/

ProcMgr.getIMERemoconAreaId = function()
{
	alert("ZeroLeft -> " + IMEvar.productInfor.ZeroLeft); 
	
	if(IMEvar.productInfor.ZeroLeft == 'TTX/MIX')
	{
		this.isTTXMIX = true;
	}
	else
	{
		this.isTTXMIX = false;
	}
}

ProcMgr.isTTXMIXEnable =function()
{
    return this.isTTXMIX;
}

ProcMgr.setDefaultRemoteType=function()
{
	alert("***** ProcMgr.setDefaultRemoteType()");

//temp : for webkit
/*
	curWidget.setInputType(24);
*/
}

ProcMgr.setNumericRemoteType=function()
{
	alert("***** ProcMgr.setNumericRemoteType()");

//temp : for webkit
/*
	curWidget.setInputType(27);
*/
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  Key  register / unregister / process  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.registerKey =function()
{   
	alert("***** ProcMgr.registerKey()");
	if(this.isKeyRegister== false)
	{
		var p = $.sf.plugin('APPCOMMON');
		var i=0;
		for(i=0; i < KEY_CODE_LIST.length; i++)
		{         
		     if(p){
		        p.RegisterKey(KEY_CODE_LIST[i]);
		    }
		}	
		this.isKeyRegister=true;
	}
}

ProcMgr.unregisterKey =function()
{  
	alert("***** ProcMgr.unregisterKey ()");
	if(this.isKeyRegister== true && this.isCalling==false)
	{
		var p = $.sf.plugin('APPCOMMON');
		
		var i=0;
		for(i=0; i < KEY_CODE_LIST.length; i++)
		{             
		    if(p){
				p.UnregisterKey(KEY_CODE_LIST[i]);
		    }
		}
		this.isKeyRegister=false;
	}
}

ProcMgr.registerCallKey =function()
{	
	alert("***** ProcMgr.registerCallKey()");

	if(this.isCallKeyRegister== false)
	{
		var p = $.sf.plugin('APPCOMMON');
		var i=0;
		for(i=0; i < CALL_BLOCK_KEY_CODE_LIST.length; i++)
		{         
		     if(p){
				p.RegisterKey(CALL_BLOCK_KEY_CODE_LIST[i]);
		    }
		}	
		this.isCallKeyRegister=true;
	}
}

ProcMgr.unregisterCallKey  =function()
{
	alert("***** ProcMgr.unregisterCallKey ()");
		
	if(this.isCallKeyRegister== true && this.isCalling==false)
	{
		var p = $.sf.plugin('APPCOMMON');
	
		var i=0;
		for(i=0; i < CALL_BLOCK_KEY_CODE_LIST.length; i++)
		{             
		    if(p){
		        p.UnregisterKey(CALL_BLOCK_KEY_CODE_LIST[i]);
		    }
		}
		this.isCallKeyRegister=false;
	}
}

ProcMgr.processBlockKey  =function(key_code)
{
    alert("***** ProcMgr.processBlockKey () key_code : " + key_code);
    
    if(key_code== 40000002 || key_code== 40000003 || key_code== 40000004 || key_code== 40000005)
    {
    	return;
    }
    
	var BlockKey = false;
    var i=0;
    for(i=0; i < CHANNEL_KEY_CODE_LIST.length; i++)
    {             
        if (CHANNEL_KEY_CODE_LIST[i] == key_code) 
		{
            if(this.isCalling == true  && StateMgr.GetCurrentSubState().length <= 0)
            {
				if(g_NumObj != null)
				{
					g_NumObj.blur();	
				}	
					
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_KEY);
				BlockKey = true;
				$.sfKey.block(event);
            }
			else
			{
				return;
			}
        }
    }
	
	for(i=0; i < CALL_BLOCK_KEY_CODE_LIST.length; i++)
    {             
        if (CALL_BLOCK_KEY_CODE_LIST[i] == key_code) 
		{
			if(this.isCalling == true  && StateMgr.GetCurrentSubState().length <= 0)
			{
				if(g_NumObj != null)
				{
					g_NumObj.blur();	
				}	
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_KEY);
				BlockKey = true;
				$.sfKey.block(event); 
			}
			else
			{
				return;
			}
        }
    }
			
	if(BlockKey==false)
	{
		if(StateMgr.GetCurrentSubState().length <= 0)
        {
			if(g_NumObj != null)
			{
				g_NumObj.blur();	
			}	
			
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_KEY);
			
        }
		$.sfKey.block(event);
	}
}

ProcMgr.processInfolinkKey  =function()
{
    alert("***** ProcMgr.processInfolinkKey ()");
     
    if(this.isCalling == true || StateMgr.GetCurrentSubState().length >0 || ProcMgr.isShowNotyOfMainState()==true)
    {
        if(this.isCalling == true  && StateMgr.GetCurrentSubState().length <= 0)
        {
			if(g_NumObj != null)
			{
				g_NumObj.blur();	
			}	
				
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_KEY);
        }

        $.sfKey.block(event);
    }
    else
    {
		this.CloseWidget();
        $.sfKey.block(event);
    }
}

ProcMgr.isShowNotyOfMainState =function()
{
    alert("***** ProcMgr.isShowNotyOfMainState ()");
    
    var result = false;
    
    if(StateMgr.GetCurrentState()=="CreateAccountSuccess")
    {
    	if(WndMgr.CreateAccountSuccessStep != "Success")
    	{
    		result=true;
    	}
    }
    else if(StateMgr.GetCurrentState()=="FaceRecogSignin")
    {
		if(WndMgr.FaceRecogSigninStep != "FaceRecog" && WndMgr.FaceRecogSigninStep != "Result")
    	{
			result=true;
    	}
    }
    else if(StateMgr.GetCurrentState()=="FaceRecogRegistration")
    {
		if(WndMgr.FaceRecogRegistrationStep != "FaceDetect")
    	{
			result=true;
    	}
    }
    else
    {
    	result=false;
    }
    
    return result;    
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///// Widget Start /  Stop  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.StartWidget = function()
{     
    alert("***** ProcMgr.StartWidget()");
	
    this.start_main = PluginAPIMgr.SetSkypeWidgetState(1);
	ProcMgr.InitCameraOption();
	/*if(PluginAPIMgr.RecognitionPluginAvailable == true)
	{
		if(PluginAPIMgr.IsGestureRecognitionEnabled())
		{
			PluginAPIMgr.DisableGestureRecognition();
			this.isGestureRecognition=true;
		}
		else
		{
			this.isGestureRecognition=false;
		}	
	}*/

    if(PluginAPIMgr.GetLoginState() == "0")  //logged out state
    {
       if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
      {
            PluginAPIMgr.AutoLogin(); 
       }
       else  //manual login 
       {
			StateMgr.Start_Welcome_State();		
       }
    }
    else 
    {
        if(PluginAPIMgr.GetLoginState() == "2") //logged in state
        {
            if(this.start_main == "1")
            {
                StateMgr.Start_Main_State();
            }
        }
    }       
}

ProcMgr.CloseWidget = function()
{
	if(StateMgr.GetCurrentState()== "VideoSnapshot" || StateMgr.GetCurrentState()== "CameraCheckConnected")
	{
		PluginAPIMgr.StopPreview();	
	}
	
	setTimeout("WaitTimerCF()", 0);
	WaitTimerCF = function(){
     $.sf.exit(false);
    }
}

ProcMgr.ExitWidget = function()
{
	if(StateMgr.GetCurrentState()== "VideoSnapshot" || StateMgr.GetCurrentState()== "CameraCheckConnected")
	{
		PluginAPIMgr.StopPreview();	
	}
	
	setTimeout("WaitTimerCF()", 0);
	WaitTimerCF = function(){
     $.sf.exit(true);
    }
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////Signin , Create Account, Signout, Exit////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.Signin = function(id, pwd, savePwd)
{    
    alert("***** ProcMgr.Signin ()");
     
    g_Data.SetSigninInputInfo(id, pwd , savePwd);

    PluginAPIMgr.Login();
    
    if(StateMgr.GetCurrentState()=="Signin")
    {
    	WndMgr.NextStepSignin();
    }
    
    if(StateMgr.GetCurrentState()=="FaceRecogSignin")
    {
    	WndMgr.NextStepFaceRecogSignin();
    }    
}

ProcMgr.CancelSignin = function()
{    
    alert("***** ProcMgr.CancelSignin ()");
    
    this.loggedIn = false;  //init
    this.cblSync = false;  //init
    
    this.isLoginCencel = true;
    ProcMgr.Signout(false);
}

ProcMgr.CreateAccount = function()
{
    alert("***** ProcMgr.CreateAccount()");

    PluginAPIMgr.Register();
    WndMgr.NextStepCreateAccount();        
}

ProcMgr.CreateAccountWithNewSkypeName = function(id)
{
    alert("***** ProcMgr.CreateAccountWithNewSkypeName ()");
    g_Data.SetCreateAccountSkypeName(id);
	WndMgr.UpdateCreateAccount(id);
	
    PluginAPIMgr.Register();
    WndMgr.NextStepCreateAccount();
}

ProcMgr.ReceivedLoggedIn= function()
{
    alert("***** ProcMgr.ReceivedLoggedIn()");
    
    this.loggedIn = true;
    
	if(StateMgr.GetCurrentState() =="CreateAccount")
    {
        PluginAPIMgr.SetFullName(g_Data.DATA_CREATE_ACCOUNT_INPUT_INFO.full_name);
		PluginAPIMgr.SetCallForwardTimer(g_Data.DATA_DEFAULT_CALL_FORWARDING_TIME);
		
		var is_auto_signin = PluginAPIMgr.IsAutoSignInSet();
		if(is_auto_signin==false)
		{
			var is_auto_start =PluginAPIMgr.IsAutoStartSet();
			if(is_auto_start==true)
			{
				PluginAPIMgr.SetAutoStart(false);
			}
		}
    }

    if(this.cblSync==true)
    {
        ProcMgr.HandleLoggedIn();
    }
}

ProcMgr.ReceivedCblSync= function()
{
    alert("***** ProcMgr.ReceivedCblSync()");
    
    this.cblSync = true;
     
    if(this.loggedIn==true)
    {
        ProcMgr.HandleLoggedIn();
    }
}

ProcMgr.SavePwd= function()
{
    if(StateMgr.GetCurrentState()=="Signin")
    {
    	alert("***** ProcMgr.SavePwd(): Siginin");
    	this.SetMyPwd(g_Data.DATA_SIGNIN_INPUT_INFO.pwd);
    	PluginAPIMgr.SetLoginMode(0);    	
    }
    
    if(StateMgr.GetCurrentState()=="CreateAccount")
    {
    	alert("***** ProcMgr.SavePwd(): CreateAccount");
    	this.SetMyPwd(g_Data.DATA_CREATE_ACCOUNT_INPUT_INFO.pwd);
    	PluginAPIMgr.SetLoginMode(0); 
    }
    
    if(StateMgr.GetCurrentState()=="FaceRecogSignin")
    {
    	if(this.isFaceRegistrationAfterSignin== true || this.isSigninAfterPwdCheck == true)
    	{
	    	alert("***** ProcMgr.SavePwd(): FaceRecogSignin");
    		this.SetMyPwd(g_Data.DATA_SIGNIN_INPUT_INFO.pwd);    		
    	}
    	
    	PluginAPIMgr.SetLoginMode(1); 
    }
    
}

ProcMgr.HandleLoggedIn= function()
{
    alert("***** ProcMgr.HandleLoggedIn()");
    
    if(PluginAPIMgr.RecognitionPluginAvailable == true)
    {
    	this.SavePwd();
    }	
    
    WndMgr.DisableLoading();
   
   	if(StateMgr.GetCurrentState()=="FaceRecogSignin")
	{
		if(this.isFaceRegistrationAfterSignin==true)
		{
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.FACE_RECOG_RE_REGISTRATION);
		}
		else
		{
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.FACE_RECOG_LOGGEDIN);
		}
				
		WndMgr.NextStepFaceRecogSignin();	
	}
	else
	{
		this.StartLoggedInState();
	} 	

    this.loggedIn = false;  //init
    this.cblSync = false;  //init
    this.isFaceRegistrationAfterSignin = false; //init
    this.isSigninAfterPwdCheck = false; //init
}

ProcMgr.StartLoggedInState = function()
{
    alert("***** ProcMgr.StartLoggedInState()");
	
	if(StateMgr.GetCurrentState()=="CreateAccount")
	{
		if(PluginAPIMgr.RecognitionPluginAvailable == true)
		{
			StateMgr.Start_Create_Account_Success_State();
			return;
		}
	}

	var camera_state = PluginAPIMgr.GetCameraState();

    if(camera_state == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || camera_state == ENUM_CAM_STATE.CAM_STATE_CONNECTING) 
	{
		if(PluginAPIMgr.RecognitionPluginAvailable == false)
		{
			StateMgr.Start_Camera_Check_Disconnected_State();
		}
		else
		{
			StateMgr.Start_Main_State();
		}							
	}
	else
	{		
		var camera_check_disable = PluginAPIMgr.GetCameraCheckDisable();
		
		if(camera_check_disable==false)
		{	
			StateMgr.Start_Camera_Check_Connected_State();
		}
		else
		{
			StateMgr.Start_Main_State();
		}
	}
}

ProcMgr.Signout = function(flag_quit)
{    
    alert("***** ProcMgr.Signout () Quit : " + flag_quit);
     
     if(this.isCalling ==true)
     {
            if(flag_quit == true)
            {
                this.isQuitAfterCallEnd = true;
            }
            else
            {
                this.isLogoutAfterCallEnd = true;
            }
            WndMgr.CloseVideoCallRect();
            ProcMgr.DisconnectCall();
            return;
     }
     
    if(this.isChatting ==true)
    {
        ProcMgr.DisconnectChat(); 
    }
     
    if(StateMgr.GetCurrentState()== "VideoSnapshot" || StateMgr.GetCurrentState()== "CameraCheckConnected")
	{
		PluginAPIMgr.StopPreview();	
	}
		
	setTimeout("WaitTimerCF()", 0);
	WaitTimerCF = function(){
     
	    ProcMgr.flagQuit = flag_quit;
	    
	    if( ProcMgr.flagQuit == true)
	    {
	        PluginAPIMgr.Logout(0);
	    }
	    else
	    {
	        PluginAPIMgr.Logout(1);
	    }
   }
}

ProcMgr.CloseWithSignIn= function()
{
     if(this.isCalling == true)
    {
		this.isCloseAfterCallEnd = true;
        ProcMgr.DisconnectCall();
		
		return;
    }
    
    this.isCalling = false;
    
    if(this.isChatting ==true)
    {
        ProcMgr.DisconnectChat(); 
    }
    	
    this.CloseWidget();
}

ProcMgr.ExitWithSignIn= function()
{
    if(this.isCalling == true)
    {
		this.isExitAfterCallEnd = true;
		WndMgr.CloseVideoCallRect();
        ProcMgr.DisconnectCall();
		return;
    }
    
    this.isCalling = false;
    
     if(this.isChatting ==true)
    {
        ProcMgr.DisconnectChat(); 
    }
    
	this.ExitWidget();
}

ProcMgr.CloseWithSignOut= function()
{
    this.isExitAfterSignout = false;
	this.Signout(true);
}

ProcMgr.ExitWithSignOut= function()
{
    this.isExitAfterSignout = true;
    this.Signout(true);
}

ProcMgr.HandleLoggedOut= function()
{
	alert("***** ProcMgr.HandleLoggedOut()");
    
	var LoggedOut_Reason = PluginAPIMgr.GetLogoutReason();
	 
    switch(LoggedOut_Reason)
    {
        case ENUM_LOGOUTREASON.LOGOUT_CALLED : 
		
            if(this.flagQuit == false)
            {
                if(this.isLoginCencel == true)
                {
                	if(StateMgr.GetCurrentState() =="Signin") 
                    {
	                    WndMgr.BackStepSignin();
						StateMgr.Start_Signin_State();
                    }
                	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
                    {
	                    WndMgr.BackStepFaceRecogSignin();
						//WndMgr.ReturnFaceRecogSignin();
						StateMgr.Start_Welcome_State();
                    }

                    this.isLoginCencel = false; //init
                    
					return;
                }
				              
			   	StateMgr.Start_Welcome_State();           
            }
            else
            {
                $.sf.exit(this.isExitAfterSignout);
            }
            
        break;
 ///synchronous login, regiteration
		case ENUM_LOGOUTREASON.HTTPS_PROXY_AUTH_FAILED :
		case ENUM_LOGOUTREASON.SOCKS_PROXY_AUTH_FAILED : 
		case ENUM_LOGOUTREASON.P2P_CONNECT_FAILED :

			if(StateMgr.GetCurrentState() =="Signin")
            {
                WndMgr.BackStepSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_EXTERNAL_NETWORK_CONNECTION_FAIL);
            }
            else if(StateMgr.GetCurrentState() =="CreateAccount")
            {
                WndMgr.BackStepCreateAccount();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_EXTERNAL_NETWORK_CONNECTION_FAIL);
            }
        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
            {
                WndMgr.BackStepFaceRecogSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_EXTERNAL_NETWORK_CONNECTION_FAIL);
            }
            else
            {
                if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
                {
                     StateMgr.Start_Welcome_State();
                }
            }

        break;
		
		case ENUM_LOGOUTREASON.SERVER_CONNECT_FAILED : 
		case ENUM_LOGOUTREASON.SERVER_OVERLOADED :
		
			if(StateMgr.GetCurrentState() =="Signin")
            {
                WndMgr.BackStepSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_SERVER_CONNECTION_FAIL);
            }
            else if(StateMgr.GetCurrentState() =="CreateAccount")
            {
                WndMgr.BackStepCreateAccount();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_SERVER_CONNECTION_FAIL);
            }
        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
            {
                WndMgr.BackStepFaceRecogSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_SERVER_CONNECTION_FAIL);
            }
            else
            {
                if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
                {
                     StateMgr.Start_Welcome_State();
                }
            }
   
        break;
		
		case ENUM_LOGOUTREASON.DB_IN_USE :

			if(StateMgr.GetCurrentState() =="Signin")
            {
                WndMgr.BackStepSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_IMPOSSIBLE);
            }
            else if(StateMgr.GetCurrentState() =="CreateAccount")
            {
                WndMgr.BackStepCreateAccount();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_IMPOSSIBLE);
            }
        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
            {
                WndMgr.BackStepFaceRecogSignin();
				WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_IMPOSSIBLE);
            }
            else
            {
                if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
                {
                     StateMgr.Start_Welcome_State();
                }
            } 

        break;
 ///synchronous regiteration
		case ENUM_LOGOUTREASON.INVALID_SKYPENAME : 

			WndMgr.BackStepCreateAccount();
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_INVALID_SKYPENAME);
			
        break;
		case ENUM_LOGOUTREASON.INVALID_EMAIL : 

			WndMgr.BackStepCreateAccount();
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_INVALID_EMAIL);
			
        break;
		case ENUM_LOGOUTREASON.UNACCEPTABLE_PASSWORD : 

			WndMgr.BackStepCreateAccount();
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_UNACCEPTABLE_PASSWORD);
			
        break;
		case ENUM_LOGOUTREASON.SKYPENAME_TAKEN : 
		
            WndMgr.StopLoading();
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_SKYPENAME_TAKEN);
			
        break;
		case ENUM_LOGOUTREASON.REJECTED_AS_UNDERAGE :

			WndMgr.BackStepCreateAccount();
        	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_REJECTED_AS_UNDERAGE);
			
        break;
 ///synchronous  login
		case ENUM_LOGOUTREASON.NO_SUCH_IDENTITY :

		  if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
          {
                 StateMgr.Start_Welcome_State();
          }
          else
          {
            if(StateMgr.GetCurrentState() =="Signin")
            {
            	WndMgr.BackStepSignin();
            }            
        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
            {
                WndMgr.BackStepFaceRecogSignin();
            }
            
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_NO_SUCH_IDENTITY);
          }

        break;
		case ENUM_LOGOUTREASON.INCORRECT_PASSWORD :

		  if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
          {
                 StateMgr.Start_Welcome_State();
          }
          else
          {
                if(StateMgr.GetCurrentState() =="Signin")
	            {
	            	WndMgr.BackStepSignin();
	            	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_INCORRECT_PASSWORD);
	            }            
	        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
	            {	            	
	                WndMgr.BackStepFaceRecogSignin();
	                if(this.isFaceRegistrationAfterSignin == true || this.isSigninAfterPwdCheck== true)
	                {
	                	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_INCORRECT_PASSWORD);
	                }
	                else
	                {
	                	PluginAPIMgr.SetLoginMode(0);
	                	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_PASSWORD_HAS_CHANGED);
	                }	                
	            }
          }

        break;
		case ENUM_LOGOUTREASON.TOO_MANY_LOGIN_ATTEMPTS :
		
          if(PluginAPIMgr.IsDefaultAccountAvailable() ==1) // auto login
          {
                 StateMgr.Start_Welcome_State();
          }
          else
          {
            if(StateMgr.GetCurrentState() =="Signin")
            {
            	WndMgr.BackStepSignin();
            }            
        	else if(StateMgr.GetCurrentState() =="FaceRecogSignin") 
            {
                WndMgr.BackStepFaceRecogSignin();
            }
            
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_TOO_MANY_LOGIN_ATTEMPTS);
          }
            
        break;
/// Asynchronous 
		case ENUM_LOGOUTREASON.PASSWORD_HAS_CHANGED : 
			PluginAPIMgr.SetLoginMode(0);
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_PASSWORD_HAS_CHANGED);
        break;
		case ENUM_LOGOUTREASON.PERIODIC_UIC_UPDATE_FAILED : 
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_PERIODIC_UIC_UPDATE_FAILED);
        break;
		case ENUM_LOGOUTREASON.DB_DISK_FULL : 
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_DB_DISK_FULL);
        break;
		case ENUM_LOGOUTREASON.DB_IO_ERROR :
		case ENUM_LOGOUTREASON.DB_CORRUPT : 
		case ENUM_LOGOUTREASON.DB_FAILURE :
            WndMgr.StartOneBottonPopup(OneBtnPopupIndex.LOGGEDOUT_DB_PROBLEM);
        break;
        
/// don't use
		case ENUM_LOGOUTREASON.INVALID_APP_ID : 
        break;
		case ENUM_LOGOUTREASON.APP_ID_BLACKLISTED  : 
        break;
    }
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///// Main Update  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


ProcMgr.AccountAvataImageChanged= function()
{
    alert("***** ProcMgr.AccountAvataImageChanged()");
     if(StateMgr.GetCurrentState() =="Main")
    {
        $.sfScene.get('ListMain').updateAvata();
    }
}

ProcMgr.AccountCreditChanged= function()
{
    alert("***** ProcMgr.AccountCreditChanged()");
     if(StateMgr.GetCurrentState() =="Main")
    {
          $.sfScene.get('ListMain').updateCredit();
    }
	else if(StateMgr.GetCurrentState() =="SkypeOutCall")
	{
		WndMgr.UpdateSkypeOutCallCredit();
	}
}

ProcMgr.AccountAvailabilityChanged= function()
{
    alert("***** ProcMgr.AccountAvailabilityChanged()");
    if(StateMgr.GetCurrentState() =="Main")
    {
          $.sfScene.get('ListMain').updateOnlineStatus();
    }
}

ProcMgr.AccountMoodMsgChanged= function()
{
    alert("***** ProcMgr.AccountMoodMsgChanged()");
     if(StateMgr.GetCurrentState() =="Main")
    {
          $.sfScene.get('ListMain').updateMoodMessage();
    }
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Call  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.IncomingCall = function()
{
    alert("***** ProcMgr.IncomingCall()");
   this.isConferenceCall = false;
   
   	if(this.callEndWaitingTimer == false)
	{
		if(StateMgr.GetCurrentSubState()!="Calling" && StateMgr.SubStateList[SUB_STATE.CALLING].flagLoading != true)
		{
			this.isIncomingCall = true;
		}
	}
}

ProcMgr.IncomingConferenceCall = function()
{
    alert("***** ProcMgr.IncomingConferenceCall()");
   this.isConferenceCall = true;
}

ProcMgr.GetIsInCall = function(){
	
	return this.isCalling;
}

ProcMgr.GetIsConferenceCall = function(){
	
	return this.isConferenceCall; 
}

ProcMgr.CreateCall = function(callee_name, call_type)
{
    alert("***** ProcMgr.CreateCall()");
    if( this.isCalling == true)
    {
		g_Data.SetCreateCallInputInfo(callee_name, call_type);
		ProcMgr.SelectCallSwitch();
        return;
    }
	
	if(PluginAPIMgr.GetAccountInfo(ENUM_ACCOUNT_PROPERTY.P_AVAILABILITY) == ENUM_ACCOUNT_AVAILABILITY.CONNECTING )
    {
		if(WndMgr.iCurrentSubScene < 2){

			var scene = $.sfScene.get(WndMgr.MainSubScene[WndMgr.iCurrentSubScene].Id);
			if(scene)
			{
				scene.Activation();
			}			
		}
			
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CREATE_CALL_FAIL_NETWORK_ERROR);
		return;	
	}
  
    g_Data.SetCreateCallInputInfo(callee_name, call_type);
	
    if(PluginAPIMgr.CreateCall()==1)
	{
		ProcMgr.registerCallKey();
		StateMgr.Start_Calling_State();
	} 
	else
	{
		var scene = $.sfScene.get(WndMgr.MainSubScene[WndMgr.iCurrentSubScene].Id);
		if(scene)
		{
			scene.Activation();
		}
		
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CREATE_CALL_FAIL_PHONE_NUMBER_ERROR);	
	}
}

ProcMgr.DisconnectCall = function(endType)
{
    alert("***** ProcMgr.DisconnectCall()");
    
    ProcMgr.unregisterCallKey();
    PluginAPIMgr.DisconnectCall(endType);
    
    if(this.isQuitAfterCallEnd == true ||  this.isLogoutAfterCallEnd == true || this.isExitAfterCallEnd == true || this.isCloseAfterCallEnd==true)
    {
	   // don't display call end scene
       return;  
    }
    
    StateMgr.Start_Call_Ending_State(true);
}

ProcMgr.CancelCall = function()
{
    alert("***** ProcMgr.CancelCall()");
    this.isCallCencel = true;
    PluginAPIMgr.DisconnectCall();
}

 ProcMgr.InprogressCall= function()
 {
    alert("***** ProcMgr.InprogressCall()");
    
    this.isIncomingCall= false;
    
    if( this.isCalling == true)
    {
        if(g_Data.GetCallLocalHold() ==true || g_Data.GetCallRemoteHold() ==true)
        {
            ProcMgr.Resume();
        }
		else 
		{
			if(this.isConferenceCall==true && StateMgr.GetCurrentState()=="ConferenceCall")
			{
				WndMgr.UpdateConferenceCallMemberInfo();
			}
		}
        return;
    }
    else
    {
        this.isCalling = true;
    }
    
	ProcMgr.registerCallKey();
	
	var camera_state = PluginAPIMgr.GetCameraState();
	var is_sending_video = PluginAPIMgr.IsSendingVideo(); 
	
	if(is_sending_video== true && (camera_state == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || camera_state == ENUM_CAM_STATE.CAM_STATE_CONNECTING))
	{
		PluginAPIMgr.StopSendVideo();  
	}
	
	ProcMgr.StartCall(); 
 }

ProcMgr.StartCall = function()
{
    var call_member_type =PluginAPIMgr.GetCallMemberType();
    var call_type = PluginAPIMgr.GetCallType();
	
    alert("***** ProcMgr.StartCall() call_type : "+ call_type);

	if(PluginAPIMgr.IsConference()==1) 
    {
		if(PluginAPIMgr.IsSendingVideo()==1 ||this.isReceivingVideo ==true)
		{
			StateMgr.Start_Video_Call_State();
		}
		else
		{
			StateMgr.Start_Conference_Call_State();
		}
        
    }
    else if(call_member_type==ENUM_CALL_MEMBE_TYPE.INCOMING_P2P  ||  call_member_type== ENUM_CALL_MEMBE_TYPE.OUTGOING_P2P)  
    {
        if(call_type == "0") //voice
        {
            StateMgr.Start_Voice_Call_State(); 
       }
       else if(call_type == "1") //video
        {
            if(PluginAPIMgr.IsSendingVideo() == 0)
            {
                this.isReceivingVideo =true;
            }
            
            StateMgr.Start_Video_Call_State(); 
        }
		
		setTimeout("startTimerCF()", 0);
		startTimerCF = function(){
			ProcMgr.ProcessReceiveVideo();
		}
    } 
     else if(call_member_type==ENUM_CALL_MEMBE_TYPE.INCOMING_PSTN  ||  call_member_type== ENUM_CALL_MEMBE_TYPE.OUTGOING_PSTN)
    {
        StateMgr.Start_Skype_Out_Call_State(); 
    }
    
    //focus!!
    // window.addEventListener('click', $.sf.returnFocus); 
}
 
ProcMgr.GoCall = function()
{
    alert("***** ProcMgr.GoCall()");
    
    if(StateMgr.currentState == "Main" ||  StateMgr.currentState == "Chat")
    {
          ProcMgr.StartCall();
    }
    else
    { 
          StateMgr.ReturnToMainState(); 
    }    
}

 ProcMgr.EndCall = function()
{
	if(this.callEndWaitingTimer != false)
	{
		alert("***** ProcMgr.EndCall()-> aready call ending" );
		if(this.isIncomingCall ==true)
		{
			this.isIncomingCall =false;
		}
		return;
	}
	
    alert("***** ProcMgr.EndCall()-> calling : " + this.isCalling);
	if(StateMgr.GetCurrentSubState()!="Calling" && StateMgr.SubStateList[SUB_STATE.CALLING].flagLoading != true && this.isCalling==false)
	{
		if(PluginAPIMgr.IsWidgetActivatedByAnswer()==0) 
		{
			if(this.isIncomingCall==false)
			{
				return;
			}
		}
		else
		{
			// missed call
		}	
	}
	
	if(this.callHoldTimer== true) //init
	{
		this.callHoldTimer= false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.CALL_HOLD);
	}
	
	if(this.callResumeTimer== true) //init
	{
		this.callResumeTimer= false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.CALL_HOLD);
	}
	
    g_Data.SetCallLocalHold(false); //init
    g_Data.SetCallRemoteHold(false);//init
    this.isCalling = false; //init
    this.isConferenceCall = false; //init
    this.isVoiceMailSending = false; //init
    this.isReceivingVideo =false; //init
    g_Data.SetCallQualityGauge(1); //init
    g_Data.SetCallMemberVideoResolution("SD"); //init
    this.cameraZoomValue =0; //init
    this.isPauseVideo = false; //init
    
    
    //temp
    // window.removeEventListener('click', $.sf.returnFocus);
	
	if(this.isCloseAfterCallEnd== true)
	{
		alert("***** ProcMgr.EndCall()-> isCloseAfterCallEnd : " + this.isCloseAfterCallEnd);
		this.isCloseAfterCallEnd = false; //init
		this.CloseWidget();
		return;
	}
	
	if(this.isExitAfterCallEnd== true)
	{
		alert("***** ProcMgr.EndCall()-> isExitAfterCallEnd : " + this.isExitAfterCallEnd);
		this.isExitAfterCallEnd = false; //init
		this.ExitWidget();
		return;
	}

     if(this.isQuitAfterCallEnd == true)
    {
		alert("***** ProcMgr.EndCall()-> isQuitAfterCallEnd : " + this.isQuitAfterCallEnd);
        this.isQuitAfterCallEnd = false; //init
		this.Signout(true);
        return;
    }
    
    if(this.isLogoutAfterCallEnd == true)
    {
		alert("***** ProcMgr.EndCall()-> isLogoutAfterCallEnd : " + this.isLogoutAfterCallEnd);
		this.isLogoutAfterCallEnd = false; //init
		this.Signout(false);
		return;
    }
    
    if(this.isIncomingCall ==true)  // incoming call reject
    {
		alert("***** ProcMgr.EndCall()-> isIncomingCall : " + this.isIncomingCall);
        this.isIncomingCall =false;
		if(StateMgr.GetCurrentSubState()!="Calling" && StateMgr.SubStateList[SUB_STATE.CALLING].flagLoading != true)
       {
	   		if(StateMgr.GetCurrentState()!="Init")
			{
				PluginAPIMgr.HideConnectingWnd();
			}
	
			 return;
	   }
    }
    
	PluginAPIMgr.BlockIncomingCall();
	
    ProcMgr.unregisterCallKey();
    WndMgr.CloseVideoCallRect();
	
	if(StateMgr.GetCurrentState()!="Init")
	{
		PluginAPIMgr.HideConnectingWnd();
	}
	
    StateMgr.Start_Call_Ending_State(false);
	
	this.callEndWaitingTimer= true;
	if(this.isCallingFail==false)
	{
		PluginAPIMgr.StartOSDTimer("2000" , function() { ProcMgr.EndCallTimerCallback();}, ENUM_TIMER_TYPE.CALL_END);  
	}
	else
	{
		PluginAPIMgr.StartOSDTimer("10000" , function() { ProcMgr.EndCallTimerCallback();}, ENUM_TIMER_TYPE.CALL_END);  
	}    
}

 ProcMgr.DropCall = function()
 {
    alert("***** ProcMgr.DropCall()");
    WndMgr.CloseVideoCallRect();
    WndMgr.UpdateCallDroppedStatus();
 }

 ProcMgr.EndCallTimerCallback = function()
 {
     alert("***** ProcMgr.EndCallTimerCallback()");
	 this.callEndWaitingTimer = false;
	 this.isCallingFail = false;
	 
	 if(this.isCallStartAfterCallEnd != true)
	 {  
	 	PluginAPIMgr.UnblockIncomingCall(0);
		   
	 	if(StateMgr.currentState == "Chat")
	     {
		 	if(this.isTypingChatMsg == true)
			{
				$.sfScene.get('ChatMsgSend').setUseBackupSting(this.isTypingChatMsg);
				this.isTypingChatMsg = false;
				StateMgr.Start_Chat_Msg_Send_State();
			}
			else
			{
				StateMgr.ReturnToMainState();	
			}         
	     }
	     else
	     {
		 	//TEMPCODE:
		 	//LIVECALL
			if(StateMgr.GetCurrentState() == 'ListMainContact'){
				
				var contactScene = $.sfScene.get('ListMainContact');
				contactScene.InitializeScene();	
			}
			else if(StateMgr.GetCurrentState() == 'ListMainHistory'){

				var historyScene = $.sfScene.get('ListMainHistory');
				historyScene.ActivationForIdentity();	
				
			}
			
	        StateMgr.Start_Main_State();  
	     }
	 }
	 else
	 {
	 	PluginAPIMgr.UnblockIncomingCall(1);
		
	 	this.isCallStartAfterCallEnd = false; //init
		StateMgr.Start_Main_State(); 
		ProcMgr.CreateCall(g_Data.DATA_CREATE_CALL_INPUT_INFO.callee_name, g_Data.DATA_CREATE_CALL_INPUT_INFO.call_type );
	 }
 }
 
ProcMgr.ProcessCallingFail = function(fail_reason)
{
	alert("***** ProcMgr.ProcessCallingFail() reason -> " + fail_reason );
	this.isCallingFail = true;
	WndMgr.UpdateCallingMessage(fail_reason);
}

ProcMgr.StopCallingFailMsg = function()
{
	alert("***** ProcMgr.StopCallingFailMsg()");
	if(this.isCallingFail == true)
	{
		if(this.callEndWaitingTimer== true)
		{
			 PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.CALL_END); 
		}
		ProcMgr.EndCallTimerCallback();
	}
}


ProcMgr.ProcessReceiveVideo= function()
{
    alert("***** ProcMgr.ProcessReceiveVideo()-> this.isVideoAvailable : "+ this.isVideoAvailable);
	if(ProcMgr.IsReceivingVideo()== true)
	{
		alert("***** ProcMgr.ProcessReceiveVideo()-> already receive video");
		return;
	}	
	
	if(this.isVideoAvailable == false)
	{
		if(PluginAPIMgr.IsCallMemberVideoAvailable()==0 )
		{
			return;
		}		
	}
	
    this.isVideoAvailable = false; //init
	var is_auto_receive = PluginAPIMgr.IsAutoVideoReceive();
	alert("***** ProcMgr.ProcessReceiveVideo()-> is_auto_receive : "+ is_auto_receive);
	
	if(is_auto_receive==true  || PluginAPIMgr.IsConference()==1) //don't change during conf call.
	{
		 return;
	}
	else
	{
		StateMgr.Start_Video_Allow_State();
	}
 }
 
ProcMgr.SetStartReceiveVideo= function()
{
	alert("***** ProcMgr.SetStartReceiveVideo()");
	PluginAPIMgr.StartReceiveVideo();
}
 
 ProcMgr.StartReceiveVideo= function()
 {
    alert("***** ProcMgr.StartReceiveVideo()-> PluginAPIMgr.IsSendingVideo() : "+ PluginAPIMgr.IsSendingVideo());
    
	this.isPauseVideo=false;
	this.isReceivingVideo =true;
     
    if(PluginAPIMgr.IsSendingVideo() ==0)
    {
		if(StateMgr.GetCurrentState()=="VideoCall")
		{
			WndMgr.UpdateVideoCallYourVideo();
		}
		else
		{	
			if(StateMgr.GetCurrentState()=="Main" && WndMgr.MainSubScene[3].Id == "ListMainLiveCall")
			{
				return;  // don't change to video call	
			}	
			
			if(PluginAPIMgr.IsConference()!=1)
			{
				StateMgr.Start_Video_Call_State();
			}			
		}       
    }
    else
    {
        WndMgr.UpdateVideoCallYourVideo();
    }
    
 }
 
ProcMgr.StopReceiveVideo= function()
{
    alert("***** ProcMgr.StopReceiveVideo()-> PluginAPIMgr.IsSendingVideo() : "+ PluginAPIMgr.IsSendingVideo());
    
    this.isReceivingVideo =false;
    
    if(PluginAPIMgr.IsSendingVideo() ==0)
    {

		if(g_Data.GetCallLocalHold() ==true || g_Data.GetCallRemoteHold() ==true)
		{
			WndMgr.UpdateVideoCallYourVideo();
		}
		else
		{
			if(StateMgr.GetCurrentState()=="Main" && WndMgr.MainSubScene[3].Id == "ListMainLiveCall")
			{
				return;  // don't change to voice call or conf call	
			}	
			
			if (this.isConferenceCall == false) 
			{
				StateMgr.Start_Voice_Call_State();
			}
			else
			{
				if(StateMgr.GetCurrentState()!="ConferenceCall")
				{
					StateMgr.Start_Conference_Call_State();
				}				
			}
		}			
     }
     else
     {
        WndMgr.UpdateVideoCallYourVideo();
     }
 }
 
ProcMgr.IsReceivingVideo= function()
{
   return  this.isReceivingVideo;
}

 ProcMgr.StartSendVideo= function()
 {
    alert("***** ProcMgr.StartSendVideo()-> ProcMgr.IsReceivingVideo() : "+ ProcMgr.IsReceivingVideo());
   // PluginAPIMgr.StartSendVideo();
	WndMgr.StartVideoCallPreview();
    
    if(   ProcMgr.IsReceivingVideo() == false)  // voice -> video call
    {
		if(StateMgr.GetCurrentState()=="VideoCall")
		{
			WndMgr.UpdateVideoCallMyVideo();
		}
		else
		{
			StateMgr.Start_Video_Call_State();
		}        
    }
    else
    {
        WndMgr.UpdateVideoCallMyVideo();
    }
 }
 
ProcMgr.StopSendVideo= function()
{  
	//PluginAPIMgr.StopCamVideo();
    PluginAPIMgr.StopSendVideo();
    
    var call_type = PluginAPIMgr.GetCallType();
	alert("***** ProcMgr.StopSendVideo()-> call_type : "+ call_type);
    if(call_type == "0") //voice
    {
		if(g_Data.GetCallLocalHold() ==true || g_Data.GetCallRemoteHold() ==true)
		{
			WndMgr.UpdateVideoCallMyVideo();
		}
		else
		{
			if(StateMgr.GetCurrentState()=="Main" && WndMgr.MainSubScene[3].Id == "ListMainLiveCall")
			{
				return;  // don't change to voice call or conf call	
			}
			
			if(this.isConferenceCall==false)
			{
				StateMgr.Start_Voice_Call_State();
			}
			else
			{
				if (StateMgr.GetCurrentState() != "ConferenceCall") 
				{
					StateMgr.Start_Conference_Call_State();
				}
			}			 
		}      
    }
    else
    {
        WndMgr.UpdateVideoCallMyVideo();
    }
 }
 
ProcMgr.InitCameraOption= function()
{
	alert("***** ProcMgr.InitCameraOption()");

	this.isAutoFocusEnable();
	PluginAPIMgr.SetAutoFocus(PluginAPIMgr.GetAutoFocus()); 
	PluginAPIMgr.SetMicVolume(PluginAPIMgr.GetMicVolume());
}

ProcMgr.isAutoFocusEnable= function()
{
	alert("***** ProcMgr.isAutoFocusEnable()");
	if(PluginAPIMgr.isAutoFocusEnable()==1)
	{
		ProcMgr.isAutoFocus = true;
	}
	
	return ProcMgr.isAutoFocus;
}
 
ProcMgr.UpdateCameraState= function()
{
    alert("***** ProcMgr.UpdateCameraState()");
    
    if(StateMgr.GetCurrentSubState() == "VolumeMic")
    {
        StateMgr.Stop_Volume_Mic_State(true); 
    }
	
	ProcMgr.SetCameraZoomValue(0);
    
    WndMgr.UpdateVoiceCallCameraState();
    WndMgr.UpdateSkypeOutCallCameraState();
    WndMgr.UpdateConferenceCallCameraState();
	WndMgr.UpdateChatCameraState();

//Modified by Donghee
	if(this.isCalling == true)
	{
	   if(PluginAPIMgr.IsSendingVideo() ==0)
	   {
	        WndMgr.UpdateVideoCallCameraState();
	   }
	   else
	   {
	   		//Modified by Donghee
	   		// if(this.isCalling == true)
			ProcMgr.StopSendVideo(); 
	   }  
	} 
   
   WndMgr.UpdateVideoSnapshotCameraState();   

   WndMgr.UpdateChangePictureCameraState();	
   WndMgr.UpdateMainCameraState();

   WndMgr.UpdateCameraCheckState();
      
    alert("***** ProcMgr.UpdateCameraState() End");
   
}
 
  ProcMgr.ChangeToConferenceCall= function()
 {
    alert("***** ProcMgr.ChangeToConferenceCall() -> isConferenceCall : " + this.isConferenceCall);
    
    if(this.isCalling==true && this.isConferenceCall == false)
    {
        this.isConferenceCall =true;
        PluginAPIMgr.StopSendVideo();
		
		if(StateMgr.GetCurrentState()=="Main" && WndMgr.MainSubScene[3].Id == "ListMainLiveCall")
		{
			return;  // don't change to conf call	
		}
			
        StateMgr.Start_Conference_Call_State();
     }
 }
 
 ProcMgr.UpdateCallDuration = function( time)
{
    alert("***** ProcMgr.UpdateCallDuration()" + time);
    
    WndMgr.UpdateVoiceCallDuration(time);
    WndMgr.UpdateVideoCallDuration(time);
    WndMgr.UpdateConferenceCallDuration(time);
    WndMgr.UpdateSkypeOutCallDuration(time);
    WndMgr.UpdateMainLiveCallDuration(time);
    WndMgr.UpdateVoiceMailRecordingDuration(time);
	WndMgr.UpdateHistoryVMDuration(time);
//LIVECALL
	WndMgr.UpdateContactListCallDuration(time);
	
	WndMgr.UpdateLiveContactList(time);

}
 
 ProcMgr.UpdateCallMemberStatus = function()
 {
    alert("***** ProcMgr.UpdateCallMemberStatus()");
    
    WndMgr.UpdateConferenceCallMemberInfo();
 }
 
  ProcMgr.UpdateCallQuality = function(level)
 {
    alert("***** ProcMgr.UpdateCallQuality()");
	if(this.isCalling== true)
	{
		g_Data.SetCallQualityGauge(level);
		WndMgr.UpdateVideoCallQuality();
	}
 }
 
 ProcMgr.SendDTMF = function(keycode)
 {
     alert("***** ProcMgr.SendDTMF() keycode : "+keycode);
     
     switch(keycode)
     {          
        case $.sfKey.N1:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_1);
            break;
        case $.sfKey.N2:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_2);
            break;
        case $.sfKey.N3:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_3);
            break;
        case $.sfKey.N4:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_4);
            break;
        case $.sfKey.N5:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_5);
            break;
        case $.sfKey.N6:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_6);
            break;
        case $.sfKey.N7:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_7);
            break;
        case $.sfKey.N8:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_8);
            break;
        case $.sfKey.N9:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_9);
            break;
        case 35:	//plus100
        	if(ProcMgr.isTTXMIX == true)
			{
				return;	
			}
			
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_STAR);
            break;
		case 650 : // TTXMIX
			if(ProcMgr.isTTXMIX == false)
			{
				return;	
			}
			
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_STAR);
            break;
        case $.sfKey.N0:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_0);
            break;
        case 259:
            PluginAPIMgr.SendDTMF(ENUM_DTMF.DTMF_POUND);
            break;     
     } 
 }
 
 ProcMgr.ToggleLocalHold = function()
 {
    alert("***** ProcMgr.ToggleLocalHold()");
	
	if(this.callHoldTimer==true || this.callResumeTimer==true)
	{
		return;
	}

    if(g_Data.GetCallLocalHold() ==true)
    {
    	if(StateMgr.GetCurrentState()== "VideoCall")
    	{
    		this.callResumeTimer= true;
    		PluginAPIMgr.StartOSDTimer("700" ,
			function() { if (ProcMgr.isCalling == true) {
						ProcMgr.callResumeTimer = false;
						PluginAPIMgr.Hold(false);
				}}, 
				ENUM_TIMER_TYPE.CALL_HOLD); 
    	}
    	else
    	{
    		PluginAPIMgr.Hold(false);
    	}
    }
    else
    {
		if(StateMgr.GetCurrentState()== "VideoCall")
		{
			this.callHoldTimer= true;
			ProcMgr.LocalHoldWait();
			PluginAPIMgr.StartOSDTimer("2000" ,
				 function() { if (ProcMgr.isCalling == true) {
					ProcMgr.callHoldTimer = false;
					PluginAPIMgr.Hold(true);
			}}, 
			ENUM_TIMER_TYPE.CALL_HOLD);   
		}
		else
		{
			PluginAPIMgr.Hold(true);
		}
    }
 }
 
 ProcMgr.LocalHoldWait = function()
 {
 	if(g_Data.GetCallLocalHold()!=true && g_Data.GetCallRemoteHold()!=true)
	{
		WndMgr.VideoCallLocalHoldWait();
	} 	
 }
 
  ProcMgr.LocalHold = function()
 {
    alert("***** ProcMgr.LocalHold()");
    g_Data.SetCallLocalHold(true); 
    g_Data.SetCallRemoteHold(false);
    WndMgr.VoiceCallLocalHold();
    WndMgr.VideoCallLocalHold();
    WndMgr.ConferenceCallLocalHold();
    WndMgr.SkypeOutCallLocalHold();
    WndMgr.MainLiveCallLocalHold();
 }

  ProcMgr.RemoteHold = function()
 {
    alert("***** ProcMgr.RemoteHold()");
    g_Data.SetCallRemoteHold(true);
    g_Data.SetCallLocalHold(false);  
    WndMgr.VoiceCallRemoteHold();
    WndMgr.VideoCallRemoteHold();
    WndMgr.ConferenceCallRemoteHold();
    WndMgr.SkypeOutCallRemoteHold();
    WndMgr.MainLiveCallRemoteHold();
 }

  ProcMgr.Resume = function()
 {
    alert("***** ProcMgr.Resume()");
    g_Data.SetCallLocalHold(false); 
    g_Data.SetCallRemoteHold(false);
    WndMgr.VoiceCallResume();
    WndMgr.VideoCallResume();
    WndMgr.ConferenceCallResume();
    WndMgr.SkypeOutCallResume();
    WndMgr.MainLiveCallResume();
	
	if(StateMgr.GetCurrentState()=="VideoCall")
	{
		var call_type = PluginAPIMgr.GetCallType();
		if(call_type =="0")
		{
			if(this.isPauseVideo==false)
			{
				StateMgr.Start_Voice_Call_State();
			}
		}
		
	}
 }
 
ProcMgr.SelectCallSwitch = function()
{
	alert("***** ProcMgr.SelectCallSwitch()");
	StateMgr.Start_Call_Switch_State(); 
	
}

ProcMgr.StartCallSwitch = function()
{
	alert("***** ProcMgr.StartCallSwitch()");
	this.isCallStartAfterCallEnd = true;
	ProcMgr.DisconnectCall();
	
}

ProcMgr.CancelCallSwitch = function()
{
	alert("***** ProcMgr.CancelCallSwitch()");

	StateMgr.Stop_Call_Switch_State(true);	
}

ProcMgr.CameraZoomUp = function()
{
	if(this.cameraZoomValue>=2)
	{
		return;
	}
	this.cameraZoomValue++;
	
	PluginAPIMgr.Zoom(this.cameraZoomValue);
	
}

ProcMgr.CameraZoomDown = function()
{
	if(this.cameraZoomValue<=0)
	{
		return;
	}
	this.cameraZoomValue--;
	
	PluginAPIMgr.Zoom(this.cameraZoomValue);	
}

ProcMgr.GetCameraZoomValue = function()
{
	return this.cameraZoomValue;
}

ProcMgr.SetCameraZoomValue = function(zoom_value)
{
	this.cameraZoomValue = zoom_value;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Voice Mail  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

 
ProcMgr.SendingVoiceMail= function()
{
    alert("***** ProcMgr.SendingVoiceMail()");
     this.isCalling = false; //init
    this.isVoiceMailSending = true;
    g_Data.SetVoiceMailInputInfo(g_Data.DATA_CREATE_CALL_INPUT_INFO.callee_name);
    
    ProcMgr.registerCallKey();
    StateMgr.Start_Voice_Mail_State();
}

ProcMgr.LeaveVoicemail= function(callee_name)
{
    alert("***** ProcMgr.LeaveVoicemail()");
    this.isCalling = false; //init
    this.isVoiceMailSending = true;
    g_Data.SetVoiceMailInputInfo(callee_name);
    PluginAPIMgr.LeaveVoicemail(); 
    
    ProcMgr.registerCallKey();
    StateMgr.Start_Voice_Mail_State();
}

ProcMgr.UploadVoiceMail= function()
{
    alert("***** ProcMgr.UploadVoiceMail()");
    PluginAPIMgr.DisconnectCall();
    
}

ProcMgr.CancelVoiceMail= function()
{
    alert("***** ProcMgr.CancelVoiceMail()");
    
    PluginAPIMgr.CancelVoicemail();
    
}

ProcMgr.EndVoiceMail= function()
{
     alert("***** ProcMgr.EndVoiceMail()");
    this.isVoiceMailSending = false; //init
	
	this.callEndWaitingTimer= true;
	PluginAPIMgr.StartOSDTimer("2000" , function() { ProcMgr.EndCallTimerCallback();}, ENUM_TIMER_TYPE.CALL_END);  
}

ProcMgr.PlayHistoryVoicemail = function(nIndex)
{
	var result = PluginAPIMgr.PlayHistoryVoicemail(nIndex);
	
	if(result == '1')
	{
		this.isVoiceMailPlaying=true;
	}
	else
	{
		this.isVoiceMailPlaying=false;
	}
	
	return result;
}

ProcMgr.StopHistoryVoicemail = function(nIndex)
{
	var result = PluginAPIMgr.StopHistoryVoicemail(nIndex);
	this.isVoiceMailPlaying=false;
	
	return result;   	
}
 
 
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////  Chatting  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.OpenChatWithContact = function(skype_name)
{
    g_Data.SetChatMemberInfo(skype_name);
    
    if(this.isChatting == true &&  StateMgr.currentState =="Chat") //temp code
    {
		if(  StateMgr.currentSubState =="LiveContactSwitch")
		{
			StateMgr.Stop_Live_Contact_List_State(false); 
		}
		
		PluginAPIMgr.CloseChat();
		WndMgr.InitChat();
		$.sfScene.get('Chat').init();
		
		PluginAPIMgr.OpenChatWithContact(skype_name);
		this.isChatting =true;	
		
		$.sfScene.focus('Chat');	 
		setTimeout("UpdateTimerCF()", 0);
		UpdateTimerCF = function(){
			$.sfScene.get("Chat").updateMsgBox();
		}
    }
    else
    {
        this.isChatting =true;
        PluginAPIMgr.OpenChatWithContact(skype_name);
        StateMgr.Start_Chat_State(); 
     }
}

ProcMgr.OpenChat = function(chat_name)
{
     if(this.isChatting == true &&  StateMgr.currentState =="Chat") //temp code
    {
		if(  StateMgr.currentSubState =="LiveContactSwitch")
		{
			this.Stop_Live_Contact_List_State(false); 
		}
		
		PluginAPIMgr.CloseChat();
		$.sfScene.get('Chat').init();
		
		PluginAPIMgr.OpenChat(chat_name);
		this.isChatting =true;
		
		$.sfScene.focus('Chat');
		setTimeout("UpdateTimerCF()", 0);
		UpdateTimerCF = function(){
			$.sfScene.get("Chat").updateMsgBox();
		}
    }
    else
    {
        this.isChatting =true;
        PluginAPIMgr.OpenChat(chat_name);
        StateMgr.Start_Chat_State(); 
    }
}

ProcMgr.DisconnectChat = function()
{
    this.isChatting = false;  //init
    this.ChatParticipants = ""; //init
    
    PluginAPIMgr.CloseChat();
}

ProcMgr.CloseChat = function()
{      
    StateMgr.Start_Main_State(); 
}

ProcMgr.SendMessage = function(send_msg)
{
    PluginAPIMgr.SendMessage(send_msg);
    StateMgr.Stop_Chat_Msg_Send_State(true);
}

ProcMgr.UpdateChat =function()
{
    alert("***** WndMgr.UpdateChat()");
    if(WndMgr.ShowStateOfChatWnd()){
        $.sfScene.get("Chat").updateMsgBox();   
    }
    else
    {
		if(this.MainListFuncType == MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_REMOVE){
			
			this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.NOTHING;
			
			var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
			Scene.Activation();
					
			StateMgr.Stop_Remove_State(true);
		}		
		else if(StateMgr.MainStateList[MAIN_STATE.MAIN].flagLoad == true && WndMgr.GetMainSubIndex() == 1){
				
			$.sfScene.get("ListMainChatHistory").Refresh();
		}		
	}
}	
	
/*ProcMgr.NewChat = function()
{   
	WndMgr.UpdateNewChatMsg();
}*/

ProcMgr.CallandChatMemberUpdate = function()
{
	alert("***** ProcMgr.CallandChatMemberUpdate()");
	
	WndMgr.UpdateChatMemberInfo();
	WndMgr.UpdateVoiceCallMemberInfo();
	WndMgr.UpdateVideoCallMemberInfo();
	WndMgr.UpdateConferenceCallMemberInfo();
	WndMgr.UpdateMainLiveCallMemberInfo();
}

ProcMgr.GetCurrentChatMember= function()
{
	this.ChatParticipants =  PluginAPIMgr.GetCurrentChatProperty(ENUM_CHAT_PROPERTY.P_PARTICIPANTS);

	alert("***** ProcMgr.GetCurrentChatMember() this.ChatParticipants --> " + this.ChatParticipants);
	var s = this.ChatParticipants;
	var pos =0;
	this.ChatMember = "";
	this.ChatMemberSkypeName = "";
	var my_id = PluginAPIMgr.GetMySkyeName();
	var end_pos =0;
	this.numOfChatMember = 0;
	
	for(pos =0 ; pos <this.ChatParticipants.length; )
	{
		end_pos = s.indexOf(" ");
		if(end_pos== -1)
		{
			if(s!=my_id)
			{
				if(this.ChatMember.length ==0)
				{
					
					this.ChatMember = this.ChatMember+PluginAPIMgr.GetChatMemberDisplayName(s);
					this.ChatMemberSkypeName = this.ChatMemberSkypeName+s;
					this.numOfChatMember++;
				}
				else
				{
					this.ChatMember = this.ChatMember+", "+PluginAPIMgr.GetChatMemberDisplayName(s);
					this.ChatMemberSkypeName = this.ChatMemberSkypeName+", "+s;
					this.numOfChatMember++;
				}				
			}
			break;
		}
		else
		{
			var mem_id = this.ChatParticipants.substring(pos, pos+end_pos);
			if(mem_id!=my_id)
			{
				if(this.ChatMember.length ==0)
				{
					this.ChatMember = this.ChatMember+PluginAPIMgr.GetChatMemberDisplayName(mem_id);
					this.ChatMemberSkypeName = this.ChatMemberSkypeName+mem_id;
					this.numOfChatMember++;
				}
				else
				{
					this.ChatMember = this.ChatMember+", "+PluginAPIMgr.GetChatMemberDisplayName(mem_id);
					this.ChatMemberSkypeName = this.ChatMemberSkypeName+", "+mem_id;
					this.numOfChatMember++;
				}				
			}	
					
			s=s.substring(end_pos+1);
			alert("s : " + s);			
		}
		
		pos =pos+ end_pos+1;
	}
	alert("***** ProcMgr.GetCurrentChatMember() --> " + this.ChatMember);
	return this.ChatMember;
}

ProcMgr.GetNumberOfChatMember= function()
{
	return this.numOfChatMember;
}

ProcMgr.GetChatMemberSkypeName= function()
{
	return this.ChatMemberSkypeName;
}


ProcMgr.UpdateChatMember = function()
{   
	WndMgr.UpdateChatMember();
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//// Settings  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////  Online State
ProcMgr.SetOnlineStatus= function(setIndex)
{
    alert("***** ProcMgr.SetOnlineStatus()");
    PluginAPIMgr.SetAvailability(setIndex);
    StateMgr.Stop_Online_Status_State(true);
}

////  Change Picture
ProcMgr.SetAvatar = function(avatarImg)
{
    alert("***** ProcMgr.SetAvatar()");
	PluginAPIMgr.SetMyAvatar(avatarImg)
    StateMgr.Stop_Change_Picture_State(true);
}

////  Change Password
ProcMgr.ChangePassword= function(old_pwd, new_pwd, re_pwd)
{  
    alert("***** ProcMgr.ChangePassword()");
    
    g_Data.SetChangePWDInfo(old_pwd, new_pwd, re_pwd);
    
     WndMgr.NextStepChangePassword();
     
     if(new_pwd !=re_pwd)
     {       
        ProcMgr.HandleChangePassword( OneBtnPopupIndex.PWD_NEW_REPEAT_PWD_NOT_MATCH);
     }
     else
     {
        PluginAPIMgr.ChangePassword();
     }
}

ProcMgr.HandleChangePassword= function(result)
{
    alert("***** ProcMgr.HandleChangePassword()");
    WndMgr.NextStepChangePassword();
    
    if(result == OneBtnPopupIndex.PWD_INVALID_NEW_PWD)
    {
        var error_type = PluginAPIMgr.ValidatePasswd(PluginAPIMgr.GetMySkyeName() , g_Data.DATA_CHANGE_PWD_INPUT_INFO.new_pwd);
        
         switch(error_type)
        {
            case ENUM_PWD_VALIDATERESULT.NOT_VALIDATED :
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_INVALID_NEW_PWD);
                break;
            case ENUM_PWD_VALIDATERESULT.TOO_SHORT :
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_TOO_SHORT);
                break;
            case ENUM_PWD_VALIDATERESULT.TOO_LONG : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_TOO_LONG);
                break;
            case ENUM_PWD_VALIDATERESULT.CONTAINS_INVALID_CHAR :
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_CONTAINS_INVALID_CHAR);
                break;
            case ENUM_PWD_VALIDATERESULT.CONTAINS_SPACE : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_CONTAINS_SPACE);
                break;
            case ENUM_PWD_VALIDATERESULT.SAME_AS_USERNAME : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_SAME_AS_USERNAME);
                break;
            case ENUM_PWD_VALIDATERESULT.INVALID_FORMAT : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_INVALID_FORMAT);
                break;
            case ENUM_PWD_VALIDATERESULT.CONTAINS_INVALID_WORD : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_CONTAINS_INVALID_WORD);
                break;
            case ENUM_PWD_VALIDATERESULT.TOO_SIMPLE : 
                WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_TOO_SIMPLE);
                break;
                
             default:
                 WndMgr.StartOneBottonPopup(OneBtnPopupIndex.PWD_INVALID_NEW_PWD);
                break;
                
        }
    }
    else
    {
        WndMgr.StartOneBottonPopup(result);
    }
}

ProcMgr.SaveChangedPassword= function()
{
    alert("***** ProcMgr.SaveChangedPassword()");
    
    if(PluginAPIMgr.RecognitionPluginAvailable==false)
    {
    	return;
    }

    var new_pwd = g_Data.GetChangedPWDInfo();
    
    ProcMgr.SetMyPwd(new_pwd);
}

////  Edit Profile 
ProcMgr.SaveProfile = function(mood_msg, full_name ,email, country_code, home_phone, office_phone, mobile_phone, province, city, gender, birth_day )
{
    alert("***** ProcMgr.SaveProfile()");
    
    WndMgr.NextStepEditProfile();
    
     if(PluginAPIMgr.IsValidEmail(email) == 1)
    {
        g_Data.SetEditProfileInfo(mood_msg, full_name,email, country_code, home_phone, office_phone, mobile_phone, province, city, gender, birth_day);
    
        PluginAPIMgr.ChangeMoodMsg();
        PluginAPIMgr.ChangeFullName();
        PluginAPIMgr.ChangeEmail();    
        PluginAPIMgr.ChangeCountryCode();
        PluginAPIMgr.ChangeHomePhone();
        PluginAPIMgr.ChangeOfficePhone();
        PluginAPIMgr.ChangeMobilePhone();
        PluginAPIMgr.ChangeProvince();
        PluginAPIMgr.ChangeCity();
        PluginAPIMgr.ChangeGender();
        PluginAPIMgr.ChangeBirthDay();
        
        WndMgr.NextStepEditProfile();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.EDIT_PROFILE_OK);
    }
    else
    {
        WndMgr.NextStepEditProfile();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.EDIT_PROFILE_INVALID_EMAIL);
    }
        
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// add contact /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.SearchNewContact = function(contact_name)
{
    var normalized_contact_name = PluginAPIMgr.NormalizeIdentity(contact_name);
    
    if(normalized_contact_name.length >0)
    {
         alert("***** ProcMgr.SearchNewContact() : true");
    PluginAPIMgr.SearchNewContact(contact_name);
    }
    else
    {
        alert("***** ProcMgr.SearchNewContact() : false");
        PluginAPIMgr.SearchNewContact(contact_name);
    }
    
    WndMgr.NextStepAddContact(); 
}

ProcMgr.HandleSearchFailNewContact = function(result)
{
    alert("***** ProcMgr.HandleSearchNewContact()");
    WndMgr.BackStepAddContact();
    WndMgr.StartOneBottonPopup(result);
}

ProcMgr.SearchContactProfile = function(contact_name)
{
    alert("***** ProcMgr.SearchContactProfile()");
    WndMgr.NextStepAddContact(); 
    PluginAPIMgr.SearchContactProfile(contact_name);    
}

ProcMgr.AddContact = function(skype_name, hello_msg)
{   
     alert("***** ProcMgr.AddContact()");
     if(PluginAPIMgr.IsBlocked(skype_name) == 1)
     {
        WndMgr.NextStepAddContact(); 
         WndMgr.StartOneBottonPopup(OneBtnPopupIndex.IS_BLOCKED_SKYPE_NAME);
     }
     else if(PluginAPIMgr.IsMyName(skype_name) == 1)
     {
        WndMgr.NextStepAddContact();
         WndMgr.StartOneBottonPopup(OneBtnPopupIndex.IS_MY_SKYPE_NAME);
     }
     else if(PluginAPIMgr.IsMyBuddy(skype_name) == 1)
     {
        WndMgr.NextStepAddContact();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.IS_ALREADY_EXIST_SKYPE_NAME, skype_name);
     }
     else
     {
        PluginAPIMgr.AddContact(skype_name, hello_msg);
        
        WndMgr.NextStepAddContact();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.ADD_CONTACT_SENT);
    }
}

ProcMgr.AddSkypeOutContact = function(phone_number, diplay_name)
{   
    alert("***** ProcMgr.AddSkypeOutContact()");
	 if(phone_number.length <=0)
	 {
	        WndMgr.NextStepAddContact(); 
	        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.INVALID_PHONE_NUMBER);
	 }
     else if(PluginAPIMgr.IsBlocked(phone_number) == 1)
     {
        WndMgr.NextStepAddContact(); 
         WndMgr.StartOneBottonPopup(OneBtnPopupIndex.IS_BLOCKED_PHONE_NUMBER);
     }
     else if(PluginAPIMgr.IsMyBuddy(phone_number) == 1)
     {
        WndMgr.NextStepAddContact();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.IS_ALREADY_EXIST_PHONE_NUMBER, phone_number);
     }
     else
     {
        PluginAPIMgr.AddSkypeOutContact(phone_number, diplay_name);
        WndMgr.NextStepAddContact();
        WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NEW_CONTACT_ADDED);
     }
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////TOOLS///////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ProcMgr.BlockContact = function(skypeName,removeOption,type)
{
	
	if(removeOption){

		if(type == MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK){
			
			this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK_REMOVE;
		}
		else if(type == MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_BLOCK){
			
			this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_BLOCK_REMOVE;
		}
		else if(type == MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_BLOCK){
			
			this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_BLOCK_REMOVE;
		}			
	}
	else{
		
		this.MainListFuncType = type;	
	}
	
	PluginAPIMgr.BlockContact(skypeName,removeOption);
}

ProcMgr.UnblockContact = function(skypeName,type){
	
	this.MainListFuncType = type;
	PluginAPIMgr.UnblockContact(skypeName);
}

ProcMgr.AuthorizeContact = function(skypeName){
	
	PluginAPIMgr.AuthorizeContact(skypeName);
}

ProcMgr.IgnoreAuthReqContact = function(skypeName){
	
	PluginAPIMgr.RejectAndBlock(skypeName, "0");
}

ProcMgr.BlockAuthReqContact = function(skypeName){
	
	this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK_REQEST;
	PluginAPIMgr.RejectAndBlock(skypeName, "1");
}

ProcMgr.Blocked = function(){

	switch(this.MainListFuncType) {
		
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK_REQEST:	
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.BLOCKED_NEW_CONTACT);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CONTACT_LIST_BLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK_REMOVE:
			$.sfScene.hide('Block');			
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CONTACT_LIST_BLOCK_REMOVED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_BLOCK:			
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.HISTORY_LIST_BLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_BLOCK_REMOVE:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.HISTORY_LIST_BLOCK_REMOVED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_BLOCK:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CHAT_LIST_BLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_BLOCK_REMOVE:		
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CHAT_LIST_BLOCK_REMOVED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_BLOCK:			
			var OptionBlockScene = $.sfScene.get("OptionsBlockedUsers");
			OptionBlockScene.update();
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTION_BLOCKED);
			break;	
			
		default:
			this.BlockedByAnotherDevice();
			break;
			
	}
		
	this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.NOTHING;
}

ProcMgr.BlockedByAnotherDevice = function(){

	//Skip
	alert("ProcMgr.BlockedByAnotherDevice");

	// && WndMgr.GetCurrentOptionsSubscene == 'OptionsBlockedUsers'
	if(StateMgr.GetCurrentSubState() == SUB_STATE.OPTIONS){
			
		var OptionBlockScene = $.sfScene.get("OptionsBlockedUsers");
		OptionBlockScene.update();		
	}
}

ProcMgr.UnBlocked = function(){

	switch(this.MainListFuncType) {
		
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_UNBLOCK:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CONTACT_LIST_UNBLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_UNBLOCK:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.HISTORY_LIST_UNBLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_UNBLOCK:
			$.sfScene.hide('Block');
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.CHAT_LIST_UNBLOCKED);
			break;
			
		case MAIN_LIST_POPUP_FUNCTION_TYPE.OPTION_UNBLOCK:
			var OptionBlockScene = $.sfScene.get("OptionsBlockedUsers");
			OptionBlockScene.update();
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.OPTION_UNBLOCKED);
			break;	
				
		default:
			this.BlockedByAnotherDevice();
			break;			
	}

	this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.NOTHING;
}

ProcMgr.RemoveItem = function(Index, type)
{
	
	if(type == REMOVE_TYPE.HISTORY){

		this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_REMOVE;
		PluginAPIMgr.RemoveHistory(Index);		
	}
	else if(type == REMOVE_TYPE.CHAT){
		
		this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.CHAT_REMOVE; 
		PluginAPIMgr.RemoveChat(Index);		
	}
	
}

ProcMgr.UpdateHistoryList = function(){

	if(this.MainListFuncType == MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_REMOVE){
        			
		this.MainListFuncType = MAIN_LIST_POPUP_FUNCTION_TYPE.NOTHING;
		
		var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
		Scene.Activation();
				
		StateMgr.Stop_Remove_State(true);		
	}
	else if(StateMgr.MainStateList[MAIN_STATE.MAIN].flagLoad == true && WndMgr.GetMainSubIndex() == 1){

        var scene = $.sfScene.get("ListMainHistory");
        scene.Refresh();		
	}
}

ProcMgr.ProcessAuthRequest = function(){

	if(StateMgr.MainStateList[MAIN_STATE.MAIN].flagLoad == true && WndMgr.GetMainSubIndex() == 0){

		var scene = $.sfScene.get("ListMainContact");
		scene.Refresh();
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.ADDED_NEW_CONTACT); 
	}
}

ProcMgr.IgnoreAuthRequest = function(){

	if (StateMgr.MainStateList[MAIN_STATE.MAIN].flagLoad == true && WndMgr.GetMainSubIndex() == 0) {
		
		var scene = $.sfScene.get("ListMainContact");
		scene.Refresh();
	}	
}

ProcMgr.ShowPopupMessageForTextTest = function(data){

	var Index = data - 1;

	if(Index < 0){
		
		alert("Error!!");
		return;
	}
	
	WndMgr.StartOneBottonPopup(Index);
}


///////Face Recognition //////////////////////////////////////////////////////////////////////

///// management of ID, PWD, Face image path


ProcMgr.SetMyPwd = function(pwd)
{
	alert("ProcMgr.SetMyPwd");
		
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	var flagSaved = false;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		
		alert("***** ProcMgr.SetMyPwd() --> saved_info : "+saved_info);	
		
		for(index=0; index<info.SkypeAccount.length; ++index)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				flagSaved = true;
				break;
			}
		}	
	}
	else
	{
		info = new Object();
		info.SkypeAccount = new Array();
	}

	alert("***** ProcMgr.SetMyPwd() --> index : "+index);
		
	if(flagSaved == false)
	{
		info.SkypeAccount[index] = new Object();
		info.SkypeAccount[index].id = myId;
		info.SkypeAccount[index].face = "none";	
		info.SkypeAccount[index].face_id = -1;
		info.SkypeAccount[index].pwd_check = false;	
	}
	
	info.SkypeAccount[index].pwd = pwd;
	
	var info_string = JSON.stringify(info);	
	
	alert("***** ProcMgr.SetMyPwd() --> info_string : "+info_string);
	
	PluginAPIMgr.SetMyStorageInfo(info_string); 
}

ProcMgr.GetMyPwd = function(pwd)
{
	alert("ProcMgr.GetMyPwd");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	var myId_saved = false;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.GetMyPwd() --> saved_info : "+saved_info);	
		
		
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				myId_saved = true;
				break;
			}
		}
	}
	else
	{
		return "";
	}
	
	var pwd = "";
	
	if(myId_saved==true)
	{
		pwd =info.SkypeAccount[index].pwd;
	}
	
	return pwd;
}

ProcMgr.SetMyFaceImagePath = function(path, recogId)
{
	alert("ProcMgr.SetMyFaceImagePath");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.SetMyFaceImagePath() --> saved_info : "+saved_info);	
		
		
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				break;
			}
		}
	}

	info.SkypeAccount[index].face = path;
	info.SkypeAccount[index].face_id = recogId;	

	var info_string = JSON.stringify(info);	
	
	alert("***** ProcMgr.SetMyFaceImagePath() --> info_string : "+info_string);	
	
	PluginAPIMgr.SetMyStorageInfo(info_string); 
	
	g_Data.SetFaceRecogCompleteSkypeName(myId);	
}

ProcMgr.GetMyFaceImagePath = function()
{
	alert("ProcMgr.GetMyFaceImagePath");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	this.isRegisteredFace = false;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.GetMyFaceImagePath() --> saved_info : "+saved_info);	
				
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				break;
			}
		}
	}
	else
	{
		return "";
	}
	
	var path = info.SkypeAccount[index].face;
	
	if(path == "none")
	{
		return "";
	}
	else
	{
		this.isRegisteredFace = true;
		alert("***** ProcMgr.GetMyFaceImagePath() : "+path);
		return path;
	}	
}

ProcMgr.InitMyFaceImagePath = function()
{
	alert("ProcMgr.InitMyFaceImagePath");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.SetMyFaceImagePath() --> saved_info : "+saved_info);	
		
		
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				break;
			}
		}
	}

	PluginAPIMgr.EraseFace(info.SkypeAccount[index].face_id);
	
	info.SkypeAccount[index].face = "none";	
	info.SkypeAccount[index].face_id = -1;
	
	var info_string = JSON.stringify(info);	
	
	alert("***** ProcMgr.InitMyFaceImagePath() --> info_string : "+info_string);	
	
	PluginAPIMgr.SetMyStorageInfo(info_string);
	
	this.isRegisteredFace = false; 	
}

ProcMgr.CheckImageDuplicate= function(path, recogId)
{
	alert("ProcMgr.CheckImageDuplicate");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.CheckImageDuplicate() --> saved_info : "+saved_info);	
				
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id != myId)
			{
				if(info.SkypeAccount[index].face == path && info.SkypeAccount[index].face_id==recogId)
				{
					g_Data.SetFaceRecogDupliceteSkypeName(info.SkypeAccount[index].id);
					return true;
				}
			}
		}
	}
	
	return false;
}

ProcMgr.SetFlagPwdCheck = function(flagPwdCheck)
{
	alert("ProcMgr.SetFlagPwdCheck");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.SetFlagPwdCheck() --> saved_info : "+saved_info);	
				
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				break;
			}
		}
	}

	info.SkypeAccount[index].pwd_check = flagPwdCheck;	

	var info_string = JSON.stringify(info);	
	
	alert("***** ProcMgr.SetFlagPwdCheck() --> info_string : "+info_string);	
	
	PluginAPIMgr.SetMyStorageInfo(info_string); 
}

ProcMgr.GetFlagPwdCheck = function()
{
	alert("ProcMgr.GetFlagPwdCheck");
	
	var myId = PluginAPIMgr.GetMySkyeName();
	
	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var index =0;
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		alert("***** ProcMgr.GetFlagPwdCheck() --> saved_info : "+saved_info);	
		
		
		for(index=0; index<info.SkypeAccount.length; index++)
		{
			if(info.SkypeAccount[index].id == myId)
			{
				break;
			}
		}
	}
	else
	{
		return false;
	}
		
	if(info.SkypeAccount[index].pwd_check == 'undefined')
	{
		alert("***** ProcMgr.GetFlagPwdCheck() : undefined");
		return false;
	}
	else
	{
		alert("***** ProcMgr.GetFlagPwdCheck() : "+info.SkypeAccount[index].pwd_check);
		return info.SkypeAccount[index].pwd_check;
	}	
}


/// Account Manager
ProcMgr.CheckInputPwd= function(input_pwd)
{
	alert("ProcMgr.CheckInputPwd");
	if(StateMgr.GetCurrentSubState()=="AccountManager")
	{
		ProcMgr.CheckInputPwdForAccountManager(input_pwd);
	}
	else
	{
		ProcMgr.CheckInputPwdForSignin(input_pwd);
	}
}

ProcMgr.CancelCheckPwd= function()
{
	alert("ProcMgr.CancelCheckPwd");
	if(StateMgr.GetCurrentSubState()=="AccountManager")
	{
		WndMgr.BackStepAccountManager();
	}
	else
	{
		//WndMgr.BackStepFaceRecogSignin();
		StateMgr.Start_Welcome_State();
	}
}

ProcMgr.CheckInputPwdForAccountManager= function(input_pwd)
{
	alert("ProcMgr.CheckInputPwdForAccountManager");
	WndMgr.NextStepAccountManager();
	
	var curr_pwd = ProcMgr.GetMyPwd();
	
	if(curr_pwd==input_pwd)
	{
		if(this.isRegisteredFace==true)
		{
			if(this.isReRegisterFace==true)
			{
				ProcMgr.StartFaceRecogRegistration();
			}
			else
			{
				WndMgr.NextStepAccountManager();
			}
			
		}
		else
		{
			ProcMgr.StartFaceRecogRegistration();
		}		
	}
	else
	{
		WndMgr.StopLoading();
		
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.ACCOUNT_INCORRECT_PASSWORD);
		WndMgr.BackStepAccountManager();
	}
}

ProcMgr.CheckInputPwdForSignin= function(input_pwd)
{	
	alert("ProcMgr.CheckInputPwdForSignin");
	
	var index = g_Data.GetFaceRecogSelectedIndex();
	var RecogResult = g_Data.GetFaceRecogResult();
	alert("ProcMgr.CheckInputPwdForSignin", RecogResult[index].pwd);
	
	WndMgr.NextStepFaceRecogSignin();
	
	/*if(RecogResult[index].pwd==input_pwd)
	{
		ProcMgr.Signin(RecogResult[index].id, RecogResult[index].pwd, false);		
	}
	else
	{
		WndMgr.StopLoading();
		
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.FACE_RECOG_INCORRECT_PASSWORD);
		WndMgr.BackStepFaceRecogSignin();
	}*/
	
	ProcMgr.Signin(RecogResult[index].id, input_pwd, false);	 
}

ProcMgr.ProcessReRegisterFace= function()
{
	alert("ProcMgr.ProcessReRegisterFace");
	this.isReRegisterFace = true;
	
	ProcMgr.InitMyFaceImagePath();
	WndMgr.NextStepAccountManager();
}

ProcMgr.ProcessDeleteFace= function()
{
	alert("ProcMgr.ProcessDeleteFace");
	ProcMgr.InitMyFaceImagePath();
	
	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.ACCOUNT_DELETE_PWD_COMPLETE);
	WndMgr.NextStepAccountManager();
}

ProcMgr.ProcessSigninAfterPwdCheck = function(index)
{
	alert("ProcMgr.ProcessSigninAfterPwdCheck");
	this.isSigninAfterPwdCheck=true;
	g_Data.SetFaceRecogSelectedIndex(index);
	
	WndMgr.InputPwdStepFaceRecogSignin(); 
}

ProcMgr.InputPwdAgainforFaceSignin= function()
{
	alert("ProcMgr.InputPwdAgainforFaceSignin");
	
	if(this.isFaceRegistrationAfterSignin == true)
	{
		$.sfScene.get('AccountConnection').InputPWDAgain();
		WndMgr.InputInfoStepFaceRecogSignin();
	}
	else if(this.isSigninAfterPwdCheck== true)
	{
		WndMgr.InputPwdStepFaceRecogSignin();
	}
}


/// Signin

ProcMgr.StartFaceRecogSignin = function()
{
	alert("ProcMgr.StartFaceRecogSignin");
	this.isFaceRegistrationAfterSignin = false; //init
	this.isSigninAfterPwdCheck =false;//init
	this.CountOfRecogFail=0;
	this.CountOfRecogInfo =0;
	
	PluginAPIMgr.StartCameraForFaceRecognition(320,174,1280,720);
	 
	StateMgr.Start_Face_Recog_Signin_State();
		
	PluginAPIMgr.SubscribeFaceRecogEvent();
	
	this.FaceRecogTimer = true;
	PluginAPIMgr.StartOSDTimer("5000" , 
				function() { ProcMgr.FaceRecogTimer=false; ProcMgr.StartFaceRecog();}, 
				ENUM_TIMER_TYPE.NO_BUTTON);

}

ProcMgr.RetryFaceRecogSignin = function()
{
	alert("ProcMgr.RetryFaceRecogSignin");
	
	this.isFaceRegistrationAfterSignin = false; //init
	this.isSigninAfterPwdCheck=false; //init
	this.CountOfRecogFail=0;
	this.CountOfRecogInfo =0;
	
	PluginAPIMgr.StartCameraForFaceRecognition(320,174,1280,720);
	
	WndMgr.BackStepFaceRecogSignin();
	
	PluginAPIMgr.SubscribeFaceRecogEvent();
	
	this.FaceRecogTimer = true;
	PluginAPIMgr.StartOSDTimer("5000" , 
				function() { ProcMgr.FaceRecogTimer=false; ProcMgr.StartFaceRecog();}, 
				ENUM_TIMER_TYPE.NO_BUTTON);
}

ProcMgr.StopFaceRecogSignin  = function()
{	
	alert("ProcMgr.StopFaceRecogSignin");
	
	if(this.FaceRecogTimer==true)
	{
		this.FaceRecogTimer = false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.NO_BUTTON);
	}
	
	ProcMgr.StopFaceRecog();
	WndMgr.InitFaceRecogArea();
		
	PluginAPIMgr.StopCameraForFaceRecognition();
}

ProcMgr.StartFaceRecog = function()
{
	alert("ProcMgr.StartFaceRecog");
	this.isFaceRecog = true;

	PluginAPIMgr.StartFaceRecognitionAll();
}

ProcMgr.PauseFaceRecog = function(flagByUser)
{
	if(this.FaceRecogTimer==true)
	{
		this.FaceRecogTimer = false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.NO_BUTTON);
	}
	
	if(flagByUser==true)
	{
		this.CountOfRecogFail=0;
	}
	
	this.CountOfRecogInfo =0;
	
	alert("ProcMgr.PauseFaceRecog");
	if(this.isFaceRecog== true)
	{
		this.isFaceRecog = false;
		PluginAPIMgr.StopFaceRecognition();
	}
}

ProcMgr.RetryFaceRecog = function()
{
	alert("ProcMgr.RetryFaceRecog");
	if(this.isFaceRecog== false)
	{
		this.isFaceRecog = true;
		PluginAPIMgr.StartFaceRecognitionAll();
	}
}

ProcMgr.StopFaceRecog = function()
{
	if(this.isFaceRecog== true)
	{
		this.isFaceRecog = false;
		PluginAPIMgr.StopFaceRecognition();				
	}
	
	PluginAPIMgr.UnsubscribeFaceRecogEvent(); 		
}

ProcMgr.ProcessOnRecognizing = function(face_info, recoged)
{
	alert("ProcMgr.ProcessOnRecognizing");
	
	var result = JSON.parse(face_info);
	var result_info = null;
	
	if(recoged==false)
	{
		if(result.detectResult==null)
		{
			return;	
		}
		else
		{
			result_info = result.detectResult;
		}
	}
	else
	{
		result_info= result.recognitionResult;
	}

	var areaInfo = new Array();
	var inside_stroke =2;
	var area_width =640;
	var area_height =360;
	
	this.CountOfRecogInfo++;
	var index =0;
	
	for(var a=0; a<result_info.length; a++)
	{		
		var x=result_info[a].x/2;
		var y=result_info[a].y/2;
		var w=result_info[a].w/2;
		var h=result_info[a].h/2;
		
		x = area_width-x-w;
		
		if(x<0 || x+w > area_width || y<0 || y+h > area_height)
		{
			alert("ProcMgr.ProcessOnRecognizing -> out of area : "+a);
			continue;
		}
		
		areaInfo[index]=new Object();
		areaInfo[index].x=new Array(4);
		areaInfo[index].y=new Array(4);
		areaInfo[index].w=new Array(4);
		areaInfo[index].h=new Array(4);
		
		areaInfo[index].x[0]=String(x)+"px";
		areaInfo[index].x[1]=String(x)+"px";
		areaInfo[index].x[2]=String(x)+"px";
		areaInfo[index].x[3]=String(x+w-inside_stroke)+"px";
		
		areaInfo[index].y[0]=String(y)+"px";
		areaInfo[index].y[1]=String(y)+"px";
		areaInfo[index].y[2]=String(y+h-inside_stroke)+"px";
		areaInfo[index].y[3]=String(y)+"px";
		
		areaInfo[index].w[0]=String(w)+"px";
		areaInfo[index].w[1]=String(inside_stroke)+"px";
		areaInfo[index].w[2]=String(w)+"px";
		areaInfo[index].w[3]=String(inside_stroke)+"px";
		
		areaInfo[index].h[0]=String(inside_stroke)+"px";
		areaInfo[index].h[1]=String(h)+"px";
		areaInfo[index].h[2]=String(inside_stroke)+"px";
		areaInfo[index].h[3]=String(h)+"px";
		
		var id = -1; 
		if(recoged==false)
		{
			id = result_info[a].nDetectID; 
		}
		else
		{
			id = result_info[a].nFaceRecogID;
		}
		
		if(id == -1)
		{
			areaInfo[index].registered = false;
		}
		else
		{
			areaInfo[index].registered = true;
		}
		
		index++;
	}
	
	g_Data.SetFaceRecogAreaInfo(areaInfo);
	
	if(areaInfo.length >0)
	{
		WndMgr.UpdateFaceRecogArea();
	}
}

ProcMgr.ProcessRecogResult= function(face_info)
{
	alert("ProcMgr.ProcessRecogResult");
	
	this.isFaceRegistrationAfterSignin = false; //init
	this.isSigninAfterPwdCheck=false; //init
	
	ProcMgr.PauseFaceRecog(false);
	
	var result = JSON.parse(face_info);

	var saved_info = PluginAPIMgr.GetMyStorageInfo();
	var info = null;
	var i=0;
	var j=0;
	var index =0;
	
	var confirmResult = new Array();
	
	if(saved_info)
	{
		info = JSON.parse(saved_info);
		
		alert("***** ProcMgr.ProcessRecogResult() --> saved_info : "+saved_info);	
		
		for (i=0; i < result.recognitionResult.length; i++ )		
		{	
			for(j=0; j < info.SkypeAccount.length; j++)
			{
				if(info.SkypeAccount[j].face == result.recognitionResult[i].imageFilePath)
				{	
					confirmResult[index] =new Object();
					confirmResult[index].face = result.recognitionResult[i].imageFilePath;				
					confirmResult[index].id = info.SkypeAccount[j].id;
					confirmResult[index].pwd = info.SkypeAccount[j].pwd;
					confirmResult[index].registered = true;
					if(info.SkypeAccount[j].pwd_check == 'undefined')
					{
						confirmResult[index].pwd_check = false;
					}
					else
					{
						confirmResult[index].pwd_check = info.SkypeAccount[j].pwd_check ;
					}
					
					index++;
					break;					
				}
			}
		}
		
		var registeredResult = confirmResult;
		
		for (i=0; i < result.recognitionResult.length; i++ )		
		{
			var saved = false
			for(j=0; j < registeredResult.length; j++)
			{
				if(registeredResult[j].face == result.recognitionResult[i].imageFilePath)
				{	
					saved = true;
					break;					
				}
			}
			
			if(saved==false)
			{
				confirmResult[index] =new Object();
				confirmResult[index].face = result.recognitionResult[i].imageFilePath;				
				confirmResult[index].id = "none";
				confirmResult[index].pwd = "none";
				confirmResult[index].registered = false;
				confirmResult[index].pwd_check = false;
				
				index++;
			}
		}		
	}
	else
	{
		for (i=0; i < result.recognitionResult.length; i++ )		
		{
			confirmResult[index] =new Object();
			confirmResult[index].face = result.recognitionResult[i].imageFilePath;				
			confirmResult[index].id = "none";
			confirmResult[index].pwd = "none";
			confirmResult[index].registered = false;
			confirmResult[index].pwd_check = false;
			
			index++;
		}
	}
	
	alert("ProcMgr.ProcessRecogResult -> number of confirmResult : "+confirmResult.length);
	
	if(confirmResult.length==1 && confirmResult[0].id != "none")
	{
		if(confirmResult[0].pwd_check==false)
		{
			ProcMgr.Signin(confirmResult[0].id, confirmResult[0].pwd, false);
		}
		else
		{
			g_Data.SetFaceRecogResult(confirmResult);
			ProcMgr.ProcessSigninAfterPwdCheck(0);
		}		
	}
	else
	{		
		g_Data.SetFaceRecogResult(confirmResult);
		WndMgr.ResultStepFaceRecogSignin();
	}
	
	this.CountOfRecogFail=0;
}

ProcMgr.ProcessRecogFail= function()
{	
	this.isFaceRegistrationAfterSignin = false; //init
	this.isSigninAfterPwdCheck=false; //init
	
	this.CountOfRecogFail++;
	var confirmResult = new Array();
	
	alert("ProcMgr.ProcessRecogFail-> count of fail : "+ this.CountOfRecogFail);
	
	if(this.CountOfRecogFail>=10)
	{
		g_Data.SetFaceRecogResult(confirmResult);
		WndMgr.ResultStepFaceRecogSignin();
		this.CountOfRecogFail=0;
	}
	else
	{
		ProcMgr.PauseFaceRecog(false);
		ProcMgr.RetryFaceRecog();
	}	
}

ProcMgr.ProcessSelectedRecogResult= function(index)
{
	alert("ProcMgr.ProcessSelectedRecogResult");
	this.isFaceRegistrationAfterSignin = false; //init
	this.isSigninAfterPwdCheck=false; //init
	
	var RecogResult = g_Data.GetFaceRecogResult();
	
	if(RecogResult[index].registered == true)
	{
		//if(RecogResult[0].pwd_check==false)
		if(RecogResult[index].pwd_check==false)
		{
			ProcMgr.Signin(RecogResult[index].id, RecogResult[index].pwd, false);
		}
		else
		{
			ProcMgr.ProcessSigninAfterPwdCheck(index);
		}		
	}
	else
	{
		WndMgr.NotRegisteredStepFaceRecogSignin();
	}
}

ProcMgr.RequestFaceRegistrationAfterSignin = function(id, pwd)
{
	alert("ProcMgr.RequestFaceRegistrationAfterSignin");
	
	this.isFaceRegistrationAfterSignin = true;
	ProcMgr.Signin(id, pwd, false);
}


/// Registration

ProcMgr.RequestFaceRecogRegistration = function()
{
	alert("ProcMgr.RequestFaceRecogRegistration");
	
	if(StateMgr.GetCurrentSubState()=="AccountManager")
	{
		WndMgr.NextStepAccountManager();
	}
	else if(StateMgr.GetCurrentState() == "CreateAccountSuccess")
	{
		ProcMgr.StartFaceRecogRegistration();
	}
	else if(StateMgr.GetCurrentState() == "FaceRecogSignin")
	{
		WndMgr.NextStepFaceRecogSignin();
	}	
}

ProcMgr.SkipFaceRecogRegistration = function()
{
	alert("ProcMgr.SkipFaceRecogRegistration");
	if(StateMgr.GetCurrentSubState()=="AccountManager")
	{
		WndMgr.BackStepAccountManager();
	}
	else if(StateMgr.GetCurrentState() == "CreateAccountSuccess")
	{
		WndMgr.BackStepCreateAccountSuccess();
	}
	else if(StateMgr.GetCurrentState() == "FaceRecogSignin")
	{
		WndMgr.BackStepFaceRecogSignin();
	}	
}

ProcMgr.StartFaceRecogRegistration = function()
{
	alert("ProcMgr.StartFaceRecogRegistration");
	this.isReRegisterFace = false; // init
	this.CountOfTrainingFail =0;
	
	PluginAPIMgr.StartCameraForFaceRecognition(320,174,1280,720);
	
	if(StateMgr.GetCurrentSubState().length > 0)
	{
		this.FaceRegistrationCallerState = StateMgr.GetCurrentSubState();
	}
	else
	{
		this.FaceRegistrationCallerState=StateMgr.GetCurrentState();
	}	
	
	StateMgr.Start_Face_Recog_Registration_State();	

	PluginAPIMgr.SubscribeFaceRecogEvent();
	
	this.FaceDetectTimer = true;
	PluginAPIMgr.StartOSDTimer("5000" , 
				function() { ProcMgr.FaceDetectTimer=false; ProcMgr.StartFaceDetect();}, 
				ENUM_TIMER_TYPE.NO_BUTTON);
}

ProcMgr.CompliteFaceRecogRegistration = function(flagPwdCheck)
{
	alert("ProcMgr.CompliteFaceRecogRegistration");
	
	ProcMgr.SetFlagPwdCheck(flagPwdCheck);
	
	if(this.FaceRegistrationCallerState == "AccountManager")
	{
		StateMgr.Start_Main_State();
		StateMgr.Start_Account_Manager_State();
	}
	else
	{
		ProcMgr.StartLoggedInState();
	}
}

ProcMgr.ReturnToFaceRecogRegistrationCaller = function()
{
	alert("ProcMgr.ReturnToFaceRecogRegistrationCaller");
	
	if(this.FaceRegistrationCallerState == "AccountManager")
	{
		StateMgr.Start_Main_State();
		StateMgr.Start_Account_Manager_State();
	}
	else if(this.FaceRegistrationCallerState == "CreateAccountSuccess")
	{
		StateMgr.Start_Create_Account_Success_State();
	}
	else
	{
		ProcMgr.StartLoggedInState();
	}
}

ProcMgr.RetryFaceRecogRegistration = function()
{
	alert("ProcMgr.RetryFaceRecogRegistration");
	
	var faceImagePath = ProcMgr.GetMyFaceImagePath();
	if(faceImagePath.length>0)
	{
		ProcMgr.InitMyFaceImagePath();
	}
	
	ProcMgr.RetryFaceDetect();
	
	WndMgr.BackStepFaceRecogRegistration();
}

ProcMgr.StopFaceRecogRegistration= function()
{
	alert("ProcMgr.StopFaceRecogRegistration");
	
	if(this.FaceDetectTimer==true)
	{
		this.FaceDetectTimer = false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.NO_BUTTON);
	}
	
	ProcMgr.StopFaceTraining();
	ProcMgr.StopFaceDetect();
	
	PluginAPIMgr.StopCameraForFaceRecognition();		
}

ProcMgr.StartFaceDetect = function()
{
	alert("ProcMgr.StartFaceDetect");
	this.isFaceDetect = true;
	
	PluginAPIMgr.StartFaceDetection();
}

ProcMgr.PauseFaceDetect = function(flagByUser)
{
	alert("ProcMgr.PauseFaceDetect");
	
	if(this.FaceDetectTimer==true)
	{
		this.FaceDetectTimer = false;
		PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.NO_BUTTON);
	}
	
	if(flagByUser==true)
	{
		this.CountOfTrainingFail =0;
		WndMgr.UpdateFaceRecogBoxColor(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_RED);
	}
	
	if(this.isFaceDetect== true)
	{
		this.isFaceDetect = false;
		PluginAPIMgr.StopFaceDetection();
	}
	
	if(this.isFaceTraining== true)
	{
		ProcMgr.StopFaceTraining(); 
	}
}

ProcMgr.RetryFaceDetect = function()
{
	alert("ProcMgr.RetryFaceDetect");
	if(this.isFaceTraining== true)
	{
		ProcMgr.StopFaceTraining(); 
	}
	
	if(this.isFaceDetect== false)
	{
		this.isFaceDetect = true;
		PluginAPIMgr.StartFaceDetection();
	}
}

ProcMgr.StopFaceDetect = function()
{
	if(this.isFaceDetect== true)
	{
		this.isFaceDetect = false;
		PluginAPIMgr.StopFaceDetection();				
	}	
	
	PluginAPIMgr.UnsubscribeFaceRecogEvent(); 	
}

ProcMgr.ProcessDetectFace= function(face_info)
{
	alert("ProcMgr.ProcessDetectFace");
	var info = JSON.parse(face_info);
	var num = info.detectResult.length;
	var pos= new Array(num);

	this.PauseFaceDetect(false);
	this.StartFaceTraining(face_info);
	
}

ProcMgr.StartFaceTraining = function(face_info)
{
	alert("ProcMgr.StartFaceTraining");
	if(this.isFaceTraining== false)
	{
		this.isFaceTraining = true;
	
		WndMgr.UpdateFaceRecogBoxColor(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_YELLOW);
		PluginAPIMgr.StartFaceTraining(face_info);
	}
}

ProcMgr.StopFaceTraining = function()
{
	alert("ProcMgr.StopFaceTraining");
	if(this.isFaceTraining== true)
	{
		this.isFaceTraining = false;
	
		PluginAPIMgr.StopFaceTraining();
	}

}

ProcMgr.ProcessTrainResult= function(face_info)
{
	alert("ProcMgr.ProcessTrainResult -> count of fail : "+this.CountOfTrainingFail);
	var result = JSON.parse(face_info);
	var result_id = result.detectResult;
	
	if(result_id<0)
	{
		this.CountOfTrainingFail++;
		if(this.CountOfTrainingFail==100)
		{
			this.StopFaceTraining();
			WndMgr.RetryNotyStepFaceRecogRegistration();
			
			this.CountOfTrainingFail=0; //init
			return;
		}
		
		if(result_id==-10)
		{
			alert("Training..., please wait");
		}
		else
		{
			if( result_id==-100)
			{
				alert("too many face..");
			}
			else
			{
				alert("Fail face training~!!");
			}
			
			WndMgr.UpdateFaceRecogBoxColor(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_RED);
			
			this.StopFaceTraining();
			this.RetryFaceDetect();				
		}
	}	
	else
	{
		alert("Success face training~!!");
		WndMgr.UpdateFaceRecogBoxColor(g_Image.IMAGE_FACE_RECOG_REGISTRATION_BOX_GREEN);
		
		var flagDuplicate = ProcMgr.CheckImageDuplicate(result.imageFilePath, result_id);
		if(flagDuplicate== true)
		{
			WndMgr.DuplicateStepFaceRecogRegistration();
		}
		else
		{
			ProcMgr.SetMyFaceImagePath(result.imageFilePath, result_id); 		
			WndMgr.NextStepFaceRecogRegistration();
		}
	}
}






