/**
 * @author Samsung
 */


var HelpBarIndex = {
	
    SIGNUP_SUGGESTION				:5,
    SIGNUP_SUGGESTION_INPUT			:6,

    FORGOT_PWD :9,
	
	//List Window
	LIST_MAIN_DEFAULT						:11,	 
	LIST_MAIN_CONTACT						:12, 
	LIST_MAIN_CONTACT_PAGE					:13,
	LIST_MAIN_HISTORY_PAGE					:14,
	LIST_MAIN_HISTORY_VMPLAY				:15,	
	LIST_MAIN_CHAT_HISTORY_PAGE				:16,	 
    LIST_MAIN_CALL_PAGE						:17,
    LIST_MAIN_CALL_INPUT					:18,
    LIST_MAIN_CALL_INPUT_PLUS				:19,
    LIST_MAIN_CALL_PHONENUMBER_LIST			:20,
	LIST_MAIN_CALL_COUNTRY_LIST				:25,
    LIST_MAIN_SETTING_PAGE					:21, 
    LIST_MAIN_LIVE_CALL_PAGE				:22,
	LIST_MAIN_VOICE_CALL_PHONE_NUMBER_LIST	:23,
	
	//Live Contact Switch Window
	LIVE_CALL_CONTACT				:24,
	
	//volume
	VOLUME_MIC :26,
    VOLUME_MIC_AUTO :27,
    VOLUME_SPEAKER :28,
	
	//Call
	VIDEO_CALL_NORMAL_VIEW			:31,
	//VIDEO_CALL_NORMAL_VIEW_ZOOM		:32, 
	VIDEO_CALL_FULL_SD_VIEW			:33, 
	VIDEO_CALL_FULL_HD_VIEW			:34,
	CONF_CALL						:35, 
    VOICE_CALL						:36,
    SKYPE_OUT_CALL					:37,
    SKYPE_OUT_CALL_DIAL				:38,	
    
    //Settings
    ONLINE_STATUS								:40, 
    CHANGE_PWD									:41, 
	CHANGE_PWD_INPUT							:42, 
    CHANGE_PICTURE								:43,
	CHANGE_PICTURE_DELETE						:44,
	CHANGE_PICTURE_CONFIRM						:45,	
    EDIT_PROFILE								:46, 
    EDIT_PROFILE_INPUT							:47, 
    //EDIT_PROFILE_INPUT_NUMBER					:48, 
    EDIT_PROFILE_INPUT_PHONE_NUMBER				:49,    
    EDIT_PROFILE_SAVE							:50, 
    EDIT_PROFILE_INPUT_SAVE						:51, 
    //EDIT_PROFILE_INPUT_NUMBER_SAVE				:52, 
    EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE		:53,  
    EDIT_PROFILE_INPUT_PHONE_NUMBER_PLUS		:54, 
    EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE_PLUS	:55,  
    //EDIT_PROFILE_DATE_INPUT						:56, 
    //EDIT_PROFILE_DATE_INPUT_SAVE				:57, 
   // EDIT_PROFILE_DATE_SELECT					:58, 
   // EDIT_PROFILE_DATE_SELECT_SAVE				:59, 
    
   //Tool
	LIST_TOOL_MENU					:66,  
	LIST_TOOL_MENU_VOICE_CALL_LIST	:76,		//Check 76
	LIST_TOOL_MENU_IN_CALL_LIST		:77,
	VIEW_PROFILE					:67,
    
    //Chat
    CHAT				:71, 
    CHAT_SCROLL			:72, 
	
	//Video Snapshot
	VIDEO_SNAPSHOT			: 90,
    VIDEO_SNAPSHOT_ZOOM		: 91,
 
   	//Options   
    OPTIONS 						: 101,
    OPTIONS_SAVE					: 102,
    OPTIONS_GENERAL_SETTINGS		: 103,
    OPTIONS_GENERAL_SETTINGS_SAVE	: 104,
    OPTIONS_VIDEO_SETTINGS			: 105,
    OPTIONS_VIDEO_SETTINGS_SAVE		: 106,
    OPTIONS_PRIVACY_SETTINGS		: 107,
    OPTIONS_PRIVACY_SETTINGS_SAVE	: 108,
    OPTIONS_BLOCKED_USERS			: 109,
    OPTIONS_BLOCKED_USERS_SAVE		: 110,
    OPTIONS_BLOCKED_USERS_INPUT		: 111,
    OPTIONS_BLOCKED_USERS_INPUT_SAVE: 112,    
    OPTIONS_CALL_FORWARDING			: 113,
    OPTIONS_CALL_FORWARDING_SAVE	: 114,
    OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT			: 115,
    OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE		: 116,
    OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_PLUS		: 117,
    OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE_PLUS: 118,
    OPTIONS_CALL_FORWARDING_NUMBER_INPUT				: 119,
    OPTIONS_CALL_FORWARDING_NUMBER_INPUT_SAVE			: 120,
    OPTIONS_VOICE_MAIL						: 121,
    OPTIONS_VOICE_MAIL_SAVE					: 122,
    OPTIONS_VOICE_MAIL_NUMBER_INPUT			: 123,
    OPTIONS_VOICE_MAIL_NUMBER_INPUT_SAVE	: 124,
	OPTIONS_SELECTOR_ALLOW_CALL				: 125,
	OPTIONS_SELECTOR_ON_OFF					: 126,
	OPTIONS_SELECTOR_VIDEO					: 127,
	OPTIONS_SELECTOR_VIDEO_SHOW				: 128,
	
	//Add Contact
	ADD_CONTACT	 							:131, 
    ADD_CONTACT_SEARCH_RESULT				:133,
    ADD_CONTACT_PHONE_NUMBER				:137,
    ADD_CONTACT_PHONE_NUMBER_INPUT_TEXT		:138,
    ADD_CONTACT_PHONE_NUMBER_INPUT			:139,
    ADD_CONTACT_PHONE_NUMBER_INPUT_DEFAULT	:143,    //check... 143
	ADD_CONTACT_PHONE_NUMBER_COUNTRY_LIST	:144,
	ADD_CONTACT_REQUEST						:142,
	
	//Create Account
	CREATE_ACCOUNT_STEP1					:150,
    CREATE_ACCOUNT_STEP1_INPUT				:151,
	CREATE_ACCOUNT_STEP2					:152,
    CREATE_ACCOUNT_STEP2_INPUT				:153,
	CREATE_ACCOUNT_STEP3					:154,
	CREATE_ACCOUNT_STEP4					:155,
	
	//Welcome
	WELCOME 								:160,
	
	//Signin
	SIGNIN 								    :161,
	SIGNIN_INPUT 							:162,
	SIGNIN_LAST_ID_LIST					    :163,
		
	EXIT 									:165,
	
	CAMERA_CHECK_CONNECTED 					:171,
	CAMERA_CHECK_DISCONNECTED 				:172,

	//Add Phonenumber
	ADD_PHONENUMBER 						:181,
	ADD_PHONENUMBER_INPUT					:182,
	ADD_PHONENUMBER_INPUT_NUMBER			:183, 
	//ADD_PHONENUMBER_COUNTRY_LIST			:184, 	
	
	//face recog
	FACE_RECOG_SIGNIN : 190,	
	FACE_RECOG_RESULT : 191,
	FACE_RECOG_REGISTRATION: 192,
	ACCOUNT_MANAGER:193,
	ACCOUNT_CONNECTION:194,
	ACCOUNT_CONNECTION_INPUT:195,
	CREATE_ACCOUNT_SUCCESS:196,
	//guide page
	GUIDE_PAGE:197
	
};


function HelpBar(typeIndex,sceneId, bgImage){
   
    this.HelpBarType=0;
    this.SceneId="";
    this.HelpBarImage="";
            
    this.HelpBarBgId ="";
    this.HelpBarContentsId="";
    this.HelpBarTextStyle="";   
    
    this.HelpContentsHTML="";
    this.HelpBarHTML="";

    this.TD_HEIGHT=28;
    this.imgStyle ="padding-right:7px;";
    this.textStyle ="padding-right:15px;";
    
// for ToolTip	
	this.requestToolTip = false;
	this.ToolTipBgId ="";
	this.ToolTipTextId ="";
	this.ToolTipHTML="";
	this.isShownToolTip = false;
	this.ToolTipTextStyle="tooltip_style_default";  
	
	this.HiddenHelpBarBgId ="";
	this.HiddenContentsHTML="";
    this.HiddenHelpBarHTML="";
	
	this.imgHiddenStyle ="padding-right:7px; visibility:hidden;";
	this.textHiddenStyle ="padding-right:15px; font-size : 17px; text-align : right; visibility:hidden;";
	
	this.toolTipTimer = null;
	
// click event callback
	this.index = 0;
	this.flagClickEnable = false;
	
	this.mouseClickCallback = new Array;
  
  
 /********* start making Help bar************************/  
    if(sceneId)
    {
        this.SceneId=sceneId;
    }
    
     if(bgImage)
    {
        this.HelpBarImage=bgImage;
    }
    
    if(typeIndex)
    {
        this.setHelpBarType(typeIndex);
    }
}

HelpBar.prototype.SetOnClickCallbackFunc=function(index,func){
	
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(func)
	{
		this.mouseClickCallback[index].func = func;
	}
}

HelpBar.prototype.EnableOnClick = function()
{

	if(this.flagClickEnable == false)
	{
		for(var i=1; i<=this.index; i++)
		{
			if(this.mouseClickCallback[i].func != null)
			{
				alert("HelpBar.EnableOnClick -> i: " + i);
				this.InsertOnClick(this.mouseClickCallback[i]);
			}
		}

		
		this.flagClickEnable = true;
	}
}

HelpBar.prototype.InsertOnClick = function(clickCB)
{
	// alert("HelpBar.InsertOnClick -> img_id: " + clickCB.img_id);
	// alert("HelpBar.InsertOnClick -> text_id: " + clickCB.text_id);
	
	document.getElementById(clickCB.img_id).onclick = clickCB.func;
	$("#"+clickCB.img_id).css({'cursor' : 'pointer'});	
	document.getElementById(clickCB.text_id).onclick = clickCB.func;
	$("#"+clickCB.text_id).css({'cursor' : 'pointer'});	
}

HelpBar.prototype.DisableOnClick = function()
{
	if(this.flagClickEnable == true)
	{
		for(var i=1; i<=this.index; i++)
		{
			if(this.mouseClickCallback[i].func != null)
			{
				this.DeleteOnClick(this.mouseClickCallback[i]);
			}
		}
		
		this.flagClickEnable = false;
	}
}

HelpBar.prototype.DeleteOnClick = function(clickCB)
{
	document.getElementById(clickCB.img_id).onclick = null;
	$("#"+clickCB.img_id).css({'cursor' : ''});	
	document.getElementById(clickCB.text_id).onclick = null;
	$("#"+clickCB.text_id).css({'cursor' : ''});	
}



HelpBar.prototype.setHelpBarType=function(typeIndex){
	
    this.HelpBarType = typeIndex;	

    this._registerHelpIcon();
    this.HelpBarHTML = this.getHelpHTML();
    
    if(this.SceneId.length>0)
    {
        $("#"+this.SceneId).append(this.HelpBarHTML);
    }
	
	if(this.requestToolTip==true)
	{
		this.ToolTipHTML = this.getToolTipHTML();
		$("#"+this.SceneId).append(this.ToolTipHTML);
		
		if(ResMgr.isReverseLanguage())
		{
			$("#"+this.ToolTipTextId).css("direction","rtl");
		}
		
		this.HiddenHelpBarHTML=this.getHiddenHelpHTML();
		$("#"+this.SceneId).append(this.HiddenHelpBarHTML);
	}
}

HelpBar.prototype.getHelpBarHTML= function()
{
    return this.HelpBarHTML;
}

HelpBar.prototype.visibleObj=function()
{
	//alert("HelpBar.visibleObj : " + this.HelpBarType);
    $("#"+this.HelpBarBgId).css("display","block");

	if(this.requestToolTip==true && this.isShownToolTip==false)
	{
		this.showToolTip();
	}
	
	this.EnableOnClick();
}

HelpBar.prototype.hiddenObj=function()
{  
   //alert("HelpBar.hiddenObj() : " + this.HelpBarType);
   $("#"+this.HelpBarBgId).css("display","none");
   
   	if(this.requestToolTip==true && this.isShownToolTip==false)
	{
		this.hideToolTip();
	}
	
	this.DisableOnClick();
}

HelpBar.prototype.showToolTip=function()
{
	$("#"+this.ToolTipBgId).css("display","block");
	$("#"+this.HiddenHelpBarBgId).css("display","block");
	
	var _This = this;
	this.toolTipTimer = setTimeout("CloseTimerCF()", 5000);	
	CloseTimerCF = function(){
		alert("HelpBar -> tooltip time out");
		_This.hideToolTip();
	} 
}

HelpBar.prototype.hideToolTip=function()
{
	$("#"+this.ToolTipBgId).css("display","none");
	$("#"+this.HiddenHelpBarBgId).css("display","none");
	this.isShownToolTip=true;
	
	clearTimeout(this.toolTipTimer);
	this.toolTipTimer=null;
}
   
HelpBar.prototype._addHelpIcon = function(image, text)
{    
	this.index++;
	
	//alert("HelpBar._addHelpIcon -> this.index: " + this.index+", text: "+text);
	this.mouseClickCallback[this.index]=new Object;
	this.mouseClickCallback[this.index].func = null;
	this.mouseClickCallback[this.index].index = String(this.index);
	this.mouseClickCallback[this.index].img_id = this.HelpBarContentsId+"_"+this.mouseClickCallback[this.index].index+"_img";
	this.mouseClickCallback[this.index].text_id = this.HelpBarContentsId+"_"+this.mouseClickCallback[this.index].index+"_text";
	
	var helpHTML = "";
	helpHTML += "<td style='width: 7px;'></td>";
	helpHTML += "<td><div id ='"+this.mouseClickCallback[this.index].img_id+"'><img src='"+image+"' style='"+this.imgStyle+"'/></div></td>";
	helpHTML += "<td style='"+this.textStyle+ "'class='"+this.HelpBarTextStyle+"'><div id ='"+this.mouseClickCallback[this.index].text_id+"'>"+text+"</div></td>";
	this.HelpContentsHTML += helpHTML;
}

HelpBar.prototype.getHelpHTML = function () {
    
	var wrapHTML = "";
    if(this.HelpBarImage.length >0)
    {
        wrapHTML +="<div id ='" + this.HelpBarBgId+ "' style ='background-image :url("+this.HelpBarImage+")' >"
    }
    else
    {
         wrapHTML +="<div id ='" + this.HelpBarBgId+ "'>"
    }
    wrapHTML +="<div id ='" + this.HelpBarContentsId+ "' class= '" +this.HelpBarTextStyle+ "'>"
	wrapHTML += "<table cellpadding='0px' cellspacing='0px' align='right' style='table-layout:fixed; height:"+this.TD_HEIGHT+"px;'>";
	wrapHTML += "<tr valign='middle'>";
	wrapHTML += this.HelpContentsHTML;
	wrapHTML += "</tr>";
	wrapHTML += "</table>";
    wrapHTML += "</div>";
    wrapHTML += "</div>";

    //alert("HelpBar.prototype.getHelpHTML:"+wrapHTML);
    
	return wrapHTML;
}


////// for ToolTip

HelpBar.prototype._addHiddenIcon = function(image, text,flagDisplay)
{    
	var helpHTML = "";
	helpHTML += "<td style='width: 7px;'></td>";
	if(flagDisplay==false)
	{
		helpHTML += "<td><img src='"+image+"' style='"+this.imgHiddenStyle+"'/></td>";
	}
	else
	{
		helpHTML += "<td><img src='"+image+"' style='"+this.imgStyle+"'/></td>";
	}
	
	helpHTML += "<td style='"+this.textHiddenStyle+"'>"+text+"</td>";
	this.HiddenContentsHTML += helpHTML;
}

HelpBar.prototype.getHiddenHelpHTML = function () {
    
	var wrapHTML = "";
    wrapHTML +="<div id ='" + this.HiddenHelpBarBgId+ "'>"
	wrapHTML += "<table cellpadding='0px' cellspacing='0px' align='right' style='table-layout:fixed; height:"+this.TD_HEIGHT+"px;'>";
	wrapHTML += "<tr valign='middle'>";
	wrapHTML += this.HiddenContentsHTML;
	wrapHTML += "</tr>";
	wrapHTML += "</table>";
    wrapHTML += "</div>";

	return wrapHTML;
}

HelpBar.prototype.getToolTipHTML = function()
{
	//var arrow_left= $("div#"+this.HelpBarBgId+" img:first").css('left');
	//alert("HelpBar.prototype.getToolTipHTML-> arrow_left: "+ arrow_left);
	
	this.ToolTipTextId = this.ToolTipBgId+"_text";
	
	var wrapHTML = "";
	wrapHTML += "<div id ='"+this.ToolTipBgId+"'>"
	wrapHTML += "<table cellpadding='0px' cellspacing='0px' align='right' style='table-layout:fixed; height:66px;'>";
	wrapHTML += "<tr valign='middle'>";
	wrapHTML += "<td style='width: 20px; background-image :url("+g_Image.IMAGE_HELP_BALL_LEFT+"); background-repeat: no-repeat;'></td>";
	wrapHTML += "<td style='background-image :url("+g_Image.IMAGE_HELP_BALL_CENTER+"); background-repeat: repeat-x;'>";
	wrapHTML += "<div id ='"+this.ToolTipTextId+"' style='padding-bottom:20px; line-height:20px; height:20px' class='"+this.ToolTipTextStyle+"'>"+TV_SELECT_ADD_A_CONTACT_MSG+"</div>";
	wrapHTML += "</td>"
	wrapHTML += "<td style='width: 20px; background-image :url("+g_Image.IMAGE_HELP_BALL_RIGHT+"); background-repeat: no-repeat;'></td>";
	wrapHTML += "<td style='width: 100px;'></td>";
	wrapHTML += "</tr>";
	wrapHTML += "</table>";
	wrapHTML += "</div>";
	
	return wrapHTML;
}

HelpBar.prototype._registerHelpIcon= function()
{
    switch(this.HelpBarType)
    {
        case HelpBarIndex.VIDEO_CALL_NORMAL_VIEW:
            this.HelpBarBgId ="helpbar_bg_video_call_nor";
            this.HelpBarContentsId="helpbar_content_video_call_nor";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_GREEN, TV_SID_LARGE_SCREEN);
			/*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}*/
			
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		 /*case HelpBarIndex.VIDEO_CALL_NORMAL_VIEW_ZOOM:
            this.HelpBarBgId ="helpbar_bg_video_call_nor_zoom";
            this.HelpBarContentsId="helpbar_content_video_call_nor_zoom";
            this.HelpBarTextStyle ="helpbar_style_default";
               
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;*/

        case HelpBarIndex.VIDEO_CALL_FULL_SD_VIEW:
            this.HelpBarBgId ="helpbar_bg_video_call_sd";
            this.HelpBarContentsId="helpbar_content_video_call_sd";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_GREEN, SID_FULL_SCREEN );
            /*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}*/
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
         case HelpBarIndex.VIDEO_CALL_FULL_HD_VIEW:
            this.HelpBarBgId ="helpbar_bg_video_call_hd";
            this.HelpBarContentsId="helpbar_content_video_call_hd";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_GREEN, TV_SID_NORMAL_SCREEN);
            /*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}*/
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
        case HelpBarIndex.LIST_MAIN_CONTACT:
            this.HelpBarBgId ="helpbar_bg_list_main_contact";
            this.HelpBarContentsId="helpbar_content_list_main_contact";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_YELLOW, IDWS_MOIP_SKYPE_ADD_A_CONTACT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
			
			this.requestToolTip = true;
			this.ToolTipBgId = "tooltip_bg_main_contact" ;
			
			this.HiddenHelpBarBgId = "hidden_helpbar_bg_main_contact";
			this._addHiddenIcon(g_Image.IMAGE_HELP_BALL_ALLOW, IDWS_MOIP_POPUP_EXIT_SIGN_OUT, false);
            this._addHiddenIcon(g_Image.IMAGE_HELP_BALL_ALLOW, IDWS_MOIP_SKYPE_ADD_A_CONTACT, true );
            this._addHiddenIcon(g_Image.IMAGE_HELP_BALL_ALLOW, SID_RETURN, false);
			
            break;
            
        case HelpBarIndex.LIST_MAIN_DEFAULT:
            this.HelpBarBgId ="helpbar_bg_list_main";
            this.HelpBarContentsId="helpbar_content_list_main";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
        case HelpBarIndex.CONF_CALL:
            this.HelpBarBgId ="helpbar_bg_conf_call";
            this.HelpBarContentsId="helpbar_content_conf_call";
            this.HelpBarTextStyle ="helpbar_style_default";
                        
            /*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);				
			}*/
			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
             break;

        case HelpBarIndex.VIEW_PROFILE:
            this.HelpBarBgId ="helpbar_bg_view_profile";
            this.HelpBarContentsId="helpbar_view_contact_profile";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;	
			
		case HelpBarIndex.LIST_TOOL_MENU:
            this.HelpBarBgId ="helpbar_bg_list_tool_menu";
            this.HelpBarContentsId="helpbar_list_tool_menu";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;

            
		case HelpBarIndex.LIST_TOOL_MENU_VOICE_CALL_LIST:
            this.HelpBarBgId ="helpbar_bg_list_tool_menu_voice_call_list";
            this.HelpBarContentsId="helpbar_context_list_tool_menu_voice_call_list";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
		case HelpBarIndex.LIST_TOOL_MENU_IN_CALL_LIST:
            this.HelpBarBgId ="helpbar_bg_list_tool_menu_in_call_list";
            this.HelpBarContentsId="helpbar_context_list_tool_menu_in_call_list";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;            
        
         case HelpBarIndex.SIGNUP_SUGGESTION:
            this.HelpBarBgId ="helpbar_bg_signup_suggestion";
            this.HelpBarContentsId="helpbar_content_signup_suggestion";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
          case HelpBarIndex.SIGNUP_SUGGESTION_INPUT:
            this.HelpBarBgId ="helpbar_bg_signup_suggestion_input";
            this.HelpBarContentsId="helpbar_content_signup_suggestion_input";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
         case HelpBarIndex.LIST_MAIN_CALL_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_call";
            this.HelpBarContentsId="helpbar_content_list_main_call";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;            
                    
         case HelpBarIndex.LIST_MAIN_CALL_INPUT:
            this.HelpBarBgId ="helpbar_bg_list_main_call_input";
            this.HelpBarContentsId="helpbar_content_list_main_call_input";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
         case HelpBarIndex.LIST_MAIN_CALL_INPUT_PLUS:
            this.HelpBarBgId ="helpbar_bg_list_main_call_input_plus";
            this.HelpBarContentsId="helpbar_content_list_main_call_input_plus";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            if(ProcMgr.isTTXMIXEnable() == true)
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TTXMIX, "+" );
            }
            else
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_, "+" );
            }
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
         case HelpBarIndex.LIST_MAIN_CALL_PHONENUMBER_LIST:
            this.HelpBarBgId ="helpbar_bg_list_main_call_phonenumber_list";
            this.HelpBarContentsId="helpbar_content_list_main_call_phonenumber_list";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;

         case HelpBarIndex.LIST_MAIN_CALL_COUNTRY_LIST:
            this.HelpBarBgId ="helpbar_bg_list_main_call_country_list";
            this.HelpBarContentsId="helpbar_content_list_main_call_country_list";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
									
         case HelpBarIndex.LIST_MAIN_SETTING_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_setting";
            this.HelpBarContentsId="helpbar_content_list_main_setting";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
           case HelpBarIndex.LIST_MAIN_LIVE_CALL_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_live_call";
            this.HelpBarContentsId="helpbar_content_list_main_live_call";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;            
            
		case HelpBarIndex.LIVE_CALL_CONTACT:
			this.HelpBarBgId ="helpbar_bg_live_call_contact";
			this.HelpBarContentsId="helpbar_content_live_call_contact";
			this.HelpBarTextStyle ="helpbar_style_default";
			
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
			break;

			
        case HelpBarIndex.VOICE_CALL:
            this.HelpBarBgId ="helpbar_bg_voice_call";
            this.HelpBarContentsId="helpbar_content_voice_call";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            /*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}*/
            
            //this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            
            break;
         
         case HelpBarIndex.SKYPE_OUT_CALL:
            this.HelpBarBgId ="helpbar_bg_skype_out_call";
            this.HelpBarContentsId="helpbar_content_skype_out_call";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            /*if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}*/
			//this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
             break;
             
        case HelpBarIndex.SKYPE_OUT_CALL_DIAL:
            this.HelpBarBgId ="helpbar_bg_skype_out_dial_call";
            this.HelpBarContentsId="helpbar_content_skype_out_dial_call";
            this.HelpBarTextStyle ="helpbar_style_default";
            
             this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
             break;
			
        case HelpBarIndex.LIST_MAIN_CONTACT_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_contact_page";
            this.HelpBarContentsId="helpbar_content_list_main_contact_page";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_YELLOW, IDWS_MOIP_SKYPE_ADD_A_CONTACT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);

            break;		
			
        case HelpBarIndex.LIST_MAIN_HISTORY_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_history_page";
            this.HelpBarContentsId="helpbar_content_list_main_history_page";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;		

        case HelpBarIndex.LIST_MAIN_HISTORY_VMPLAY:
            this.HelpBarBgId ="helpbar_bg_list_main_history_vmplay";
            this.HelpBarContentsId="helpbar_content_list_main_history_vmplay";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_STOP);
            break;		
	
        case HelpBarIndex.LIST_MAIN_CHAT_HISTORY_PAGE:
            this.HelpBarBgId ="helpbar_bg_list_main_chat_page";
            this.HelpBarContentsId="helpbar_content_list_main_chat_page";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RED, IDWS_MOIP_POPUP_EXIT_SIGN_OUT);			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;

        case HelpBarIndex.LIST_MAIN_VOICE_CALL_PHONE_NUMBER_LIST:
            this.HelpBarBgId ="helpbar_bg_list_main_voice_call_phone_number_list";
            this.HelpBarContentsId="helpbar_content_list_main_voice_call_phone_number_list";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TOOLS, SID_TOOLS);			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;	
			
		case HelpBarIndex.HISTORY_TOOL_MENU:
            this.HelpBarBgId ="helpbar_bg_history_list_tool_menu";
            this.HelpBarContentsId="helpbar_content_history_list_tool_menu";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;						
			
		case HelpBarIndex.CHANGE_PICTURE:
            this.HelpBarBgId = "helpbar_bg_change_picture";
            this.HelpBarContentsId = "helpbar_content_change_picture";
            this.HelpBarTextStyle = "helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
		case HelpBarIndex.CHANGE_PICTURE_DELETE:
            this.HelpBarBgId = "helpbar_bg_change_picture_delete";
            this.HelpBarContentsId = "helpbar_content_change_picture_delete";
            this.HelpBarTextStyle = "helpbar_style_popup";
			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_DELETE);	
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;			

		case HelpBarIndex.CHANGE_PICTURE_CONFIRM:
            this.HelpBarBgId = "helpbar_bg_change_picture_confirm";
            this.HelpBarContentsId = "helpbar_content_change_picture_confirm";
            this.HelpBarTextStyle = "helpbar_style_popup";
				
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;	
           
        case HelpBarIndex.VOLUME_MIC:
            this.HelpBarBgId ="helpbar_bg_volume_mic";
            this.HelpBarContentsId="helpbar_content_volume_mic";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_LEFT_RIGHT,TV_SID_VOLUME_DOWN_UP);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
             break;
             
         case HelpBarIndex.VOLUME_MIC_AUTO:
            this.HelpBarBgId ="helpbar_bg_volume_mic_auto";
            this.HelpBarContentsId="helpbar_content_volume_mic_auto";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
             break;            
             			
        case HelpBarIndex.VOLUME_SPEAKER:
            this.HelpBarBgId ="helpbar_bg_volume_speaker";
            this.HelpBarContentsId="helpbar_content_volume_speaker";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
             break;
             
        case HelpBarIndex.FORGOT_PWD:
            this.HelpBarBgId ="helpbar_bg_forgot_pwd";
            this.HelpBarContentsId="helpbar_content_forgot_pwd";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
             break;
     
       case HelpBarIndex.ADD_CONTACT:
            this.HelpBarBgId ="helpbar_bg_add_contact";
            this.HelpBarContentsId="helpbar_content_add_contact";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
         
        case HelpBarIndex.ADD_CONTACT_PHONE_NUMBER			:
            this.HelpBarBgId ="helpbar_bg_add_contact_phone_number";
            this.HelpBarContentsId="helpbar_content_add_contact_phone_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
        
     case HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT_TEXT			:
            this.HelpBarBgId ="helpbar_bg_add_contact_phone_number_input_text";
            this.HelpBarContentsId="helpbar_content_add_contact_phone_number_input_text";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;

         case HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT			:
            this.HelpBarBgId ="helpbar_bg_add_contact_phone_number_input";
            this.HelpBarContentsId="helpbar_content_add_contact_phone_number_input";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_ADD_M_ADD );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_INPUT_DEFAULT :
            this.HelpBarBgId ="helpbar_bg_add_contact_phone_number_input_defualt";
            this.HelpBarContentsId="helpbar_content_add_contact_phone_number_input_defualt";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;            

         case HelpBarIndex.ADD_CONTACT_PHONE_NUMBER_COUNTRY_LIST :
            this.HelpBarBgId ="helpbar_bg_add_contact_phone_number_country_list";
            this.HelpBarContentsId="helpbar_content_add_contact_phone_number_country_list";
            this.HelpBarTextStyle ="helpbar_style_popup";
           
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
            
        case HelpBarIndex.ADD_CONTACT_SEARCH_RESULT		:
            this.HelpBarBgId ="helpbar_bg_add_contact_search_result";
            this.HelpBarContentsId="helpbar_content_add_contact_search_result";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
		case HelpBarIndex.ADD_CONTACT_REQUEST:
            this.HelpBarBgId ="helpbar_bg_add_contact_request";
            this.HelpBarContentsId="helpbar_content_add_contact_request";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
            case HelpBarIndex.ONLINE_STATUS:
            
            this.HelpBarBgId ="helpbar_bg_online_status";
            this.HelpBarContentsId="helpbar_content_online_status";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
             case HelpBarIndex.CHANGE_PWD:
            
            this.HelpBarBgId ="helpbar_bg_change_password";
            this.HelpBarContentsId="helpbar_content_change_password";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
            case HelpBarIndex.CHANGE_PWD_INPUT:
            
            this.HelpBarBgId ="helpbar_bg_change_password_input";
            this.HelpBarContentsId="helpbar_content_change_password_input";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
           case HelpBarIndex.CHAT:
            this.HelpBarBgId ="helpbar_bg_chat";
            this.HelpBarContentsId="helpbar_content_chat";
            this.HelpBarTextStyle ="helpbar_style_popup";

            if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
          case HelpBarIndex.CHAT_SCROLL:
            this.HelpBarBgId ="helpbar_bg_chat_scroll";
            this.HelpBarContentsId="helpbar_content_chat_scroll";
            this.HelpBarTextStyle ="helpbar_style_popup";

            if(ProcMgr.isGenoaS==false)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, TV_SID_CONTACK_LIST);	
			}
			
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_UP_DOWN, SID_PAGE_UP_DOWN_KR_SCREEN);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
         
          case HelpBarIndex.EDIT_PROFILE:
            this.HelpBarBgId ="helpbar_bg_edit_profile";
            this.HelpBarContentsId="helpbar_content_edit_profile";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
          case HelpBarIndex.EDIT_PROFILE_INPUT:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input";
            this.HelpBarContentsId="helpbar_content_edit_profile_input";
            this.HelpBarTextStyle ="helpbar_style_popup";

           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
         /*case HelpBarIndex.EDIT_PROFILE_INPUT_NUMBER:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_number";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;*/
           
        case HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_phone_number";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_phone_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
         case HelpBarIndex.EDIT_PROFILE_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
          case HelpBarIndex.EDIT_PROFILE_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
         /*case HelpBarIndex.EDIT_PROFILE_INPUT_NUMBER_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_number_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_number_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;*/
           
        case HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_phone_number_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_phone_number_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
        
        case HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_PLUS:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_phone_number_plus";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_phone_number_plus";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            if(ProcMgr.isTTXMIXEnable() == true)
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TTXMIX, "+" );
            }
            else
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_, "+" );
            }
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
       case HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE_PLUS:
            this.HelpBarBgId ="helpbar_bg_edit_profile_input_phone_number_save_plus";
            this.HelpBarContentsId="helpbar_content_edit_profile_input_phone_number_save_plus";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
              if(ProcMgr.isTTXMIXEnable() == true)
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TTXMIX, "+" );
            }
            else
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_, "+" );
            }
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
       /*case HelpBarIndex.EDIT_PROFILE_DATE_INPUT:
            this.HelpBarBgId ="helpbar_bg_edit_profile_date_input";
            this.HelpBarContentsId="helpbar_content_edit_profile_date_input";
            this.HelpBarTextStyle ="helpbar_style_popup";

           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
        case HelpBarIndex.EDIT_PROFILE_DATE_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_date_input_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_date_input_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;*/
           
          /*case HelpBarIndex.EDIT_PROFILE_DATE_SELECT:
            this.HelpBarBgId ="helpbar_bg_edit_profile_date_select";
            this.HelpBarContentsId="helpbar_content_edit_profile_date_select";
            this.HelpBarTextStyle ="helpbar_style_popup";

           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_SELECT);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
        case HelpBarIndex.EDIT_PROFILE_DATE_SELECT_SAVE:
            this.HelpBarBgId ="helpbar_bg_edit_profile_date_select_save";
            this.HelpBarContentsId="helpbar_content_edit_profile_date_select_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_SELECT );
           this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;*/
           
          case HelpBarIndex.VIDEO_SNAPSHOT:
            this.HelpBarBgId ="helpbar_bg_video_snapshot";
            this.HelpBarContentsId="helpbar_content_video_snapshot";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;		
			
          case HelpBarIndex.VIDEO_SNAPSHOT_ZOOM:
            this.HelpBarBgId ="helpbar_bg_video_snapshot_zoom";
            this.HelpBarContentsId="helpbar_content_video_snapshot_zoom";
            this.HelpBarTextStyle ="helpbar_style_popup";

			this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_UP_DOWN,SID_ZOOM_INOUT);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;		
				
     case HelpBarIndex.OPTIONS:
            this.HelpBarBgId ="helpbar_bg_options";
            this.HelpBarContentsId="helpbar_content_options";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_save";
            this.HelpBarContentsId="helpbar_content_options_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_GENERAL_SETTINGS:
            this.HelpBarBgId ="helpbar_bg_options_general_settings";
            this.HelpBarContentsId="helpbar_content_options_general_settings";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_GENERAL_SETTINGS_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_general_settings_save";
            this.HelpBarContentsId="helpbar_content_options_general_settings_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_VIDEO_SETTINGS:
            this.HelpBarBgId ="helpbar_bg_options_video_settings";
            this.HelpBarContentsId="helpbar_content_options_video_settings";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_VIDEO_SETTINGS_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_video_settings_save";
            this.HelpBarContentsId="helpbar_content_options_video_settings_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_PRIVACY_SETTINGS:
            this.HelpBarBgId ="helpbar_bg_options_privacy_settings";
            this.HelpBarContentsId="helpbar_content_options_privacy_settings";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_PRIVACY_SETTINGS_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_privacy_settings_save";
            this.HelpBarContentsId="helpbar_content_options_privacy_settings_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_BLOCKED_USERS:
            this.HelpBarBgId ="helpbar_bg_options_blocked_users";
            this.HelpBarContentsId="helpbar_content_options_blocked_users";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_BLOCKED_USERS_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_blocked_users_save";
            this.HelpBarContentsId="helpbar_content_options_blocked_users_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_BLOCKED_USERS_INPUT:
            this.HelpBarBgId ="helpbar_bg_options_blocked_users_input";
            this.HelpBarContentsId="helpbar_content_options_blocked_users_input";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_BLOCKED_USERS_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_blocked_users_input_save";
            this.HelpBarContentsId="helpbar_content_options_blocked_users_input_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
          case HelpBarIndex.OPTIONS_CALL_FORWARDING:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_CALL_FORWARDING_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_save";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_phone_number";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_phone_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_phone_number_save";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_phone_number_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_PLUS:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_phone_number_plus";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_phone_number_plus";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            if(ProcMgr.isTTXMIXEnable() == true)
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TTXMIX, "+" );
            }
            else
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_, "+" );
            }
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_CALL_FORWARDING_PHONE_NUMBER_INPUT_SAVE_PLUS:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_phone_number_save_plus";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_phone_number_save_plus";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
            if(ProcMgr.isTTXMIXEnable() == true)
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_TTXMIX, "+" );
            }
            else
            {
                this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_, "+" );
            }
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
         case HelpBarIndex.OPTIONS_CALL_FORWARDING_NUMBER_INPUT:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_number";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			  
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_CALL_FORWARDING_NUMBER_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_call_forwarding_number_save";
            this.HelpBarContentsId="helpbar_content_options_call_forwarding_number_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );

			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
        case HelpBarIndex.OPTIONS_VOICE_MAIL:
            this.HelpBarBgId ="helpbar_bg_options_voice_mail";
            this.HelpBarContentsId="helpbar_content_options_voice_mail";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_VOICE_MAIL_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_voice_mail_save";
            this.HelpBarContentsId="helpbar_content_options_voice_mail_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
        case HelpBarIndex.OPTIONS_VOICE_MAIL_NUMBER_INPUT:
            this.HelpBarBgId ="helpbar_bg_options_voice_mail_phone_number";
            this.HelpBarContentsId="helpbar_content_options_voice_mail_phone_number";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );

			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
            break;

        case HelpBarIndex.OPTIONS_VOICE_MAIL_NUMBER_INPUT_SAVE:
            this.HelpBarBgId ="helpbar_bg_options_voice_mail_phone_number_save";
            this.HelpBarContentsId="helpbar_content_options_voice_mail_phone_number_save";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );

			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	 
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_BLUE, SID_SAVE);
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;

        case HelpBarIndex.OPTIONS_SELECTOR_ALLOW_CALL:
            this.HelpBarBgId ="helpbar_bg_options_selector_allow_call";
            this.HelpBarContentsId="helpbar_content_options_selector_allow_call";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
			
        case HelpBarIndex.OPTIONS_SELECTOR_ON_OFF:
            this.HelpBarBgId ="helpbar_bg_options_selector_on_off";
            this.HelpBarContentsId="helpbar_content_options_selector_on_off";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;			

        case HelpBarIndex.OPTIONS_SELECTOR_VIDEO:
            this.HelpBarBgId ="helpbar_bg_options_selector_video";
            this.HelpBarContentsId="helpbar_content_options_selector_video";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
			
        case HelpBarIndex.OPTIONS_SELECTOR_VIDEO_SHOW:
            this.HelpBarBgId ="helpbar_bg_options_selector_video_show";
            this.HelpBarContentsId="helpbar_content_options_selector_video_show";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;

		case HelpBarIndex.CREATE_ACCOUNT_STEP1:
            this.HelpBarBgId ="helpbar_bg_create_account_step1";
            this.HelpBarContentsId="helpbar_content_create_account_step1";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
        case HelpBarIndex.CREATE_ACCOUNT_STEP1_INPUT:
            this.HelpBarBgId ="helpbar_bg_create_account_step1_input";
            this.HelpBarContentsId="helpbar_content_create_account_step1_input";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		case HelpBarIndex.CREATE_ACCOUNT_STEP2:
            this.HelpBarBgId ="helpbar_bg_create_account_step2";
            this.HelpBarContentsId="helpbar_content_create_account_step2";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
            
        case HelpBarIndex.CREATE_ACCOUNT_STEP2_INPUT:
            this.HelpBarBgId ="helpbar_bg_create_account_step2_input";
            this.HelpBarContentsId="helpbar_content_create_account_step2_input";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		case HelpBarIndex.CREATE_ACCOUNT_STEP3:
            this.HelpBarBgId ="helpbar_bg_create_account_step3";
            this.HelpBarContentsId="helpbar_content_create_account_step3";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		case HelpBarIndex.CREATE_ACCOUNT_STEP4:
            this.HelpBarBgId ="helpbar_bg_create_account_step4";
            this.HelpBarContentsId="helpbar_content_create_account_step4";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;

		case HelpBarIndex.WELCOME:
			this.HelpBarBgId ="helpbar_bg_welcome";
            this.HelpBarContentsId="helpbar_content_welcome";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
		case HelpBarIndex.GUIDE_PAGE:
            this.HelpBarBgId ="helpbar_bg_guide_page";
            this.HelpBarContentsId="helpbar_content_guide_page";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		case HelpBarIndex.SIGNIN:
            this.HelpBarBgId ="helpbar_bg_signin";
            this.HelpBarContentsId="helpbar_content_signin";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
      
		case HelpBarIndex.SIGNIN_LAST_ID_LIST:
            this.HelpBarBgId ="helpbar_bg_signin_last_id_list";
            this.HelpBarContentsId="helpbar_content_signin_last_id_list";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
                        
        case HelpBarIndex.SIGNIN_INPUT:
            this.HelpBarBgId ="helpbar_bg_signin_input";
            this.HelpBarContentsId="helpbar_content_signin_input";
            this.HelpBarTextStyle ="helpbar_style_default";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
			
		 case HelpBarIndex.EXIT:
            this.HelpBarBgId ="helpbar_bg_exit";
            this.HelpBarContentsId="helpbar_content_exit";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
             break;
			 
		case HelpBarIndex.CAMERA_CHECK_CONNECTED:
            this.HelpBarBgId ="helpbar_bg_camera_check_connected";
            this.HelpBarContentsId="helpbar_content_camera_check_connected";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;
		
		case HelpBarIndex.CAMERA_CHECK_DISCONNECTED:
            this.HelpBarBgId ="helpbar_bg_camera_check_disconnected";
            this.HelpBarContentsId="helpbar_content_camera_check_disconnected";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;

          case HelpBarIndex.ADD_PHONENUMBER:
            this.HelpBarBgId ="helpbar_bg_add_phonenumber";
            this.HelpBarContentsId="helpbar_content_add_phonenumber";
            this.HelpBarTextStyle ="helpbar_style_popup";
	
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
		  		   
		  case HelpBarIndex.ADD_PHONENUMBER_INPUT:
            this.HelpBarBgId ="helpbar_bg_add_phonenumber_input";
            this.HelpBarContentsId="helpbar_content_add_phonenumber_input";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER );
			
			if(ResMgr.GetCurLanguage()==ENUM_TV_LANGUAGE.KOR)
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH_KOR, SID_DELETE );
			}
			else
			{
				this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_PRECH, SID_DELETE );
			}	 
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;
           
		  case HelpBarIndex.ADD_PHONENUMBER_INPUT_NUMBER:
            this.HelpBarBgId ="helpbar_bg_add_phonenumber_input_number";
            this.HelpBarContentsId="helpbar_content_add_phonenumber_input_number";
            this.HelpBarTextStyle ="helpbar_style_popup";
            
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_1_9, SID_NUMBER ); 
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );         
           break;   
        
   		case HelpBarIndex.FACE_RECOG_SIGNIN:
            this.HelpBarBgId ="helpbar_bg_face_recog_signin";
            this.HelpBarContentsId="helpbar_content_face_recog_signin";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break; 
            
  		case HelpBarIndex.FACE_RECOG_RESULT:
            this.HelpBarBgId ="helpbar_bg_face_recog_result";
            this.HelpBarContentsId="helpbar_content_face_recog_result";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;   
            
        case HelpBarIndex.FACE_RECOG_REGISTRATION:
            this.HelpBarBgId ="helpbar_bg_face_recog_registration";
            this.HelpBarContentsId="helpbar_content_face_recog_registration";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break; 
            
        case HelpBarIndex.ACCOUNT_MANAGER:            
            this.HelpBarBgId ="helpbar_bg_account_manager";
            this.HelpBarContentsId="helpbar_content_account_manager";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;  
            
        case HelpBarIndex.ACCOUNT_CONNECTION:    
            this.HelpBarBgId ="helpbar_bg_account_connection";
            this.HelpBarContentsId="helpbar_content_account_connection";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break;
            
        case HelpBarIndex.ACCOUNT_CONNECTION_INPUT:            
            this.HelpBarBgId ="helpbar_bg_account_connection_input";
            this.HelpBarContentsId="helpbar_content_account_connection_input";
            this.HelpBarTextStyle ="helpbar_style_popup";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_ENTER, SID_INPUT );
            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN);
            break; 
            
		case HelpBarIndex.CREATE_ACCOUNT_SUCCESS:
            this.HelpBarBgId ="helpbar_bg_create_account_success";
            this.HelpBarContentsId="helpbar_content_create_account_success";
            this.HelpBarTextStyle ="helpbar_style_default";

            this._addHelpIcon(g_Image.IMAGE_HELP_BAR_ICON_RETURN, SID_RETURN );
            break;     
    }
}





