var NORMAL_ITEM_H = 62;

var CONTACT_BUTTON_HIGHLIGHT = { 
 
	NO_ONE						:	0,		//return Main or another Scene
	VIDEO_BUTTON				:	1,
	VOICE_BUTTON				:	2,
	ADD_BUTTON					:	3,
	IGNORE_BUTTON				:	4,	
	BLOCK_BUTTON				:	5,
	GO_CALL_BUTTON				:	6,
	END_CALL_BUTTON				:	7,
	POPUP_AND_SUB_LIST			:	8,		//select button & show sub Scene	ex) calling wnd, tool list
	MAX							:	9,

}

var CONTACT_BUTTON_MODE = { 
 
	NOTHING_TYPE				:	0,
	NORMAL_TYPE					:	1,		//video,voice
	ONLY_VOICE_CALL_TYPE		:	2,		//voice
	REQUEST_AUTH_TYPE			:	3,		//add, ignor, block
	LIVE_CALL_TYPE				:	4,		//go call, end call
}

function ContactFuncPopup () {

	//bg ground
	this.Frame			    = null,
	
	//buttons
	this.VideoButton	    = null,
	this.VoiceButton	    = null,
	this.AddButton		    = null,
	this.IgnoreButton		= null,
	this.BlockButton		= null,
	this.GoCallButton		= null,
	this.EndCallButton		= null,
	
	//for type & positon		
	this.CurContactName		= null;
	this.CurPosition		= -1;
		
	//for highlight
	this.LastHighlight			= CONTACT_BUTTON_HIGHLIGHT.NO_ONE;
	this.LastHighlightButton	= null;
	
	//for button mode	
	this.PrevButtonMode     = CONTACT_BUTTON_MODE.NOTHING_TYPE;
	this.ButtonMode			= CONTACT_BUTTON_MODE.NOTHING_TYPE;
		
	//flag
	this.flag_Focus		= false;
	this.Popup_mode		= null;
	this.CurSubScene	= null;
}

ContactFuncPopup.prototype.Create = function() {

	alert("ContactFuncPopup.Create()");
	
	this.Popup_mode	= false;
	this.CreateObject("contact");
}


ContactFuncPopup.prototype.CreateObject = function(Ename) {

	var Scene;
	
Scene = $.sfScene.get("ListMainContact");
	var This_ = Scene.list.FuncPopup;
	//contactButtons
	//contactVideoButton

    this.Frame = new CompBase();
    this.Frame.CreateBG(Ename + "Buttons");
    this.Frame.SetBGImage("");	
    
	//create video button
    this.VideoButton = new ButtonBase();
	this.VideoButton.Create(Ename + "VideoButton",BUTTON_BASE_TYPE.BG_FG_TEXT);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_NORMAL_BG);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_HIGHLIGHT_BG);	
	this.VideoButton.SetBgImage(BUTTON_BASE_STATE.SELECT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_SELECT_BG);
    this.VideoButton.SetBgImage(BUTTON_BASE_STATE.DIM,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_DIM_BG);
    this.VideoButton.SetText(IDWS_MOIP_VIDEO_CALL);
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");		
	this.VideoButton.SetTextStyle(BUTTON_BASE_STATE.DIM,"cFuncButton_Text_Dim");		
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON);
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON);
	this.VideoButton.SetFgImage(BUTTON_BASE_STATE.DIM,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_ICON_DIM);
    this.VideoButton.SetID(CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON);
	this.VideoButton.SetOnClickCallbackFunc(function(){This_.ClickVideoButton();});
	this.VideoButton.SetOnRightClickCallbackFunc(function(){This_.ClickVideoButton();});

    this.VoiceButton = new ButtonBase();
    this.VoiceButton.Create(Ename + "VoiceButton",BUTTON_BASE_TYPE.BG_FG_TEXT);
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_NORMAL_BG);
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_HIGHLIGHT_BG);	
    this.VoiceButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VIDEO_BTN_SELECT_BG);
    this.VoiceButton.SetText(IDWS_MOIP_VOICE_CALL);
	this.VoiceButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.VoiceButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");
	this.VoiceButton.SetFgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VOICE_ICON);
    this.VoiceButton.SetFgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_VOICE_ICON);
	this.VoiceButton.SetID(CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON);
	this.VoiceButton.SetOnClickCallbackFunc(function(){This_.ClickVoiceButton();});
	this.VoiceButton.SetOnRightClickCallbackFunc(function(){This_.ClickVoiceButton();});
	
    this.AddButton = new ButtonBase();
    this.AddButton.Create(Ename + "AddButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.AddButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_NORMAL_BG);
    this.AddButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_HIGHLIGHT_BG);	
    this.AddButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_SELECT_BG);
    this.AddButton.SetText(SID_ADD_M_ADD);
	this.AddButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur"); 
	this.AddButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");   
	this.AddButton.SetID(CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON);
	this.AddButton.SetOnClickCallbackFunc(function(){This_.ClickAddButton();});
 	this.AddButton.SetOnRightClickCallbackFunc(function(){This_.ClickAddButton();});
 	
	this.IgnoreButton = new ButtonBase();
    this.IgnoreButton.Create(Ename + "IgnoreButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.IgnoreButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_NORMAL_BG);
    this.IgnoreButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_HIGHLIGHT_BG);	
    this.IgnoreButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_SELECT_BG);
    this.IgnoreButton.SetText(SID_IGNORE_KR_SHORT);
	this.IgnoreButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.IgnoreButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");	
    this.IgnoreButton.SetID(CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON);
	this.IgnoreButton.SetOnClickCallbackFunc(function(){This_.ClickIgnoreButton();});
	this.IgnoreButton.SetOnRightClickCallbackFunc(function(){This_.ClickIgnoreButton();});


	this.BlockButton = new ButtonBase();
    this.BlockButton.Create(Ename + "BlockButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.BlockButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_NORMAL_BG);
    this.BlockButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_HIGHLIGHT_BG);	
    this.BlockButton.SetBgImage(BUTTON_BASE_STATE.SELECT, g_Image.IMAGE_LIST_MAIN_CONTACT_LIST_ITEM_CAHT_BTN_SELECT_BG);
    this.BlockButton.SetText(IDWS_MOIP_SKYPE_BLOCK);
	this.BlockButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	this.BlockButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");	
    this.BlockButton.SetID(CONTACT_BUTTON_HIGHLIGHT.BLOCK_BUTTON);
	this.BlockButton.SetOnClickCallbackFunc(function(){This_.ClickBlockButton();});    
	this.BlockButton.SetOnRightClickCallbackFunc(function(){This_.ClickBlockButton();});    

    this.GoCallButton = new ButtonBase();
	this.GoCallButton.Create(Ename + "GoCallButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.GoCallButton.SetBgImage(BUTTON_BASE_STATE.NORMAL,g_Image.IMAGE_LIVE_CONTACT_GO_CALL_BTN_NORMAL);
    this.GoCallButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT,g_Image.IMAGE_LIVE_CONTACT_GO_CALL_BTN_HIGHLIGHT);	
    this.GoCallButton.SetText(TV_SID_GO_CALL);
	this.GoCallButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	//this.GoCallButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");		
    this.GoCallButton.SetID(CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON);    
	this.GoCallButton.SetOnClickCallbackFunc(function(){This_.ClickGoCallButton();});
	this.GoCallButton.SetOnRightClickCallbackFunc(function(){This_.ClickGoCallButton();});

    this.EndCallButton = new ButtonBase();
    this.EndCallButton.Create(Ename + "EndCallButton",BUTTON_BASE_TYPE.BG_TEXT);
    this.EndCallButton.SetBgImage(BUTTON_BASE_STATE.NORMAL, g_Image.IMAGE_LIVE_CONTACT_END_CALL_BTN_NORMAL);
    this.EndCallButton.SetBgImage(BUTTON_BASE_STATE.HIGHLIGHT, g_Image.IMAGE_LIVE_CONTACT_END_CALL_BTN_HIGHLIGHT);	
    this.EndCallButton.SetText(TV_SID_END_CALL);
	this.EndCallButton.SetTextStyle(BUTTON_BASE_STATE.NORMAL,"cFuncButton_Text_Blur");
	//this.EndCallButton.SetTextStyle(BUTTON_BASE_STATE.HIGHLIGHT,"cFuncButton_Text_Highlight");
	this.EndCallButton.SetID(CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON);
	this.EndCallButton.SetOnClickCallbackFunc(function(){This_.ClickEndCallButton();});
	this.EndCallButton.SetOnRightClickCallbackFunc(function(){This_.ClickEndCallButton();});

} 

ContactFuncPopup.prototype.Show = function() {

    this.Frame.Show();
} 

ContactFuncPopup.prototype.Hide = function() {

    this.Frame.Hide();   
    
}

ContactFuncPopup.prototype.SetCurPosition = function(nItemIndex) {

	alert("ContactFuncPopup.SetCurPosition(" + nItemIndex + ")");
	
	if(nItemIndex < 0 || nItemIndex > MaxNumOfMainItem){
		
		alert("Error nItemIndex is not valid!!!");
		this.CurPosition = 0;
	}
	else {
		this.CurPosition = nItemIndex;
	}
    
	this.MovePosition();

}

ContactFuncPopup.prototype.SetCurProperty = function(Name) {

	alert("ContactFuncPopup.SetCurProperty");

	this.CurContactName = Name;

	var CurButtonType;
	var Availability;
	
	//process exception..
	if(Name && Name.length > 0){
		
		Availability = parseInt(PluginAPIMgr.GetContactAvailabilityWithName(Name));		
	}
	else{
		
		Availability = null;
	}

	//TEMPCODE 	
	var Camera_State = PluginAPIMgr.GetCameraState();
	var IsInCall = ProcMgr.GetIsInCall();
		
//LIVE CALL
	if(IsInCall == true && this.CurPosition == 0)
	{
		alert("LIVE_CALL_TYPE");
		CurButtonType = CONTACT_BUTTON_MODE.LIVE_CALL_TYPE;
	}
	else if(Availability == null) 
	{
		alert("Availability is null");
		CurButtonType = CONTACT_BUTTON_MODE.NOTHING_TYPE;
	}	
	else if(Availability == ENUM_CONTACT_AVAILABILITY.UNKNOWN)
	{
		alert("REQUEST_AUTH_TYPE");
		CurButtonType = CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE;
	}
	else if(Availability == ENUM_CONTACT_AVAILABILITY.SKYPEOUT || 
		Availability == ENUM_CONTACT_AVAILABILITY.BLOCKED_SKYPEOUT || 
		Name == "echo123")
	{
		alert("ONLY_VOICE_CALL_TYPE");
		CurButtonType = CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE;
	}
	else
	{
		if(!(Camera_State == ENUM_CAM_STATE.CAM_STATE_DISCONNECTED || Camera_State == ENUM_CAM_STATE.CAM_STATE_CONNECTING))
		{			
			alert("NORMAL_TYPE");
			CurButtonType = CONTACT_BUTTON_MODE.NORMAL_TYPE;
		}	 		
		else 
		{
			alert("ONLY_VOICE_CALL_TYPE 2");
			CurButtonType = CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE;
		}		
	}

    this.PrevButtonMode = this.ButtonMode;
	this.ButtonMode = CurButtonType;
	
	this.InitButtons();

}
	
	
ContactFuncPopup.prototype.MovePosition = function() {

	var tempY = (this.CurPosition * NORMAL_ITEM_H);	
	var TopP = tempY + 'px';

	$("#"+ this.Frame.GetBGLayer().Obj).css('top', TopP );
	
}


ContactFuncPopup.prototype.InitButtons = function() {
    
	alert("ContactFuncPopup.InitButtons");
	
	if(this.PrevButtonMode == this.ButtonMode) {
		alert("Not Changed");
		return;
	}
		
	this.ReSetHighlight();

	if(this.ButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE)
	{	
		if(this.PrevButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE){
			
			this.VideoButton.blur();
		}
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE){

			this.AddButton.Hide();
			this.IgnoreButton.Hide();
			this.BlockButton.Hide();	
			
			this.VideoButton.Show();
			this.VoiceButton.Show();
		}
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE){
			
			this.GoCallButton.Hide();
			this.EndCallButton.Hide();

			this.VideoButton.Show();
			this.VoiceButton.Show();
						
		}	
		//CONTACT_BUTTON_MODE.NOTHING_TYPE
		else 
		{
			alert("First Initialized Buttons");
						
			this.VideoButton.Show();
			this.VoiceButton.Show();
		}
	}
	else if(this.ButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) 
	{

		if(this.PrevButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE){
			
			this.VideoButton.dim();
		}				
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE){
			
			this.AddButton.Hide();
			this.IgnoreButton.Hide();
			this.BlockButton.Hide();	
			
			this.VideoButton.dim();
						
			this.VideoButton.Show();					
			this.VoiceButton.Show();
			
		}
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE){
			
			this.GoCallButton.Hide();
			this.EndCallButton.Hide();

			this.VideoButton.dim();

			this.VideoButton.Show();
			this.VoiceButton.Show();
						
		}				
		else {
			
			this.VideoButton.dim();
						
			this.VideoButton.Show();					
			this.VoiceButton.Show();
		}				
	}

	else if(this.ButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE){
		
		//change blur state form dim state...
		if(this.PrevButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE){
			
			this.VoiceButton.Hide();
			this.VideoButton.Hide();
		}		
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) {
		
			this.VideoButton.blur();		

			this.VideoButton.Hide();
			this.VoiceButton.Hide();

		}	
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE){
			
			this.GoCallButton.Hide();
			this.EndCallButton.Hide();
		}
				
		this.AddButton.Show();
		this.IgnoreButton.Show();
		this.BlockButton.Show();	
					
	}
	else if(this.ButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE){

		if (this.PrevButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE) {
		
			this.VoiceButton.Hide();
			this.VideoButton.Hide();
			
		}	
		else if (this.PrevButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) {
		
			this.VideoButton.blur();
			
			this.VideoButton.Hide();
			this.VoiceButton.Hide();
		
		}
		else if (this.PrevButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE) {
		
			this.AddButton.Hide();
			this.IgnoreButton.Hide();
			this.BlockButton.Hide();
		
		}
		else{
			alert("First Initialized Buttons");			
		}

		this.GoCallButton.Show();
		this.EndCallButton.Show();		
	}
	else{
		alert("InitButtons() Error ??? ");

		if(this.PrevButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE){
			
			this.GoCallButton.Hide();
			this.EndCallButton.Hide();

		}	
		else if(this.PrevButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE){
			
			this.AddButton.Hide();
			this.IgnoreButton.Hide();
			this.BlockButton.Hide();	
			
		}
		else {

			this.VideoButton.blur();
			
			this.VideoButton.Hide();
			this.VoiceButton.Hide();
		
		}
	}
}


ContactFuncPopup.prototype.ReSetHighlight = function(){


	//unselect
    if(this.LastHighlightButton)
    {
        this.LastHighlightButton.blur();
    }
	
	//reset lighlight
	this.LastHighlight			= CONTACT_BUTTON_HIGHLIGHT.NO_ONE;
	this.LastHighlightButton	= null;
	
}


ContactFuncPopup.prototype.Highlight = function(){

	alert("ContactFuncPopup.Highlight");

	//1. move contact with Focus
	if(this.flag_Focus){
		
		//initialize highlight
		if(this.ButtonMode != this.PrevButtonMode){
				
			this.InitializeHighlight();				
		}		
	}
	//2. return to previous focus
    else if(this.LastHighlightButton && this.LastHighlightButton.GetState() == BUTTON_BASE_STATE.SELECT)
    {
		//check CONTACT_BUTTON_HIGHLIGHT.SELECT_POPUP_AND_SUB_LIST		
        this.LastHighlightButton.highlight();
        this.LastHighlight = this.LastHighlightButton.GetID();
    }
	else if(this.LastHighlightButton){ // current sate is NORMAL because this.Blur();
		
		this.LastHighlightButton.highlight();
		this.LastHighlight = this.LastHighlightButton.GetID();
	}
	//3. first going  	
    else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.NO_ONE){
		
          this.InitializeHighlight();     
    }
	   	
	this.flag_Focus = true;
	this.CurSubScene = null;
}

ContactFuncPopup.prototype.Blur = function(){	
	alert("ContactFuncPopup.Blur");	
	
	//check case at return scene
	if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST){
		
		this.LastHighlightButton.select();
	}
	//return main 
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.NO_ONE){
		
		//highlight button change to blur
		if(this.LastHighlightButton){			
		    this.LastHighlightButton.blur();
			this.LastHighlightButton = null;			
		}
	}
	//case: Popup, to return here!!! 	
	else if(this.LastHighlightButton){			
	    this.LastHighlightButton.blur();			
	}	

	this.flag_Focus = false;
	
}


ContactFuncPopup.prototype.InitializeHighlight = function(){

					
	alert("InitializeHighlight");
	
    if(this.ButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE ||
		this.ButtonMode == CONTACT_BUTTON_MODE.NO_CHAT_TYPE)
    {
        this.VideoButton.highlight();
        this.LastHighlightButton = this.VideoButton;
        this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON;                     
    }
    else if(this.ButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE)
    {
        this.VoiceButton.highlight();
        this.LastHighlightButton = this.VoiceButton;
        this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON;        
    }
    else if(this.ButtonMode == CONTACT_BUTTON_MODE.REQUEST_AUTH_TYPE)
    {
        this.AddButton.highlight();
        this.LastHighlightButton = this.AddButton;
        this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON;			
    }		
    else if(this.ButtonMode == CONTACT_BUTTON_MODE.LIVE_CALL_TYPE)
    {
        this.GoCallButton.highlight();
        this.LastHighlightButton = this.GoCallButton;
        this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON;			
    }
}

ContactFuncPopup.prototype.KeyProcess = function (keyCode) {
	
	alert("ContactFuncPopup.KeyProcess");
	switch (keyCode) {

		case $.sfKey.LEFT:
			alert("KEY_LEFT");
			this.processLeftKey();
			break;		
			
		case $.sfKey.RIGHT:
			alert("KEY_RIGHT");
			this.processRightKey();
			break;
			
		case $.sfKey.ENTER:
			alert("KEY_ENTER");
			this.processEnterKey();
			break;
			
		case $.sfKey.TOOLS:
			alert("KEY_TOOLS");
			this.processToolKey();
			break;
			
		case $.sfKey.RETURN:
			alert("KEY_RETURN");
			$.sfKey.block(event);
			this.processReturnKey();			
			break;
			
		case $.sfKey.EXIT:
			alert("KEY_EXIT");								
			this.processExitKey();
			$.sfKey.block(event);
			break;
            
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
            
        default:
            ProcMgr.processBlockKey(keyCode);
            break;  
				
	}
	
}

ContactFuncPopup.prototype.processLeftKey = function() {
    
	if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON
        || this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON
		|| this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON) { 
		
			this.processReturnKey();
					
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON) {
	
		if(this.ButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE)
		{
			this.processReturnKey();
		}
		else {
			this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON;
			
			this.VideoButton.highlight();
			this.LastHighlightButton = this.VideoButton;
			
			this.VoiceButton.blur();			
		}
				
				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON;
				
		this.AddButton.highlight();
		this.LastHighlightButton = this.AddButton;
		
		this.IgnoreButton.blur();
				
	} 
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.BLOCK_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON;
			
		this.IgnoreButton.highlight();
		this.LastHighlightButton = this.IgnoreButton;
		
		this.BlockButton.blur();
				
	}  	   	   
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON;
			
		this.GoCallButton.highlight();
		this.LastHighlightButton = this.GoCallButton;
		
		this.EndCallButton.blur();
				
	}
	    
}

ContactFuncPopup.prototype.processRightKey = function() {
    
    //alert("ContactFuncPopup.processRightKey");
    
	if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON) {
		
		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON;
		
		this.VideoButton.blur();		
		this.VoiceButton.highlight();
		
		this.LastHighlightButton = this.VoiceButton;
				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON) {
		//Nothing
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON;
			
		this.IgnoreButton.highlight();
		this.LastHighlightButton = this.IgnoreButton;
		
		this.AddButton.blur();
				
	}     
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.BLOCK_BUTTON;
			
		this.BlockButton.highlight();
		this.LastHighlightButton = this.BlockButton;
		
		this.IgnoreButton.blur();
				
	}  	   
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON) {
		//Nothing
	}     
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON) {

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON;
			
		this.EndCallButton.highlight();
		this.LastHighlightButton = this.EndCallButton;
		
		this.GoCallButton.blur();
				
	}
    else{
        alert("Nothins else");        
    }
	
}

ContactFuncPopup.prototype.processEnterKey = function() {
     
	//TEMPCODE
	var IsInCall = ProcMgr.GetIsInCall();	
	var ReturnScene = $.sfScene.get('ListMainContact');

	
	if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON) {		

ReturnScene.Deactivation();

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;	
		ProcMgr.CreateCall(this.CurContactName ,1);									
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON) {
						
ReturnScene.Deactivation();

		//TEMPCODE:		
		if (this.ButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) {
			
			ProcMgr.CreateCall( this.CurContactName ,0);
		}
		else
		{																
				if(IsInCall == true)
				{
					//create call directlry
					ProcMgr.CreateCall( this.CurContactName ,0);
				}
				else
				{
					this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;
					StateMgr.Show_ContactPhoneNumberList('ListMainContact',this.CurPosition,this.CurContactName);	
				}
			this.CurSubScene = 'ListMainContactPhoneNumberList';

		}
	
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON) {
				
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.AuthorizeContact(this.CurContactName);
		}				
				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON) {

		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.IgnoreAuthReqContact(this.CurContactName);
		}
				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.BLOCK_BUTTON) {
			
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.BlockAuthReqContact(this.CurContactName);
		}				
				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON) {

		ProcMgr.GoCall();				
	}
	else if(this.LastHighlight == CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON) {
			
		ProcMgr.DisconnectCall();		
	}
}


ContactFuncPopup.prototype.processReturnKey = function() {
		
		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.NO_ONE;
		WndMgr.ReturnSubToMain();	
}

ContactFuncPopup.prototype.processExitKey = function() {
		
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.NO_ONE;
	StateMgr.Start_Exit_State(false);	
}


ContactFuncPopup.prototype.processToolKey = function() {

	var IsInCall = ProcMgr.GetIsInCall();
	
	if(IsInCall){
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL_IN_CONTACT_LIST);
	}
	else{

		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;	

		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.CONTACT_LIST);	
	}
    
}

ContactFuncPopup.prototype.HideSubScene = function(){
	
	if(this.CurSubScene){
		$.sfScene.hide(this.CurSubScene); 
	}   	
}


ContactFuncPopup.prototype.MoveToVideoCallBtn = function(){
	
	alert("ContactFuncPopup.MoveToVideoCallBtn");
		
	if(this.ButtonMode == CONTACT_BUTTON_MODE.NORMAL_TYPE)
	{
		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VIDEO_BUTTON;
		this.VoiceButton.blur();
		this.LastHighlightButton = this.VideoButton;		
	}
	else
	{
		alert("ButtonMode has no video button");
	}

}

ContactFuncPopup.prototype.MoveToChatBtn = function(){
	
	alert("ContactFuncPopup.MoveToChatBtn");

}

ContactFuncPopup.prototype.ClickVideoButton = function(){
	alert("ContactFuncPopup.ClickVideoButton");	
	
	var ReturnScene = $.sfScene.get('ListMainContact');
	ReturnScene.Deactivation();

    if(this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;			
	}	
		
	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
	
	this.LastHighlightButton = this.VideoButton;
	this.VideoButton.highlight();	

	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;
	ProcMgr.CreateCall(this.CurContactName ,1);	
}


ContactFuncPopup.prototype.ClickVoiceButton = function(){
	alert("ContactFuncPopup.ClickVoiceButton");	

	var ReturnScene = $.sfScene.get('ListMainContact');
	ReturnScene.Deactivation();

    if(this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;			
	}	

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
	
	this.LastHighlightButton = this.VoiceButton;
	this.VoiceButton.highlight();
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.VOICE_BUTTON;

	if (this.ButtonMode == CONTACT_BUTTON_MODE.ONLY_VOICE_CALL_TYPE) {
		
		ProcMgr.CreateCall( this.CurContactName ,0);
	}
	else{
														
		this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.POPUP_AND_SUB_LIST;				
		StateMgr.Show_ContactPhoneNumberList('ListMainContact',this.CurPosition,this.CurContactName);	
		
		this.CurSubScene = 'ListMainContactPhoneNumberList';
	}
}

ContactFuncPopup.prototype.ClickChatButton = function(){
	alert("ContactFuncPopup.ClickChatButton");	

}

ContactFuncPopup.prototype.ClickAddButton = function(){
	alert("ContactFuncPopup.ClickAddButton");	

    if(this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;		
	}

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
		
	this.LastHighlightButton = this.AddButton;
	this.AddButton.highlight();	
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.ADD_BUTTON; 

	if(this.Popup_mode == false)
	{
	
		var IsInCall = ProcMgr.GetIsInCall();	
	
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.AuthorizeContact(this.CurContactName);
		}	
	}
}

ContactFuncPopup.prototype.ClickIgnoreButton = function(){
	alert("ContactFuncPopup.ClickIgnoreButton");	

    if(this.Popup_mode == false && this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;		
	}

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
		
	this.LastHighlightButton = this.IgnoreButton;
	this.IgnoreButton.highlight();
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.IGNORE_BUTTON; 

	if(this.Popup_mode == false)
	{
		var IsInCall = ProcMgr.GetIsInCall();
			
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.IgnoreAuthReqContact(this.CurContactName);
		}
	}
}

ContactFuncPopup.prototype.ClickBlockButton = function(){
	alert("ContactFuncPopup.ClickBlockButton");	


    if(this.Popup_mode == false && this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;		
	}

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
		
	this.LastHighlightButton = this.BlockButton;
	this.BlockButton.highlight();	
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.BLOCK_BUTTON; 

	if(this.Popup_mode == false)
	{
		var IsInCall = ProcMgr.GetIsInCall();
			
		if(IsInCall){
			WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_IN_CONTACT_LIST);
		}
		else{
			ProcMgr.BlockAuthReqContact(this.CurContactName);
		}		
	}
}


ContactFuncPopup.prototype.ClickGoCallButton = function(){
	alert("ContactFuncPopup.ClickGoCallButton");	

    if(this.Popup_mode == false && this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;		
	}

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
		
	this.LastHighlightButton = this.GoCallButton;
	this.GoCallButton.highlight();	
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.GO_CALL_BUTTON; 

	ProcMgr.GoCall();
}

ContactFuncPopup.prototype.ClickEndCallButton = function(){
	alert("ContactFuncPopup.ClickEndCallButton");	

    if(this.Popup_mode == false && this.flag_Focus == false)
	{   
		$.sfScene.get('ListMain').selectOnCurrHighlight();
		this.flag_Focus = true;
		this.CurSubScene = null;		
	}

	if(this.LastHighlightButton)
	{
		this.LastHighlightButton.blur();
	}
		
	this.LastHighlightButton = this.EndCallButton;
	this.EndCallButton.highlight();	
	this.LastHighlight = CONTACT_BUTTON_HIGHLIGHT.END_CALL_BUTTON; 

	ProcMgr.DisconnectCall();
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function pContactFuncPopup () {

	ContactFuncPopup.call(this);
}

pContactFuncPopup.prototype = new ContactFuncPopup(); 

pContactFuncPopup.prototype.Create = function(){

	alert("pContactFuncPopup.Create()");
	
	this.Popup_mode = true;
	this.CreateObject("pContact");
	
}

