/*
var DEFAULT_SEARCH_DATA = { 
 
    SkypName		:   " ",
    FullName		:   " ",
    Country			:   " ",
    AvatarPath		:   " "
}

*/

function CountryItem () {
 
 	this.NameLayerIndex		= -1;
    this.PrefixLayerIndex		= -1;	
	this.FlagLayerIndex		= -1;
	
	this.eID	= null;	

    this.NameStyle				= new Array(ITEM_STATE.MAX);   
    this.PrefixStyle			= new Array(ITEM_STATE.MAX);
		
    ListItem.call(this);
}

CountryItem.prototype = new ListItem(); 


CountryItem.prototype.Create = function(eName) {
    
    alert("CountryItem.Create()");

    this.CreateBG(eName); 
	this.CreateName(eName);	
    this.CreatePrefix(eName);	
    this.CreateFlag(eName);		
	
	this.eID = eName;
	
	this.SetBgImage(ITEM_STATE.NORMAL,' ');
	//this.SetBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_CALL_COUNTR_FLAG_LIST_ITEM_HIGHLIGHT_BG);	
		
	this.NameStyle[ITEM_STATE.NORMAL] = "cFlagList_Name_Text_Normal";
	this.NameStyle[ITEM_STATE.HIGHLIGHT] = "cFlagList_Name_Text_Highlight";	

	this.PrefixStyle[ITEM_STATE.NORMAL] = "cFlagList_Prefix_Text_Normal";
	this.PrefixStyle[ITEM_STATE.HIGHLIGHT] = "cFlagList_Prefix_Text_Highlight";	

}

CountryItem.prototype.CreateName = function(eRootName) {

    var ElementStr = eRootName + "Name";
    
    this.NameLayerIndex = this.LayerArray.length;  
    this.AddTextLayer(ElementStr);
             
}

CountryItem.prototype.CreatePrefix = function(eRootName) {

    var ElementStr = eRootName + "Prefix";

    this.PrefixLayerIndex = this.LayerArray.length;    
    this.AddTextLayer(ElementStr);    
  
}

CountryItem.prototype.CreateFlag = function(eRootName) {

    var ElementStr = eRootName + "Flag";
	
    this.FlagLayerIndex = this.LayerArray.length;    
    this.AddImageLayer(ElementStr);    
  
}


CountryItem.prototype.SetContainerStyle = function(type){
 
 	var Scene;
	var LeftPostionOfPrefix;
	var FlagStyle;
	
	switch(type) {
		
		case FLAG_LIST_TYPE.LIST_MAIN_CALL:
			Scene = "_ListMainCall";
			LeftPostionOfPrefix = "180px";
			FlagStyle = "cFlagList_Flag_ListMainCall";
			break;
			
		default:
			Scene = "_AddPhoneNumber";
			LeftPostionOfPrefix = "160px";
			FlagStyle = "cFlagList_Flag_AddPhoneNumber";			
			break;
			
	}
	
	this.LayerArray[this.BGLayerIndex].SetStyle(this.eID + Scene);	
	this.LayerArray[this.FlagLayerIndex].SetStyle(FlagStyle);
	$("#"+this.LayerArray[this.PrefixLayerIndex].Obj).css('left', LeftPostionOfPrefix);

}


CountryItem.prototype.SetItem = function(DataObject) {
	
	alert("CountryItem.SetItem()");

	var Name = DataObject.Name;	
	var Prefix = DataObject.Prefix;
	var Flag = DataObject.FlagImg;
	
	this.LayerArray[this.NameLayerIndex].SetText(Name);	
	this.LayerArray[this.PrefixLayerIndex].SetText(Prefix);
	this.LayerArray[this.FlagLayerIndex].SetImage(Flag);
	
	this.ExistData = true;
}


CountryItem.prototype.Normal = function() {
	
    this.State = ITEM_STATE.NORMAL;
	this.ChangeBG();
    this.LayerArray[this.NameLayerIndex].SetStyle(this.NameStyle[ITEM_STATE.NORMAL]);
    this.LayerArray[this.PrefixLayerIndex].SetStyle(this.PrefixStyle[ITEM_STATE.NORMAL]);	
}

CountryItem.prototype.Highlight = function() {
	
	this.State = ITEM_STATE.HIGHLIGHT;
	this.ChangeBG();
    this.LayerArray[this.NameLayerIndex].SetStyle(this.NameStyle[ITEM_STATE.HIGHLIGHT]);
	this.LayerArray[this.PrefixLayerIndex].SetStyle(this.PrefixStyle[ITEM_STATE.HIGHLIGHT]);
    	
	
}
