
var MaxNumOfCountryItem = 5;

function CountryList() {
								
    ScrollList.call(this);
}

CountryList.prototype = new ScrollList(); 

CountryList.prototype.Create = function() {

    alert("CountryList.Create");

	//Set List 
	this.CreateBG("CFlagList");    
	this.SetNumOfVisibleItem(MaxNumOfCountryItem);
	this.SetItemClass(CountryItem);
	this.CreateScrBar("CFlagListScrollBar");
	this.SetScrBarImage(g_Image.IMAGE_SIGNUP_COUNTRY_LIST_SCROLLBAR_BG,
		g_Image.IMAGE_BLOCK_SCROLLBAR_TOP,
		g_Image.IMAGE_BLOCK_SCROLLBAR_CENTER,
		g_Image.IMAGE_BLOCK_SCROLLBAR_BOTTOM);	
			
	this.InitData();

	var Scene = $.sfScene.get('CountryFlagList');
	var This_ = Scene.FlagList;

	//Imae Lable
	this.UpArrow = new CompBase(); 
	this.UpArrow.CreateBG("CFlagListUpArrow");
	this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
	this.UpArrow.SetOnClickCallbackFunc(function(){This_.PreviousPage();});	
	this.UpArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_SEL);});
	this.UpArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.UP_NOR);});			

	this.DownArrow = new CompBase(); 
	this.DownArrow.CreateBG("CFlagListDownArrow");
	this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
	this.DownArrow.SetOnClickCallbackFunc(function(){This_.NextPage();});	
	this.DownArrow.SetOnMouseOverCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_SEL);});
	this.DownArrow.SetOnMouseOutCallbackFunc(function(){This_.ChangeArrow(ARROW_TYPE.DOWN_NOR);});		

	
}

/*

CountryList.prototype.GetCurSkypeName = function(){

	return this.ItemArray[this.CurrentItemIndex].GetSkypeName();
	
}

*/

CountryList.prototype.InitData = function(){

	alert("CountryList.InitData ");	
	
	var NumOfCountryList = g_Data.GetNumOfCountry();
	var tempData = new Array(NumOfCountryList);  
		
	for (var i=0; i < NumOfCountryList; i++) {
						
		tempData[i] = new CountryData();
		tempData[i].SetData(g_Data.DATA_COUNTRY_NAME_ARRAY[i],g_Data.DATA_COUNTRY_PREFIX_ARRAY[i],g_Data.DATA_COUNTRY_CODE_ARRAY[i]);		
		this.AddData(tempData[i]);					
	}		

	this.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.SetClickEventAvailable(WndMgr.MouseClickEnable);
			
	this.ShowItem();
	this.SetScrBarPosition(210,0,5);

}

CountryList.prototype.SetStyle = function(type){

	alert("CountryList.SetStyle(" + type  +")");	
	
	var HighlightImg;

	if(type == FLAG_LIST_TYPE.LIST_MAIN_CALL){	
		this.SetScrBarStyle('CFlagListScrollBar_ListMainCall');
		HighlightImg = g_Image.IMAGE_LIST_MAIN_CALL_COUNTR_FLAG_LIST_ITEM_HIGHLIGHT_BG;	
		
		this.UpArrow.SetStyle(0,'CFlagListUpArrow_ListMainCall');
		this.DownArrow.SetStyle(0,'CFlagListDownArrow_ListMainCall');
	}
	else {
		this.SetScrBarStyle('CFlagListScrollBar_AddPhoneNumber');
		HighlightImg = g_Image.IMAGE_SIGNUP_COUNTRY_LIST_ITEM_HIGHLIGHT;
		
		this.UpArrow.SetStyle(0,'CFlagListUpArrow_AddPhoneNumber');
		this.DownArrow.SetStyle(0,'CFlagListDownArrow_AddPhoneNumber');
		
	}
	
	for (var i=0; i< MaxNumOfCountryItem ; i++) {
		
		this.ItemArray[i].SetContainerStyle(type);
		this.ItemArray[i].SetBgImage(ITEM_STATE.HIGHLIGHT,HighlightImg);
	}
	
}

CountryList.prototype.onClickEventFunc1 = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.ProcessClick(0);	
}

CountryList.prototype.onClickEventFunc2 = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.ProcessClick(1);	
}

CountryList.prototype.onClickEventFunc3 = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.ProcessClick(2);	
}

CountryList.prototype.onClickEventFunc4 = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.ProcessClick(3);	
}

CountryList.prototype.onClickEventFunc5 = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.ProcessClick(4);	
}

/*
CountryList.prototype.PrevScroll = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.FlagList.PreviousPage();
}

CountryList.prototype.NextScroll = function()
{
	var OriginalScene = $.sfScene.get("CountryFlagList");	
	OriginalScene.FlagList.NextPage();

}
*/

CountryList.prototype.ChangeArrow = function(Type)
{
	alert("CountryList.ChangeArrow");

	switch(Type)
	{
		case ARROW_TYPE.UP_NOR:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_NOR);
			break;
			
		case ARROW_TYPE.UP_SEL:
			this.UpArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_UP_SEL);
			break;

		case ARROW_TYPE.DOWN_NOR:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_NOR);
			break;
			
		case ARROW_TYPE.DOWN_SEL:
			this.DownArrow.SetBGImage(g_Image.IMAGE_LIST_MAIN_ARROW_DOWN_SEL);
			break;		
	}
}
