/**
 * @author Samsung
 */

 function View(id){
 		this.viewObj=id; /*= document.getElementById(id);*/
        
        this.currentHighlight =null;
        this.currentSelected =null;
       // this.currentHighlight= new Item();
        this.anchor=null;
        
        this.flag_ShowState=false;
        this.flag_Focus=false;
        
        this.helpBar = null;
        
    	this.onClickCallbackFunc = null;
		this.flagClickEnable = false;        
}

View.prototype.show = function(){
     
     this.flag_ShowState=this;
     if(this.helpBar)
     {
        this.helpBar.visibleObj();
     }
}


View.prototype.hide = function(){
	 this.viewObj.style.display = "none";
     this.flag_ShowState=false;
     
      if(this.helpBar)
     {
        this.helpBar.hiddenObj();
     }
}

View.prototype.setAnchor= function(id){

    this.anchor =document.getElementById(id);    
 
}

View.prototype.SetBgImage=function(bgImage){
    //this.viewObj.style.backgroundImage ="url("+bgImage+")";
    $("#"+ this.viewObj).css('background-image', 'url('+bgImage+')');
}

View.prototype.setCurrenHighlight=function(obj){

    if( this.currentHighlight !=obj && this.currentHighlight !=null)
    {
        this.currentHighlight.blur();
    }
    this.currentHighlight=obj;
    
    if(this.currentHighlight)
    {
        this.currentHighlight.highlight();
    }
    
}

View.prototype.setCurrenHighlightObj = function(obj){
	
	this.currentHighlight=obj;
}


View.prototype.getCurrentHighlight=function(){

    return this.currentHighlight;
}

View.prototype.setCurrentSelect = function(obj){
    if(obj == this.currentHighlight)
    {
        this.currentHighlight.select();
        this.currentSelected=obj;
    }
}

View.prototype.getCurrentSelected=function(){

    return this.currentSelected;
}

View.prototype.focus= function(){
	alert("##### View.prototype.focus");
	 this.anchor.focus();
     this.flag_Focus=true;
}

View.prototype.blur= function(){
	alert("##### View.prototype.blur");
	 this.anchor.blur();
     this.flag_Focus=false;
}

View.prototype.flagFocus= function(){
    return this.flag_Focus;
}

View.prototype.showState= function(){
    return this.flag_ShowState;
}

View.prototype._onfocus=function(){

    alert("##### View.prototype._onfocus");
}

View.prototype._onblur=function(){

    alert("##### View.prototype._onblur");
}

View.prototype.registHelpBar= function(obj){
    if(obj)
    {
           this.helpBar = obj;
           this.helpBar.visibleObj();
    }
    
}

View.prototype.changeHelpBar= function(obj){

    if(this.helpBar == obj)
    {
        return;
    }
    
    if(this.helpBar != null)
    {
           this.helpBar.hiddenObj();
    }
    
     if(obj)
    {
           this.helpBar = obj;
           this.helpBar.visibleObj();
    } 
}

View.prototype.visibleObj=function()
{
    //alert("Button.prototype.visibleObj()");
    $("#"+this.viewObj).css("visibility","visible");

}

View.prototype.hiddenObj=function(){
    //alert("Button.prototype.hiddenObj()");
    $("#"+this.viewObj).css("visibility","hidden");
}

View.prototype.SetOnClickCallbackFunc = function(func)
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	alert("View.SetOnClickCallbackFunc() set on image_layer");

	this.onClickCallbackFunc = func;
	//this.EnableOnClick();			
}

View.prototype.EnableOnClick = function()
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.flagClickEnable == false)
	{
		var object = this.viewObj;
		var this_ = this;
		document.getElementById(object).onclick = function(){this_.onClickCallbackFunc(this_);};
		this.flagClickEnable = true;
		//$("#"+this.image_layer.GetObjectId()).css({'cursor' : 'pointer'});	
	}
}

View.prototype.DisableOnClick = function()
{
	if(WndMgr.MouseClickEnable==false)
	{
		return;	
	}
	
	if(this.flagClickEnable == true)
	{
		var object = this.viewObj;
		document.getElementById(object).onclick = null;
		this.flagClickEnable = false;
		//$("#"+this.image_layer.GetObjectId()).css({'cursor' : ''});	 
	}
}

