
function SceneCallEnding(options) {
	this.options = options;
    
    this.FlagEnding = false;
    this.FlagDropped= false;
     
    this.PopupCallbackFn = null;
    
    this.CallEndingView=null;
	this.CallEndingDim=null;
    
    this.PopupMsg = null;
    this.OkBtn = null;
   
    this.PopupTimer = null;

}

SceneCallEnding.prototype.initialize = function () {
	alert("SceneCallEnding.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneCallEnding.prototype.handleShow = function () {
	alert("SceneCallEnding.handleShow()");
	// this function will be called when the scene manager show this scene 

    //this.highlight(this.OkBtn);
	this.CallEndingDim.show();
    this.update();

}

SceneCallEnding.prototype.handleHide = function () {
	alert("SceneCallEnding.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.CallEndingDim.hide();

}

SceneCallEnding.prototype.handleFocus = function () {
	alert("SceneCallEnding.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneCallEnding.prototype.handleBlur = function () {
	alert("SceneCallEnding.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneCallEnding.prototype.handleKeyDown = function (keyCode) {
	alert("SceneCallEnding.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
		case $.sfKey.EXIT:
            $.sfKey.block(event);
			break;
            
       case 147:  //infolink
       case 261:  //contents
       case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCallEnding.prototype.create = function(){
    alert("SceneCallEnding.create()");
    this.CallEndingView = new View("CallEnding");
   	if(WndMgr.Bg_CallEnd != null)
	{
		this.CallEndingView.SetBgImage(WndMgr.Bg_CallEnd.src);
	}
	else
    {
		this.CallEndingView.SetBgImage(g_Image.IMAGE_CALL_ENDING_BG); 
	}   
	  
    this.CallEndingDim = new DimBg("CallEndingDim", "CallEnding"); 
	
    this.PopupMsg = new Label(null,"call_ending_message");
    this.PopupMsg.SetTextStyle("call_ending_message_style");
   // this.PopupMsg.SetText(IDWS_MOIP_SKYPE_SIGNIN);

    this.OkBtn = new Button();
    this.OkBtn.SetImageObjId("call_ending_btn");
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);	
    this.OkBtn.SetTextObjId("call_ending_btn_text");
    this.OkBtn.SetText(SID_OK_KR_YES);
	this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	//this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"common_btn_text_f19_normal_style");
    this.OkBtn.hiddenObj();
}

SceneCallEnding.prototype.highlight=function(obj)
{
    this.CallEndingView.setCurrenHighlight(obj);

}

SceneCallEnding.prototype.processEnterKey = function(){
    alert("SceneCallEnding.processEnterKey() ");
    
    var currentHighlight =  this.CallEndingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.OkBtn:

            break;
    }
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCallEnding.prototype.setFlagEnding = function(flag_ending)
{
    this.FlagEnding =  flag_ending;
}

SceneCallEnding.prototype.setFlagDropped = function(flag_dropped)
{
    this.FlagDropped =  flag_dropped;
}

SceneCallEnding.prototype.update = function()
{
    alert("SceneCallEnding.update() ");
   if(this.FlagEnding== true)
   {
        this.PopupMsg.SetText(IDWS_MOIP_SKYPE_CALL_ENDED);
   }
   else
   {
        if(this.FlagDropped==true)
        {
            this.PopupMsg.SetText(TV_SID_CALL_DROPPED);              
            this.FlagDropped = false;  //init
        }
        else
        {
           this.PopupMsg.SetText(IDWS_MOIP_SKYPE_CALL_ENDED);  
        }
   }
}










