function SceneCalling(options) {
	this.options = options;
    
    this.CallingView=null;
	this.CallingDim=null;
	
	this.CallingPageView = null;
	this.CallingFailPageView =null;

    this.CallMemberThumbnailLabel = null;
    this.CallMembertNameLabel = null;

    this.MyThumbnailLabel = null;
    this.MyNameLabel = null;

    this.CallMessageLabel = null;
	this.CallFailMessageLabel = null;
    this.CallStatusLabel = null;
    
    this.CancelBtn = null;
	this.OkBtn = null;
    
    this.CallingAnimation =null;
    this.CallingAnimation_1 =null;
    this.CallingAnimation_2=null;
    this.CallingAnimation_3=null;
    this.CallingAnimation_4 =null;
    this.CallingAnimation_5 =null;
    this.CallingAnimationList = new Array(5);
    
    this.FlagAnimation = false;
    this.CallingTimer = null;
    this.iCurrAniImage=0;

}

SceneCalling.prototype.initialize = function () {
	alert("SceneCalling.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneCalling.prototype.handleShow = function () {
	alert("SceneCalling.handleShow()");
	// this function will be called when the scene manager show this scene 

	this.CallingDim.show();
	this.update();
   
	this.FlagAnimation=true;
	this.startTimer();       
}

SceneCalling.prototype.handleHide = function () {
	alert("SceneCalling.handleHide()");
	// this function will be called when the scene manager hide this scene  
    this.CallingDim.hide();

    this.FlagAnimation=false;
	if(this.CallingTimer != null)
	{
		this.stopTimer();
	}
}

SceneCalling.prototype.handleFocus = function () {
	alert("SceneCalling.handleFocus()");
	// this function will be called when the scene manager focus this scene
     if(this.CancelBtn.GetFlagDim()== false)
    {
         this.highlight(this.CancelBtn);
    }
}

SceneCalling.prototype.handleBlur = function () {
	alert("SceneCalling.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    this.highlight(null);
}

SceneCalling.prototype.handleKeyDown = function (keyCode) {
	alert("SceneCalling.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
		
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

		case 147:  //infolink
		case 261:  //contents
		case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneCalling.prototype.create = function(){
    alert("SceneCalling.create()");
    this.CallingView = new View("Calling");
    this.CallingView.SetBgImage(WndMgr.Bg_Calling.src);
	
	this.CallingDim = new DimBg("CallingDim", "Calling"); 
	
	this.CallingPageView = new View("calling_page");
	
	this.CallingFailPageView = new View("calling_fail_page");
	this.CallingFailPageView.hiddenObj();
    
    this.CallMembertNameLabel = new Label(null,"calling_call_member_name");
    this.CallMembertNameLabel.SetTextStyle("calling_call_member_name_style");
    this.CallMembertNameLabel.SetReverseDisable(true);
    this.CallMembertNameLabel.SetIsPlainText(true);

    this.CallMemberThumbnailLabel= new Label("calling_call_member_thumbnail", null);
    this.CallMemberThumbnailLabel.SetBgImage(g_Image.IMAGE_CALLING_CALL_MEMBER_THUMBNAIL);
    this.CallMemberThumbnailLabel.AppendFgImage("calling_call_member_thumbnail_avata","3px","2px","69px","69px");
   
    this.MyThumbnailLabel= new Label("calling_my_thumbnail", null);
    this.MyThumbnailLabel.SetBgImage(g_Image.IMAGE_CALLING_MY_THUMBNAIL);
    this.MyThumbnailLabel.AppendFgImage("calling_my_thumbnail_avata","3px","2px","69px","69px");
    
    this.CallMessageLabel= new Label("calling_message", "calling_message_text");
    this.CallMessageLabel.SetBgImage(g_Image.IMAGE_CALLING_CALL_STATUS_BG);
    this.CallMessageLabel.SetTextStyle("calling_message_text_style");
   
    this.CallFailMessageLabel= new Label("calling_fail_message", "calling_fail_message_text");
    this.CallFailMessageLabel.SetBgImage(g_Image.IMAGE_CALLING_CALL_FAIL_MSG_BG);
	this.CallFailMessageLabel.SetIsTextInTable(true);
    this.CallFailMessageLabel.SetTextStyle("calling_message_text_style");
    
    this.CallStatusLabel= new Label(null, "calling_call_status_text");
    this.CallStatusLabel.SetTextStyle("calling_call_status_text_style");
    
    var this_ = $.sfScene.get("Calling");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.CancelBtn = new Button();
    this.CancelBtn.SetImageObjId("calling_cancel_btn");
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CALLING_BTN_NORMAL);
    this.CancelBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CALLING_BTN_NORMALFOCUS);
	this.CancelBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CALLING_BTN_DIM);	
    this.CancelBtn.SetTextObjId("calling_cancel_btn_text");
    this.CancelBtn.SetText(SID_CANCEL);
	this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	//this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"common_btn_text_f17_highlight_style");	
    this.CancelBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
	this.CancelBtn.SetOnClickCallbackFunc(clickCF);
	
	this.OkBtn = new Button();
    this.OkBtn.SetImageObjId("calling_ok_btn");
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_CALLING_BTN_NORMAL);
    this.OkBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_CALLING_BTN_NORMALFOCUS);
	this.OkBtn.SetBgImage(BtnImgIndex.BTN_DIM_IMG, g_Image.IMAGE_CALLING_BTN_DIM);	
    this.OkBtn.SetTextObjId("calling_ok_btn_text");
    this.OkBtn.SetText(SID_OK_KR_YES);
	this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f17_normal_style");
	//this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"common_btn_text_f17_highlight_style");	
    this.OkBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_DIM_STYLE,"common_btn_text_f17_dim_style");
	this.OkBtn.SetOnClickCallbackFunc(clickCF);
	
    this.CallingAnimation= new Label("calling_animation", null);
    
    var a=0;
    for( a=0; a < this.CallingAnimationList.length; a++)
    {
        this.CallingAnimationList[a] = new Label("calling_animation_"+String((this.CallingAnimationList.length-1)-a), null); // move to left
        this.CallingAnimationList[a].SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_NORMAL);
    }   
}

SceneCalling.prototype.highlight=function(obj)
{
    this.CallingView.setCurrenHighlight(obj);

}

SceneCalling.prototype.update = function()
{
    this.MyThumbnailLabel.SetFgImage(PluginAPIMgr.GetMyAvataImage());
    
    this.CallMembertNameLabel.SetText(g_Data.DATA_CREATE_CALL_INPUT_INFO.callee_name); 
    this.CallMemberThumbnailLabel.SetFgImage(PluginAPIMgr.GetContactAvataImage(g_Data.DATA_CREATE_CALL_INPUT_INFO.callee_name));
    
    if(WndMgr.isCallingFail ==  true)
    {
        this.CallStatusLabel.SetText(IDWS_MOIP_SKYPE_FAILED);
        this.CancelBtn.SetFlagDim(true);
    }
    else
    {
        this.CallStatusLabel.SetText(TV_SID_CALLING);
         if(this.CancelBtn.GetFlagDim()== true)
        {
            this.CancelBtn.SetFlagDim(false);
        }
    }
    
    WndMgr.isCallingFail =  false; //init
    
    this.CallMessageLabel.SetText("");
	this.CallFailMessageLabel.SetText("");
    
    var a=0;
    for( a=0; a < this.CallingAnimationList.length; a++)
    {
        this.CallingAnimationList[a].SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_NORMAL);
    }
    this.iCurrAniImage=0;
    this.CallingAnimationList[this.iCurrAniImage].SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_FOCUS);
    
	this.CallingFailPageView.hiddenObj();
	this.CallingPageView.visibleObj();
}

SceneCalling.prototype.updateCallingStatus = function(call_status)
{
    this.CallStatusLabel.SetText(this.GetCallStatusString(call_status));
}

SceneCalling.prototype.updateCallingMessage = function(call_status)
{
    if(this.FlagAnimation==true)
    {
		this.FlagAnimation=false;
		this.stopTimer();
    }
    
    this.CallStatusLabel.SetText("");
    this.CallFailMessageLabel.SetText(this.GetCallStatusString(call_status));

	this.highlight(this.OkBtn);

	this.CallingPageView.hiddenObj();
	this.CallingFailPageView.visibleObj();
	
}

SceneCalling.prototype.updateCallingButton= function(flag_dim)
{
    if(flag_dim == true)
    {
         if(this.CancelBtn.GetFlagDim()== false)
        {
			var currentHighlight =  this.CallingView.getCurrentHighlight();
			if(currentHighlight==this.CancelBtn)
			{
				this.highlight(null);
			}            
            this.CancelBtn.SetFlagDim(true);
        }
    }
}

SceneCalling.prototype.startTimer = function()
{  
	alert("SceneCalling.startTimer() ");
	
	var scene = $.sfScene.get('Calling');
	
	this.CallingTimer=setInterval("timerCF()", 500);
	timerCF = function() { scene.CallingTimerCallback();}
}

SceneCalling.prototype.stopTimer = function()
{
    alert("SceneCalling.stopTimer() ");
    
	clearInterval( this.CallingTimer);
    this.CallingTimer=null;
    this.iCurrAniImage =0;
}

SceneCalling.prototype.CallingTimerCallback = function()
{
     this.iCurrAniImage++;
     
    if(this.iCurrAniImage >= this.CallingAnimationList.length)
    {
        this.iCurrAniImage = 0;
    }   
    
    var a=0;
    for( a=0; a < this.CallingAnimationList.length; a++)
    {
        this.CallingAnimationList[a].SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_NORMAL);
    }
    this.CallingAnimationList[this.iCurrAniImage].SetBgImage(g_Image.IMAGE_CALLING_ANIMATION_FOCUS);
	
	
	if(ProcMgr.callEndWaitingTimer ==true)
	{
		this.stopTimer();
	}

}

SceneCalling.prototype.GetCallStatusString = function(call_status)
{
	switch(call_status)
    {
	    case ENUM_CALL_STATUS.UNPLACED : 
	        return "UNPLACED";
	        break;
	    case ENUM_CALL_STATUS.ROUTING : 
	        return "ROUTING";
	        break;
	    case ENUM_CALL_STATUS.CANCELLED : 
	        return IDWS_MOIP_CANCELLED;
	        break;
	    case ENUM_CALL_STATUS.FAILED :
	        return IDWS_MOIP_SKYPE_FAILED ;
	        break;
	    case ENUM_CALL_STATUS.EARLYMEDIA :
	        return "EARLYMEDIA";
	        break;
	    case ENUM_CALL_STATUS.RINGING_OUT :
	        return  IDWS_MOIP_SKYPE_RINGING;
	        break;
	    case ENUM_CALL_STATUS.RINGING_IN : 
	        return  IDWS_MOIP_SKYPE_RINGING;
	        break;
	    case ENUM_CALL_STATUS.INPROGRESS : 
	        return "INPROGRESS";
	        break;
	    case ENUM_CALL_STATUS.LOCALHOLD : 
	        return "LOCALHOLD";
	        break;
	    case ENUM_CALL_STATUS.REMOTEHOLD : 
	        return "REMOTEHOLD";
	        break;
	    case ENUM_CALL_STATUS.FINISHED : 
	        return IDWS_MOIP_SKYPE_FINISHED;
	        break;
	    case ENUM_CALL_STATUS.MISSED : 
	        return "MISSED";
	        break;
	    case ENUM_CALL_STATUS. REFUSED : 
	        return IDWS_MOIP_SKYPE_BUSY;
	        break;
	    case ENUM_CALL_STATUS.BUSY : 
	        return IDWS_MOIP_SKYPE_BUSY;
	        break;
	    case ENUM_CALL_STATUS.DROPPED : 
	        return "DROPPED";
	        break;
	    case ENUM_CALL_STATUS.VM_BUFFERING_GREETING :
	        return "VM_BUFFERING_GREETING";
	        break;
	    case ENUM_CALL_STATUS.VM_PLAYING_GREETING :
	        return "VM_PLAYING_GREETING";
	        break;
	    case ENUM_CALL_STATUS.VM_RECORDING :
	        return "VM_RECORDING";
	        break;
	    case ENUM_CALL_STATUS.VM_UPLOADING : 
	        return "VM_UPLOADING";
	        break;
	    case ENUM_CALL_STATUS.VM_SENT : 
	        return "VM_SENT";
	        break;
	    case ENUM_CALL_STATUS.VM_CANCELLED : 
	        return "VM_CANCELLED";
	        break;
	    case ENUM_CALL_STATUS.VM_FAILED : 
	        return "VM_FAILED";
	        break;
	    case ENUM_CALL_STATUS.TRANSFERRING : 
	        return "TRANSFERRING";
	        break;
	    case ENUM_CALL_STATUS.TRANSFERRED : 
	        return "TRANSFERRED";
	        break;
	        
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_1 :
	            return IDWS_MOIP_SKYPEOUT_FAIL24;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_2:
	                return IDWS_MOIP_SKYPEOUT_FAIL4;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_3 :
	                return IDWS_MOIP_SKYPEOUT_FAIL7;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_4 :
	                return IDWS_MOIP_SKYPEOUT_FAIL8;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_5 :
	                return IDWS_MOIP_SKYPEOUT_FAIL9;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_6 :
	                return IDWS_MOIP_SKYPEOUT_FAIL10;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_7 :
	                return IDWS_MOIP_SKYPEOUT_FAIL12;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_8 :
	                return IDWS_MOIP_SKYPEOUT_FAIL13;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_9 :
	                return IDWS_MOIP_SKYPEOUT_FAIL17;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_10 :
	                return IDWS_MOIP_SKYPEOUT_FAIL2;
	        break;
	    case ENUM_CALL_STATUS.SKYPEOUT_FAIL_REASON_11 :
	                return SID_EMERGENCY_CALL;
	        break;
	        
        case ENUM_CALL_STATUS.CALL_BEING_FORWARDED:
	                return IDWS_MOIP_CALL_BEING_FORWARDED;
	        break;
    }
}


SceneCalling.prototype.processEnterKey = function(){
    alert("SceneCalling.processEnterKey() ");
    
    var currentHighlight =  this.CallingView.getCurrentHighlight();
    
    switch(currentHighlight)
    {           
        case this.CancelBtn:
             if(this.CancelBtn.GetFlagDim()== false)
            {
                this.highlight(null);
                this.CancelBtn.SetFlagDim(true);
                ProcMgr.CancelCall(); 
            }          
            break;
			
		case this.OkBtn:
			ProcMgr.StopCallingFailMsg(); 
			break;
    }
}

SceneCalling.prototype.processReturnKey = function(){
    alert("SceneCalling.processReturnKey() ");

	var currentHighlight =  this.CallingView.getCurrentHighlight();
	
	if(currentHighlight == this.OkBtn)
	{
		ProcMgr.StopCallingFailMsg(); 
	}
}

SceneCalling.prototype.processClickEvent = function(obj){
	alert("SceneCalling.processClickEvent() ");
	
	this.processEnterKey();
}


