
var ConfirmPopupIndex ={ 

        SAVE_EDIT_PROFILE	: 1,
		
/////Change Picture///// 
		SAVE_SNAP_SHOT		: 2,
		DELETE_PICTURE		: 3,	
        
        SAVE_OPTIONS	: 4,
		START_CALL_AFTER_END_CALL	: 5,

//// face Recog		
		FACE_RE_REGISTRATION	: 6,
		FACE_DELETE	: 7,

 };

function SceneConfirmPopup(options) {
	this.options = options;
    
    this.PopupType = 0;
    this.YesCallbackFn = null;
    this.NoCallbackFn = null;
    
    this.ConfirmPopupView=null;
	this.ConfirmPopupDim=null;
    
    this.PopupMsg = null;
    this.YesBtn = null;
    this.NoBtn = null;
   
    this.CloseTimer = false;

}

SceneConfirmPopup.prototype.initialize = function () {
	alert("SceneConfirmPopup.initialize()");
    
   this.create();
}

SceneConfirmPopup.prototype.handleShow = function () {
	alert("SceneConfirmPopup.handleShow()");
	this.ConfirmPopupDim.show();
    this.highlight(this.YesBtn);
    this.update();
    
    this.startTimer();
    
}

SceneConfirmPopup.prototype.handleHide = function () {
	alert("SceneConfirmPopup.handleHide()");
	// this function will be called when the scene manager hide this scene  
	this.ConfirmPopupDim.hide();
	
    if (this.CloseTimer ==true)
    {
        this.stopTimer();
    }
}

SceneConfirmPopup.prototype.handleFocus = function () {
	alert("SceneConfirmPopup.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneConfirmPopup.prototype.handleBlur = function () {
	alert("SceneConfirmPopup.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneConfirmPopup.prototype.handleKeyDown = function (keyCode) {
	alert("SceneConfirmPopup.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
		this.resetTimer();
        this.processLeftRightKey();
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
        case $.sfKey.EXIT:
            this.processReturnKey();
            $.sfKey.block(event);
			break;

         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneConfirmPopup.prototype.create = function(){
    alert("SceneConfirmPopup.create()");
    this.ConfirmPopupView = new View("ConfirmPopup");
    this.ConfirmPopupView.SetBgImage(WndMgr.Bg_Popup.src);
	
	this.ConfirmPopupDim = new DimBg("ConfirmPopupDim", "ConfirmPopup");    
    
    this.PopupMsg = new Label(null,"confirm_popup_message");
    this.PopupMsg.SetTextStyle("confirm_popup_message_style");
    this.PopupMsg.SetText(IDWS_MOIP_SKYPE_SIGNIN);
    
    var this_ = $.sfScene.get("ConfirmPopup");
    var clickCF =  function(obj){this_.processClickEvent(obj);};

    this.YesBtn = new Button();
    this.YesBtn.SetImageObjId("confirm_popup_yes_btn");
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.YesBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);	
    this.YesBtn.SetTextObjId("confirm_popup_yes_btn_text");
    this.YesBtn.SetText(SID_YES);
    this.YesBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	this.YesBtn.SetOnClickCallbackFunc(clickCF);
	
    this.NoBtn = new Button();
    this.NoBtn.SetImageObjId("confirm_popup_no_btn");
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_LOADING_BTN_NORMAL);
    this.NoBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_LOADING_BTN_NORMALFOCUS);	
    this.NoBtn.SetTextObjId("confirm_popup_no_btn_text");
    this.NoBtn.SetText(SID_NO);
    this.NoBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"common_btn_text_f19_normal_style");
	this.NoBtn.SetOnClickCallbackFunc(clickCF);
}

SceneConfirmPopup.prototype.highlight=function(obj)
{
	alert("SceneConfirmPopup.highlight() ");
    this.ConfirmPopupView.setCurrenHighlight(obj);
}

SceneConfirmPopup.prototype.startTimer = function()
{
    alert("SceneConfirmPopup.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("30000" , function() { $.sfScene.get('ConfirmPopup').popupTimerCallback();}, ENUM_TIMER_TYPE.TWO_BUTTON);
}

SceneConfirmPopup.prototype.resetTimer = function()
{
    alert("SceneConfirmPopup.resetTimer() ");
	
	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("30000" ,ENUM_TIMER_TYPE.TWO_BUTTON);
	}
}

SceneConfirmPopup.prototype.stopTimer = function()
{
    alert("SceneConfirmPopup.stopTimer() ");

	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TWO_BUTTON); 
}

SceneConfirmPopup.prototype.popupTimerCallback = function()
{
    alert("SceneConfirmPopup.popupTimerCallback() ");
	
	if (this.CloseTimer == false)
	{
		return;
	}
	this.CloseTimer = false;	
		
	WndMgr.StopConfirmPopup(); 
}


SceneConfirmPopup.prototype.processLeftRightKey = function(){
    alert("SceneConfirmPopup.processLeftRightKey() ");
    
    var currentHighlight =  this.ConfirmPopupView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
           this.highlight(this.NoBtn);
            break;
            
        case this.NoBtn:
           this.highlight(this.YesBtn);
            break;
    }
}

SceneConfirmPopup.prototype.processEnterKey = function(){
    alert("SceneConfirmPopup.processEnterKey() ");
    
    var currentHighlight =  this.ConfirmPopupView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.YesBtn:
           WndMgr.NextConfirmPopup(); 
            break;
            
        case this.NoBtn:
           WndMgr.StopConfirmPopup(); 
            break;
    }
}

SceneConfirmPopup.prototype.processReturnKey = function(){
    alert("SceneConfirmPopup.processReturnKey() ");
    
    WndMgr.StopConfirmPopup();
}

SceneConfirmPopup.prototype.yseCallBack = function()
{
	alert("SceneConfirmPopup.yseCallBack() ");
	if(this.YesCallbackFn)
	{
		this.YesCallbackFn();
	}
}

SceneConfirmPopup.prototype.noCallBack = function()
{
	alert("SceneConfirmPopup.noCallBack() ");
	if(this.NoCallbackFn)
	{
		this.NoCallbackFn();
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneConfirmPopup.prototype.initPopup = function(typeIndex)
{
    this.PopupType =  typeIndex;
}

SceneConfirmPopup.prototype.update = function()
{
    alert("SceneConfirmPopup.update() ");
    this.updatePopupMsg();
    this.updateYesCallbakcFn();
    this.updateNoCallbakcFn();
}

SceneConfirmPopup.prototype.updatePopupMsg = function()
{
    alert("SceneConfirmPopup.updatePopupMsg() ");
    
    switch(this.PopupType)
    {
        case ConfirmPopupIndex.SAVE_EDIT_PROFILE : 
            this.PopupMsg.SetText(IDWS_MOIP_WANT_TO_CHANGE_SETTING);
            break;

        case ConfirmPopupIndex.SAVE_SNAP_SHOT : 
            this.PopupMsg.SetText(IDWS_MOIP_SAVE_SELECTED_PICTURE);
            break;	
			
        case ConfirmPopupIndex.DELETE_PICTURE : 
            this.PopupMsg.SetText(IDWS_MOIP_DELETE_SELECTED_PICTURE);
            break;		
            
        case ConfirmPopupIndex.SAVE_OPTIONS : 
            this.PopupMsg.SetText(IDWS_MOIP_WANT_TO_CHANGE_SETTING);
            break;
			
	    case ConfirmPopupIndex.START_CALL_AFTER_END_CALL :
			this.PopupMsg.SetText(TV_SID_START_NEW_CALL_CURRENT_CALL_WILL_END_MSG);
			break;
			
	    case ConfirmPopupIndex.FACE_RE_REGISTRATION :
			this.PopupMsg.SetText(TV_ALREADY_FACE_REGISTERED_ACCOUNT_MSG);
			break;
			
	    case ConfirmPopupIndex.FACE_DELETE:
			this.PopupMsg.SetText(TV_REMOVE_FACE_FROM_ACCOUNT_QUERY_MSG);
			break;
					
    }
}

SceneConfirmPopup.prototype.updateYesCallbakcFn = function()
{
    alert("SceneConfirmPopup.updateYesCallbakcFn() ");
	switch(this.PopupType)
	{
        case ConfirmPopupIndex.SAVE_EDIT_PROFILE :
    
	        this.YesCallbackFn = function(){$.sfScene.get('EditProfile').saveProfile();};
	        break;
		
        case ConfirmPopupIndex.SAVE_SNAP_SHOT :
    
	        this.YesCallbackFn = function(){
				
				if(PluginAPIMgr.GetNumOfSnapShot() == TOTAL_NUM_OF_SNAPSHOT){
					
					StateMgr.Start_Main_State();
					StateMgr.Start_Change_Picture_State();					
					
				}
				else {

					PluginAPIMgr.SaveSnapShot();
					$.sfScene.focus('VideoSnapshot');					
				}				
			
			};
	        break;		

        case ConfirmPopupIndex.DELETE_PICTURE :
    
	        this.YesCallbackFn = function(){
				
				var Index = $.sfScene.get('ChangePicture').GetDeletePhotoIndex();
				PluginAPIMgr.DeleteSnapShot(Index);				
				WndMgr.StartChangePictureStep();
									
			};
	        break;				
            
        case ConfirmPopupIndex.SAVE_OPTIONS : 
            this.YesCallbackFn = function(){OptionsMgr.SaveOptions();};
            break;
            
	    case ConfirmPopupIndex.FACE_RE_REGISTRATION :
			this.YesCallbackFn = function(){ProcMgr.ProcessReRegisterFace();};
			break;
			
	    case ConfirmPopupIndex.FACE_DELETE:
	        this.YesCallbackFn = function(){
	        	ProcMgr.ProcessDeleteFace();				
			};
			break;
		
    }
}

SceneConfirmPopup.prototype.updateNoCallbakcFn = function()
{
    alert("SceneConfirmPopup.updateNoCallbakcFn() ");
	switch(this.PopupType)
	{
        case ConfirmPopupIndex.SAVE_EDIT_PROFILE : 
    
	        this.NoCallbackFn = function(){StateMgr.Stop_Edit_Profile_State(true); };
	        break;
			
        case ConfirmPopupIndex.SAVE_SNAP_SHOT :
    
	        this.NoCallbackFn = function(){
			
				$.sfScene.focus('VideoSnapshot');
			
			};
	        break;	
			
        case ConfirmPopupIndex.DELETE_PICTURE :
    
	        this.NoCallbackFn = function(){				
				WndMgr.StartChangePictureStep();
			};
	        break;							
        
        case ConfirmPopupIndex.SAVE_OPTIONS : 
            this.NoCallbackFn = function(){StateMgr.Stop_Options_State(true); };
            break;
            
	    case ConfirmPopupIndex.FACE_RE_REGISTRATION :
	        this.NoCallbackFn = function(){				
				WndMgr.BackStepAccountManager();
			};
			
			break;
		
	    case ConfirmPopupIndex.FACE_DELETE:
	        this.NoCallbackFn = function(){				
				WndMgr.BackStepAccountManager();
			};
			
			break;
    }
}

SceneConfirmPopup.prototype.processClickEvent = function(obj){
	alert("SceneConfirmPopup.processClickEvent() ");
	
	var currentHighlight =  this.ConfirmPopupView.getCurrentHighlight();
    if(currentHighlight != obj)
    {
    	this.highlight(obj);
    }
	
	this.processEnterKey();
}

