function SceneEditProfile(options) {
	this.options = options;
    
    this.EditProfileView=null;
	this.EditProfileDim =null;
    
    this.EditProfilePage1=null;
    this.EditProfilePage2=null;
    
    this.TitleBar = null;    
    
    this.SkypeCreditLabel = null;
    this.VoiceMailExpireLabel = null;
    this.MoodMsgLabel = null;
    this.FullNameLabel = null;
    this.EmailLabel = null;
    this.CountryRegionLabel = null;
    this.HomePhoneLabel = null;
    this.OfficePhoneLabel = null;
    this.MobilePhoneLabel = null;
    this.StateProvinceLabel = null;
    this.CityLabel = null;
    this.GenderLabel = null;
    this.BirthDateLabel = null;
    
     this.SkypeCreditValue= null;
     this.VoiceMailExpireValue = null;
     this.MoodMsgInputBox= null;
     this.FullNameInputBox= null;
     this.EmailInputBox= null;
     this.CountryRegionBtn= null;
     this.HomePhoneCountryCodeBtn= null;
     this.OfficePhoneCountryCodeBtn= null;
     this.MobilePhoneCountryCodeBtn= null;
     this.HomePhoneNumberInputBox= null;
     this.OfficePhoneNumberInputBox= null;
     this.MobilePhoneNumberInputBox= null;
     this.StateProvinceInputBox= null;
     this.CityInputBox= null;
     this.GenderBtn= null;
     this.DayNumberInputBox= null;
     this.MonthNumberInputBox= null;
     this.YearNumberInputBox= null;
     
     this.CountryRegionArrowLabel= null;
     this.HomePhoneCountryCodeArrowLabel= null;
     this.OfficePhoneCountryCodeArrowLabel= null;
     this.MobilePhoneCountryCodeArrowLabel= null;
     this.GenderArrowLabel= null;
    
    this.DayLabel = null;
    this.MonthLabel = null;
    this.YearLabel = null;
    
    this.GenderList = null;
    
    this.GenderListItem0 =null;
    this.GenderListItem1 =null;
    this.GenderListItem2 =null;
    
    this.FlagShowGenderList = false;
    
     this.ScrollBg=null;
     this.ScrollTop=null;
     this.ScrollCenter=null;
     this.ScrollUnder=null;
     
     this.ItemOder = new Array(16);
    
//////  init data  ///////////////////////////////////////////////////////////////////////////////////////////////////////////    
    this.flagPWD = false;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    
   this.flagMoodMsgInit =false;
   this.flagFullNameInit =false;
   this.flagEmailInit =false;
   this.flagStateInit =false;
   this.flagCityInit =false;
   
   this.initMoodMsgText ="";
   this.initFullNameText ="";
   this.initEmail ="";
   this.initProvince="";
   this.initCity="";
   
   this.initCountryCode ="";
   
   this.initHomePhoneNumber ="";
   this.initOfficePhoneNumber ="";
   this.initMobilePhoneNumber ="";
      
   this.initHomePhoneCountryCode ="";
   this.initOfficePhoneCountryCode ="";
   this.initMobilePhoneCountryCode ="";
   this.initHomePhoneLocalCode ="";
   this.initOfficePhoneLocalCode ="";
   this.initMobilePhoneLocalCode ="";
   
    this.currCountryCode ="";
    this.currHomePhoneCountryCode ="";
    this.currOfficePhoneCountryCode ="";
    this.currMobilePhoneCountryCode ="";

   this.initGender = "";
   
   this.initBirthDate ="";
   this.initDay ="";
   this.initMonth ="";
   this.initYear ="";
   
	this.HomePhonePrefix = null;
	this.OfficePhonePrefix = null;
	this.MobilePhonePrefix = null;
    
    this.flagChange = false;
    this.reserveHighlight =null;
    this.InitFlag = true;
    
    this.DefaultHelpBar =null;
    this.InputHelpBar =null;
    //this.NumberInputHelpBar =null;
    this.PhoneNumberInputHelpBar =null;   
    
    this.SaveDefaultHelpBar =null;
    this.SaveInputHelpBar =null;
    //this.SaveNumberInputHelpBar =null;
    this.SavePhoneNumberInputHelpBar =null;
    
    this.PlusPhoneNumberInputHelpBar =null;
    this.PlusSavePhoneNumberInputHelpBar =null;
    
    //this.DateInputHelpBar =null;
    //this.DateSaveInputHelpBar =null;
    //this.DateSelectHelpBar =null;
    //this.DateSaveSelectHelpBar =null;
    
    this.flagPlusBtnEnable = false;
    
    //this.flagDayEditable = false;
    //this.flagMonthEditable = false;
    //this.flagYearEditable = false;
    
    this.minDay = 1;
    /*this.maxDay =31;
    
    this.minMonth =1;
    this.maxMonth=12;
    
    this.minYear =1900;
    this.maxYear =1997;*/
	
	this.CloseTimer = false;

	//sublist flag
	this.flagShownDayList = false;
	this.flagShownMonthList = false;
	this.flagShownYearList = false;
	this.flagShownCountryList = false;
	this.flagShownPrefixList = false;
	
	this.TopArrow = null;
	this.BottomArrow = null;
	
	this.currPage =1;

}

SceneEditProfile.prototype.initialize = function () {
	alert("SceneEditProfile.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneEditProfile.prototype.handleShow = function () {
	alert("SceneEditProfile.handleShow()");
	// this function will be called when the scene manager show this scene
	this.EditProfileDim.show(); 
     if(this.InitFlag == true)
    {
        this.initEditProfile();
    }
    
	this.startTimer();
}

SceneEditProfile.prototype.handleHide = function () {
	alert("SceneEditProfile.handleHide()");
	// this function will be called when the scene manager hide this scene  
	
	this.HideSubList();
	
	this.EditProfileDim.hide();
	
	if(this.FlagShowGenderList == true)
	{
		this.hideGenderList();
	}

	if(this.CloseTimer==true)
	{
		this.stopTimer();
	}
}

SceneEditProfile.prototype.handleFocus = function () {
	alert("SceneEditProfile.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	if(this.CloseTimer == false)
	{
		this.startTimer();
	}
    
     var currentHighlight = this.EditProfileView.getCurrentHighlight();
     
     if(currentHighlight ==null && this.reserveHighlight ==null)
    {
        this.highlight(this.MoodMsgInputBox);
    }
    else
    {
        if(this.reserveHighlight !=null)
        {
             this.goToPage1(); 
             this.highlight(this.reserveHighlight );
             this.reserveHighlight =null;
        }
        else
        {
            this.highlight(currentHighlight);
        }
    }
	
	this.ResetSubListFlag();
}

SceneEditProfile.prototype.handleBlur = function () {
	alert("SceneEditProfile.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
    var  obj = this.EditProfileView.getCurrentHighlight();
	if(obj != null)
	{
		obj.blur();	
	}   
}

SceneEditProfile.prototype.handleKeyDown = function (keyCode) {
	alert("SceneEditProfile.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	PluginAPIMgr.PlayAudio(keyCode);
	switch (keyCode) {
		case $.sfKey.LEFT:
			this.resetTimer();
            this.processLeftKey();
			break;
		case $.sfKey.RIGHT:
			this.resetTimer();
             this.processRightKey();
			break;
		case $.sfKey.UP:
			this.resetTimer();
         this.processUpKey();
         break;
		case $.sfKey.DOWN:
			this.resetTimer();
            this.processDownKey();
			break;

		case $.sfKey.ENTER:
             this.processEnterKey();
			break;
            
        case $.sfKey.BLUE:
            this.processBlueKey();
			break
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
        case $.sfKey.EXIT:
            this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneEditProfile.prototype.create = function(){
    alert("SceneEditProfile.create()");
    this.EditProfileView = new View("EditProfile");
    this.EditProfileView.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_BG);
	
	this.EditProfileDim = new DimBg("EditProfileDim", "EditProfile");  
	
	this.EditProfilePage1 = new View("edit_profile_page_1");
	
	this.EditProfilePage2 = new View("edit_profile_page_2");
	this.EditProfilePage2.hiddenObj();
	 
	 var scene = $.sfScene.get("EditProfile");
    
    this.TitleBar = new Label(null,"edit_profile_title");
    this.TitleBar.SetTextStyle("edit_profile_title_style");
    this.TitleBar.SetText(TV_SID_EDIT_PROFILE);
   
    this.SkypeCreditLabel = new Label(null,"edit_profile_skype_credit_text");
    this.SkypeCreditLabel.SetTextStyle("edit_profile_text_style");
    this.SkypeCreditLabel.SetText(TV_SID_SKYPE_CREDIT);
    
    this.VoiceMailExpireLabel = new Label(null,"edit_profile_voice_mail_expire_text");
    this.VoiceMailExpireLabel.SetTextStyle("edit_profile_text_style");
    this.VoiceMailExpireLabel.SetText(TV_SID_VOICE_MAIL_EXPIRE);
    
    this.MoodMsgLabel = new Label(null,"edit_profile_mood_message_text");
    this.MoodMsgLabel.SetTextStyle("edit_profile_text_style");
    this.MoodMsgLabel.SetText(IDWS_MOIP_MOOD_MESSAGE);
    
    this.FullNameLabel = new Label(null,"edit_profile_full_name_text");
    this.FullNameLabel.SetTextStyle("edit_profile_text_style");
    this.FullNameLabel.SetText(IDWS_MOIP_FULL_NAME);
    
    this.EmailLabel = new Label(null,"edit_profile_email_text");
    this.EmailLabel.SetTextStyle("edit_profile_text_style");
    this.EmailLabel.SetText(IDWS_MOIP_E_MAIL);
    
    this.CountryRegionLabel = new Label(null,"edit_profile_country_region_text");
    this.CountryRegionLabel.SetTextStyle("edit_profile_text_style");
    this.CountryRegionLabel.SetText(IDWS_MOIP_SETTING_COUNTRY);
    
    this.HomePhoneLabel = new Label(null,"edit_profile_home_phone_text");
    this.HomePhoneLabel.SetTextStyle("edit_profile_text_style");
    this.HomePhoneLabel.SetText(IDWS_MOIP_HOME_PHONE);
    
    this.OfficePhoneLabel = new Label(null,"edit_profile_office_phone_text");
    this.OfficePhoneLabel.SetTextStyle("edit_profile_text_style");
    this.OfficePhoneLabel.SetText(IDWS_MOIP_OFFICE_PHONE);
    
    this.MobilePhoneLabel = new Label(null,"edit_profile_mobile_phone_text");
    this.MobilePhoneLabel.SetTextStyle("edit_profile_text_style");
    this.MobilePhoneLabel.SetText(IDWS_MOIP_MOBILE_PHONE);
    
    this.StateProvinceLabel = new Label(null,"edit_profile_state_province_text");
    this.StateProvinceLabel.SetTextStyle("edit_profile_text_style");
    this.StateProvinceLabel.SetText(IDWS_MOIP_SETTING_STATE);
    
    this.CityLabel = new Label(null,"edit_profile_city_text");
    this.CityLabel.SetTextStyle("edit_profile_text_style");
    this.CityLabel.SetText(IDWS_MOIP_SETTING_CITY);
    
    this.GenderLabel = new Label(null,"edit_profile_gender_text");
    this.GenderLabel.SetTextStyle("edit_profile_text_style");
    this.GenderLabel.SetText(IDWS_MOIP_SETTING_GENDER);
    
    this.BirthDateLabel = new Label(null,"edit_profile_birth_date_text");
    this.BirthDateLabel.SetTextStyle("edit_profile_text_style");
    this.BirthDateLabel.SetText(IDWS_MOIP_SETTING_BIRTH_DATE);
    
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
    this.SkypeCreditValue = new Label(null,"edit_profile_skype_credit_value");
    this.SkypeCreditValue.SetTextStyle("edit_profile_value_style");
    this.SkypeCreditValue.SetReverseDisable(true);
    
    this.VoiceMailExpireValue = new Label(null,"edit_profile_voice_mail_expire_value");
    this.VoiceMailExpireValue.SetTextStyle("edit_profile_value_style");
    this.VoiceMailExpireValue.SetReverseDisable(true);
    
    this.MoodMsgInputBox= new Button();
    this.MoodMsgInputBox.SetImageObjId("edit_profile_mood_message_input_box");
    this.MoodMsgInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.MoodMsgInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.MoodMsgInputBox.SetTextObjId("edit_profile_mood_message_input_box_text");
    this.MoodMsgInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.MoodMsgInputBox.SetMaxStringLength(50);//(200);
    this.MoodMsgInputBox.SetIsPlainText(true);
    this.MoodMsgInputBox.SetOnTextChangeFunc(function(){ $.sfScene.get('EditProfile').isChange();});
 	
 	var CurLangID = ResMgr.GetCurLanguage();
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.MoodMsgInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_lagre_style");
	}
	else
	{
		this.MoodMsgInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_style");
	}
    this.MoodMsgInputBox.SetTextEditorInfo(TV_SID_EDIT_PROFILE, TV_SID_ENTER_MOOD_MESSAGE);
    
    this.FullNameInputBox= new Button();
    this.FullNameInputBox.SetImageObjId("edit_profile_full_name_input_box");
    this.FullNameInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.FullNameInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.FullNameInputBox.SetTextObjId("edit_profile_full_name_input_box_text");
    this.FullNameInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.FullNameInputBox.SetMaxStringLength(50);//(100);
    this.FullNameInputBox.SetIsPlainText(true);
    this.FullNameInputBox.SetOnTextChangeFunc(function(){ $.sfScene.get('EditProfile').isChange();});    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.FullNameInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_lagre_style");
	}
	else
	{
		this.FullNameInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_style");
	}    
    this.FullNameInputBox.SetTextEditorInfo(TV_SID_EDIT_PROFILE, IDWS_MOIP_INPUT_YOUR_FULL_NAME);
    
    this.EmailInputBox= new Button();
    this.EmailInputBox.SetImageObjId("edit_profile_email_input_box");
    this.EmailInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.EmailInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.EmailInputBox.SetTextObjId("edit_profile_email_input_box_text");
    this.EmailInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.EmailInputBox.SetMaxStringLength(50);//(100);
    this.EmailInputBox.SetIsPlainText(true);
    this.EmailInputBox.SetOnTextChangeFunc(function(){ $.sfScene.get('EditProfile').isChange();});    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.EmailInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_lagre_style");
	}
	else
	{
		this.EmailInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_style");
	}    
    this.EmailInputBox.SetTextEditorInfo(TV_SID_EDIT_PROFILE, IDWS_MOIP_OPTIONS_USER_PROFILE_KEYPAD_HELP_ENTER_EMAIL);
    
    this.CountryRegionBtn= new Button();
    this.CountryRegionBtn.SetImageObjId("edit_profile_country_region_btn");
    this.CountryRegionBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.CountryRegionBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.CountryRegionBtn.SetTextObjId("edit_profile_country_region_btn_text");
    this.CountryRegionBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.CountryRegionBtn.AppendFgImage("edit_profile_country_region_btn_icon","240px","11px","37px","27px");
	this.CountryRegionBtn.SetReverseDisable(true);
	
    this.CountryRegionArrowLabel= new Label("edit_profile_country_region_arrow_down", null);
    this.CountryRegionArrowLabel.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_ICON);
        
    this.HomePhoneCountryCodeBtn = new Button();
    this.HomePhoneCountryCodeBtn.SetImageObjId("edit_profile_home_phone_country_code_btn");
    this.HomePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMAL);
    this.HomePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMALFOCUS);	
    this.HomePhoneCountryCodeBtn.AppendFgImage("edit_profile_home_phone_country_code_btn_icon","13px","11px","37px","27px");

    this.HomePhoneCountryCodeArrowLabel= new Label("edit_profile_home_phone_country_code_arrow_down", null);
    this.HomePhoneCountryCodeArrowLabel.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_ICON);
    
    this.OfficePhoneCountryCodeBtn = new Button();
    this.OfficePhoneCountryCodeBtn.SetImageObjId("edit_profile_office_phone_country_code_btn");
    this.OfficePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMAL);
    this.OfficePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMALFOCUS);	
    this.OfficePhoneCountryCodeBtn.AppendFgImage("edit_profile_office_phone_country_code_btn_icon","13px","11px","37px","27px");

    this.OfficePhoneCountryCodeArrowLabel= new Label("edit_profile_office_phone_country_code_arrow_down", null);
    this.OfficePhoneCountryCodeArrowLabel.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_ICON);
    
    this.MobilePhoneCountryCodeBtn = new Button();
    this.MobilePhoneCountryCodeBtn.SetImageObjId("edit_profile_mobile_phone_country_code_btn");
    this.MobilePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMAL);
    this.MobilePhoneCountryCodeBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_COUNTRY_CODE_BTN_NORMALFOCUS);	
    this.MobilePhoneCountryCodeBtn.AppendFgImage("edit_profile_mobile_phone_country_code_btn_icon","13px","11px","37px","27px");

    this.MobilePhoneCountryCodeArrowLabel= new Label("edit_profile_mobile_phone_country_code_arrow_down", null);
    this.MobilePhoneCountryCodeArrowLabel.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_ICON);

    this.HomePhoneNumberInputBox= new NumberInputBox();
    this.HomePhoneNumberInputBox.SetButtonObjId("edit_profile_home_phone_number_input_box");
    this.HomePhoneNumberInputBox.SetButtonTextObjId("edit_profile_home_phone_number_input_box_text");
    this.HomePhoneNumberInputBox.SetInputBoxObjId("edit_profile_home_phone_number_input_box_editor");
    this.HomePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMAL);
    this.HomePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMALFOCUS);  
    this.HomePhoneNumberInputBox.setPrevEventOnLeftFunc(function(){scene.processLeftKey(); scene.resetTimer();});
    this.HomePhoneNumberInputBox.setPrevEventOnRightFunc(function(){scene.processRightKey(); scene.resetTimer();});
    this.HomePhoneNumberInputBox.setPrevEventOnDownFunc(function(){scene.processDownKey(); scene.resetTimer();});
    this.HomePhoneNumberInputBox.setPrevEventOnUpFunc(function(){scene.processUpKey(); scene.resetTimer();});
    this.HomePhoneNumberInputBox.setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
    this.HomePhoneNumberInputBox.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); });
    this.HomePhoneNumberInputBox.setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey(); });
    this.HomePhoneNumberInputBox.setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });
	this.HomePhoneNumberInputBox.setAnyKeyFunc(function(keyCode){scene.isChange(); scene.resetTimer();});
	this.HomePhoneNumberInputBox.setEnterFunc(function(){scene.processEnterKey()});
	this.HomePhoneNumberInputBox.SetReverseDisable(true);

    this.OfficePhoneNumberInputBox= new NumberInputBox();
    this.OfficePhoneNumberInputBox.SetButtonObjId("edit_profile_office_phone_number_input_box");
    this.OfficePhoneNumberInputBox.SetButtonTextObjId("edit_profile_office_phone_number_input_box_text");
    this.OfficePhoneNumberInputBox.SetInputBoxObjId("edit_profile_office_phone_number_input_box_editor");
    this.OfficePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMAL);
    this.OfficePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMALFOCUS);
    this.OfficePhoneNumberInputBox.setPrevEventOnLeftFunc(function(){scene.processLeftKey(); scene.resetTimer();});
    this.OfficePhoneNumberInputBox.setPrevEventOnRightFunc(function(){scene.processRightKey(); scene.resetTimer();});
    this.OfficePhoneNumberInputBox.setPrevEventOnDownFunc(function(){scene.processDownKey(); scene.resetTimer();});
    this.OfficePhoneNumberInputBox.setPrevEventOnUpFunc(function(){scene.processUpKey(); scene.resetTimer();});
    this.OfficePhoneNumberInputBox.setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
    this.OfficePhoneNumberInputBox.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); });
	this.OfficePhoneNumberInputBox.setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey(); });
	this.OfficePhoneNumberInputBox.setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });
    this.OfficePhoneNumberInputBox.setAnyKeyFunc(function(keyCode){scene.isChange(); scene.resetTimer();});
	this.OfficePhoneNumberInputBox.setEnterFunc(function(){scene.processEnterKey()});
	this.OfficePhoneNumberInputBox.SetReverseDisable(true);
	
    this.MobilePhoneNumberInputBox= new NumberInputBox();
    this.MobilePhoneNumberInputBox.SetButtonObjId("edit_profile_mobile_phone_number_input_box");
    this.MobilePhoneNumberInputBox.SetButtonTextObjId("edit_profile_mobile_phone_number_input_box_text");
    this.MobilePhoneNumberInputBox.SetInputBoxObjId("edit_profile_mobile_phone_number_input_box_editor");
    this.MobilePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMAL);
    this.MobilePhoneNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_PHONE_NUMBER_INPUT_BOX_NORMALFOCUS);
    this.MobilePhoneNumberInputBox.setPrevEventOnLeftFunc(function(){scene.processLeftKey(); scene.resetTimer();});
    this.MobilePhoneNumberInputBox.setPrevEventOnRightFunc(function(){scene.processRightKey(); scene.resetTimer();});
    this.MobilePhoneNumberInputBox.setPrevEventOnDownFunc(function(){scene.processDownKey(); scene.resetTimer();});
    this.MobilePhoneNumberInputBox.setPrevEventOnUpFunc(function(){scene.processUpKey(); scene.resetTimer();});
    this.MobilePhoneNumberInputBox.setPrevEventOnBlueFunc(function(){scene.processBlueKey()});
    this.MobilePhoneNumberInputBox.setPrevEventOnReturnFunc(function(){$.sfKey.block(event); scene.processReturnKey(); });
	this.MobilePhoneNumberInputBox.setPrevEventOnExitFunc(function(){$.sfKey.block(event); scene.processExitKey();});
    this.MobilePhoneNumberInputBox.setPrevEventOnInfolinkFunc(function(){$.sfKey.block(event); });
	this.MobilePhoneNumberInputBox.setAnyKeyFunc(function(keyCode){scene.isChange(); scene.resetTimer();});
	this.MobilePhoneNumberInputBox.setEnterFunc(function(){scene.processEnterKey()});
	this.MobilePhoneNumberInputBox.SetReverseDisable(true);
	
    this.StateProvinceInputBox= new Button();
    this.StateProvinceInputBox.SetImageObjId("edit_profile_state_province_input_box");
    this.StateProvinceInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.StateProvinceInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.StateProvinceInputBox.SetTextObjId("edit_profile_state_province_input_box_text");
    this.StateProvinceInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.StateProvinceInputBox.SetMaxStringLength(50);//(100);
    this.StateProvinceInputBox.SetIsPlainText(true);
    this.StateProvinceInputBox.SetOnTextChangeFunc(function(){  $.sfScene.get('EditProfile').isChange();});    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.StateProvinceInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_lagre_style");
	}
	else
	{
		this.StateProvinceInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_style");
	}        
    this.StateProvinceInputBox.SetTextEditorInfo(TV_SID_EDIT_PROFILE, TV_SID_ENTER_STATE_PROVINCE);
    
    this.CityInputBox= new Button();
    this.CityInputBox.SetImageObjId("edit_profile_city_input_box");
    this.CityInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.CityInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.CityInputBox.SetTextObjId("edit_profile_city_input_box_text");
    this.CityInputBox.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    this.CityInputBox.SetMaxStringLength(50);//(100);
    this.CityInputBox.SetIsPlainText(true);
    this.CityInputBox.SetOnTextChangeFunc(function(){ $.sfScene.get('EditProfile').isChange();});    
 	if(CurLangID == ENUM_TV_LANGUAGE.HEB)
	{
		this.CityInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_lagre_style");
	}
	else
	{
		this.CityInputBox.SetHelpText(IDWS_MOIP_PRESS_ENTER, "edit_profile_btn_help_style");
	}      
    this.CityInputBox.SetTextEditorInfo(TV_SID_EDIT_PROFILE, TV_SID_ENTER_CITY);
    
    this.GenderBtn= new Button();
    this.GenderBtn.SetImageObjId("edit_profile_gender_btn");
    this.GenderBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMAL);
    this.GenderBtn.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_INPUT_BOX_NORMALFOCUS);
    this.GenderBtn.SetTextObjId("edit_profile_gender_btn_text");
	this.GenderBtn.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
    
    this.GenderArrowLabel= new Label("edit_profile_gender_arrow_down", null);
    this.GenderArrowLabel.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_ICON); 

    this.DayNumberInputBox= new Button();
    this.DayNumberInputBox.SetImageObjId("edit_profile_birth_date_day_number_input_box");
    this.DayNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_DAY_MONTH_INPUT_BOX_NORMAL);
    this.DayNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_DAY_MONTH_INPUT_BOX_NORMALFOCUS);
    this.DayNumberInputBox.SetTextObjId("edit_profile_birth_date_day_number_input_box_text");
    this.DayNumberInputBox.AppendFgImage("edit_profile_birth_date_day_number_input_box_icon","46px","8px","11px","33px");
   // this.DayNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
    this.DayNumberInputBox.SetOnTextChangeFunc(function(){scene.isChange();});
    
    this.MonthNumberInputBox= new Button();
    this.MonthNumberInputBox.SetImageObjId("edit_profile_birth_date_month_number_input_box");
    this.MonthNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_DAY_MONTH_INPUT_BOX_NORMAL);
    this.MonthNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_DAY_MONTH_INPUT_BOX_NORMALFOCUS);
    this.MonthNumberInputBox.SetTextObjId("edit_profile_birth_date_month_number_input_box_text");
    this.MonthNumberInputBox.AppendFgImage("edit_profile_birth_date_month_number_input_box_icon","46px","8px","11px","33px");
    //this.MonthNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
    this.MonthNumberInputBox.SetOnTextChangeFunc(function(){scene.isChange();});
    
    this.YearNumberInputBox= new Button();
    this.YearNumberInputBox.SetImageObjId("edit_profile_birth_date_year_number_input_box");
    this.YearNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_EDIT_PROFILE_YEAR_INPUT_BOX_NORMAL);
    this.YearNumberInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_YEAR_INPUT_BOX_NORMALFOCUS);
    this.YearNumberInputBox.SetTextObjId("edit_profile_birth_date_year_number_input_box_text");
    this.YearNumberInputBox.AppendFgImage("edit_profile_birth_date_year_number_input_box_icon","54px","8px","11px","33px");
   // this.YearNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
    this.YearNumberInputBox.SetOnTextChangeFunc(function(){scene.isChange();});
    
    this.DayLabel = new Label(null,"edit_profile_birth_date_day_text");
    this.DayLabel.SetTextStyle("edit_profile_birth_date_text_style");
    this.DayLabel.SetText(SID_DAY);
    
    this.MonthLabel = new Label(null,"edit_profile_birth_date_month_text");
    this.MonthLabel.SetTextStyle("edit_profile_birth_date_text_style");
    this.MonthLabel.SetText(SID_MONTH);
    
    this.YearLabel = new Label(null,"edit_profile_birth_date_year_text");
    this.YearLabel.SetTextStyle("edit_profile_birth_date_text_style");
    this.YearLabel.SetText(SID_YEAR);
    
    this.GenderList= new Label("edit_profile_gender_list", null);
    this.GenderList.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_GENDER_LIST_BG );
    
    this.GenderListItem0= new Button();
    this.GenderListItem0.SetImageObjId("edit_profile_gender_list_btn_0");
    this.GenderListItem0.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.GenderListItem0.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_GENDER_LIST_BTN_NORMALFOCUS);
    this.GenderListItem0.SetTextObjId("edit_profile_gender_list_btn_0_text");
	this.GenderListItem0.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
	this.GenderListItem0.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"edit_profile_btn_style_focus");
    this.GenderListItem0.SetText("");
    
    this.GenderListItem1= new Button();
    this.GenderListItem1.SetImageObjId("edit_profile_gender_list_btn_1");
    this.GenderListItem1.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.GenderListItem1.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_GENDER_LIST_BTN_NORMALFOCUS);
    this.GenderListItem1.SetTextObjId("edit_profile_gender_list_btn_1_text");
	this.GenderListItem1.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
	this.GenderListItem1.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"edit_profile_btn_style_focus");
    this.GenderListItem1.SetText(SID_MALE_KR_MAN);

    this.GenderListItem2= new Button();
    this.GenderListItem2.SetImageObjId("edit_profile_gender_list_btn_2");
    this.GenderListItem2.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, null);
    this.GenderListItem2.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_EDIT_PROFILE_GENDER_LIST_BTN_NORMALFOCUS);
    this.GenderListItem2.SetTextObjId("edit_profile_gender_list_btn_2_text");
	this.GenderListItem2.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_NORMAL_STYLE,"edit_profile_btn_style");
	this.GenderListItem2.SetTextStyle(BtnTextStyleIndex.BTN_TEXT_FOCUS_STYLE,"edit_profile_btn_style_focus");
    this.GenderListItem2.SetText(SID_FEMALE_KR_WOMAN);
    
    this.DefaultHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE,"EditProfile");
    this.DefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processReturnKey();});
    this.InputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT,"EditProfile");
    this.InputHelpBar.SetOnClickCallbackFunc(1, function(){this_.processEnterKey();});
    this.InputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    //this.NumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_NUMBER,"EditProfile");
    this.PhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER,"EditProfile");
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.PhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    this.PlusPhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_PLUS,"EditProfile");
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
	this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputPlus();});
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.inputDelete();});
    this.PlusPhoneNumberInputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    
    this.SaveDefaultHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_SAVE,"EditProfile");
    this.SaveDefaultHelpBar.SetOnClickCallbackFunc(1, function(){this_.processBlueKey();});
    this.SaveDefaultHelpBar.SetOnClickCallbackFunc(2, function(){this_.processReturnKey();});
    this.SaveInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_SAVE,"EditProfile");
    this.SaveInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.processEnterKey();});
    this.SaveInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.processBlueKey();});    
    this.SaveInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processReturnKey();});
    //this.SaveNumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_NUMBER_SAVE,"EditProfile");
    this.SavePhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE,"EditProfile");
    this.SavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.SavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputDelete();});
    this.SavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.processBlueKey();});    
    this.SavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});
    this.PlusSavePhoneNumberInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_INPUT_PHONE_NUMBER_SAVE_PLUS,"EditProfile");
    this.PlusSavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(1, function(){this_.startKeypad();});
    this.PlusSavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(2, function(){this_.inputPlus();});
    this.PlusSavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(3, function(){this_.inputDelete();});
    this.PlusSavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(4, function(){this_.processBlueKey();});    
    this.PlusSavePhoneNumberInputHelpBar.SetOnClickCallbackFunc(5, function(){this_.processReturnKey();});
     //this.DateInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_DATE_INPUT,"EditProfile");
     //this.DateSaveInputHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_DATE_INPUT_SAVE,"EditProfile");
     //this.DateSelectHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_DATE_SELECT,"EditProfile");
     //this.DateSaveSelectHelpBar = new HelpBar(HelpBarIndex.EDIT_PROFILE_DATE_SELECT_SAVE,"EditProfile");
    
     this.MoodMsgInputBox.registHelpBar( this.InputHelpBar);
     this.FullNameInputBox.registHelpBar( this.InputHelpBar);
     this.EmailInputBox.registHelpBar( this.InputHelpBar);
     this.CountryRegionBtn.registHelpBar( this.DefaultHelpBar);
     this.HomePhoneCountryCodeBtn.registHelpBar( this.DefaultHelpBar);
     this.OfficePhoneCountryCodeBtn.registHelpBar( this.DefaultHelpBar);
     this.MobilePhoneCountryCodeBtn.registHelpBar( this.DefaultHelpBar);
     this.HomePhoneNumberInputBox.registHelpBar( this.PhoneNumberInputHelpBar);
     this.OfficePhoneNumberInputBox.registHelpBar( this.PhoneNumberInputHelpBar);
     this.MobilePhoneNumberInputBox.registHelpBar( this.PhoneNumberInputHelpBar);
     this.StateProvinceInputBox.registHelpBar( this.InputHelpBar);
     this.CityInputBox.registHelpBar( this.InputHelpBar);
     this.GenderBtn.registHelpBar( this.DefaultHelpBar);
     this.DayNumberInputBox.registHelpBar( this.InputHelpBar);
     this.MonthNumberInputBox.registHelpBar( this.InputHelpBar);
     this.YearNumberInputBox.registHelpBar( this.InputHelpBar);
     
     this.GenderListItem0.registHelpBar( this.DefaultHelpBar);
     this.GenderListItem1.registHelpBar( this.DefaultHelpBar);
     this.GenderListItem2.registHelpBar( this.DefaultHelpBar);
     
    this.ScrollBg= new Label("edit_profile_scroll_bg", null);
    this.ScrollBg.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_SCROLL_BG);
    
    this.ScrollTop= new Label("edit_profile_scroll_top", null);
    this.ScrollTop.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_SCROLL_TOP);
    
    this.ScrollUnder= new Label("edit_profile_scroll_under", null);
    this.ScrollUnder.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_SCROLL_UNDER);
    
    this.ScrollCenter= new Label("edit_profile_scroll_center", null);
    this.ScrollCenter.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_SCROLL_CENTER);
    
    var a=0;
    for(a=0; a < this.ItemOder.length; a++)
    {
        this.ItemOder[a] = new Object();
    }
    
    this.ItemOder[0].obj = this.MoodMsgInputBox;
    this.ItemOder[0].oder = 1;
    this.ItemOder[1].obj = this.FullNameInputBox;
    this.ItemOder[1].oder = 1;
    this.ItemOder[2].obj = this.EmailInputBox;
    this.ItemOder[2].oder = 1;
    this.ItemOder[3].obj = this.CountryRegionBtn;
    this.ItemOder[3].oder = 1;
    this.ItemOder[4].obj = this.HomePhoneCountryCodeBtn;
    this.ItemOder[4].oder = 1;
    this.ItemOder[5].obj = this.OfficePhoneCountryCodeBtn;
    this.ItemOder[5].oder = 1;
    this.ItemOder[6].obj = this.MobilePhoneCountryCodeBtn;
    this.ItemOder[6].oder =1;
    this.ItemOder[7].obj = this.HomePhoneNumberInputBox;
    this.ItemOder[7].oder = 1;
    this.ItemOder[8].obj = this.OfficePhoneNumberInputBox;
    this.ItemOder[8].oder = 1;
    this.ItemOder[9].obj = this.MobilePhoneNumberInputBox;
    this.ItemOder[9].oder = 1;
    this.ItemOder[10].obj = this.StateProvinceInputBox;
    this.ItemOder[10].oder = 2;
    this.ItemOder[11].obj = this.CityInputBox;
    this.ItemOder[11].oder =2;
    this.ItemOder[12].obj = this.GenderBtn;
    this.ItemOder[12].oder = 2;
    this.ItemOder[13].obj = this.DayNumberInputBox;
    this.ItemOder[13].oder = 2;
    this.ItemOder[14].obj = this.MonthNumberInputBox;
    this.ItemOder[14].oder = 2;
    this.ItemOder[15].obj = this.YearNumberInputBox;
    this.ItemOder[15].oder = 2;
    
   	var this_ = $.sfScene.get("EditProfile");
	var clickCF =  function(obj){this_.processClickEvent(obj);};
	
    for(a=0; a < this.ItemOder.length; a++)
    {
        this.ItemOder[a].obj.SetOnClickCallbackFunc(clickCF);
    }
    
    this.GenderListItem0.SetOnClickCallbackFunc(clickCF);
    this.GenderListItem1.SetOnClickCallbackFunc(clickCF);
    this.GenderListItem2.SetOnClickCallbackFunc(clickCF);
    
    this.TopArrow= new Label("edit_profile_top_arrow", null);
    this.TopArrow.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_TOP_NOR);
    this.TopArrow.SetOnClickCallbackFunc(clickCF);
    this.TopArrow.SetOnMouseOutOverImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_TOP_NOR, g_Image.IMAGE_EDIT_PROFILE_ALLOW_TOP_OVER);

    this.BottomArrow= new Label("edit_profile_bottom_arrow", null);
    this.BottomArrow.SetBgImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_BOTTOM_NOR);
    this.BottomArrow.SetOnClickCallbackFunc(clickCF);
    this.BottomArrow.SetOnMouseOutOverImage(g_Image.IMAGE_EDIT_PROFILE_ALLOW_BOTTOM_NOR, g_Image.IMAGE_EDIT_PROFILE_ALLOW_BOTTOM_OVER);
}

SceneEditProfile.prototype.changeToDefaultHelpBar= function(){
      
     alert("SceneChat.changeToDefaultHelpBar() " );
     this.MoodMsgInputBox.changeHelpBar( this.InputHelpBar);
     this.FullNameInputBox.registHelpBar( this.InputHelpBar);
     this.EmailInputBox.changeHelpBar( this.InputHelpBar);
     this.CountryRegionBtn.changeHelpBar( this.DefaultHelpBar);
     this.HomePhoneCountryCodeBtn.changeHelpBar( this.DefaultHelpBar);
     this.OfficePhoneCountryCodeBtn.changeHelpBar( this.DefaultHelpBar);
     this.MobilePhoneCountryCodeBtn.changeHelpBar( this.DefaultHelpBar);
     this.StateProvinceInputBox.changeHelpBar( this.InputHelpBar);
     this.CityInputBox.changeHelpBar( this.InputHelpBar);
     this.GenderBtn.changeHelpBar( this.DefaultHelpBar);

    //if( this.flagDayEditable == false)
    //{
        this.DayNumberInputBox.changeHelpBar( this.InputHelpBar);
    /*}
    else
    {
        this.DayNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
    }*/
    
    //if(this.flagMonthEditable == false)
    //{
        this.MonthNumberInputBox.changeHelpBar( this.InputHelpBar);
    /*}
    else
    {
        this.MonthNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
    }*/
    
     //if(this.flagYearEditable == false)
     //{
        this.YearNumberInputBox.changeHelpBar( this.InputHelpBar);
        
      /*}
      else
      {
        this.YearNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
      }*/
     
     this.checkPlusBtnEnable();
}

SceneEditProfile.prototype.changeToSaveHelpBar= function(){
       alert("SceneChat.changeToSaveHelpBar() " );
     this.MoodMsgInputBox.changeHelpBar( this.SaveInputHelpBar);
     this.FullNameInputBox.registHelpBar( this.SaveInputHelpBar);
     this.EmailInputBox.changeHelpBar( this.SaveInputHelpBar);
     this.CountryRegionBtn.changeHelpBar( this.SaveDefaultHelpBar);
     this.HomePhoneCountryCodeBtn.changeHelpBar( this.SaveDefaultHelpBar);
     this.OfficePhoneCountryCodeBtn.changeHelpBar( this.SaveDefaultHelpBar);
     this.MobilePhoneCountryCodeBtn.changeHelpBar( this.SaveDefaultHelpBar);
     this.StateProvinceInputBox.changeHelpBar( this.SaveInputHelpBar);
     this.CityInputBox.changeHelpBar( this.SaveInputHelpBar);
     this.GenderBtn.changeHelpBar( this.SaveDefaultHelpBar);
        // if( this.flagDayEditable == false)
    //{
        this.DayNumberInputBox.changeHelpBar( this.SaveInputHelpBar);
     /*}
     else
     {
        this.DayNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
     }*/
     
     // if(this.flagMonthEditable == false)
    //{
        this.MonthNumberInputBox.changeHelpBar( this.SaveInputHelpBar);
     /*}
     else
     {
        this.MonthNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
     }*/
     
       //   if(this.flagYearEditable == false)
     //{
     this.YearNumberInputBox.changeHelpBar( this.SaveInputHelpBar);
     /*}
     else
     {
        this.YearNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
     }*/
     
     this.checkPlusBtnEnable();
}

SceneEditProfile.prototype.setInitFlag= function(init_flag){
     this.InitFlag = init_flag;
}

SceneEditProfile.prototype.initEditProfile = function()
{
    this.highlight(null);
    
    this.MoodMsgInputBox.SetText("");
    this.FullNameInputBox.SetText("");
    this.EmailInputBox.SetText("");
    this.StateProvinceInputBox.SetText("");
    this.CityInputBox.SetText("");
    
    this.goToPage1();
    this.hideGenderList();
     
    this.SkypeCreditValue.SetText(PluginAPIMgr.GetMyCredit());
    this.VoiceMailExpireValue.SetText(PluginAPIMgr.GetMyVoiceMailExpireDate());
    
    this.initMoodMsgText = PluginAPIMgr.GetMyMoodMsg();
    this.MoodMsgInputBox.SetText(this.initMoodMsgText);
    this.initFullNameText = PluginAPIMgr.GetMyFullName();
    this.FullNameInputBox.SetText(this.initFullNameText);
    this.initEmail  = PluginAPIMgr.GetMyEmail(); 
    this.EmailInputBox.SetText(this.initEmail);

    this.initCountryCode = PluginAPIMgr.GetMyCountryCode();
    this.currCountryCode = this.initCountryCode; 
    this.CountryRegionBtn.SetFgImage(PluginAPIMgr.GetMyCountryFlag());
    this.CountryRegionBtn.SetText(PluginAPIMgr.GetMyCountryName());
    
    this.initHomePhoneNumber = PluginAPIMgr.GetMyHomePhone();
    this.initOfficePhoneNumber = PluginAPIMgr.GetMyOfficePhone();
    this.initMobilePhoneNumber = PluginAPIMgr.GetMyMobilePhone();
    
   if(this.initHomePhoneNumber.length >0) 
   {
       this.initHomePhoneCountryCode =PluginAPIMgr.FindCountryCodeByNumber(this.initHomePhoneNumber );
       this.initHomePhoneLocalCode =PluginAPIMgr.GetLocalNumber(this.initHomePhoneNumber );
       if(this.initHomePhoneLocalCode=="0")
       {
            this.initHomePhoneLocalCode = "";
       }  
   }
   else
   {
   	 this.initHomePhoneLocalCode = "";
	 this.initHomePhoneCountryCode ="";
   }
   
   this.currHomePhoneCountryCode =this.initHomePhoneCountryCode;
   
   if(this.initOfficePhoneNumber.length >0) 
   {
       this.initOfficePhoneCountryCode =PluginAPIMgr.FindCountryCodeByNumber(this.initOfficePhoneNumber);
       this.initOfficePhoneLocalCode =PluginAPIMgr.GetLocalNumber(this.initOfficePhoneNumber);
       if(this.initOfficePhoneLocalCode=="0")
       {
            this.initOfficePhoneLocalCode = "";
       }
   }
   else
   {
   		this.initOfficePhoneLocalCode = "";
		this.initOfficePhoneCountryCode = "";
   }
   
   this.currOfficePhoneCountryCode =this.initOfficePhoneCountryCode;
    
    if(this.initMobilePhoneNumber.length >0) 
   {
       this.initMobilePhoneCountryCode =PluginAPIMgr.FindCountryCodeByNumber(this.initMobilePhoneNumber);
       this.initMobilePhoneLocalCode =PluginAPIMgr.GetLocalNumber(this.initMobilePhoneNumber);
       if(this.initMobilePhoneLocalCode=="0")
       {
            this.initMobilePhoneLocalCode = "";
       } 
   }
   else
   {
   		this.initMobilePhoneLocalCode = "";
		this.initMobilePhoneCountryCode = "";	
   }
   
   this.currMobilePhoneCountryCode =this.initMobilePhoneCountryCode;
   
     this.HomePhoneNumberInputBox.setInitString(this.initHomePhoneLocalCode);
     this.OfficePhoneNumberInputBox.setInitString(this.initOfficePhoneLocalCode);
     this.MobilePhoneNumberInputBox.setInitString(this.initMobilePhoneLocalCode);
     
	 if(this.initHomePhoneCountryCode.length > 0)
	 {
	 	this.HomePhoneCountryCodeBtn.SetFgImage(g_Image.base_flag_image_path + this.initHomePhoneCountryCode.toUpperCase() + ".png");
	 }
	 else
	 {
	 	this.HomePhoneCountryCodeBtn.SetFgImage("");
	 }
	 
     if(this.initOfficePhoneCountryCode.length >0)
	 {
	 	this.OfficePhoneCountryCodeBtn.SetFgImage(g_Image.base_flag_image_path + this.initOfficePhoneCountryCode.toUpperCase() + ".png");
	 }
	 else
	 {
	 	this.OfficePhoneCountryCodeBtn.SetFgImage("");
	 }
     
	 if(this.initMobilePhoneCountryCode.length >0)
	 {
	 	 this.MobilePhoneCountryCodeBtn.SetFgImage(g_Image.base_flag_image_path + this.initMobilePhoneCountryCode.toUpperCase() + ".png");    
	 }
     else
	 {
	 	this.MobilePhoneCountryCodeBtn.SetFgImage("");
	 }
     
     this.initProvince =  PluginAPIMgr.GetMyProvince(); 
     this.StateProvinceInputBox.SetText(this.initProvince);
     
     this.initCity = PluginAPIMgr.GetMyCity();
     this.CityInputBox.SetText(this.initCity); 
     this.initGender =PluginAPIMgr.GetMyGender();
     this.GenderBtn.SetText(this.initGender);
     this.initBirthDate =PluginAPIMgr.GetMyBirthDay();
     var date_len = this.initBirthDate.length;
    this.initDay =this.initBirthDate.substring(date_len-2, date_len);
    this.initMonth =this.initBirthDate.substring(date_len-4,date_len-2);
    this.initYear =this.initBirthDate.substring(date_len-8,date_len-4);
    
    if(this.initYear == "0" || this.initYear=="00" || this.initYear=="000"  || this.initYear=="0000")
    {
        this.initYear = "";
    }
    else
    {
       var a = 4 -  this.initYear.length;
       if(a >=1 && a <= 3)
       {
          for( a ; a > 0; a--)
          {
             this.initYear  = "0"+this.initYear ;
          }
       }
    }
    
     if(this.initMonth == "0" || this.initMonth == "00")
    { 
        this.initMonth = "";
    }
    else
    {
       var b = 2 -  this.initMonth.length;
       if(b ==1)
       {
             this.initMonth = "0"+this.initMonth;
       }
    }
    
     if( this.initDay == "0" || this.initDay == "00")
    {
        this.initDay = "";
    }
    else
    {
       var c = 2 -  this.initDay .length;
       if(c ==1)
       {
             this.initDay  = "0"+this.initDay ;

       }
    
    }
    
     this.DayNumberInputBox.SetText(this.initDay );
     this.MonthNumberInputBox.SetText(this.initMonth);
     this.YearNumberInputBox.SetText(this.initYear );  
     //this.CancelBirthDateEditable();
     
     this.flagChange = false;
     this.changeToDefaultHelpBar();
     
     this.InitFlag = false;
}

SceneEditProfile.prototype.updateScrollBar = function(){   
    var total_item = 2;
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    var a=0;
    for(a=0; a < this.ItemOder.length; a++)
    {
        if(this.ItemOder[a].obj ==currentHighlight)
        {
            alert("SceneChat.updateScrollBar() :  ItemOder : " + a);
            break;
        }
    }
    
    var max_scroll_length = 331;
    var init_scroll_start_position = 87;//77;
    var curr_scroll_start_position = init_scroll_start_position;
    var curr_scroll_length=0;   

    var scroll_rate= Math.floor(max_scroll_length / total_item);
    var upper_item = this.ItemOder[a].oder - 1;
    var extra_length =max_scroll_length - (scroll_rate*total_item)
    
    curr_scroll_start_position =  init_scroll_start_position +(scroll_rate*upper_item);
    curr_scroll_length = scroll_rate + extra_length;

    var center_top = String(curr_scroll_start_position);
    var center_height = String(curr_scroll_length);
    
    var scroll_top = String(curr_scroll_start_position-5);
    var scroll_under = String(curr_scroll_start_position+curr_scroll_length);
    
    $("#edit_profile_scroll_center").css("top",  center_top+"px");
    $("#edit_profile_scroll_center").height(center_height+"px");
    
    $("#edit_profile_scroll_top").css("top",  scroll_top+"px");
    $("#edit_profile_scroll_under").css("top",  scroll_under+"px");
    
    
   alert("SceneEditProfile.updateScrollBar() top: "+ scroll_top+" length : "+center_height+" bottom : " + scroll_under);

}

SceneEditProfile.prototype.highlight=function(obj)
{
    this.EditProfileView.setCurrenHighlight(obj);
    if(obj !=null)
    {
	    if (obj != this.GenderListItem0 && obj != this.GenderListItem1 && obj != this.GenderListItem2)
		{
			this.updateScrollBar();
		}
    }
    
    this.checkPlusBtnEnable();   
}

/*
SceneEditProfile.prototype.startIME= function(obj)
{    
    var scene = $.sfScene.get("EditProfile");
    
    if(obj == this.MoodMsgInputBox)
    {
        if(this.flagMoodMsgInit ==false)
        {
            this.MoodMsgInputBox.initInputBox( this.flagPWD, this.initMoodMsgText, 200,  this.callerObj );
            this.flagMoodMsgInit =true;
       }
       else
       {
            this.MoodMsgInputBox.initInputBox( this.flagPWD, this.MoodMsgInputBox.GetText(), 200,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
    
     if(obj == this.FullNameInputBox)
    {
        if(this.flagFullNameInit ==false)
        {
            this.FullNameInputBox.initInputBox( this.flagPWD, this.initFullNameText, this.maxStringLenght,  this.callerObj );
            this.flagFullNameInit =true
       }
       else
       {
            this.FullNameInputBox.initInputBox( this.flagPWD, this.FullNameInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
     
     if(obj == this.EmailInputBox)
    {
        if(this.flagEmailInit ==false)
        {
            this.EmailInputBox.initInputBox( this.flagPWD, this.initEmail, this.maxStringLenght,  this.callerObj );
            this.flagEmailInit =true
       }
       else
       {
            this.EmailInputBox.initInputBox( this.flagPWD, this.EmailInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
    
      if(obj == this.StateProvinceInputBox)
    {
        if(this.flagStateInit ==false)
        {
            this.StateProvinceInputBox.initInputBox( this.flagPWD, this.initProvince, this.maxStringLenght,  this.callerObj );
            this.flagStateInit =true
       }
       else
       {
            this.StateProvinceInputBox.initInputBox( this.flagPWD, this.StateProvinceInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
    
     if(obj == this.CityInputBox)
    {
        if(this.flagCityInit ==false)
        {
            this.CityInputBox.initInputBox( this.flagPWD, this.initCity, this.maxStringLenght,  this.callerObj );
            this.flagCityInit =true
       }
       else
       {
            this.CityInputBox.initInputBox( this.flagPWD, this.CityInputBox.GetText(), this.maxStringLenght,  this.callerObj );
       }
        obj.imeShow(new IMEShell(obj.IMEObjInfo.id, function(){scene.imeReady()}, 'en'));
    }
}*/

SceneEditProfile.prototype.processLeftKey = function()
{
    alert("SceneEditProfile.processLeftKey() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.HomePhoneCountryCodeBtn:
           this.highlight(this.HomePhoneNumberInputBox);
            break;
        
        case this.OfficePhoneCountryCodeBtn:
            this.highlight(this.OfficePhoneNumberInputBox);
            break;
            
       case this.MobilePhoneCountryCodeBtn:
            this.highlight(this.MobilePhoneNumberInputBox);
            break;
            
       case this.HomePhoneNumberInputBox:
             this.moveToCountryCodeBtn();
            break;
        
        case this.OfficePhoneNumberInputBox:
            this.moveToCountryCodeBtn();
            break;
            
       case this.MobilePhoneNumberInputBox:
             this.moveToCountryCodeBtn();
            break;
            
        case this.DayNumberInputBox:
            //this.CancelBirthDateEditable();
            this.highlight(this.YearNumberInputBox);
            break;
            
        case this.MonthNumberInputBox:
            //this.CancelBirthDateEditable();
           this.highlight(this.DayNumberInputBox);
            break;
            
        case this.YearNumberInputBox:
            //this.CancelBirthDateEditable();
           this.highlight(this.MonthNumberInputBox);
            break;
    }
}

SceneEditProfile.prototype.processRightKey = function()
{
    alert("SceneEditProfile.processRightKey() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
        case this.HomePhoneCountryCodeBtn:
           this.highlight(this.HomePhoneNumberInputBox);
            break;
        
        case this.OfficePhoneCountryCodeBtn:
            this.highlight(this.OfficePhoneNumberInputBox);
            break;
            
       case this.MobilePhoneCountryCodeBtn:
            this.highlight(this.MobilePhoneNumberInputBox);
            break;
            
       case this.HomePhoneNumberInputBox:
             this.moveToCountryCodeBtn();
            break;
        
        case this.OfficePhoneNumberInputBox:
            this.moveToCountryCodeBtn();
            break;
            
       case this.MobilePhoneNumberInputBox:
             this.moveToCountryCodeBtn();
            break;
            
        case this.DayNumberInputBox:
            //this.CancelBirthDateEditable();
            this.highlight(this.MonthNumberInputBox);
            break;
            
        case this.MonthNumberInputBox:
           //this.CancelBirthDateEditable();
           this.highlight(this.YearNumberInputBox);
            break;
            
        case this.YearNumberInputBox:
           //this.CancelBirthDateEditable();
           this.highlight(this.DayNumberInputBox);
            break;
    }
}

SceneEditProfile.prototype.processUpKey = function()
{
    alert("SceneEditProfile.processUpKey() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
   
    switch(currentHighlight)
    {
        case this.MoodMsgInputBox:
        this.goToPage2();
            this.highlight(this.DayNumberInputBox);
            break;
            
       case this.FullNameInputBox:
            this.highlight(this.MoodMsgInputBox);
            break;
            
        case this.EmailInputBox:
            this.highlight(this.FullNameInputBox);
            break;
            
       case this.CountryRegionBtn:
           this.highlight(this.EmailInputBox);
            break;
            
        case this.HomePhoneCountryCodeBtn:
           this.highlight(this.CountryRegionBtn);
            break;
        
        case this.OfficePhoneCountryCodeBtn:
            this.highlight(this.HomePhoneCountryCodeBtn);
            break;
            
       case this.MobilePhoneCountryCodeBtn:
            this.highlight(this.OfficePhoneCountryCodeBtn);
            break;
            
       case this.HomePhoneNumberInputBox:
             this.highlight(this.CountryRegionBtn);
            break;
        
        case this.OfficePhoneNumberInputBox:
            this.highlight(this.HomePhoneNumberInputBox);
            break;
            
       case this.MobilePhoneNumberInputBox:
            this.highlight(this.OfficePhoneNumberInputBox);
            break;
            
        case this.StateProvinceInputBox:
            this.goToPage1();
            this.highlight(this.MobilePhoneNumberInputBox);
            break;
            
        case this.CityInputBox:
            this.highlight(this.StateProvinceInputBox);
            break;
            
        case this.GenderBtn:        
			if(this.FlagShowGenderList==true)
			{
				this.hideGenderList();
			}
            
            this.highlight(this.CityInputBox);
            break;
            
        case this.DayNumberInputBox:
         /* if(this.flagDayEditable==true)
         {
            this.UpDay();
         }
         else
         {*/
            this.highlight(this.GenderBtn);
           //}
           
            break;
            
        case this.MonthNumberInputBox:
          /* if(this.flagMonthEditable==true)
         {
            this.UpMonth();
         }
         else
         {*/
            this.highlight(this.GenderBtn);
          // }
           
            break;
            
        case this.YearNumberInputBox:
         /* if(this.flagYearEditable==true)
         {
            this.UpYear();
         }
         else
         {*/
            this.highlight(this.GenderBtn);
          // }
           
            break;
            
        case this.GenderListItem0:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem2);
            }
            break;
            
        case this.GenderListItem1:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem0);
            }
            break;
            
        case this.GenderListItem2:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem1);
            }
            break;
    }
}

SceneEditProfile.prototype.processDownKey = function()
{
    alert("SceneEditProfile.processDownKey() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();

    switch(currentHighlight)
    {
        case this.MoodMsgInputBox:
            this.highlight(this.FullNameInputBox);
            break;
            
        case this.FullNameInputBox:
            this.highlight(this.EmailInputBox);
            break;
            
        case this.EmailInputBox:
           this.highlight(this.CountryRegionBtn);
            break;
            
       case this.CountryRegionBtn:
           this.highlight(this.HomePhoneNumberInputBox);
            break;
            
        case this.HomePhoneCountryCodeBtn:
           this.highlight(this.OfficePhoneCountryCodeBtn);
            break;
        
        case this.OfficePhoneCountryCodeBtn:
            this.highlight(this.MobilePhoneCountryCodeBtn);
            break;
            
       case this.MobilePhoneCountryCodeBtn:
            this.goToPage2();
            this.highlight(this.StateProvinceInputBox);
            break;
            
       case this.HomePhoneNumberInputBox:
             this.highlight(this.OfficePhoneNumberInputBox);
            break;
        
        case this.OfficePhoneNumberInputBox:
            this.highlight(this.MobilePhoneNumberInputBox);
            break;
            
       case this.MobilePhoneNumberInputBox:
            this.goToPage2();
            this.highlight(this.StateProvinceInputBox);
            break;
            
        case this.StateProvinceInputBox:
            this.highlight(this.CityInputBox);
            break;
            
        case this.CityInputBox:
            this.moveToGenderBtn();
            break;
            
        case this.GenderBtn:
        
             if(this.FlagShowGenderList==false)
            {
                this.highlight(this.DayNumberInputBox);
            }
            else
            {
                 this.highlight(this.GenderListItem0);
            }

            break;
            
        case this.DayNumberInputBox:
         /*if(this.flagDayEditable==true)
         {
            this.DownDay();
         }
         else
         {*/
            this.goToPage1();
           this.highlight(this.MoodMsgInputBox);
           //}
            break;
            
        case this.MonthNumberInputBox:
         /*if(this.flagMonthEditable==true)
         {
            this.DownMonth();
         }
         else
         {*/
            this.goToPage1();
           this.highlight(this.MoodMsgInputBox);
           //}
            break;
            
        case this.YearNumberInputBox:
          /*  if(this.flagYearEditable==true)
         {
            this.DownYear();
         }
         else
         {*/
            this.goToPage1();
           this.highlight(this.MoodMsgInputBox);
           //}
            break;

            break;
            
        case this.GenderListItem0:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem1);
            }
            break;
            
        case this.GenderListItem1:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem2);
            }
            break;
            
        case this.GenderListItem2:
             if(this.FlagShowGenderList==true)
            {
                this.highlight(this.GenderListItem0);
            }
            break;
    }
}

SceneEditProfile.prototype.togglePage = function(){
    alert("SceneEditProfile.togglePage() ");
    if(this.currPage==1)
    {
    	this.goToPage2();
    	this.highlight(this.StateProvinceInputBox);
    }
    else
    {
    	this.goToPage1();
    	this.highlight(this.MoodMsgInputBox);
    }
}

SceneEditProfile.prototype.goToPage1 = function(){
    alert("SceneEditProfile.goToPage1() ");
     this.currPage =1;
     this.EditProfilePage2.hiddenObj();
     this.EditProfilePage1.visibleObj();    
 }
 
SceneEditProfile.prototype.goToPage2 = function(){
    alert("SceneEditProfile.goToPage2() ");
    this.currPage =2;
     this.EditProfilePage1.hiddenObj();
     this.EditProfilePage2.visibleObj();    
}
 
SceneEditProfile.prototype.showGenderList= function(){
    alert("SceneEditProfile.showGenderList() ");
    this.FlagShowGenderList = true;
    
     this.StateProvinceInputBox.DisableOnClick();
     this.CityInputBox.DisableOnClick();
     this.GenderBtn.DisableOnClick();
     this.DayNumberInputBox.DisableOnClick();
     this.MonthNumberInputBox.DisableOnClick();
     this.YearNumberInputBox.DisableOnClick();
     this.TopArrow.DisableOnClick();
     this.BottomArrow.DisableOnClick();
     
    this.GenderList.visibleObj();
	
	if(this.GenderBtn.GetText() ==this.GenderListItem1.GetText())
	{
		this.highlight(this.GenderListItem1);
	}
	else if(this.GenderBtn.GetText() ==this.GenderListItem2.GetText())
	{
		this.highlight(this.GenderListItem2);
	}
	else
	{
		this.highlight(this.GenderListItem0);
	}    
 }
 
SceneEditProfile.prototype.hideGenderList= function(){
    alert("SceneEditProfile.hideGenderList() ");
    this.FlagShowGenderList = false;
    
     this.StateProvinceInputBox.EnableOnClick();
     this.CityInputBox.EnableOnClick();
     this.GenderBtn.EnableOnClick();
     this.DayNumberInputBox.EnableOnClick();
     this.MonthNumberInputBox.EnableOnClick();
     this.YearNumberInputBox.EnableOnClick();
     this.TopArrow.EnableOnClick();
     this.BottomArrow.EnableOnClick();
     
    this.GenderList.hiddenObj();    
 }
 
/*
SceneEditProfile.prototype.initInputBox = function(flagPWD, initText, maxLen, callerObj)
{
    alert("SceneEditProfile.initInputBox()");
    this.flagPWD = flagPWD;
    this.initText = initText;
    this.maxStringLenght = maxLen;
    this.callerObj = callerObj;
}

SceneEditProfile.prototype.imeReady = function(){
    alert("SceneEditProfile.imeReady() ");

	var obj = this.EditProfileView.getCurrentHighlight();

    obj.setKeyFunc($.sfKey.LEFT, function(keyCode){$.sfScene.get('EditProfile').processLeftKey();  return false;});
	obj.setKeyFunc($.sfKey.RIGHT,  function(keyCode){$.sfScene.get('EditProfile').processRightKey();  return false;});
    obj.setKeyFunc($.sfKey.DOWN, function(keyCode){$.sfScene.get('EditProfile').processDownKey();  return false;});
	obj.setKeyFunc($.sfKey.UP,  function(keyCode){$.sfScene.get('EditProfile').processUpKey();  return false;});

    obj.setKeyFunc(88,  function(keyCode){$.sf.returnFocus();  $.sfScene.get('EditProfile').processReturnKey(); $.sfKey.block(event); return false;}); // return key
    obj.setKeyFunc(108,  function(keyCode){$.sfScene.get('EditProfile').DeleteAllText();  $.sfScene.get('EditProfile').isChange(); return false;}); // red key
    obj.setKeyFunc(22,  function(keyCode){$.sfScene.get('EditProfile').processBlueKey();  return false;}); // blue key
    
    obj.setAnyKeyFunc(function(){$.sfScene.get('EditProfile').isChange()});
        
	obj.setReady();
}

SceneEditProfile.prototype.GetInputText = function()
{
    var obj = this.EditProfileView.getCurrentHighlight();
    return obj.getString();
}

SceneEditProfile.prototype.DeleteAllText = function()
{
    var obj = this.EditProfileView.getCurrentHighlight();
    obj. setString("");
}
*/

SceneEditProfile.prototype.moveToCountryRegionBtn = function()
{
    alert("SceneAddContactPhoneNumber.moveToCountryRegionBtn() ");

    this.highlight(this.CountryRegionBtn);
   	$.sfScene.focus('EditProfile');
    $.sf.returnFocus();
}

SceneEditProfile.prototype.moveToGenderBtn = function()
{
    alert("SceneAddContactPhoneNumber.moveToGenderBtn() ");
  
    this.highlight(this.GenderBtn);
    $.sfScene.get('EditProfile').isChange();
}

SceneEditProfile.prototype.moveToCountryCodeBtn= function()
{
    alert("SceneAddContactPhoneNumber.moveToCountryCodeBtn() ");
    
        var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    if(currentHighlight == this.HomePhoneNumberInputBox)
    {
         this.highlight(this.HomePhoneCountryCodeBtn);
    }
    
     if( currentHighlight == this.OfficePhoneNumberInputBox)
    {
        this.highlight(this.OfficePhoneCountryCodeBtn);  
    }
    
     if(currentHighlight == this.MobilePhoneNumberInputBox)
    {
        this.highlight(this.MobilePhoneCountryCodeBtn); 
    }
   
   	$.sfScene.focus('EditProfile');
    $.sf.returnFocus();
}

SceneEditProfile.prototype.processEnterKey = function(){

	var currentHighlight =  this.EditProfileView.getCurrentHighlight();
	var ThisScene = $.sfScene.get("EditProfile");
	
	switch(currentHighlight)
	{
		case this.CountryRegionBtn:
		case this.HomePhoneCountryCodeBtn:
		case this.OfficePhoneCountryCodeBtn:
		case this.MobilePhoneCountryCodeBtn:
		case this.HomePhoneNumberInputBox:
		case this.OfficePhoneNumberInputBox:
		case this.MobilePhoneNumberInputBox:
		case this.GenderBtn:
		case this.GenderListItem0:
		case this.GenderListItem1:
		case this.GenderListItem2:
		case this.DayNumberInputBox:
		case this.MonthNumberInputBox:
		case this.YearNumberInputBox:
		
			this.resetTimer();
		break;
	}
	
	switch(currentHighlight)
	{  
          case this.MoodMsgInputBox:
          case this.FullNameInputBox:
          case this.EmailInputBox:
          	
          	this.startTextInput();
            break;

		case this.CountryRegionBtn:
			this.showCountryList();
			break;      
		case this.HomePhoneCountryCodeBtn:
			this.showPrefixList(FLAG_LIST_TYPE.EDIT_PROFILE_HOME_PHONE,ThisScene.SetHomeCountry,null);
			break;
		
		case this.OfficePhoneCountryCodeBtn:
			this.showPrefixList(FLAG_LIST_TYPE.EDIT_PROFILE_OFFICE_PHONE,ThisScene.SetOfficeCountry,null);
			break;
		
		case this.MobilePhoneCountryCodeBtn:
			this.showPrefixList(FLAG_LIST_TYPE.EDIT_PROFILE_MOBILE_PHONE,ThisScene.SetMobileCountry,null);
			break;
// add (UI, Setting <v1.21>, 20110621)--------------------------------------------------------------------------->>	
		case this.HomePhoneNumberInputBox:
			this.highlight(this.OfficePhoneNumberInputBox);
			break;
        
        case this.OfficePhoneNumberInputBox:
			this.highlight(this.MobilePhoneNumberInputBox);
			break;
            
		case this.MobilePhoneNumberInputBox:
            this.goToPage2();
            this.highlight(this.StateProvinceInputBox);
            break;
// -------------------------------------------------------------------------------------------------------------<<			
       case this.GenderBtn:
            if(this.FlagShowGenderList==false)
            {
                this.showGenderList();
            }
            else
            {
                 this.hideGenderList();
            }
            
            break;
            
        case this.StateProvinceInputBox:
        case this.CityInputBox:
        
            this.startTextInput();
            break;

        case this.DayNumberInputBox:
			this.ShowDayList();
			break;
			
        case this.MonthNumberInputBox:
			this.ShowMonthList();
			break;
			
        case this.YearNumberInputBox:
			this.ShowYearList();
			break;
                        
       case this.GenderListItem0:
       case this.GenderListItem1:
       case this.GenderListItem2:
       
             if(this.FlagShowGenderList==true)
            {
                this.GenderBtn.SetText(currentHighlight.GetText());
            }
            this.hideGenderList();
            this.moveToGenderBtn();
            break;
	}

}
/*
SceneEditProfile.prototype.ToggleBirthDateEditable= function()
{
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    if(currentHighlight ==this.DayNumberInputBox)
    {
        if(this.flagDayEditable == false)
        {
            this.flagDayEditable = true;         
        }
        else
        {
            this.flagDayEditable = false;           
        }
            
        this.flagMonthEditable = false;
        this.flagYearEditable = false;    
    }
    
   if(currentHighlight ==this.MonthNumberInputBox)
    {
        if(this.flagMonthEditable == false)
        {
            this.flagMonthEditable = true;          
        }
        else
        {
            this.flagMonthEditable = false;          
        }
            
        this.flagDayEditable = false;
        this.flagYearEditable = false;   
    }
    
     if(currentHighlight ==this.YearNumberInputBox)
    {
        if(this.flagYearEditable == false)
        {
            this.flagYearEditable = true;           
        }
        else
        {
            this.flagYearEditable = false;           
        }
        
        this.flagDayEditable = false;
        this.flagMonthEditable = false;   
    }
    
    this.SetEditableIcon();
}

SceneEditProfile.prototype.CancelBirthDateEditable= function()
{
    this.flagDayEditable = false;
    this.flagMonthEditable = false;
    this.flagYearEditable = false;
    this.SetEditableIcon();
}

SceneEditProfile.prototype.SetEditableIcon= function()
{
    this.DayNumberInputBox.SetFgImage("");
    this.MonthNumberInputBox.SetFgImage("");
    this.YearNumberInputBox.SetFgImage("");
    
    if(this.flagDayEditable == true)
    {
         this.DayNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
         this.maxDay = this.GetMaxDay();
         
         if(this.DayNumberInputBox.GetText() =="")
         {
             this.DayNumberInputBox.SetText("00");
         }
         
         if(this.flagChange == true)
         {
            this.DayNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
        }
        else
        {
            this.DayNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateInputHelpBar);
        }
    }
     else if(this.flagMonthEditable == true)
    {
          this.MonthNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
          
          if(this.MonthNumberInputBox.GetText() =="")
         {
             this.MonthNumberInputBox.SetText("00");
         }
          
           if(this.flagChange == true)
         {
            this.DayNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
        }
        else
        {
            this.DayNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateInputHelpBar);
        }
        
    }
    else if(this.flagYearEditable == true)
    {
          this.YearNumberInputBox.SetFgImage(g_Image.IMAGE_EDIT_PROFILE_ARROW_UP_DOWN);
          
          if(this.YearNumberInputBox.GetText() =="")
         {
             this.YearNumberInputBox.SetText("0000");
         }
          
          if(this.flagChange == true)
         {
            this.DayNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateSaveSelectHelpBar);
        }
        else
        {
            this.DayNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateSelectHelpBar);
        }
    }
    else
    {
         if(this.flagChange == true)
         {
            this.DayNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateSaveInputHelpBar);
        }
        else
        {
            this.DayNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.MonthNumberInputBox.changeHelpBar( this.DateInputHelpBar);
            this.YearNumberInputBox.changeHelpBar( this.DateInputHelpBar);
        }
        
          if(this.DayNumberInputBox.GetText() =="00")
         {
             this.DayNumberInputBox.SetText("");
         }
         
          if(this.MonthNumberInputBox.GetText() =="00")
         {
             this.MonthNumberInputBox.SetText("");
         }
         
          if(this.YearNumberInputBox.GetText() =="0000")
         {
             this.YearNumberInputBox.SetText("");
         }
    }
}






SceneEditProfile.prototype.DownDay= function()
{
    var current_day= Number(this.DayNumberInputBox.GetText());
    
    if( current_day == 0)
    {
        current_day = this.maxDay; 
    }
    else
    {
         current_day --;
         
         if(current_day < this.minDay)
         {
            current_day = this.maxDay;
         }
    }
    
       var input_day = String(current_day);
       var b = 2 -  input_day.length;
       if(b >=1)
       {
          for( b ; b > 0; b--)
          {
             input_day = "0"+input_day;
          }
       }
       
       this.DayNumberInputBox.SetText(input_day);
}

SceneEditProfile.prototype.UpDay= function()
{
    var current_day = Number(this.DayNumberInputBox.GetText());
    
    if( current_day == 0)
    {
        current_day = this.minDay; 
    }
    else
    {
         current_day ++;
         
         if(current_day > this.maxDay)
         {
            current_day = this.minDay;
         }
    }
    
       var input_day = String(current_day);
       var b = 2 -  input_day.length;
       if(b >=1)
       {
          for( b ; b > 0; b--)
          {
             input_day = "0"+input_day;
          }
       }
       
       this.DayNumberInputBox.SetText(input_day);
}

SceneEditProfile.prototype.DownMonth= function()
{
    var current_month = Number(this.MonthNumberInputBox.GetText());
    
    if( current_month == 0)
    {
        current_month = this.maxMonth; 
    }
    else
    {
         current_month --;
         
         if(current_month < this.minMonth)
         {
            current_month = this.maxMonth;
         }
    }
    
       var input_month = String(current_month);
       var b = 2 -  input_month.length;
       if(b >=1)
       {
          for( b ; b > 0; b--)
          {
             input_month = "0"+input_month;
          }
       }
       
       this.MonthNumberInputBox.SetText(input_month);
       
       this.ChangeDay();
}

SceneEditProfile.prototype.UpMonth= function()
{
    var current_month = Number(this.MonthNumberInputBox.GetText());
    
    if( current_month == 0)
    {
        current_month = this.minMonth; 
    }
    else
    {
         current_month ++;
         
         if(current_month > this.maxMonth)
         {
            current_month = this.minMonth;
         }
    }
    
       var input_month = String(current_month);
       var b = 2 -  input_month.length;
       if(b >=1)
       {
          for( b ; b > 0; b--)
          {
             input_month = "0"+input_month;
          }
       }
       
       this.MonthNumberInputBox.SetText(input_month);
       
       this.ChangeDay();
}

SceneEditProfile.prototype.DownYear= function()
{
    var current_year= Number(this.YearNumberInputBox.GetText());
    
    if( current_year == 0)
    {
        current_year = this.maxYear; 
    }
    else
    {
         current_year --;
         
         if(current_year < this.minYear)
         {
            current_year = this.maxYear;
         }
    }
    
       var input_year = String(current_year);
       
       this.YearNumberInputBox.SetText(input_year);
       
       this.ChangeDay();
}

SceneEditProfile.prototype.UpYear= function()
{
    var current_year = Number(this.YearNumberInputBox.GetText());
    
    if( current_year == 0)
    {
        current_year = this.minYear; 
    }
    else
    {
         current_year ++;
         
         if(current_year > this.maxYear)
         {
            current_year = this.minYear;
         }
    }
    
       var input_year = String(current_year);
       
       this.YearNumberInputBox.SetText(input_year);
       
       this.ChangeDay();
}
*/

SceneEditProfile.prototype.showPrefixList = function(type,callBack)
{
	alert("SceneEditProfile.showFlagList() ");
		
	var ThisScene = $.sfScene.get("EditProfile");
	var ListScene = $.sfScene.get("CountryFlagList");
	var CountryCode;
	
	if(type == FLAG_LIST_TYPE.EDIT_PROFILE_HOME_PHONE){
		CountryCode = ThisScene.currHomePhoneCountryCode;
	}
	else if(type == FLAG_LIST_TYPE.EDIT_PROFILE_MOBILE_PHONE){
		CountryCode = ThisScene.currMobilePhoneCountryCode;
	}
	else{
		CountryCode = ThisScene.currOfficePhoneCountryCode;
	}
	
	var Index = g_Data.GetCountryIndexWithCode(CountryCode);
	
	ListScene.Init(type,'EditProfile',callBack,null);	
				
	$.sfScene.get("CountryFlagList").SetCurIndex(Index);					
	$.sfScene.show('CountryFlagList');
	setTimeout("CloseTimerCF()", 0);
	CloseTimerCF = function(){$.sfScene.focus('CountryFlagList');}	
	
	this.flagShownPrefixList = true;
	
}

SceneEditProfile.prototype.SetHomeCountry = function()
{
    alert("SceneEditProfile.SetCountry() ");
	
	var Scene = $.sfScene.get("CountryFlagList");	
	var FlagImage = Scene.GetCountryFlag();
	var Prefix = Scene.GetPrefix();
    var CountryCode = Scene.GetCountryCode();

	var This_ = $.sfScene.get("EditProfile");	
	This_.HomePhoneCountryCodeBtn.SetFgImage(FlagImage);
	This_.currHomePhoneCountryCode = CountryCode;
    
    $.sfScene.get('EditProfile').isChange();
	
}

SceneEditProfile.prototype.SetOfficeCountry = function()
{
    alert("SceneEditProfile.SetOfficeCountry() ");

	var Scene = $.sfScene.get("CountryFlagList");	
	var FlagImage = Scene.GetCountryFlag();
	var Prefix = Scene.GetPrefix();
    var CountryCode = Scene.GetCountryCode();

	var This_ = $.sfScene.get("EditProfile");	
	This_.OfficePhoneCountryCodeBtn.SetFgImage(FlagImage);
	This_.currOfficePhoneCountryCode = CountryCode;
    
    $.sfScene.get('EditProfile').isChange();

}

SceneEditProfile.prototype.SetMobileCountry = function()
{
    alert("SceneEditProfile.SetMobileCountry() ");

	var Scene = $.sfScene.get("CountryFlagList");	
	var FlagImage = Scene.GetCountryFlag();
	var Prefix = Scene.GetPrefix();
    var CountryCode = Scene.GetCountryCode();

	var This_ = $.sfScene.get("EditProfile");	
	This_.MobilePhoneCountryCodeBtn.SetFgImage(FlagImage);
	This_.currMobilePhoneCountryCode = CountryCode;
    
    $.sfScene.get('EditProfile').isChange();

}
SceneEditProfile.prototype.showCountryList = function()
{
	alert("SceneEditProfile.showCountryList() ");

	var this_ = $.sfScene.get("EditProfile");	
	var Index = g_Data.GetCountryIndexWithCode(this.currCountryCode);
	
	StateMgr.Show_CountryFlagName(COUNTRY_LIST_TYPE.EDIT_PROFILE,'EditProfile',this_.SetCountry,Index);
	
	this.flagShownCountryList = true;
}

SceneEditProfile.prototype.SetCountry = function()
{
    alert("SceneEditProfile.SetCountry() ");
	
	var ListScene = $.sfScene.get("SignupCountryList");	
	var this_ = $.sfScene.get("EditProfile");
    var Prefix = ListScene.GetPrefix();
    var CountryCode = ListScene.GetCountryCode();

	this_.CountryRegionBtn.SetText(ListScene.GetCountryName());				
	this_.CountryRegionBtn.SetFgImage(ListScene.GetCountryFlag());	
	this_.currCountryCode =CountryCode;
    
    $.sfScene.get('EditProfile').isChange();
}

SceneEditProfile.prototype.isChange= function()
{
    if( this.InitFlag == true)
    {
        return;
    }
    
    var backup_flag = this.flagChange ;
    this.flagChange = false;
    
    if(this.initMoodMsgText !=this.MoodMsgInputBox.GetText())
    {
        this.flagChange = true;
    }
    
    if(this.initFullNameText !=this.FullNameInputBox.GetText())
    {
        this.flagChange = true;
    }
    
     if(this.initEmail !=this.EmailInputBox.GetText())
    {
        this.flagChange = true;
    }
    
    if(this.initCountryCode != this.currCountryCode )
    {
        this.flagChange = true;
    }
    
    if(this.currHomePhoneCountryCode !=this.initHomePhoneCountryCode)
    {
        this.flagChange = true;
    }
    
    if(this.currOfficePhoneCountryCode !=this.initOfficePhoneCountryCode)
    {
        this.flagChange = true;
    }
    
     if(this.currMobilePhoneCountryCode !=this.initMobilePhoneCountryCode)
    {
        this.flagChange = true;
    }
    
    if( this.initHomePhoneLocalCode !=this.HomePhoneNumberInputBox.GetText())
   {
        this.flagChange = true;
    }
    
    if(this.initOfficePhoneLocalCode != this.OfficePhoneNumberInputBox.GetText())
    {
        this.flagChange = true;
    }
    
    if(this.initMobilePhoneLocalCode != this.MobilePhoneNumberInputBox.GetText())
   {
        this.flagChange = true;
   }
   
   if(this.initProvince != this.StateProvinceInputBox.GetText())
   {
        this.flagChange = true;
   }
   
   if(this.initCity != this.CityInputBox.GetText())
   {
        this.flagChange = true;
   }
  
   if(this.initGender != this.GenderBtn.GetText())
   {
        this.flagChange = true;
   }
   
    if( this.DayNumberInputBox.GetText() != "" && this.DayNumberInputBox.GetText() != "00" &&  
        this.MonthNumberInputBox.GetText() != "" &&  this.MonthNumberInputBox.GetText() != "00" && 
        this.YearNumberInputBox.GetText() != "" &&  this.YearNumberInputBox.GetText() != "0000")
    {
        if(this.initDay != this.DayNumberInputBox.GetText())
       {
            this.flagChange = true;
       }
       
       if(this.initMonth != this.MonthNumberInputBox.GetText())
       {
            this.flagChange = true;
       }
       
        if(this.initYear != this.YearNumberInputBox.GetText())
       {
            this.flagChange = true;
       }
   }
   
   if(backup_flag !=  this.flagChange )
   {
       if(this.flagChange == true)
       {
            this.changeToSaveHelpBar();
       }
       else
       { 
            this.changeToDefaultHelpBar();
       }
   }
   else
   {
        this.checkPlusBtnEnable();   
   }
   
   alert("SceneEditProfile.isChange () :  " + this.flagChange );
  
   return  this.flagChange; 

}

SceneEditProfile.prototype.processReturnKey = function(){
    alert("SceneEditProfile.processReturnKey() ");
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    if(currentHighlight == this.GenderListItem0 ||  currentHighlight == this.GenderListItem1 || currentHighlight == this.GenderListItem2)
    {
            this.hideGenderList();
            this.moveToGenderBtn();
    }
    else
    {
	 	this.highlight(null);
		
        if(this.isChange() == true)
        {
            WndMgr.StartEditProfileSaveReturnStep();
        }
        else
        {
            StateMgr.Stop_Edit_Profile_State(true); 
        }
    }
}

SceneEditProfile.prototype.processExitKey = function(){
    alert("SceneEditProfile.processExitKey() ");
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    if(currentHighlight != this.GenderListItem0 &&  currentHighlight != this.GenderListItem1 && currentHighlight != this.GenderListItem2)
    {
	 	this.highlight(null);
		
        if(this.isChange() == true)
        {
            WndMgr.StartEditProfileSaveReturnStep();
        }
        else
        {
            StateMgr.Stop_Edit_Profile_State(true); 
        }
    }
}


SceneEditProfile.prototype.processBlueKey = function(){
    alert("SceneEditProfile.processBlueKey() ");
    
     if(this.isChange() ==false)
    {
        return; 
    }
    
	this.highlight(null);
    this.saveProfile();
}

SceneEditProfile.prototype.saveProfile= function()
{
    alert("SceneEditProfile.saveProfile() ");

    var mood_msg = this.MoodMsgInputBox.GetText(); 
    var full_name = this.FullNameInputBox.GetText(); 
    var email = this.EmailInputBox.GetText();
    var country_code = this.currCountryCode;
    
    var home_phone = this.addCountryPrefix(this.currHomePhoneCountryCode, this.HomePhoneNumberInputBox.GetText() );
    var office_phone= this.addCountryPrefix(this.currOfficePhoneCountryCode, this.OfficePhoneNumberInputBox.GetText() );
    var mobile_phone= this.addCountryPrefix(this.currMobilePhoneCountryCode, this.MobilePhoneNumberInputBox.GetText() );
    
    var province = this.StateProvinceInputBox.GetText();
    var city = this.CityInputBox.GetText();
    var gender = this.GenderBtn.GetText(); 
    
    var input_year = this.YearNumberInputBox.GetText();
    var input_month =  this.MonthNumberInputBox.GetText(); 
    var input_day = this.DayNumberInputBox.GetText();
    
     if(input_year.length ==0 || input_month.length ==0 || input_day.length  == 0 || input_year =="0000" || input_month =="00" || input_day  == "00")  // don't change
     {
        if(this.initYear.length >0 && this.initMonth.length >0 && this.initDay.length >0 )
        {
            input_year = this.initYear ;
            input_month = this.initMonth ;
            input_day = this.initDay ;
        }
        else
        {
            input_year = "0000" ;
            input_month = "00" ;
            input_day = "00" ;
        }
     }

    var birth_day = input_year + input_month + input_day;
    
    ProcMgr.SaveProfile(mood_msg, full_name,email, country_code, home_phone, office_phone, mobile_phone, province, city, gender, birth_day );

}

SceneEditProfile.prototype.addCountryPrefix = function(input_country_code, input_phone_number){
    var Prefix = PluginAPIMgr.GetISOCountryPrefix(input_country_code);
    alert("SceneEditProfile.addCountryPrefix() : " + Prefix);
    
    if(input_phone_number.indexOf("+") ==0)
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("00") ==0 )
    {
        return input_phone_number;
    }
    else if(input_phone_number.indexOf("011") ==0)
    {
        return input_phone_number;
    }
    else
    {
		if(input_phone_number.length >0)
		{
			if(Prefix !="0")
			{
				return  "+"+ Prefix + input_phone_number;	
			}
			else
			{
				return  input_phone_number;
			}			
		}
		else
		{
			return "";
		}		
    }   
}

SceneEditProfile.prototype.InputEmailAgain = function()
{
    alert("SceneEditProfile.InputEmailAgain() ");
   
    this.reserveHighlight  =this.EmailInputBox;
}


SceneEditProfile.prototype.checkPlusBtnEnable = function()
{
    alert("SceneEditProfile.checkPlusBtnEnable() ");
        
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    if(currentHighlight !=this.HomePhoneNumberInputBox && currentHighlight !=this.OfficePhoneNumberInputBox  && currentHighlight !=this.MobilePhoneNumberInputBox )
    {
           return;
    }
    
    var PhoneNumberInputBox =  currentHighlight;
    var input_phone_number = PhoneNumberInputBox.GetText();
    var pos_of_caret = PhoneNumberInputBox.GetPosOfCaret();
    
    if(input_phone_number.length ==0)
    {
        this.flagPlusBtnEnable = true;
    }
    else if(input_phone_number.indexOf("+") ==0 || input_phone_number.indexOf("00") ==0 || input_phone_number.indexOf("011") ==0)
    {
        this.flagPlusBtnEnable = false;
    }   
    else if( pos_of_caret ==0)
    {
        this.flagPlusBtnEnable = true;
    }
    else
    {
         this.flagPlusBtnEnable = false;
    }

    this.setPlusBtnEnable();
}

SceneEditProfile.prototype.setPlusBtnEnable = function()
{
    alert("SceneEditProfile.setPlusBtnEnable() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    if(currentHighlight !=this.HomePhoneNumberInputBox && currentHighlight !=this.OfficePhoneNumberInputBox  && currentHighlight !=this.MobilePhoneNumberInputBox )
    {
           return;
    }
    
    var PhoneNumberInputBox =  currentHighlight;
    
    if(this.flagPlusBtnEnable == true)
    {
        if(this.flagChange == true)
        {
            PhoneNumberInputBox.changeHelpBar( this.PlusSavePhoneNumberInputHelpBar);
        }
        else
        {
             PhoneNumberInputBox.changeHelpBar( this.PlusPhoneNumberInputHelpBar);
        }
        
        PhoneNumberInputBox.setFlagPhoneNumber(true);
    }
    else
    {   
         if(this.flagChange == true)
        {
            PhoneNumberInputBox.changeHelpBar( this.SavePhoneNumberInputHelpBar);
        }
        else
        {
             PhoneNumberInputBox.changeHelpBar( this.PhoneNumberInputHelpBar);
        }
        
        PhoneNumberInputBox.setFlagPhoneNumber(false);
    }    
}

SceneEditProfile.prototype.GetMaxDay= function()
{
    var current_month = Number(this.MonthNumberInputBox.GetText());
    var current_year= Number(this.YearNumberInputBox.GetText());
    
    var max_day = 31;
    
    if(current_month ==0 || current_year==0)
    {
        max_day = 31;
    }
    else
    {
        if(current_month == 1 || current_month == 3 || current_month == 5 || current_month == 7 || current_month == 8 || current_month == 10 || current_month == 12 )
        {
            max_day = 31;
        }
         else if(current_month == 4 || current_month == 6 || current_month == 9 || current_month == 11 )
        {
            max_day = 30;
        }
        else
        {
             if ((current_year % 4 == 0 && current_year % 100 != 0) || current_year % 400 == 0)
             {
                max_day = 29;
             }
             else
             {
                max_day = 28;
             }
        }
        
    }
    
    return max_day;
}

SceneEditProfile.prototype.ChangeDay= function()
{
       var current_year= Number(this.YearNumberInputBox.GetText());
       var current_month = Number(this.MonthNumberInputBox.GetText());
       var current_day = Number(this.DayNumberInputBox.GetText());
       
       if(current_year>0 && current_month >0)
       {
          var max_day= this.GetMaxDay();
          
          if( current_day > max_day)
          {
               current_day =  this.minDay
               var input_day = String(current_day);
               var b = 2 -  input_day.length;
               if(b >=1)
               {
                  for( b ; b > 0; b--)
                  {
                     input_day = "0"+input_day;
                  }
               }
               
               this.DayNumberInputBox.SetText(input_day);
          }
       }
}

SceneEditProfile.prototype.ShowDayList = function(){

	var current_day	= Number(this.DayNumberInputBox.GetText());
	var maxday		= this.GetMaxDay();	
	var ThisScene	= $.sfScene.get("EditProfile");
	
	$.sfScene.get('EditProfileDayList').Init(maxday,current_day,ThisScene.SetDay);
	$.sfScene.show('EditProfileDayList');
	$.sfScene.focus('EditProfileDayList');
	
	this.flagShownDayList = true;
		
}

SceneEditProfile.prototype.ShowMonthList = function(){

	var current_month	= Number(this.MonthNumberInputBox.GetText());	
	var ThisScene	= $.sfScene.get("EditProfile");
	
	$.sfScene.get('EditProfileMonthList').Init(current_month,ThisScene.SetMonth);
	$.sfScene.show('EditProfileMonthList');
	$.sfScene.focus('EditProfileMonthList');
	
	this.flagShownMonthList = true;
		
}

SceneEditProfile.prototype.ShowYearList = function(){

	var current_year	= Number(this.YearNumberInputBox.GetText());	
	var ThisScene	= $.sfScene.get("EditProfile");

	$.sfScene.show('EditProfileYearList');
	$.sfScene.get('EditProfileYearList').Init(current_year,ThisScene.SetYear);
	$.sfScene.focus('EditProfileYearList');
	
	this.flagShownYearList = true;
		
}


SceneEditProfile.prototype.SetDay = function()
{
    alert("SceneEditProfile.SetDay() ");
	
	var dayScene = $.sfScene.get("EditProfileDayList");	
	var thisScene = $.sfScene.get("EditProfile");
	
    var day = dayScene.GetDay();
	thisScene.DayNumberInputBox.SetText(day);				
}

SceneEditProfile.prototype.SetMonth = function()
{
    alert("SceneEditProfile.SetMonth() ");
	
	var dayScene = $.sfScene.get("EditProfileMonthList");	
	var thisScene = $.sfScene.get("EditProfile");
	
    var month = dayScene.GetMonth();
	thisScene.MonthNumberInputBox.SetText(month);	
	thisScene.ChangeDay();				
}

SceneEditProfile.prototype.SetYear = function()
{
    alert("SceneEditProfile.SetYear() ");
	
	var yearScene = $.sfScene.get("EditProfileYearList");	
	var thisScene = $.sfScene.get("EditProfile");
	
    var year = yearScene.GetYear();
	alert("year = " + year);	
	thisScene.YearNumberInputBox.SetText(year);
	thisScene.ChangeDay();				
}

SceneEditProfile.prototype.startTimer = function()
{
    alert("SceneEditProfile.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('EditProfile').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneEditProfile.prototype.resetTimer = function()
{
    alert("SceneEditProfile.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneEditProfile.prototype.stopTimer = function()
{
    alert("SceneEditProfile.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneEditProfile.prototype.popupTimerCallback = function()
{
	alert("SceneEditProfile.popupTimerCallback() ");
	if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;

 	this.highlight(null);
    StateMgr.Stop_Edit_Profile_State(true); 
}


SceneEditProfile.prototype.ResetSubListFlag = function(){

	this.flagShownDayList = false;
	this.flagShownMonthList = false;
	this.flagShownYearList = false;
	this.flagShownCountryList = false;
	this.flagShownPrefixList = false;	
	
}

SceneEditProfile.prototype.HideSubList = function(){

	if(this.flagShownPrefixList){
				
		$.sfScene.hide('CountryFlagList');		
	}
	else if(this.flagShownCountryList){
		
		$.sfScene.hide('SignupCountryList');
	}
	else if(this.flagShownDayList){
		
		$.sfScene.hide('EditProfileDayList');		
	}
	else if(this.flagShownMonthList){
		
		$.sfScene.hide('EditProfileMonthList');
	}
	else if(this.flagShownYearList){
		
		$.sfScene.hide('EditProfileYearList');
	}
	else{
		alert("Nothing...");			
	}
		
}

SceneEditProfile.prototype.processClickEvent = function(obj){
	alert("SceneEditProfile.processClickEvent() ");
	
	this.resetTimer();
	
	if(obj == this.TopArrow || obj == this.BottomArrow)
	{
		this.togglePage();
		return;
	}
	
	
	var currentHighlight =  this.EditProfileView.getCurrentHighlight();

	if(currentHighlight != obj)
    {
    	this.highlight(obj);    	
    }
    
	if(obj == this.HomePhoneNumberInputBox || obj == this.OfficePhoneNumberInputBox || obj == this.MobilePhoneNumberInputBox)
	{
		return;
	}
    	
    this.processEnterKey();	
}

SceneEditProfile.prototype.startTextInput = function(){
    alert("SceneEditProfile.startTextInput() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.MoodMsgInputBox:
		case this.FullNameInputBox:
		case this.EmailInputBox:
		case this.StateProvinceInputBox:
		case this.CityInputBox:
		
		if(this.CloseTimer == true)
		{
			this.stopTimer();
		}	
        
        WndMgr.StartTextEditor(currentHighlight, "EditProfile", this.EditProfileDim);
        break;            
    }    
}

SceneEditProfile.prototype.startKeypad = function(){
    alert("SceneEditProfile.startKeypad() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.HomePhoneNumberInputBox:
		case this.OfficePhoneNumberInputBox:
		case this.MobilePhoneNumberInputBox:
		
		if(this.CloseTimer == true)
		{
			this.stopTimer();
		}	
        
        var this_ =$.sfScene.get("EditProfile");
        var stopCF = function(){this_.startTimer();};
        
        WndMgr.StartKeypad(currentHighlight, "EditProfile", stopCF);
        break;            
    }    
}

SceneEditProfile.prototype.inputPlus = function(){
    alert("SceneEditProfile.inputPlus() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.HomePhoneNumberInputBox:
		case this.OfficePhoneNumberInputBox:
		case this.MobilePhoneNumberInputBox:
		
		if(this.CloseTimer == true)
		{
			this.resetTimer();
		}	
		
		var keycode =35; //plus100
		if(ProcMgr.isTTXMIX == false)
		{
			keycode = 650 ; // TTXMIX
		}
        
        currentHighlight.processNumberKey(keycode);
        break;            
    }    
}

SceneEditProfile.prototype.inputDelete = function(){
    alert("SceneEditProfile.inputDelete() ");
    
    var currentHighlight =  this.EditProfileView.getCurrentHighlight();
    
    switch(currentHighlight)
    {
		case this.HomePhoneNumberInputBox:
		case this.OfficePhoneNumberInputBox:
		case this.MobilePhoneNumberInputBox:
		
		if(this.CloseTimer == true)
		{
			this.resetTimer();
		}	
		        
        currentHighlight.processPreChKey();
        break;            
    }    
}
