/*
 * To do in this scene
 * 1. list control.
 * 
*/


function SceneListMainContact(options) {

	this.options = options;
    
	//object
	this.GIFLayer				= null;	
    this.list					= null;
	this.ContactListHelpBar		= null;
			
	//flags
	this.Status			= ENUM_SCENE_STATUS.INITIALIZED;
	this.LiveCallMode	= false;
	this.SetFocus		= false;	
	this.IsShownObj		= false;
	
	this.Timer	= null;
	
	this.WheelOperation = false;

}

SceneListMainContact.prototype.initialize = function () {
	alert("SceneListMainContact.initialize()");
	this.createLoading();
}

SceneListMainContact.prototype.handleShow = function () {
	alert("SceneListMainContact.handleShow()");
	
	//TEMPCODE : only one to function call 'GetIsCall' 
	this.ShowLoading();	

	this.Timer = setTimeout("ShowObj()", 300);	

	ShowObj = function(){
	
		This_ = $.sfScene.get("ListMainContact");
		
		This_.ShowObj();
		This_.HideLoading();
		This_.FocusObj();
				
	}

}

SceneListMainContact.prototype.handleHide = function () {
	alert("SceneListMainContact.handleHide()");
	
    clearTimeout( this.Timer);
    this.Timer = null;	
	
	if (this.IsShownObj) {

		this.list.Hide();
		this.IsShownObj = false;
		this.Status = ENUM_SCENE_STATUS.DISAPPEARED;
	}	
	
}

SceneListMainContact.prototype.handleFocus = function () {
	
	//TEMPCODE:
	//set focus when popup was shown...
	if(this.IsShownObj){
		alert("SceneListMainContact.handleFocus()");
		this.ContactListHelpBar.visibleObj();	
		this.list.highlight();	
	}
		
	this.SetFocus = true;
}

SceneListMainContact.prototype.handleBlur = function () {
	alert("SceneListMainContact.handleBlur()");
		
	this.list.blur();

	//TEMPCODE: must not disappear when showing popup wnd.
	this.ContactListHelpBar.hiddenObj();
		
	this.SetFocus = false;	

}

SceneListMainContact.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneListMainContact.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	//TEMPCODE:
//	if(this.IsShownObj == false){
//		return;
//	}
	
	switch(keyCode) {
		
		case $.sfKey.RED:
            StateMgr.Start_Signout_State();
			break;

		case $.sfKey.YELLOW:
			this.processYellowKey();
			break;
			
		default:
			this.list.KeyProcess(keyCode);					
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainContact.prototype.create = function(){
    alert("SceneListMainContact.create() ");

	this.list = new ContactList();	
    this.list.Create();

    this.ContactListHelpBar = new HelpBar(HelpBarIndex.LIST_MAIN_CONTACT_PAGE, "ListMain");

	var this_ = $.sfScene.get('ListMainContact');
    this.ContactListHelpBar.SetOnClickCallbackFunc(1, function(){this_.processRedKey();});
    this.ContactListHelpBar.SetOnClickCallbackFunc(2, function(){this_.processYellowKey();});
    this.ContactListHelpBar.SetOnClickCallbackFunc(3, function(){this_.processToolKey();});
    this.ContactListHelpBar.SetOnClickCallbackFunc(4, function(){this_.processReturnKey();});

	this.Status = ENUM_SCENE_STATUS.CREATED;
	
    this.TempDiv = document.getElementById("ListMainContact");
   	this.TempDiv.onmousewheel = function()
   	{
   		if(this_.WheelOperation == false)
   		{
   			alert("SceneListMainContact.onmousewheel");
	   		this_.WheelOperation = true;
	   		PluginAPIMgr.StartOSDTimer("700" , function() { this_.timerCallback();}, ENUM_TIMER_TYPE.NO_BUTTON);
	   		
			if(event.wheelDelta > 0)
			{
				//alert("Up Up");
				this_.list.PageScroll(true);
			}
			else
			{
				//alert("Down Down");
				this_.list.PageScroll(false);
			}
	    }		
    };	
}

SceneListMainContact.prototype.createLoading = function(){

	this.GIFLayer = new JPGImageLayer("Contact_loading_gif");
	this.GIFLayer.SetImage(WndMgr.Bg_LoadingGIF.src); 
 
}

//to refresh in current page
SceneListMainContact.prototype.Refresh = function(){

	if(this.Status == ENUM_SCENE_STATUS.ACTIVATED && this.IsShownObj == true){
				
		this.list.Refresh();
	} 

}

SceneListMainContact.prototype.setDestroyFlag= function(destroy_flag){
     
	 if(destroy_flag ){
	 	this.Status = ENUM_SCENE_STATUS.DESTORYED;	
	 }
	 	 
}

SceneListMainContact.prototype.CheckValidList = function(){
	
	if( this.list.GetTotalDataNum() > 0){
		return true;
	}
	else {
		return false;
	}
}

//Initializ list
SceneListMainContact.prototype.InitializeScene = function(){

	this.list.Initialize();	
	this.Status = ENUM_SCENE_STATUS.ACTIVATED;
	this.LiveCallMode = ProcMgr.GetIsInCall();	

}

SceneListMainContact.prototype.GetState = function(){
	
	return this.Status;
}


SceneListMainContact.prototype.Activation = function(){
	alert("SceneListMainContact.Activation()");	
	
	if(this.Status > ENUM_SCENE_STATUS.CREATED){
		
		this.Status = ENUM_SCENE_STATUS.ACTIVATED;
		this.list.Refresh();				
	}
		
}

SceneListMainContact.prototype.Deactivation = function(){
	alert("SceneListMainContact.Deactivation()");	
	
	this.Status = ENUM_SCENE_STATUS.DEACTIVATED;
}

SceneListMainContact.prototype.ProgressCallDuration = function(strTime){

	if(this.IsShownObj && this.LiveCallMode){		
		this.list.ProgressCallDuration(strTime);
	}
	
}

SceneListMainContact.prototype.ShowLoading = function(){
	
	$("#"+ this.GIFLayer.Obj).css('display', 'block');
}

SceneListMainContact.prototype.HideLoading = function(){
	
	$("#"+ this.GIFLayer.Obj).css('display', 'none');
}


SceneListMainContact.prototype.ShowObj = function(){
	
	if(this.Status == ENUM_SCENE_STATUS.INITIALIZED){					
		this.create();
	}						

	var IsInCall = ProcMgr.GetIsInCall();
			
	if(this.Status == ENUM_SCENE_STATUS.CREATED || this.Status == ENUM_SCENE_STATUS.DESTORYED || 
		this.LiveCallMode != IsInCall){		
		
		this.list.Initialize();	
		this.Status = ENUM_SCENE_STATUS.ACTIVATED;
		this.LiveCallMode = IsInCall;
		
	}
	else{
		this.Activation();
	}
	
	this.list.Show();
	
	this.IsShownObj = true;
	
}


SceneListMainContact.prototype.FocusObj = function(){
	
	//check focus
	if(this.SetFocus){
		
		alert("SceneListMainContact.FocusObj()");
		this.ContactListHelpBar.visibleObj();	
		this.list.highlight();				
	}	
}

SceneListMainContact.prototype.GetIsShownObj = function(){
	
	return this.IsShownObj;
}


//for ListMainContactPhoneNumberList
SceneListMainContact.prototype.MoveToVideoCallBtn = function(){
	
	this.list.MoveToVideoCallBtn();	
}

SceneListMainContact.prototype.MoveToChatBtn = function(){
	
	this.list.MoveToChatBtn();	
}

SceneListMainContact.prototype.RefreshForIndex = function(Index){
	
	this.Status = ENUM_SCENE_STATUS.ACTIVATED;
	this.list.RefreshForIndex(Index);	
}


//move to main ... 
SceneListMainContact.prototype.processReturnKey = function(){
	
	this.list.MoveToMain();	
}


SceneListMainContact.prototype.processYellowKey = function(){
    alert("SceneListMainContact.processYellowKey() ");
    
	var IsInCall = ProcMgr.GetIsInCall();
	
	if(IsInCall){
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL);
	}
	else
	{
		StateMgr.Start_Add_Contact_State();
	}    
}

SceneListMainContact.prototype.processRedKey = function(){
    alert("SceneListMainContact.processRedKey() ");
    
        StateMgr.Start_Signout_State();   
}

SceneListMainContact.prototype.processToolKey=function()
{
    alert("SceneListMainContact.processToolKey() ");
	
	var IsInCall = ProcMgr.GetIsInCall();
	
	if(IsInCall){
		WndMgr.StartOneBottonPopup(OneBtnPopupIndex.NOT_AVAILABLE_DURING_CALL_IN_CONTACT_LIST);
	}
	else{

		StateMgr.Start_List_Tools_State(TOOL_MENU_LIST_TYPE.CONTACT_LIST);	
	}	
}


SceneListMainContact.prototype.timerCallback=function()
{
	this.WheelOperation = false;
}


