
function SceneListMainToolList(options) {

	this.options	= options;
    
	//Object
	//this.ListMainToolListDim = null;
	this.ToolList	= null;
	this.MenuText	= null;	
	this.HelpBar = null;
	
	
	//flag
	this.IsUnblock		= false;
	this.SubSceneType	= null;
	
	//data info
	this.Identity		= null;
	this.Display		= null;	
	this.Index			= null;
	this.Availability	= null;
	this.IsBuddy		= null;
	this.IsBlockedUser	= null;

	//timer
    this.CloseTimer = false;

}

SceneListMainToolList.prototype.initialize = function () {
	alert("SceneListMainToolList.initialize()");
	this.create();
}

SceneListMainToolList.prototype.handleShow = function () {
	alert("SceneListMainToolList.handleShow()");
	// this.ListMainToolListDim.show();
	this.SetMenu(); 
    this.ToolList.Show();
	
	this.startTimer();

}

SceneListMainToolList.prototype.handleHide = function () {
	alert("SceneListMainToolList.handleHide()");
	// this.ListMainToolListDim.hide();

    if (this.CloseTimer == true)
    {
        this.stopTimer();
    }

}

SceneListMainToolList.prototype.handleFocus = function () {
	alert("SceneListMainToolList.handleFocus()");
	
	this.ToolList.highlight();
	this.ToolListHelpBar.visibleObj();	
	
}

SceneListMainToolList.prototype.handleBlur = function () {
	alert("SceneListMainToolList.handleBlur()");
	
	this.ToolList.blur();
	this.ToolListHelpBar.hiddenObj();	
}

SceneListMainToolList.prototype.handleKeyDown = function (keyCode) {
	
	alert("SceneListMainToolList.handleKeyDown(" + keyCode + ")");
	
PluginAPIMgr.PlayAudio(keyCode);
	
	if(keyCode == $.sfKey.RETURN)
	{		
		this.processReturnKey();
		$.sfKey.block(event);
	}
	else if(keyCode == $.sfKey.EXIT){
		this.processReturnKey();
		$.sfKey.block(event);
	}
	else if( keyCode == 147 || keyCode == 261  || keyCode == 115  )   //infolink ,contents,wiselink
	{
		ProcMgr.processInfolinkKey(); 
	}	
	else {
		
		if(keyCode == $.sfKey.DOWN || keyCode == $.sfKey.UP)
		{
			this.resetTimer();	
		}
			
		this.ToolList.KeyProcess(keyCode);	
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneListMainToolList.prototype.create = function(){
    alert("SceneListMainToolList.create() ");


    this.MenuText = new Label(null,"toolListMenuText");    
    this.MenuText.SetText(SID_TOOLS);

	this.ToolList = new MenuList();
	this.ToolList.CreateBG("toolList");
	this.ToolList.SetBGImage(g_Image.IMAGE_LIST_MAIN_TOOL_LIST_NEW_BG);	
	this.ToolList.SetNumOfVisibleItem(7);
	this.ToolList.SetStartDataIndex(0);
	this.ToolList.SetItemClass(MenuListItem);
	this.ToolList.SetItemBgImage(ITEM_STATE.NORMAL," ");
	this.ToolList.SetItemBgImage(ITEM_STATE.HIGHLIGHT,g_Image.IMAGE_LIST_MAIN_TOOL_LIST_ITEM_NEW_HIGHLIGHT);
	this.ToolList.SetItemDefualtTextStyle(ITEM_STATE.NORMAL,"cToolList_Text_Normal");
	this.ToolList.SetItemDefualtTextStyle(ITEM_STATE.HIGHLIGHT,"cToolList_Text_Highlight");
	this.ToolList.SetItemDisableTextStyle("cToolList_Text_Disable");
	this.ToolList.SetDataType(ITEM_DATA_TYPE.TEXT_ONLY);
	
	var scene = $.sfScene.get("ListMainToolList");
	this.ToolList.SetItemPressedEventCallback(scene.ProcessKeyEnter);
	
	// this.ListMainToolListDim = new DimBg("ListMainToolListDim", "ListMainToolList"); 
	
	//Text, Image, Diable
	var tempdata1 = ["1",null];
	var tempdata2 = ["2",null];
	var tempdata3 = ["3",null];
	var tempdata4 = ["4",null];
	var tempdata5 = ["5",null];
	var tempdata6 = ["6",null];
	var tempdata7 = ["7",null];
		
	this.ToolList.AddData(tempdata1);
	this.ToolList.AddData(tempdata2);
	this.ToolList.AddData(tempdata3);
	this.ToolList.AddData(tempdata4);
	this.ToolList.AddData(tempdata5);	
	this.ToolList.AddData(tempdata6);
	this.ToolList.AddData(tempdata7);

	this.ToolList.SetOnClickCallbackFunc(0,this.onClickEventFunc1);
	this.ToolList.SetOnClickCallbackFunc(1,this.onClickEventFunc2);
	this.ToolList.SetOnClickCallbackFunc(2,this.onClickEventFunc3);
	this.ToolList.SetOnClickCallbackFunc(3,this.onClickEventFunc4);
	this.ToolList.SetOnClickCallbackFunc(4,this.onClickEventFunc5);
	this.ToolList.SetOnClickCallbackFunc(5,this.onClickEventFunc6);
	this.ToolList.SetOnClickCallbackFunc(6,this.onClickEventFunc7);	
	this.ToolList.SetClickEventAvailable(WndMgr.MouseClickEnable);
	
	this.ToolList.ShowItem();

    this.ToolListHelpBar = new HelpBar(HelpBarIndex.LIST_TOOL_MENU, "toolList");
    this.ToolListHelpBar.SetOnClickCallbackFunc(1, function(){scene.processReturnKey();});
        
    
    //no change. allways show
}


SceneListMainToolList.prototype.ProcessKeyEnter = function(){

	alert("SceneListMainToolList.ProcessKeyEnter() ");

	var scene = $.sfScene.get("ListMainToolList");
	var Index = scene.ToolList.GetCurrentItem();

	if(scene.SubSceneType == 0){

		switch(Index) {
	
			case 0:
				scene.ShowVeiwProfile();
				break;
			case 1:
				scene.SendVoicemail();
				break;				
			case 2:
				scene.ShowRenamePopup();
				break;		
			case 3:
				scene.ShowRemoveContactPopup();
				break;				
			case 4:
				scene.ShowBlockPopup();
				break;
			case 5:
				scene.ShowLogoutPopup();
				break;				
			case 6:
				scene.ShowAddContactPopup();
				break;					
						
		}
		
	}
	else if(scene.SubSceneType > 0){
		
		switch(Index) {
	
			case 0:
				scene.ShowVeiwProfile();
				break;
			case 1:
			   scene.SendVoicemail();
				break;				
			case 2:
				scene.ShowAddPopup();
				break;		
			case 3:
				scene.ShowBlockPopup();
				break;				
			case 4:
				scene.ShowRemovePopup();
				break;
			case 5:
				scene.ShowLogoutPopup();
				break;
		}				
	}

}


SceneListMainToolList.prototype.SetMenu = function(){

	alert("SceneListMainToolList.ResetMenuText() ");
	
	//set data info
 	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());
 	
	this.Identity	= Scene.list.GetCurIdentityName();
	this.Display	= Scene.list.GetCurDisplayName();
	this.Index		= Scene.list.GetCurIndex();
	
	
	alert("Identity = " + this.Identity);	

	this.Availability	= parseInt(PluginAPIMgr.GetContactAvailabilityWithName(this.Identity));
	this.IsBuddy 		= PluginAPIMgr.IsMyBuddy(this.Identity);
	this.IsBlockedUser	= PluginAPIMgr.IsBlocked(this.Identity);

	//alert("IsBuddy = " + this.IsBuddy);
	//alert("IsBlockedUser = " + this.IsBlockedUser);
	
	this.SetVeiwProfileMenu(0);
	this.SetSendVoicemailMenu(1);

	this.SubSceneType = WndMgr.GetMainSubIndex();
	switch(this.SubSceneType) {

		case 0:
			this.SetRenameMenu(2);
			this.SetRemoveMenu(3);
			this.SetBlockMenu(4);
			this.SetLogoutMenu(5);
			this.SetAddContactMenu(6);
			break;			
		case 1:
			this.SetAddToContaxctMenu(2);
			this.SetBlockMenu(3);
			this.SetRemoveMenu(4);
			this.SetLogoutMenu(5);	
			this.SetBlankMenu(6);
			break;

//		default :
//			this.SetBlankMenu(0);		
//			this.SetBlankMenu(1);		
//			this.SetBlankMenu(2);		
//			this.SetBlankMenu(3);		
//			this.SetBlankMenu(4);				
//			break;

	}

}


SceneListMainToolList.prototype.SetVeiwProfileMenu = function(Index){

	//TEMPCODE: check previous status. do not try in same status.
	var tempdata = [IDWS_MOIP_SKYPE_VIEW_PROFILE ,null];
	this.ToolList.ChangeData(Index,tempdata);
	this.ToolList.SetEnableItem(Index);
	
}

SceneListMainToolList.prototype.SetSendVoicemailMenu = function(Index){

	//TEMPCODE:
	var tempdata = [IDWS_MOIP_SEND_VOICEMAIL ,null];
	this.ToolList.ChangeData(Index,tempdata);


	var MyCapability = parseInt(PluginAPIMgr.GetAccountCapability(ENUM_CONTACT_CAPABILITY.CAPABILITY_VOICEMAIL));
	var YourCapability = PluginAPIMgr.HasVoiceMailCapability(this.Identity);

//	alert("Capability = " + MyCapability);
//	alert("YourCapability = " + YourCapability);
		
	//Set Disable if Blocked user & added user & pstn number & no capablility of voicemail 
	if(	this.IsBuddy == false || 
		this.Availability == ENUM_CONTACT_AVAILABILITY.BLOCKED || 
		this.Availability == ENUM_CONTACT_AVAILABILITY.BLOCKED_SKYPEOUT ||
	 	this.Availability == ENUM_CONTACT_AVAILABILITY.UNKNOWN ||
	 	this.Availability == ENUM_CONTACT_AVAILABILITY.SKYPEOUT ||		
		(MyCapability == ENUM_CAPABILITY_STATUS.NO_CAPABILITY && YourCapability == false)){
			
		this.ToolList.SetDisableItem(Index); 
	}
	else{
				
		this.ToolList.SetEnableItem(Index); 
	}

}


SceneListMainToolList.prototype.SetRenameMenu = function(Index){

	var tempdata = [SID_RENAME ,null];
	this.ToolList.ChangeData(Index,tempdata);
	this.ToolList.SetEnableItem(Index);

}

SceneListMainToolList.prototype.SetRemoveMenu = function(Index){

	//TEMPCODE:
	if(Index == 3){
		
		var tempdata = [IDWS_MOIP_SKYPE_REMOVE ,null];	
		this.ToolList.ChangeData(3,tempdata);

		if(this.Availability == ENUM_CONTACT_AVAILABILITY.UNKNOWN || 
			this.Identity == 'echo123'){
				
			this.ToolList.SetDisableItem(3);
		}
		else {
			
			this.ToolList.SetEnableItem(3);
		}

	}
	else if(Index == 4){

		var tempdata = [IDWS_MOIP_SKYPE_DELETE_THIS_ENTRY ,null];
		this.ToolList.ChangeData(4,tempdata);
		this.ToolList.SetEnableItem(4);	
		
	}

}

SceneListMainToolList.prototype.SetBlockMenu = function(Index){
	
	//TEMPCODE: no relationship with buddy
	if(this.IsBlockedUser == 1){
		
		var tempdata = [IDWS_MOIP_UNBLOCKED,null]; 
		this.ToolList.ChangeData(Index,tempdata);
		
		this.IsUnblock	= true;		
		this.ToolList.SetEnableItem(Index);	
	}
	else if(this.Availability == ENUM_CONTACT_AVAILABILITY.UNKNOWN){

		var tempdata = [IDWS_MOIP_SKYPE_BLOCK,null];
		this.ToolList.ChangeData(Index,tempdata);

		this.IsUnblock	= false;
		this.ToolList.SetDisableItem(Index);	
	}
	else{

		var tempdata = [IDWS_MOIP_SKYPE_BLOCK,null];
		this.ToolList.ChangeData(Index,tempdata);
		
		this.IsUnblock	= false;
		this.ToolList.SetEnableItem(Index);
	}
		

}

SceneListMainToolList.prototype.SetAddToContaxctMenu = function(Index){

	var tempdata = [IDWS_MOIP_ADD_TO_CONTACTS ,null];
	this.ToolList.ChangeData(Index,tempdata);
	
	if(this.IsBuddy == true || this.IsBlockedUser == 1 || this.Identity == 'echo123'){
		
		this.ToolList.SetDisableItem(Index);
	}
	else{
		
		this.ToolList.SetEnableItem(Index);
	}
}

SceneListMainToolList.prototype.SetLogoutMenu = function(Index){

	var tempdata = [IDWS_MOIP_POPUP_EXIT_SIGN_OUT ,null];
	this.ToolList.ChangeData(Index,tempdata);
	this.ToolList.SetEnableItem(Index);

}

SceneListMainToolList.prototype.SetAddContactMenu = function(Index){

	var tempdata = [IDWS_MOIP_SKYPE_ADD_A_CONTACT ,null];
	this.ToolList.ChangeData(Index,tempdata);
	this.ToolList.SetEnableItem(Index);

}

SceneListMainToolList.prototype.SetBlankMenu = function(Index){

	// alert("SceneListMainToolList.SetBlankMenu -- " + Index);
	var tempdata = [" " ,null];
	this.ToolList.ChangeData(Index,tempdata);
	this.ToolList.SetDisableItem(Index);
	
}

SceneListMainToolList.prototype.ShowVeiwProfile = function(){

	//StateMgr.Stop_List_Tools_State(false);
	StateMgr.Start_View_Profile_State(this.Identity);
	
}


SceneListMainToolList.prototype.ShowBlockPopup = function(){

	//StateMgr.Stop_List_Tools_State(false);
		
	var type;
	
	if(this.IsUnblock){
		
		if(this.SubSceneType == 0){
			type = MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_UNBLOCK;
		}
		else if(this.SubSceneType == 1){
			type = MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_UNBLOCK;
		}
	}
	else{

		if(this.SubSceneType == 0){
			type = MAIN_LIST_POPUP_FUNCTION_TYPE.CONTACT_BLOCK;
		}
		else if(this.SubSceneType == 1){
			type = MAIN_LIST_POPUP_FUNCTION_TYPE.HISTORY_BLOCK;
		}
	}
		
	StateMgr.Start_Block_State(type,this.Identity,this.Display);
	
}

SceneListMainToolList.prototype.ShowRenamePopup = function(){

	//StateMgr.Stop_List_Tools_State(false);
	StateMgr.Start_Rename_State(this.Identity);
			
}

SceneListMainToolList.prototype.ShowRemovePopup = function(){

	//StateMgr.Stop_List_Tools_State(false);
	StateMgr.Start_Remove_State(this.SubSceneType,this.Identity,this.Display,this.Index);

}


SceneListMainToolList.prototype.ShowRemoveContactPopup = function(){

	//StateMgr.Stop_List_Tools_State(false);
	StateMgr.Start_Remove_Contact_State(this.Identity,this.Display);

}



SceneListMainToolList.prototype.SendVoicemail = function(){

	//Check!!!!
	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
	Scene.Activation();
	 	
	StateMgr.Stop_List_Tools_State(false);   
	ProcMgr.LeaveVoicemail(this.Identity);

}

SceneListMainToolList.prototype.ShowAddPopup = function(){

	var IS_PSTN = PluginAPIMgr.GetHistoryPropWithIndex(this.Index,ENUM_HISTORY_PROPERTY.P_IS_PSTN);
	
	if(IS_PSTN == '1'){
		alert("AddSkypeOutContact(" + this.Identity + ")");
		PluginAPIMgr.AddSkypeOutContact(this.Identity,"");
	}
	else{
		alert("AddContact(" + this.Identity + ")");
		PluginAPIMgr.AddContact(this.Identity, "");
	}

	StateMgr.Stop_List_Tools_State(false);

	WndMgr.StartOneBottonPopup(OneBtnPopupIndex.ADD_REMOVED_CONTACT);
		
}


SceneListMainToolList.prototype.processReturnKey = function(){

	//check
	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
	Scene.Activation();
	    	 
	StateMgr.Stop_List_Tools_State(true);
}


SceneListMainToolList.prototype.startTimer = function()
{
    alert("SceneListMainToolList.startTimer() ");
	
	this.CloseTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('ListMainToolList').popupTimerCallback();}, ENUM_TIMER_TYPE.POPUP_WND);
}

SceneListMainToolList.prototype.resetTimer = function()
{
    alert("SceneListMainToolList.resetTimer() ");

	if(this.CloseTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.POPUP_WND);
	}
}

SceneListMainToolList.prototype.stopTimer = function()
{
    alert("SceneListMainToolList.stopTimer() ");
	
	this.CloseTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.POPUP_WND);
}

SceneListMainToolList.prototype.popupTimerCallback = function()
{
	alert("SceneListMainToolList.popupTimerCallback() ");
   if(this.CloseTimer==false)
   {
   	return
   }
   this.CloseTimer = false;
   
   this.processReturnKey();
}

SceneListMainToolList.prototype.ShowLogoutPopup = function(){

	//check
	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
	Scene.Activation();

	StateMgr.Start_Signout_State();			
}

SceneListMainToolList.prototype.ShowAddContactPopup = function(){

	//check
	var Scene = $.sfScene.get(WndMgr.GetMainSubSceneID());	
	Scene.Activation();

	StateMgr.Start_Add_Contact_State();
}

SceneListMainToolList.prototype.onClickEventFunc1 = function(){
	
	alert("SceneListMainToolList.onClickEventFunc1() ");

	var This_ = $.sfScene.get("ListMainToolList");
	This_.ShowVeiwProfile();
}

SceneListMainToolList.prototype.onClickEventFunc2 = function(){

	alert("SceneListMainToolList.onClickEventFunc2() ");
	
	var This_ = $.sfScene.get("ListMainToolList");
	This_.SendVoicemail();
}

SceneListMainToolList.prototype.onClickEventFunc3 = function(){
	
	alert("SceneListMainToolList.onClickEventFunc3() ");	

	var This_ = $.sfScene.get("ListMainToolList");	
	if(This_.SubSceneType == 0)
	{
		This_.ShowRenamePopup();
	}
	else
	{
		This_.ShowAddPopup();
	}
}

SceneListMainToolList.prototype.onClickEventFunc4 = function(){
	
	alert("SceneListMainToolList.onClickEventFunc4() ");	

	var This_ = $.sfScene.get("ListMainToolList");	
	if(This_.SubSceneType == 0)
	{
		This_.ShowRemoveContactPopup();
	}
	else
	{
		This_.ShowBlockPopup();
	}
}

SceneListMainToolList.prototype.onClickEventFunc5 = function(){

	alert("SceneListMainToolList.onClickEventFunc5() ");	

	var This_ = $.sfScene.get("ListMainToolList");	
	if(This_.SubSceneType == 0)
	{
		This_.ShowBlockPopup();
	}
	else
	{
		This_.ShowRemovePopup();
	}
}

SceneListMainToolList.prototype.onClickEventFunc6 = function(){
	
	alert("SceneListMainToolList.onClickEventFunc6() ");	
	
	var This_ = $.sfScene.get("ListMainToolList");
	This_.ShowLogoutPopup();

}

SceneListMainToolList.prototype.onClickEventFunc7 = function(){
	
	alert("SceneListMainToolList.onClickEventFunc7() ");	

	var This_ = $.sfScene.get("ListMainToolList");
	if(This_.SubSceneType == 0)
	{
		This_.ShowAddContactPopup();
	}

}
