/**
 * @author Samsung
 */

function SceneOptionsAboutSkype(options)
{
    this.options = options;

    this.OptionsAboutSkypeView = null;
    this.AboutSkypeLabel = null;
    this.VersionLabel = null;
    this.CopyrightLabel = null;
    this.TrademarkLabel = null;
}

SceneOptionsAboutSkype.prototype.initialize = function ()
{
	alert("SceneOptionsAboutSkype.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
   this.create();
}

SceneOptionsAboutSkype.prototype.handleShow = function ()
{
	alert("SceneOptionsAboutSkype.handleShow()");
	// this function will be called when the scene manager show this scene 
}

SceneOptionsAboutSkype.prototype.handleHide = function ()
{
	alert("SceneOptionsAboutSkype.handleHide()");
	// this function will be called when the scene manager hide this scene  
}

SceneOptionsAboutSkype.prototype.handleFocus = function ()
{
	alert("SceneOptionsAboutSkype.handleFocus()");
	// this function will be called when the scene manager focus this scene
}

SceneOptionsAboutSkype.prototype.handleBlur = function ()
{
	alert("SceneOptionsAboutSkype.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneOptionsAboutSkype.prototype.handleKeyDown = function (keyCode)
{
	alert("SceneOptionsAboutSkype.handleKeyDown(" + keyCode + ")");
    // TODO : write an key event handler when this scene get focued
    PluginAPIMgr.PlayAudio(keyCode);
    switch (keyCode) {
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
            break;
         case $.sfKey.EXIT:
			$.sfKey.block(event);
			break;
		
        case 147:  //infolink
        case 261:  //contents
        case 115:  //wiselink
            ProcMgr.processInfolinkKey(); 
			break;
    }
}

/////////////////////////////////////////////////////////////////////////////
SceneOptionsAboutSkype.prototype.create = function()
{
    alert("SceneOptionsAboutSkype.create()");

    this.OptionsAboutSkypeView = new View("OptionsAboutSkype");

    this.AboutSkypeLabel = new Label(null, "options_about_skype_label");
    this.AboutSkypeLabel.SetTextStyle("options_about_skype_label_style");
    this.AboutSkypeLabel.SetText(IDWS_MOIP_ABOUT_SKYPE);

    this.VersionLabel = new Label(null, "options_about_version_label");
    //this.VersionLabel.SetReverseDisable(true);
    this.VersionLabel.SetTextStyle("options_about_msg_label_style");    
    this.VersionLabel.SetText(g_Data.CombinateStrings(SID_MIX_SKYPE_VERSION,"2.0"));
    if(ResMgr.isReverseLanguage())
    {
    	$("#options_about_version_label").css("text-align","right");
    }
    else
    {
    	$("#options_about_version_label").css("text-align","left");
    }

    this.CopyrightLabel = new Label(null, "options_about_copyright_label");
    this.CopyrightLabel.SetTextStyle("options_about_msg_label_style");
    if(ResMgr.isReverseLanguage())
    {
    	this.CopyrightLabel.SetText(g_Data.CombinateStrings(TV_MIX_SKYPE_LIMITED_TRADE_MARK_MSG,"2012-2003"));
    }
    else
    {
    	this.CopyrightLabel.SetText(g_Data.CombinateStrings(TV_MIX_SKYPE_LIMITED_TRADE_MARK_MSG,"2003-2012"));
    }
    
    
}

SceneOptionsAboutSkype.prototype.processReturnKey = function(){
    alert("SceneOptionsAboutSkype.processReturnKey() ");
    WndMgr.ReturnOptionsSubToMain();
}
