function SceneRename(options) {
	this.options = options;
    
    this.RenameView=null;
	this.RenameDim=null;
    
    this.TitleBar = null;    
    
    this.TextInputBox = null;
	this.MsgLengthLabel = null;
    
    this.flagPWD = false;
    this.initText ="";
    this.maxStringLenght = 50;
    this.callerObj = null;
    
	this.TargetIdentity = null;	

	//timer
    this.TextInputTimer = false;
	
	this.isRenameEnable = false;
}

SceneRename.prototype.initialize = function () {
	alert("SceneRename.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneRename.prototype.handleShow = function () {
	alert("SceneRename.handleShow()");
	// this function will be called when the scene manager show this scene 
    this.RenameDim.show();
    
    this.TextInputBox.initKeySet();
    this.TextInputBox.initInputBox( this.flagPWD, this.initText, this.maxStringLenght,  this.callerObj );
	
	this.startTimer();
}

SceneRename.prototype.handleHide = function () {
	alert("SceneRename.handleHide()");
	// this function will be called when the scene manager hide this scene
	this.RenameDim.hide();
	  
    var obj = this.RenameView.getCurrentHighlight();
	if(obj != null)
	{
		 obj.imeHide();
	}
   
	this.MsgLengthLabel.SetText("");
	
	if(this.TextInputTimer == true)
	{
		this.stopTimer();
	}
}

SceneRename.prototype.handleFocus = function () {
	alert("SceneRename.handleFocus()");
	// this function will be called when the scene manager focus this scene
    this.highlight(this.TextInputBox);
}

SceneRename.prototype.handleBlur = function () {
	alert("SceneRename.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneRename.prototype.handleKeyDown = function (keyCode) {
	alert("SceneRename.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:

			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
			this.processEnterKey();
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case $.sfKey.EXIT:
            //this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneRename.prototype.create = function(){
    alert("SceneRename.create()");
    this.RenameView = new View("Rename");
    this.RenameView.SetBgImage(WndMgr.Bg_ChatMsg.src);
	
	this.RenameDim = new DimBg("RenameDim", "Rename"); 
    
    this.TitleBar = new Label(null,"rename_title");
    this.TitleBar.SetTextStyle("rename_title_style");
    this.TitleBar.SetText(SID_RENAME);
    
    this.TextInputBox= new InputBox();
	this.TextInputBox.SetButtonObjId("rename_input_box");
    this.TextInputBox.SetButtonTextObjId("rename_input_box_text");
	this.TextInputBox.SetInputBoxObjId("rename_input_box_editor");
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_IMG, g_Image.IMAGE_INPUT_BOX_NORMAL);
	this.TextInputBox.SetBgImage(BtnImgIndex.BTN_NORMAL_FOCUS_IMG, g_Image.IMAGE_INPUT_BOX_NORMALFOCUS);	
	this.TextInputBox.setKeypadPos(675,100);
    this.TextInputBox.setWordBoxPos(236,50);
	
	this.MsgLengthLabel = new Label(null,"rename_msg_length");
    this.MsgLengthLabel.SetTextStyle("rename_msg_length_style");
    this.MsgLengthLabel.SetText("");
    
}

SceneRename.prototype.highlight=function(obj)
{
    this.RenameView.setCurrenHighlight(obj);
   
   	if(obj != null)
	{
		var scene = $.sfScene.get("Rename");
    	
    	var ime = new IMEShell(obj.IMEObjInfo.id, scene.imeReady, 'en' /*, 'en' ,  "2_35_259"*/);
	}
	else
	{
		this.TextInputBox.imeHide();
	}
}

SceneRename.prototype.processReturnKey = function(){
    alert("SceneRename.processReturnKey() ");
	
	this.highlight(null);	
	StateMgr.Stop_Rename_State(true);
	$.sfKey.block(event);
	
	//TEMPCODE
	var scene = $.sfScene.get("ListMainContact");
	scene.Activation();	

}

SceneRename.prototype.initInputBox = function(flagPWD, initText, maxLen, callerObj)
{
    alert("SceneRename.initInputBox()");
    this.flagPWD = flagPWD;
    this.initText = initText;
    this.maxStringLenght = maxLen;
    this.callerObj = callerObj;
}

SceneRename.prototype.imeReady = function(imeObject){
    alert("SceneRename.imeReady() ");

	var this_ = $.sfScene.get('Rename');
	var obj = this_.RenameView.getCurrentHighlight();
	
	obj.imeShow(imeObject);
	
    obj.setKeyFunc(88,  function(keyCode){this_.processReturnKey(); $.sfKey.block(event); return false;}); // return key
   	obj.setKeyFunc(45,  function(keyCode){this_.processReturnKey(); $.sfKey.block(event); return false;}); // exit key
    obj.setKeyFunc(108, function(keyCode){this_.DeleteAllText(); return false;}); // red key
    obj.setKeyFunc(222, function(keyCode){$.sfKey.block(event);  return false;}); // source
    
	obj.setKeyFunc(147, function(keyCode){$.sfKey.block(event);  return false;}); // infolink
	obj.setKeyFunc(261, function(keyCode){$.sfKey.block(event);  return false;}); // contents
	obj.setKeyFunc(115, function(keyCode){$.sfKey.block(event);  return false;}); // wiselink
    
	obj.setOnCompleteFunc(function(keyCode){this_.updateMsgLength(); this_.checkRenameEnable(); this_.resetTimer(); return false;})
	obj.setAnyKeyFunc(function(keyCode){this_.resetTimer();  return false;}); 
    obj.setEnterFunc( function(keyCode){this_.processEnterKey(); return false;}); // enter key
    
    obj.setKeySetFunc("qwerty");
    
	obj.setReady();
	
	this_.updateMsgLength();
}

SceneRename.prototype.GetInputText = function()
{
    var obj = this.RenameView.getCurrentHighlight();
    return obj.getString();
}

SceneRename.prototype.DeleteAllText = function()
{
	this.resetTimer();
    var obj = this.RenameView.getCurrentHighlight();
    obj. setString("");
	
	this.updateMsgLength();
	this.checkRenameEnable();
}

SceneRename.prototype.processEnterKey = function(){
    alert("SceneRename.processEnterKey() ");

	var DisplayName = this.TextInputBox.GetText();
	alert("DisplayName = " + DisplayName);

	if(this.isRenameEnable==true)
	{	
		PluginAPIMgr.RenameContact(this.TargetIdentity, DisplayName);		
		this.processReturnKey();		
	}
	else{
		this.processReturnKey();
	}
}

SceneRename.prototype.Init = function(Identity){
    alert("SceneRename.Init() ");

	this.TargetIdentity = Identity;
}

SceneRename.prototype.updateMsgLength = function()
{
	alert("SceneRename.updateMsgLength() ");
    var obj = this.RenameView.getCurrentHighlight();
    var input_string = obj.getString();
	
	obj.SetText(input_string);
	this.MsgLengthLabel.SetText(String(input_string.length) +"/" +String(this.maxStringLenght));  	
}

SceneRename.prototype.checkRenameEnable = function()
{
    var input_text = this.TextInputBox.GetText();
    
    if(input_text.length ==0)
    {
        this.isRenameEnable = false;
    }
    else
    {
        var a=0;
        for(a=0; a<input_text.length; a++)
        {
            this.isRenameEnable = false;
             var ch = input_text.substring(a,  a+1);
             if(ch !=" ")
             {
                 this.isRenameEnable = true;
                 break;
			}
        }
    }
    
    alert("SceneRename.checkRenameEnable()  :  " +this.isRenameEnable);
}

SceneRename.prototype.startTimer = function()
{
    alert("SceneRename.startTimer() ");
	
	this.TextInputTimer = true;
	PluginAPIMgr.StartOSDTimer("60000" , function() { $.sfScene.get('Rename').popupTimerCallback();}, ENUM_TIMER_TYPE.TEXT_INPUT);
}

SceneRename.prototype.resetTimer = function()
{
    alert("SceneRename.resetTimer() ");

	if(this.TextInputTimer == true)
	{
		PluginAPIMgr.RestartOSDTimer("60000" ,ENUM_TIMER_TYPE.TEXT_INPUT);
	}
}

SceneRename.prototype.stopTimer = function()
{
    alert("SceneRename.stopTimer() ");
	
	this.TextInputTimer = false;
	PluginAPIMgr.StopOSDTimer(ENUM_TIMER_TYPE.TEXT_INPUT);
}

SceneRename.prototype.popupTimerCallback = function()
{
   alert("SceneRename.popupTimerCallback() ");
   	if(this.TextInputTimer == false)
	{
		return;
	}	
	
	this.TextInputTimer = false;
	
	this.highlight(null);	
	StateMgr.Stop_Rename_State(true);

	//TEMPCODE
	var scene = $.sfScene.get("ListMainContact");
	scene.Activation();	
}



