function SceneWidgetLoading(options) {
	this.options = options;
    
    this.WidgetLoadingView=null;
    
	//this.DimBg = null;
    this.LoadingBg = null;
    this.LoadingAni = null;
    this.LoadingMsg = null;
    
    this.FlagAnimation = false;
    this.LoadingAniImage = new Array(36);
    this.iCurrAniImage =0;
    
    this.WidgetLoadingTimer = null;
}

SceneWidgetLoading.prototype.initialize = function () {
	alert("SceneWidgetLoading.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
    
   this.create();
}

SceneWidgetLoading.prototype.handleShow = function () {
	alert("SceneWidgetLoading.handleShow()");
	// this function will be called when the scene manager show this scene 

    this.FlagAnimation=true;
    this.startTimer();
    
}

SceneWidgetLoading.prototype.handleHide = function () {
	alert("SceneWidgetLoading.handleHide()");
	// this function will be called when the scene manager hide this scene  
    
    this.FlagAnimation=false;
	if(this.WidgetLoadingTimer != null)
	{
		this.stopTimer();
	}
}

SceneWidgetLoading.prototype.handleFocus = function () {
	alert("SceneWidgetLoading.handleFocus()");
	// this function will be called when the scene manager focus this scene

}

SceneWidgetLoading.prototype.handleBlur = function () {
	alert("SceneWidgetLoading.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneWidgetLoading.prototype.handleKeyDown = function (keyCode) {
	alert("SceneWidgetLoading.handleKeyDown(" + keyCode + ")");
	PluginAPIMgr.PlayAudio(keyCode);
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case $.sfKey.LEFT:
		case $.sfKey.RIGHT:
			break;
		case $.sfKey.UP:

			break;
		case $.sfKey.DOWN:

			break;

		case $.sfKey.ENTER:
			break;
            
        case $.sfKey.RETURN:
            this.processReturnKey();
            $.sfKey.block(event);
			break;
            
         case $.sfKey.EXIT:
           this.processExitKey();
            $.sfKey.block(event);
			break;
            
         case 147:  //infolink
         case 261:  //contents
         case 115:  //wiselink
            $.sfKey.block(event);
			break;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

SceneWidgetLoading.prototype.create = function(){
    alert("SceneWidgetLoading.create()");
    this.WidgetLoadingView = new View("WidgetLoading");
    this.WidgetLoadingView.SetBgImage(g_Image.IMAGE_WIDGET_LOADING_BG);

    this.LoadingBg= new Label("widget_loading_bg", null);
    this.LoadingBg.SetBgImage(g_Image.IMAGE_WIDGET_LOADING_BOX_BG);
    
    var a=0;
    for (a=0; a < this.LoadingAniImage.length; a++)
    {
        var b = (a+1);
        if(b<10)
        {
            this.LoadingAniImage[a] = g_Image.base_loading_image_path +"create_loading"+"0"+b+".png";
        }
        else
        {
            this.LoadingAniImage[a] = g_Image.base_loading_image_path +"create_loading"+b+".png";
        }
    }
    
    this.LoadingAni= new Label("widget_loading_animation", null);
    this.LoadingAni.SetBgImage(this.LoadingAniImage[this.iCurrAniImage]);
    
    this.LoadingMsg = new Label(null,"widget_loading_message");
    this.LoadingMsg.SetTextStyle("widget_loading_message_style");
    this.LoadingMsg.SetText(SID_LOADING_3DOT_KR_DIF);
     
}

SceneWidgetLoading.prototype.highlight=function(obj)
{
    this.WidgetLoadingView.setCurrenHighlight(obj);

}

SceneWidgetLoading.prototype.startTimer = function()
{   
	var scene = $.sfScene.get('WidgetLoading');
    this.WidgetLoadingTimer=setInterval("timerCF()", 100);
    timerCF = function() {  scene.loadingTimerCallback();}
}

SceneWidgetLoading.prototype.stopTimer = function()
{
    alert("SceneLoading.stopTimer() ");
    
	clearInterval( this.WidgetLoadingTimer);
    this.WidgetLoadingTimer=null;
    this.iCurrAniImage =0;
}

SceneWidgetLoading.prototype.loadingTimerCallback = function()
{
     this.iCurrAniImage++;
     
    if(this.iCurrAniImage >= this.LoadingAniImage.length)
    {
        this.iCurrAniImage = 0;
    }   
    
    this.LoadingAni.SetBgImage(this.LoadingAniImage[this.iCurrAniImage]);
	
}


SceneWidgetLoading.prototype.processReturnKey = function(){
    alert("SceneWidgetLoading.processReturnKey() ");   
   ProcMgr.CloseWidget(); 
}


SceneWidgetLoading.prototype.processExitKey = function(){
    alert("SceneWidgetLoading.processExitKey() ");   
   ProcMgr.ExitWidget();
}



